/* Utils.c generated by valac 0.38.10, the Vala compiler
 * generated from Utils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>




gboolean noise_utils_is_cancelled (GCancellable* cancellable);
gboolean noise_utils_flags_set (gint flags, gint to_check);
gchar* noise_utils_get_desktop_shell (void);


/**
     * Checks whether //cancellable// is canceled.
     *
     * @param cancellable The GLib.Cancellable object to query.
     * @return whether the cancellable is canceled; or //false// in case //cancellable// was null.
     */
inline gboolean noise_utils_is_cancelled (GCancellable* cancellable) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GCancellable* _tmp1_;
#line 38 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	_tmp1_ = cancellable;
#line 38 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	if (_tmp1_ != NULL) {
#line 61 "Utils.c"
		GCancellable* _tmp2_;
		gboolean _tmp3_;
#line 38 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
		_tmp2_ = cancellable;
#line 38 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
		_tmp3_ = g_cancellable_is_cancelled (_tmp2_);
#line 38 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
		_tmp0_ = _tmp3_;
#line 70 "Utils.c"
	} else {
#line 38 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
		_tmp0_ = FALSE;
#line 74 "Utils.c"
	}
#line 38 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	result = _tmp0_;
#line 38 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	return result;
#line 80 "Utils.c"
}


/**
     * Checks whether the set of flags specified by //to_check// are set in //flags//.
     *
     * @param flags Set of flags to check.
     * @param to_check Set of flags to look for in //flags//.
     * @return Whether all the flags in //to_check// were set in //flags//.
     */
inline gboolean noise_utils_flags_set (gint flags, gint to_check) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	_tmp0_ = flags;
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	_tmp1_ = to_check;
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	_tmp2_ = to_check;
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	result = (_tmp0_ & _tmp1_) == _tmp2_;
#line 49 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	return result;
#line 106 "Utils.c"
}


/**
     * Returns the name of the current desktop shell.
     *
     * Encoding is the same of unix filenames.
     *
     * @return name of the desktop shell, or null if it's not found.
     */
gchar* noise_utils_get_desktop_shell (void) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	result = _tmp1_;
#line 60 "/builddir/build/BUILD/music-0.4.2/core/Utils/Utils.vala"
	return result;
#line 129 "Utils.c"
}



