/* AudioPlayerDevice.c generated by valac 0.38.10, the Vala compiler
 * generated from AudioPlayerDevice.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <noise-core.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <noise.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>


#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE (noise_plugins_audio_player_device_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevice))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))

typedef struct _NoisePluginsAudioPlayerDevice NoisePluginsAudioPlayerDevice;
typedef struct _NoisePluginsAudioPlayerDeviceClass NoisePluginsAudioPlayerDeviceClass;
typedef struct _NoisePluginsAudioPlayerDevicePrivate NoisePluginsAudioPlayerDevicePrivate;

#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY (noise_plugins_audio_player_library_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibrary))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))

typedef struct _NoisePluginsAudioPlayerLibrary NoisePluginsAudioPlayerLibrary;
typedef struct _NoisePluginsAudioPlayerLibraryClass NoisePluginsAudioPlayerLibraryClass;
enum  {
	NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_0_PROPERTY,
	NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_audio_player_device_properties[NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NoisePluginsAudioPlayerLibraryPrivate NoisePluginsAudioPlayerLibraryPrivate;
typedef struct _NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData;

struct _NoisePluginsAudioPlayerDevice {
	GObject parent_instance;
	NoisePluginsAudioPlayerDevicePrivate * priv;
};

struct _NoisePluginsAudioPlayerDeviceClass {
	GObjectClass parent_class;
};

struct _NoisePluginsAudioPlayerDevicePrivate {
	GMount* mount;
	GIcon* icon;
	gboolean is_androphone;
	GeeLinkedList* music_folders;
	NoisePluginsAudioPlayerLibrary* library;
};

struct _NoisePluginsAudioPlayerLibrary {
	NoiseLibrary parent_instance;
	NoisePluginsAudioPlayerLibraryPrivate * priv;
	gint medias_rowid;
	gint playlists_rowid;
	gint smartplaylists_rowid;
	NoiseGStreamerTagger* tagger;
};

struct _NoisePluginsAudioPlayerLibraryClass {
	NoiseLibraryClass parent_class;
};

struct _NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoisePluginsAudioPlayerDevice* self;
	gboolean _tmp0_;
	GeeLinkedList* _tmp1_;
	GMount* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* file;
	GMount* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	gboolean _tmp19_;
	GFileInputStream* _tmp20_;
	GFile* _tmp21_;
	GFileInputStream* _tmp22_;
	GDataInputStream* dis;
	GDataInputStream* _tmp23_;
	gchar* line;
	gchar* _tmp24_;
	GDataInputStream* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	gboolean _tmp30_;
	gchar* folders_unparsed;
	const gchar* _tmp31_;
	gchar** _tmp32_;
	gchar** _tmp33_;
	gchar** _tmp34_;
	gint _tmp34__length1;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	const gchar* _tmp38_;
	gchar** _tmp39_;
	gchar** _tmp40_;
	gchar** folder_collection;
	gint folder_collection_length1;
	gint _folder_collection_size_;
	gint folder_it;
	gchar* _tmp41_;
	gchar* folder;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	GeeLinkedList* _tmp44_;
	GMount* _tmp45_;
	GFile* _tmp46_;
	GFile* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	GError* e;
	FILE* _tmp55_;
	GError* _tmp56_;
	const gchar* _tmp57_;
	GeeLinkedList* files;
	GeeLinkedList* _tmp58_;
	gint items;
	GeeLinkedList* _folder_list;
	GeeLinkedList* _tmp59_;
	GeeLinkedList* _tmp60_;
	gint _folder_size;
	GeeLinkedList* _tmp61_;
	gint _tmp62_;
	gint _tmp63_;
	gint _folder_index;
	gint _tmp64_;
	gint _tmp65_;
	gint _tmp66_;
	gchar* _vala1_folder;
	GeeLinkedList* _tmp67_;
	gint _tmp68_;
	gpointer _tmp69_;
	GFile* music_folder_file;
	const gchar* _tmp70_;
	GFile* _tmp71_;
	gint _tmp72_;
	GFile* _tmp73_;
	GeeLinkedList* _tmp74_;
	gint _tmp75_;
	gint _tmp76_;
	NoisePluginsAudioPlayerLibrary* _tmp77_;
	NoiseGStreamerTagger* _tmp78_;
	GeeLinkedList* _tmp79_;
	GeeLinkedList* _tmp80_;
	gint _tmp81_;
	gint _tmp82_;
	NoisePluginsAudioPlayerLibrary* _tmp83_;
	GError * _inner_error_;
};


static gpointer noise_plugins_audio_player_device_parent_class = NULL;
static NoiseDeviceIface * noise_plugins_audio_player_device_noise_device_parent_iface = NULL;
static GType noise_plugins_audio_player_device_type_id = 0;

GType noise_plugins_audio_player_device_get_type (void) G_GNUC_CONST;
GType noise_plugins_audio_player_library_get_type (void) G_GNUC_CONST;
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevicePrivate))
NoisePluginsAudioPlayerDevice* noise_plugins_audio_player_device_new (GMount* mount, gboolean is_androphone);
NoisePluginsAudioPlayerDevice* noise_plugins_audio_player_device_construct (GType object_type, GMount* mount, gboolean is_androphone);
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_new (NoisePluginsAudioPlayerDevice* device);
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_construct (GType object_type, NoisePluginsAudioPlayerDevice* device);
static void noise_plugins_audio_player_device_real_finish_initialization (NoiseDevice* base);
static void __lambda8_ (NoisePluginsAudioPlayerDevice* self);
static void ___lambda8__noise_device_device_unmounted (NoiseDevice* _sender, gpointer self);
static void noise_plugins_audio_player_device_finish_initialization_async (NoisePluginsAudioPlayerDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void noise_plugins_audio_player_device_finish_initialization_finish (NoisePluginsAudioPlayerDevice* self, GAsyncResult* _res_);
static gboolean noise_plugins_audio_player_device_real_start_initialization (NoiseDevice* base);
static void noise_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data);
static void noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper (GObject *source_object, GAsyncResult *res, void *user_data);
static gboolean noise_plugins_audio_player_device_finish_initialization_async_co (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_);
void noise_plugins_audio_player_library_queue_finished (NoisePluginsAudioPlayerLibrary* self);
static gboolean __lambda9_ (NoisePluginsAudioPlayerDevice* self);
static gboolean ___lambda9__gsource_func (gpointer self);
static NoiseLibrary* noise_plugins_audio_player_device_real_get_library (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_getEmptyDeviceTitle (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_getEmptyDeviceDescription (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_getContentType (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_getDisplayName (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_setDisplayName (NoiseDevice* base, const gchar* name);
static gchar* noise_plugins_audio_player_device_real_get_fancy_description (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_mount (NoiseDevice* base, GMount* mount);
static GMount* noise_plugins_audio_player_device_real_get_mount (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_uri (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_icon (NoiseDevice* base, GIcon* icon);
static GIcon* noise_plugins_audio_player_device_real_get_icon (NoiseDevice* base);
static guint64 noise_plugins_audio_player_device_real_get_capacity (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_fancy_capacity (NoiseDevice* base);
static guint64 noise_plugins_audio_player_device_real_get_used_space (NoiseDevice* base);
gchar* noise_plugins_audio_player_device_get_music_folder (NoisePluginsAudioPlayerDevice* self);
static guint64 noise_plugins_audio_player_device_real_get_free_space (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_unmount (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_eject (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_synchronize (NoiseDevice* base);
static gboolean noise_plugins_audio_player_device_real_only_use_custom_view (NoiseDevice* base);
static GtkWidget* noise_plugins_audio_player_device_real_get_custom_view (NoiseDevice* base);
static gboolean noise_plugins_audio_player_device_real_read_only (NoiseDevice* base);
static void noise_plugins_audio_player_device_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gpointer _g_object_ref0 (gpointer self) {
#line 39 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return self ? g_object_ref (self) : NULL;
#line 277 "AudioPlayerDevice.c"
}


NoisePluginsAudioPlayerDevice* noise_plugins_audio_player_device_construct (GType object_type, GMount* mount, gboolean is_androphone) {
	NoisePluginsAudioPlayerDevice * self = NULL;
	GMount* _tmp0_;
	GMount* _tmp1_;
	gboolean _tmp2_;
	GeeLinkedList* _tmp3_;
	NoisePluginsAudioPlayerLibrary* _tmp4_;
	NoiseLibrariesManager* _tmp5_;
	NoisePluginsAudioPlayerLibrary* _tmp6_;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp8_;
	GThemedIcon* _tmp9_;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) g_object_new (object_type, NULL);
#line 39 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = mount;
#line 39 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 39 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 39 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->mount = _tmp1_;
#line 40 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp2_ = is_androphone;
#line 40 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->is_androphone = _tmp2_;
#line 41 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp3_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 41 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->music_folders);
#line 41 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->music_folders = _tmp3_;
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp4_ = noise_plugins_audio_player_library_new (self);
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->library);
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->library = _tmp4_;
#line 43 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp5_ = noise_libraries_manager;
#line 43 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp6_ = self->priv->library;
#line 43 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_libraries_manager_add_library (_tmp5_, (NoiseLibrary*) _tmp6_);
#line 44 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp8_ = is_androphone;
#line 44 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_tmp8_) {
#line 44 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = "phone";
#line 333 "AudioPlayerDevice.c"
	} else {
#line 44 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = "music-player";
#line 337 "AudioPlayerDevice.c"
	}
#line 44 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp9_ = (GThemedIcon*) g_themed_icon_new (_tmp7_);
#line 44 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 44 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->icon = (GIcon*) _tmp9_;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return self;
#line 347 "AudioPlayerDevice.c"
}


NoisePluginsAudioPlayerDevice* noise_plugins_audio_player_device_new (GMount* mount, gboolean is_androphone) {
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return noise_plugins_audio_player_device_construct (NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, mount, is_androphone);
#line 354 "AudioPlayerDevice.c"
}


static void __lambda8_ (NoisePluginsAudioPlayerDevice* self) {
}


static void ___lambda8__noise_device_device_unmounted (NoiseDevice* _sender, gpointer self) {
#line 48 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	__lambda8_ ((NoisePluginsAudioPlayerDevice*) self);
#line 365 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_real_finish_initialization (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 48 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_signal_connect_object ((NoiseDevice*) self, "device-unmounted", (GCallback) ___lambda8__noise_device_device_unmounted, self, 0);
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_finish_initialization_async (self, NULL, NULL);
#line 377 "AudioPlayerDevice.c"
}


static gboolean noise_plugins_audio_player_device_real_start_initialization (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = TRUE;
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 390 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data) {
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	_data_ = _data;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_data_->self);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_slice_free (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData, _data_);
#line 401 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper (GObject *source_object, GAsyncResult *res, void *user_data) {
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _task_data_;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 413 "AudioPlayerDevice.c"
	}
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_task_data_->_task_complete_ = TRUE;
#line 417 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_finish_initialization_async (NoisePluginsAudioPlayerDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	NoisePluginsAudioPlayerDevice* _tmp0_;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_ = g_slice_new0 (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_callback_ = _callback_;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper, _user_data_);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_callback_ == NULL) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_task_complete_ = TRUE;
#line 434 "AudioPlayerDevice.c"
	}
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_task_set_task_data (_data_->_async_result, _data_, noise_plugins_audio_player_device_finish_initialization_async_data_free);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->self = _tmp0_;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_finish_initialization_async_co (_data_);
#line 444 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_finish_initialization_finish (NoisePluginsAudioPlayerDevice* self, GAsyncResult* _res_) {
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 452 "AudioPlayerDevice.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 472 "AudioPlayerDevice.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1415 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 491 "AudioPlayerDevice.c"
	} else {
		const gchar* _tmp2_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp2_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
#line 498 "AudioPlayerDevice.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 504 "AudioPlayerDevice.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp3_ = old;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = replacement;
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
#line 514 "AudioPlayerDevice.c"
	}
#line 1416 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 518 "AudioPlayerDevice.c"
		gchar* _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp5_ = g_strdup (self);
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1417 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 526 "AudioPlayerDevice.c"
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp6_ = old;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp9_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp8_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		regex = _tmp10_;
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 558 "AudioPlayerDevice.c"
				goto __catch1_g_regex_error;
			}
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1420 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 567 "AudioPlayerDevice.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp12_ = regex;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp13_ = replacement;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = _tmp14_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 583 "AudioPlayerDevice.c"
				goto __catch1_g_regex_error;
			}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
			return NULL;
#line 594 "AudioPlayerDevice.c"
		}
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp15_ = _tmp11_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp11_ = NULL;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp15_;
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_free0 (_tmp11_);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1421 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 608 "AudioPlayerDevice.c"
	}
	goto __finally1;
	__catch1_g_regex_error:
	{
		GError* e = NULL;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1423 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 622 "AudioPlayerDevice.c"
	}
	__finally1:
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1419 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return NULL;
#line 633 "AudioPlayerDevice.c"
	}
}


static gboolean __lambda9_ (NoisePluginsAudioPlayerDevice* self) {
	gboolean result = FALSE;
#line 96 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 96 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 644 "AudioPlayerDevice.c"
}


static gboolean ___lambda9__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda9_ ((NoisePluginsAudioPlayerDevice*) self);
#line 94 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 653 "AudioPlayerDevice.c"
}


static gboolean noise_plugins_audio_player_device_finish_initialization_async_co (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_) {
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	switch (_data_->_state_) {
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		case 0:
#line 662 "AudioPlayerDevice.c"
		goto _state_0;
		default:
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_assert_not_reached ();
#line 667 "AudioPlayerDevice.c"
	}
	_state_0:
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp0_ = _data_->self->priv->is_androphone;
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->_tmp0_) {
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp1_ = _data_->self->priv->music_folders;
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp2_ = _data_->self->priv->mount;
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp3_ = g_mount_get_root (_data_->_tmp2_);
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp5_ = g_file_get_uri (_data_->_tmp4_);
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp7_ = g_strconcat (_data_->_tmp6_, "/Music/", NULL);
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp1_, _data_->_tmp8_);
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp8_);
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp6_);
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_tmp4_);
#line 698 "AudioPlayerDevice.c"
	} else {
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp9_ = _data_->self->priv->mount;
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp10_ = g_mount_get_root (_data_->_tmp9_);
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp12_ = g_file_get_uri (_data_->_tmp11_);
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp14_ = g_strconcat (_data_->_tmp13_, "/.is_audio_player", NULL);
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp16_ = g_file_new_for_uri (_data_->_tmp15_);
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp15_);
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp13_);
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_tmp11_);
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->file = _data_->_tmp17_;
#line 726 "AudioPlayerDevice.c"
		{
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp18_ = _data_->file;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp19_ = g_file_query_exists (_data_->_tmp18_, NULL);
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (_data_->_tmp19_ == TRUE) {
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp21_ = _data_->file;
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp22_ = g_file_read (_data_->_tmp21_, NULL, &_data_->_inner_error_);
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp20_ = _data_->_tmp22_;
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 742 "AudioPlayerDevice.c"
					goto __catch0_g_error;
				}
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp23_ = g_data_input_stream_new ((GInputStream*) _data_->_tmp20_);
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->dis = _data_->_tmp23_;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				while (TRUE) {
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp25_ = _data_->dis;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp26_ = g_data_input_stream_read_line (_data_->_tmp25_, NULL, NULL, &_data_->_inner_error_);
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp24_ = _data_->_tmp26_;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->line);
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_data_->dis);
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_data_->_tmp20_);
#line 765 "AudioPlayerDevice.c"
						goto __catch0_g_error;
					}
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp27_ = _data_->_tmp24_;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp24_ = NULL;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_data_->line);
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->line = _data_->_tmp27_;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp28_ = _data_->line;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (!(_data_->_tmp28_ != NULL)) {
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->_tmp24_);
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						break;
#line 784 "AudioPlayerDevice.c"
					}
#line 69 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp29_ = _data_->line;
#line 69 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp30_ = string_contains (_data_->_tmp29_, "audio_folders=");
#line 69 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (_data_->_tmp30_) {
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp31_ = _data_->line;
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp33_ = _data_->_tmp32_ = g_strsplit (_data_->_tmp31_, "audio_folders=", 2);
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp34_ = _data_->_tmp33_;
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp34__length1 = _vala_array_length (_data_->_tmp32_);
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp35_ = _data_->_tmp34_[1];
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp36_ = g_strdup (_data_->_tmp35_);
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp37_ = _data_->_tmp36_;
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp34_ = (_vala_array_free (_data_->_tmp34_, _data_->_tmp34__length1, (GDestroyNotify) g_free), NULL);
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->folders_unparsed = _data_->_tmp37_;
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp38_ = _data_->folders_unparsed;
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp40_ = _data_->_tmp39_ = g_strsplit (_data_->_tmp38_, ",", 0);
#line 814 "AudioPlayerDevice.c"
						{
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection_length1 = 0;
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->_folder_collection_size_ = 0;
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection = _data_->_tmp40_;
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection_length1 = _vala_array_length (_data_->_tmp39_);
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							for (_data_->folder_it = 0; _data_->folder_it < _vala_array_length (_data_->_tmp39_); _data_->folder_it = _data_->folder_it + 1) {
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_data_->_tmp41_ = g_strdup (_data_->folder_collection[_data_->folder_it]);
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_data_->folder = _data_->_tmp41_;
#line 830 "AudioPlayerDevice.c"
								{
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp42_ = _data_->folder;
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp43_ = string_replace (_data_->_tmp42_, " ", "");
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->folder);
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->folder = _data_->_tmp43_;
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp44_ = _data_->self->priv->music_folders;
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp45_ = _data_->self->priv->mount;
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp46_ = g_mount_get_root (_data_->_tmp45_);
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp47_ = _data_->_tmp46_;
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp48_ = g_file_get_uri (_data_->_tmp47_);
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp49_ = _data_->_tmp48_;
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp50_ = g_strconcat (_data_->_tmp49_, "/", NULL);
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp51_ = _data_->_tmp50_;
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp52_ = _data_->folder;
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp53_ = g_strconcat (_data_->_tmp51_, _data_->_tmp52_, NULL);
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp54_ = _data_->_tmp53_;
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp44_, _data_->_tmp54_);
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp54_);
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp51_);
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp49_);
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_object_unref0 (_data_->_tmp47_);
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->folder);
#line 874 "AudioPlayerDevice.c"
								}
							}
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection = (_vala_array_free (_data_->folder_collection, _data_->folder_collection_length1, (GDestroyNotify) g_free), NULL);
#line 879 "AudioPlayerDevice.c"
						}
#line 69 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->folders_unparsed);
#line 883 "AudioPlayerDevice.c"
					}
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_data_->_tmp24_);
#line 887 "AudioPlayerDevice.c"
				}
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_free0 (_data_->line);
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_data_->dis);
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_data_->_tmp20_);
#line 895 "AudioPlayerDevice.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->e = _data_->_inner_error_;
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_inner_error_ = NULL;
#line 79 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp55_ = stderr;
#line 79 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp56_ = _data_->e;
#line 79 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp57_ = _data_->_tmp56_->message;
#line 79 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			fprintf (_data_->_tmp55_, "Error: %s\n", _data_->_tmp57_);
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_error_free0 (_data_->e);
#line 915 "AudioPlayerDevice.c"
		}
		__finally0:
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (_data_->file);
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_clear_error (&_data_->_inner_error_);
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_object_unref (_data_->_async_result);
#line 63 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			return FALSE;
#line 930 "AudioPlayerDevice.c"
		}
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->file);
#line 934 "AudioPlayerDevice.c"
	}
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp58_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->files = _data_->_tmp58_;
#line 83 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->items = 0;
#line 942 "AudioPlayerDevice.c"
	{
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp59_ = _data_->self->priv->music_folders;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp60_ = _g_object_ref0 (_data_->_tmp59_);
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_list = _data_->_tmp60_;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp61_ = _data_->_folder_list;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp62_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp61_);
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp63_ = _data_->_tmp62_;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_size = _data_->_tmp63_;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_index = -1;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		while (TRUE) {
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp64_ = _data_->_folder_index;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_folder_index = _data_->_tmp64_ + 1;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp65_ = _data_->_folder_index;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp66_ = _data_->_folder_size;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (!(_data_->_tmp65_ < _data_->_tmp66_)) {
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				break;
#line 974 "AudioPlayerDevice.c"
			}
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp67_ = _data_->_folder_list;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp68_ = _data_->_folder_index;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp69_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp67_, _data_->_tmp68_);
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_vala1_folder = (gchar*) _data_->_tmp69_;
#line 85 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp70_ = _data_->_vala1_folder;
#line 85 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp71_ = g_file_new_for_uri (_data_->_tmp70_);
#line 85 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->music_folder_file = _data_->_tmp71_;
#line 86 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp72_ = _data_->items;
#line 86 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp73_ = _data_->music_folder_file;
#line 86 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp74_ = _data_->files;
#line 86 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp75_ = noise_file_utils_count_music_files (_data_->_tmp73_, (GeeCollection*) _data_->_tmp74_);
#line 86 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->items = _data_->_tmp72_ + _data_->_tmp75_;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (_data_->music_folder_file);
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_free0 (_data_->_vala1_folder);
#line 1004 "AudioPlayerDevice.c"
		}
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_folder_list);
#line 1008 "AudioPlayerDevice.c"
	}
#line 89 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp76_ = _data_->items;
#line 89 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_debug ("AudioPlayerDevice.vala:89: found %d items to import\n", _data_->_tmp76_);
#line 90 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp77_ = _data_->self->priv->library;
#line 90 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp78_ = _data_->_tmp77_->tagger;
#line 90 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp79_ = _data_->files;
#line 90 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_gstreamer_tagger_discoverer_import_media (_data_->_tmp78_, (GeeCollection*) _data_->_tmp79_);
#line 91 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp80_ = _data_->files;
#line 91 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp81_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp80_);
#line 91 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp82_ = _data_->_tmp81_;
#line 91 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->_tmp82_ == 0) {
#line 92 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp83_ = _data_->self->priv->library;
#line 92 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		noise_plugins_audio_player_library_queue_finished (_data_->_tmp83_);
#line 1034 "AudioPlayerDevice.c"
	}
#line 94 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda9__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_data_->files);
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->_state_ != 0) {
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1048 "AudioPlayerDevice.c"
		}
	}
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_object_unref (_data_->_async_result);
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return FALSE;
#line 1055 "AudioPlayerDevice.c"
}


static NoiseLibrary* noise_plugins_audio_player_device_real_get_library (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	NoiseLibrary* result = NULL;
	NoisePluginsAudioPlayerLibrary* _tmp0_;
	NoiseLibrary* _tmp1_;
#line 100 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 101 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->library;
#line 101 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 ((NoiseLibrary*) _tmp0_);
#line 101 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 101 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1074 "AudioPlayerDevice.c"
}


static gchar* noise_plugins_audio_player_device_real_getEmptyDeviceTitle (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 105 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_strdup (_ ("Empty device!"));
#line 105 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 105 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1090 "AudioPlayerDevice.c"
}


static gchar* noise_plugins_audio_player_device_real_getEmptyDeviceDescription (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 108 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_strdup (_ ("This device does not contain any music."));
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1106 "AudioPlayerDevice.c"
}


static gchar* noise_plugins_audio_player_device_real_getContentType (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gboolean _tmp0_;
#line 112 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 113 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->is_androphone;
#line 113 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_tmp0_) {
#line 1120 "AudioPlayerDevice.c"
		gchar* _tmp1_;
#line 114 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = g_strdup ("android");
#line 114 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp1_;
#line 114 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1128 "AudioPlayerDevice.c"
	} else {
		gchar* _tmp2_;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_strdup ("audioplayer");
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp2_;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1137 "AudioPlayerDevice.c"
	}
}


static gchar* noise_plugins_audio_player_device_real_getDisplayName (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
#line 119 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 120 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->is_androphone;
#line 120 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_tmp0_) {
#line 1153 "AudioPlayerDevice.c"
		GMount* _tmp1_;
		gchar* _tmp2_;
#line 121 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = self->priv->mount;
#line 121 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_mount_get_name (_tmp1_);
#line 121 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp2_;
#line 121 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1164 "AudioPlayerDevice.c"
	} else {
		GFile* file = NULL;
		GMount* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gchar* name = NULL;
		GMount* _tmp12_;
		gchar* _tmp13_;
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = self->priv->mount;
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_mount_get_root (_tmp3_);
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = _tmp6_;
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = g_strconcat (_tmp7_, "/.is_audio_player", NULL);
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp9_ = _tmp8_;
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp10_ = g_file_new_for_path (_tmp9_);
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp11_ = _tmp10_;
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp9_);
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp7_);
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp5_);
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file = _tmp11_;
#line 124 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp12_ = self->priv->mount;
#line 124 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp13_ = g_mount_get_name (_tmp12_);
#line 124 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		name = _tmp13_;
#line 1211 "AudioPlayerDevice.c"
		{
			GFile* _tmp14_;
			gboolean _tmp15_;
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp14_ = file;
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp15_ = g_file_query_exists (_tmp14_, NULL);
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (_tmp15_ == TRUE) {
#line 1221 "AudioPlayerDevice.c"
				GFileInputStream* _tmp16_ = NULL;
				GFile* _tmp17_;
				GFileInputStream* _tmp18_;
				GDataInputStream* dis = NULL;
				GDataInputStream* _tmp19_;
				gchar* line = NULL;
#line 127 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp17_ = file;
#line 127 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp18_ = g_file_read (_tmp17_, NULL, &_inner_error_);
#line 127 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp16_ = _tmp18_;
#line 127 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1236 "AudioPlayerDevice.c"
					goto __catch2_g_error;
				}
#line 127 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp19_ = g_data_input_stream_new ((GInputStream*) _tmp16_);
#line 127 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				dis = _tmp19_;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				while (TRUE) {
#line 1245 "AudioPlayerDevice.c"
					gchar* _tmp20_ = NULL;
					GDataInputStream* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					const gchar* _tmp24_;
					const gchar* _tmp25_;
					gboolean _tmp26_;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp21_ = dis;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp22_ = g_data_input_stream_read_line (_tmp21_, NULL, NULL, &_inner_error_);
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp20_ = _tmp22_;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (line);
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (dis);
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_tmp16_);
#line 1267 "AudioPlayerDevice.c"
						goto __catch2_g_error;
					}
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp23_ = _tmp20_;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp20_ = NULL;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (line);
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					line = _tmp23_;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp24_ = line;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (!(_tmp24_ != NULL)) {
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_tmp20_);
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						break;
#line 1286 "AudioPlayerDevice.c"
					}
#line 131 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp25_ = line;
#line 131 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp26_ = string_contains (_tmp25_, "name=");
#line 131 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (_tmp26_) {
#line 1294 "AudioPlayerDevice.c"
						gchar* names_unparsed = NULL;
						const gchar* _tmp27_;
						gchar** _tmp28_;
						gchar** _tmp29_;
						gchar** _tmp30_;
						gint _tmp30__length1;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						gchar* _tmp33_;
						const gchar* _tmp34_;
						gchar** _tmp35_;
						gchar** _tmp36_;
#line 132 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp27_ = line;
#line 132 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp29_ = _tmp28_ = g_strsplit (_tmp27_, "name=", 2);
#line 132 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp30_ = _tmp29_;
#line 132 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp30__length1 = _vala_array_length (_tmp28_);
#line 132 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp31_ = _tmp30_[1];
#line 132 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp32_ = g_strdup (_tmp31_);
#line 132 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp33_ = _tmp32_;
#line 132 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp30_ = (_vala_array_free (_tmp30_, _tmp30__length1, (GDestroyNotify) g_free), NULL);
#line 132 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						names_unparsed = _tmp33_;
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp34_ = names_unparsed;
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp36_ = _tmp35_ = g_strsplit (_tmp34_, "\"", 0);
#line 1329 "AudioPlayerDevice.c"
						{
							gchar** names_collection = NULL;
							gint names_collection_length1 = 0;
							gint _names_collection_size_ = 0;
							gint names_it = 0;
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection = _tmp36_;
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection_length1 = _vala_array_length (_tmp35_);
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							for (names_it = 0; names_it < _vala_array_length (_tmp35_); names_it = names_it + 1) {
#line 1341 "AudioPlayerDevice.c"
								gchar* _tmp37_;
								gchar* names = NULL;
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_tmp37_ = g_strdup (names_collection[names_it]);
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								names = _tmp37_;
#line 1348 "AudioPlayerDevice.c"
								{
									gboolean _tmp38_ = FALSE;
									const gchar* _tmp39_;
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_tmp39_ = names;
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									if (_tmp39_ != NULL) {
#line 1356 "AudioPlayerDevice.c"
										const gchar* _tmp40_;
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp40_ = names;
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp38_ = g_strcmp0 (_tmp40_, "") != 0;
#line 1362 "AudioPlayerDevice.c"
									} else {
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp38_ = FALSE;
#line 1366 "AudioPlayerDevice.c"
									}
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									if (_tmp38_) {
#line 1370 "AudioPlayerDevice.c"
										const gchar* _tmp41_;
										gchar* _tmp42_;
#line 135 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp41_ = names;
#line 135 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp42_ = g_strdup (_tmp41_);
#line 135 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_g_free0 (name);
#line 135 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										name = _tmp42_;
#line 1381 "AudioPlayerDevice.c"
									}
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (names);
#line 1385 "AudioPlayerDevice.c"
								}
							}
#line 133 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection = (_vala_array_free (names_collection, names_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1390 "AudioPlayerDevice.c"
						}
#line 131 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (names_unparsed);
#line 1394 "AudioPlayerDevice.c"
					}
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_tmp20_);
#line 1398 "AudioPlayerDevice.c"
				}
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_free0 (line);
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (dis);
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_tmp16_);
#line 1406 "AudioPlayerDevice.c"
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			FILE* _tmp43_;
			GError* _tmp44_;
			const gchar* _tmp45_;
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			e = _inner_error_;
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_inner_error_ = NULL;
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp43_ = stderr;
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp44_ = e;
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp45_ = _tmp44_->message;
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			fprintf (_tmp43_, "Error: %s\n", _tmp45_);
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_error_free0 (e);
#line 1430 "AudioPlayerDevice.c"
		}
		__finally2:
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_free0 (name);
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (file);
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_clear_error (&_inner_error_);
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			return NULL;
#line 1445 "AudioPlayerDevice.c"
		}
#line 143 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = name;
#line 143 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file);
#line 143 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1453 "AudioPlayerDevice.c"
	}
}


static void noise_plugins_audio_player_device_real_setDisplayName (NoiseDevice* base, const gchar* name) {
	NoisePluginsAudioPlayerDevice * self;
#line 147 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 147 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (name != NULL);
#line 1464 "AudioPlayerDevice.c"
}


static gchar* noise_plugins_audio_player_device_real_get_fancy_description (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gboolean _tmp0_;
#line 151 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 152 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->is_androphone;
#line 152 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_tmp0_) {
#line 1478 "AudioPlayerDevice.c"
		gchar* _tmp1_;
#line 153 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = g_strdup (_ ("Android Phone"));
#line 153 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp1_;
#line 153 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1486 "AudioPlayerDevice.c"
	} else {
		gchar* _tmp2_;
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_strdup (_ ("Audio Player"));
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp2_;
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1495 "AudioPlayerDevice.c"
	}
}


static void noise_plugins_audio_player_device_real_set_mount (NoiseDevice* base, GMount* mount) {
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	GMount* _tmp1_;
#line 159 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 159 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (mount != NULL);
#line 160 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = mount;
#line 160 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 160 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 160 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->mount = _tmp1_;
#line 1516 "AudioPlayerDevice.c"
}


static GMount* noise_plugins_audio_player_device_real_get_mount (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	GMount* result = NULL;
	GMount* _tmp0_;
	GMount* _tmp1_;
#line 163 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 164 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 164 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 164 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 164 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1535 "AudioPlayerDevice.c"
}


static gchar* noise_plugins_audio_player_device_real_get_uri (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	GMount* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 167 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = g_mount_get_default_location (_tmp0_);
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp2_ = _tmp1_;
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp3_ = g_file_get_uri (_tmp2_);
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp4_ = _tmp3_;
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_tmp2_);
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp4_;
#line 168 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1565 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_real_set_icon (NoiseDevice* base, GIcon* icon) {
	NoisePluginsAudioPlayerDevice * self;
	GIcon* _tmp0_;
	GIcon* _tmp1_;
#line 171 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 171 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (icon != NULL);
#line 172 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = icon;
#line 172 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 172 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 172 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->icon = _tmp1_;
#line 1585 "AudioPlayerDevice.c"
}


static GIcon* noise_plugins_audio_player_device_real_get_icon (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	GIcon* result = NULL;
	GIcon* _tmp0_;
	GIcon* _tmp1_;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->icon;
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1604 "AudioPlayerDevice.c"
}


static guint64 noise_plugins_audio_player_device_real_get_capacity (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	guint64 rv = 0ULL;
	guint64 _tmp11_;
	GError * _inner_error_ = NULL;
#line 180 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 181 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	rv = (guint64) 0;
#line 1618 "AudioPlayerDevice.c"
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
		guint64 _tmp6_;
#line 184 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = noise_device_get_uri ((NoiseDevice*) self);
#line 184 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = _tmp0_;
#line 184 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 184 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 184 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error_);
#line 184 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 184 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 184 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp1_);
#line 184 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file_info = _tmp5_;
#line 184 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1648 "AudioPlayerDevice.c"
			goto __catch3_g_error;
		}
#line 185 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE);
#line 185 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		rv = _tmp6_;
#line 183 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file_info);
#line 1657 "AudioPlayerDevice.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* err = NULL;
		FILE* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 183 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		err = _inner_error_;
#line 183 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_inner_error_ = NULL;
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = stdout;
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = err;
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp9_ = _tmp8_->message;
#line 187 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		fprintf (_tmp7_, "Error calculating capacity of iPod: %s\n", _tmp9_);
#line 183 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_error_free0 (err);
#line 1680 "AudioPlayerDevice.c"
	}
	__finally3:
#line 183 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1685 "AudioPlayerDevice.c"
		guint64 _tmp10_ = 0ULL;
#line 183 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 183 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_clear_error (&_inner_error_);
#line 183 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return _tmp10_;
#line 1693 "AudioPlayerDevice.c"
	}
#line 190 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp11_ = rv;
#line 190 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = (guint64) _tmp11_;
#line 190 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1701 "AudioPlayerDevice.c"
}


static gchar* noise_plugins_audio_player_device_real_get_fancy_capacity (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	guint64 _tmp0_;
	gchar* _tmp1_;
#line 193 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 194 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = noise_device_get_capacity ((NoiseDevice*) self);
#line 194 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = g_format_size_full (_tmp0_, G_FORMAT_SIZE_DEFAULT);
#line 194 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 194 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1720 "AudioPlayerDevice.c"
}


static guint64 noise_plugins_audio_player_device_real_get_used_space (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	guint64 _tmp0_;
	guint64 _tmp1_;
#line 197 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 198 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = noise_device_get_capacity ((NoiseDevice*) self);
#line 198 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = noise_device_get_free_space ((NoiseDevice*) self);
#line 198 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_ - _tmp1_;
#line 198 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1739 "AudioPlayerDevice.c"
}


gchar* noise_plugins_audio_player_device_get_music_folder (NoisePluginsAudioPlayerDevice* self) {
	gchar* result = NULL;
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 202 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->music_folders;
#line 202 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
#line 202 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = (gchar*) _tmp1_;
#line 202 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1757 "AudioPlayerDevice.c"
}


static guint64 noise_plugins_audio_player_device_real_get_free_space (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	guint64 rv = 0ULL;
	GError * _inner_error_ = NULL;
#line 205 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 206 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	rv = (guint64) 0;
#line 1770 "AudioPlayerDevice.c"
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
		guint64 _tmp6_;
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = noise_device_get_uri ((NoiseDevice*) self);
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = _tmp0_;
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error_);
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp1_);
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file_info = _tmp5_;
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1800 "AudioPlayerDevice.c"
			goto __catch4_g_error;
		}
#line 210 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
#line 210 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		rv = _tmp6_;
#line 208 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file_info);
#line 1809 "AudioPlayerDevice.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* err = NULL;
		FILE* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 208 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		err = _inner_error_;
#line 208 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_inner_error_ = NULL;
#line 212 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = stdout;
#line 212 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = err;
#line 212 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp9_ = _tmp8_->message;
#line 212 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		fprintf (_tmp7_, "Error calculating free space on iPod: %s\n", _tmp9_);
#line 208 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_error_free0 (err);
#line 1832 "AudioPlayerDevice.c"
	}
	__finally4:
#line 208 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1837 "AudioPlayerDevice.c"
		guint64 _tmp10_ = 0ULL;
#line 208 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 208 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_clear_error (&_inner_error_);
#line 208 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return _tmp10_;
#line 1845 "AudioPlayerDevice.c"
	}
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = rv;
#line 215 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1851 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_real_unmount (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
#line 218 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 219 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 219 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_mount_unmount_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
#line 1864 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_real_eject (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	gboolean _tmp1_;
#line 222 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 223 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 223 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = g_mount_can_eject (_tmp0_);
#line 223 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_tmp1_) {
#line 1880 "AudioPlayerDevice.c"
		GMount* _tmp2_;
		GVolume* _tmp3_;
		GVolume* _tmp4_;
		GDrive* _tmp5_;
		GDrive* _tmp6_;
#line 224 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = self->priv->mount;
#line 224 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = g_mount_get_volume (_tmp2_);
#line 224 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = _tmp3_;
#line 224 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = g_volume_get_drive (_tmp4_);
#line 224 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = _tmp5_;
#line 224 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_drive_eject_with_operation (_tmp6_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
#line 224 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp6_);
#line 224 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp4_);
#line 1902 "AudioPlayerDevice.c"
	}
}


static void noise_plugins_audio_player_device_real_synchronize (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
#line 228 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 1911 "AudioPlayerDevice.c"
}


static gboolean noise_plugins_audio_player_device_real_only_use_custom_view (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
#line 232 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 233 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 233 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1924 "AudioPlayerDevice.c"
}


static GtkWidget* noise_plugins_audio_player_device_real_get_custom_view (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	GtkWidget* result = NULL;
#line 236 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 237 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = NULL;
#line 237 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1937 "AudioPlayerDevice.c"
}


static gboolean noise_plugins_audio_player_device_real_read_only (NoiseDevice* base) {
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
#line 240 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 241 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1950 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_class_init (NoisePluginsAudioPlayerDeviceClass * klass) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_type_class_add_private (klass, sizeof (NoisePluginsAudioPlayerDevicePrivate));
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_audio_player_device_finalize;
#line 1961 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_noise_device_interface_init (NoiseDeviceIface * iface) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_noise_device_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->finish_initialization = (void (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_finish_initialization;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->start_initialization = (gboolean (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_start_initialization;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_library = (NoiseLibrary* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_library;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->getEmptyDeviceTitle = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_getEmptyDeviceTitle;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->getEmptyDeviceDescription = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_getEmptyDeviceDescription;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->getContentType = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_getContentType;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->getDisplayName = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_getDisplayName;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->setDisplayName = (void (*) (NoiseDevice *, const gchar*)) noise_plugins_audio_player_device_real_setDisplayName;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_fancy_description = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_fancy_description;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_mount = (void (*) (NoiseDevice *, GMount*)) noise_plugins_audio_player_device_real_set_mount;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_mount = (GMount* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_mount;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_uri = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_uri;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_icon = (void (*) (NoiseDevice *, GIcon*)) noise_plugins_audio_player_device_real_set_icon;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_icon = (GIcon* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_icon;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_capacity = (guint64 (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_capacity;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_fancy_capacity = (gchar* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_fancy_capacity;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_used_space = (guint64 (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_used_space;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_free_space = (guint64 (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_free_space;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->unmount = (void (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_unmount;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->eject = (void (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_eject;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->synchronize = (void (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_synchronize;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->only_use_custom_view = (gboolean (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_only_use_custom_view;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_custom_view = (GtkWidget* (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_get_custom_view;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->read_only = (gboolean (*) (NoiseDevice *)) noise_plugins_audio_player_device_real_read_only;
#line 2016 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_instance_init (NoisePluginsAudioPlayerDevice * self) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv = NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_GET_PRIVATE (self);
#line 33 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->is_androphone = FALSE;
#line 2025 "AudioPlayerDevice.c"
}


static void noise_plugins_audio_player_device_finalize (GObject * obj) {
	NoisePluginsAudioPlayerDevice * self;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevice);
#line 31 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 32 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 34 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->music_folders);
#line 36 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->library);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	G_OBJECT_CLASS (noise_plugins_audio_player_device_parent_class)->finalize (obj);
#line 2043 "AudioPlayerDevice.c"
}


GType noise_plugins_audio_player_device_get_type (void) {
	return noise_plugins_audio_player_device_type_id;
}


GType noise_plugins_audio_player_device_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsAudioPlayerDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_audio_player_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsAudioPlayerDevice), 0, (GInstanceInitFunc) noise_plugins_audio_player_device_instance_init, NULL };
	static const GInterfaceInfo noise_device_info = { (GInterfaceInitFunc) noise_plugins_audio_player_device_noise_device_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	noise_plugins_audio_player_device_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoisePluginsAudioPlayerDevice", &g_define_type_info, 0);
	g_type_module_add_interface (module, noise_plugins_audio_player_device_type_id, NOISE_TYPE_DEVICE, &noise_device_info);
	return noise_plugins_audio_player_device_type_id;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



