/* CDPlayer.c generated by valac 0.38.10, the Vala compiler
 * generated from CDPlayer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <noise-core.h>
#include <gst/gst.h>
#include <noise.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gee.h>
#include <gst/pbutils/pbutils.h>
#include <gtk/gtk.h>


#define NOISE_PLUGINS_TYPE_CD_PLAYER (noise_plugins_cd_player_get_type ())
#define NOISE_PLUGINS_CD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayer))
#define NOISE_PLUGINS_CD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayerClass))
#define NOISE_PLUGINS_IS_CD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_CD_PLAYER))
#define NOISE_PLUGINS_IS_CD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_CD_PLAYER))
#define NOISE_PLUGINS_CD_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayerClass))

typedef struct _NoisePluginsCDPlayer NoisePluginsCDPlayer;
typedef struct _NoisePluginsCDPlayerClass NoisePluginsCDPlayerClass;
typedef struct _NoisePluginsCDPlayerPrivate NoisePluginsCDPlayerPrivate;
enum  {
	NOISE_PLUGINS_CD_PLAYER_0_PROPERTY,
	NOISE_PLUGINS_CD_PLAYER_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_cd_player_properties[NOISE_PLUGINS_CD_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))

struct _NoisePluginsCDPlayer {
	GObject parent_instance;
	NoisePluginsCDPlayerPrivate * priv;
	NoisePipeline* pipe;
	GstElement* playbin2;
	gboolean first_start;
};

struct _NoisePluginsCDPlayerClass {
	GObjectClass parent_class;
};

struct _NoisePluginsCDPlayerPrivate {
	NoiseInstallGstreamerPluginsDialog* dialog;
	gchar* device;
	gdouble volume;
};


static gpointer noise_plugins_cd_player_parent_class = NULL;
static NoisePlaybackIface * noise_plugins_cd_player_noise_playback_parent_iface = NULL;
static GType noise_plugins_cd_player_type_id = 0;

GType noise_plugins_cd_player_get_type (void) G_GNUC_CONST;
#define NOISE_PLUGINS_CD_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayerPrivate))
NoisePluginsCDPlayer* noise_plugins_cd_player_new (GMount* mount);
NoisePluginsCDPlayer* noise_plugins_cd_player_construct (GType object_type, GMount* mount);
gboolean noise_plugins_cd_player_initialize (NoisePluginsCDPlayer* self);
void noise_plugins_cd_player_pipe_source_setup (NoisePluginsCDPlayer* self, GstElement* playbin, GstElement* source);
static void _noise_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_ (GstElement* _sender, GstElement* source, gpointer self);
gulong _dynamic_source_setup1_connect (gpointer obj, const char * signal_name, GCallback handler, gpointer data);
static gboolean noise_plugins_cd_player_bus_callback (NoisePluginsCDPlayer* self, GstBus* bus, GstMessage* message);
static gboolean _noise_plugins_cd_player_bus_callback_gst_bus_func (GstBus* bus, GstMessage* message, gpointer self);
static gboolean _noise_playback_update_position_gsource_func (gpointer self);
static GeeCollection* noise_plugins_cd_player_real_get_supported_uri (NoisePlayback* base);
static gboolean noise_plugins_cd_player_real_update_position (NoisePlayback* base);
static void noise_plugins_cd_player_real_play (NoisePlayback* base);
static void noise_plugins_cd_player_real_pause (NoisePlayback* base);
static void noise_plugins_cd_player_real_set_state (NoisePlayback* base, GstState s);
static void noise_plugins_cd_player_real_set_media (NoisePlayback* base, NoiseMedia* media);
static void noise_plugins_cd_player_real_set_position (NoisePlayback* base, gint64 pos);
static gint64 noise_plugins_cd_player_real_get_position (NoisePlayback* base);
static gint64 noise_plugins_cd_player_real_get_duration (NoisePlayback* base);
static void noise_plugins_cd_player_real_set_volume (NoisePlayback* base, gdouble val);
static gdouble noise_plugins_cd_player_real_get_volume (NoisePlayback* base);
static void noise_plugins_cd_player_real_enable_equalizer (NoisePlayback* base);
static void noise_plugins_cd_player_real_disable_equalizer (NoisePlayback* base);
static void noise_plugins_cd_player_real_set_equalizer_gain (NoisePlayback* base, gint index, gint val);
static void noise_plugins_cd_player_finalize (GObject * obj);


NoisePluginsCDPlayer* noise_plugins_cd_player_construct (GType object_type, GMount* mount) {
	NoisePluginsCDPlayer * self = NULL;
	GMount* _tmp0_;
	GVolume* _tmp1_;
	GVolume* _tmp2_;
	gchar* _tmp3_;
#line 40 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 40 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) g_object_new (object_type, NULL);
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = mount;
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = g_mount_get_volume (_tmp0_);
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = _tmp1_;
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp3_ = g_volume_get_identifier (_tmp2_, G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE);
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_g_free0 (self->priv->device);
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self->priv->device = _tmp3_;
#line 42 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_g_object_unref0 (_tmp2_);
#line 43 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_plugins_cd_player_initialize (self);
#line 40 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return self;
#line 147 "CDPlayer.c"
}


NoisePluginsCDPlayer* noise_plugins_cd_player_new (GMount* mount) {
#line 40 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return noise_plugins_cd_player_construct (NOISE_PLUGINS_TYPE_CD_PLAYER, mount);
#line 154 "CDPlayer.c"
}


static void _noise_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_ (GstElement* _sender, GstElement* source, gpointer self) {
#line 51 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_plugins_cd_player_pipe_source_setup ((NoisePluginsCDPlayer*) self, _sender, source);
#line 161 "CDPlayer.c"
}


gulong _dynamic_source_setup1_connect (gpointer obj, const char * signal_name, GCallback handler, gpointer data) {
#line 51 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return g_signal_connect_object (obj, signal_name, handler, data, 0);
#line 168 "CDPlayer.c"
}


static gboolean _noise_plugins_cd_player_bus_callback_gst_bus_func (GstBus* bus, GstMessage* message, gpointer self) {
	gboolean result;
	result = noise_plugins_cd_player_bus_callback ((NoisePluginsCDPlayer*) self, bus, message);
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 177 "CDPlayer.c"
}


static gboolean _noise_playback_update_position_gsource_func (gpointer self) {
	gboolean result;
	result = noise_playback_update_position ((NoisePlayback*) self);
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 186 "CDPlayer.c"
}


gboolean noise_plugins_cd_player_initialize (NoisePluginsCDPlayer* self) {
	gboolean result = FALSE;
	NoisePipeline* _tmp0_;
	NoisePipeline* _tmp1_;
	GstElement* _tmp2_;
	GstElement* _tmp3_;
	NoisePipeline* _tmp4_;
	GstElement* _tmp5_;
	NoisePipeline* _tmp6_;
	GstBus* _tmp7_;
	NoisePipeline* _tmp8_;
	GstBus* _tmp9_;
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = noise_pipeline_new ();
#line 48 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_g_object_unref0 (self->pipe);
#line 48 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self->pipe = _tmp0_;
#line 50 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = self->pipe;
#line 50 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = _tmp1_->playbin;
#line 50 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self->playbin2 = _tmp2_;
#line 51 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp3_ = self->playbin2;
#line 51 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_dynamic_source_setup1_connect (_tmp3_, "source-setup", (GCallback) _noise_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_, self);
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp4_ = self->pipe;
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp5_ = _tmp4_->playbin;
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_object_set ((GObject*) _tmp5_, "uri", "cdda://1", NULL);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp6_ = self->pipe;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp7_ = _tmp6_->bus;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	gst_bus_add_signal_watch_full (_tmp7_, G_PRIORITY_DEFAULT);
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp8_ = self->pipe;
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp9_ = _tmp8_->bus;
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	gst_bus_add_watch_full (_tmp9_, G_PRIORITY_DEFAULT, _noise_plugins_cd_player_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _noise_playback_update_position_gsource_func, g_object_ref ((NoisePlayback*) self), g_object_unref);
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	result = TRUE;
#line 58 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 244 "CDPlayer.c"
}


void noise_plugins_cd_player_pipe_source_setup (NoisePluginsCDPlayer* self, GstElement* playbin, GstElement* source) {
	GstElement* _tmp0_;
	const gchar* _tmp1_;
	GstElement* _tmp2_;
	GObjectClass* _tmp3_;
	GParamSpec* _tmp4_;
	GstElement* _tmp6_;
	GObjectClass* _tmp7_;
	GParamSpec* _tmp8_;
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_return_if_fail (self != NULL);
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_return_if_fail (playbin != NULL);
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_return_if_fail (source != NULL);
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = source;
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = self->priv->device;
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_object_set ((GObject*) _tmp0_, "device", _tmp1_, NULL);
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = source;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp3_ = G_OBJECT_GET_CLASS ((GObject*) _tmp2_);
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp4_ = g_object_class_find_property (_tmp3_, "paranoia-mode");
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	if (_tmp4_ != NULL) {
#line 277 "CDPlayer.c"
		GstElement* _tmp5_;
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp5_ = source;
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		g_object_set ((GObject*) _tmp5_, "paranoia-mode", 0, NULL);
#line 283 "CDPlayer.c"
	}
#line 67 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp6_ = source;
#line 67 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp7_ = G_OBJECT_GET_CLASS ((GObject*) _tmp6_);
#line 67 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp8_ = g_object_class_find_property (_tmp7_, "read-speed");
#line 67 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	if (_tmp8_ != NULL) {
#line 293 "CDPlayer.c"
		GstElement* _tmp9_;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp9_ = source;
#line 68 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		g_object_set ((GObject*) _tmp9_, "read-speed", 2, NULL);
#line 299 "CDPlayer.c"
	}
}


static GeeCollection* noise_plugins_cd_player_real_get_supported_uri (NoisePlayback* base) {
	NoisePluginsCDPlayer * self;
	GeeCollection* result = NULL;
	GeeLinkedList* uris = NULL;
	GeeLinkedList* _tmp0_;
#line 71 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 72 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	uris = _tmp0_;
#line 73 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "cdda://");
#line 74 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	result = (GeeCollection*) uris;
#line 74 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 321 "CDPlayer.c"
}


static gboolean noise_plugins_cd_player_real_update_position (NoisePlayback* base) {
	NoisePluginsCDPlayer * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 77 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = self->first_start;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	if (_tmp1_) {
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp0_ = TRUE;
#line 338 "CDPlayer.c"
	} else {
		gboolean _tmp2_ = FALSE;
		NoisePlaybackManager* _tmp3_;
		NoisePlaybackManager* _tmp4_;
		NoiseMedia* _tmp5_;
		NoiseMedia* _tmp6_;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp3_ = noise_app_get_player ();
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp4_ = _tmp3_;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp5_ = noise_playback_manager_get_current_media (_tmp4_);
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp6_ = _tmp5_;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		if (_tmp6_ != NULL) {
#line 355 "CDPlayer.c"
			gint64 _tmp7_;
			NoisePlaybackManager* _tmp8_;
			NoisePlaybackManager* _tmp9_;
			NoiseMedia* _tmp10_;
			NoiseMedia* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp7_ = noise_playback_get_position ((NoisePlayback*) self);
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp8_ = noise_app_get_player ();
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp9_ = _tmp8_;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp10_ = noise_playback_manager_get_current_media (_tmp9_);
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp11_ = _tmp10_;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp12_ = noise_media_get_resume_pos (_tmp11_);
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp13_ = _tmp12_;
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp2_ = _tmp7_ >= (((gint64) (_tmp13_ - 1)) * 1000000000);
#line 379 "CDPlayer.c"
		} else {
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp2_ = FALSE;
#line 383 "CDPlayer.c"
		}
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp0_ = _tmp2_;
#line 387 "CDPlayer.c"
	}
#line 78 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	if (_tmp0_) {
#line 391 "CDPlayer.c"
		gint64 _tmp14_;
#line 79 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		self->first_start = FALSE;
#line 80 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp14_ = noise_playback_get_position ((NoisePlayback*) self);
#line 80 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		g_signal_emit_by_name ((NoisePlayback*) self, "current-position-update", _tmp14_);
#line 399 "CDPlayer.c"
	} else {
		NoisePlaybackManager* _tmp15_;
		NoisePlaybackManager* _tmp16_;
		NoiseMedia* _tmp17_;
		NoiseMedia* _tmp18_;
#line 81 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp15_ = noise_app_get_player ();
#line 81 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp16_ = _tmp15_;
#line 81 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp17_ = noise_playback_manager_get_current_media (_tmp16_);
#line 81 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		_tmp18_ = _tmp17_;
#line 81 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		if (_tmp18_ != NULL) {
#line 415 "CDPlayer.c"
			NoisePipeline* _tmp19_;
			GstElement* _tmp20_;
			NoisePlaybackManager* _tmp21_;
			NoisePlaybackManager* _tmp22_;
			NoiseMedia* _tmp23_;
			NoiseMedia* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp19_ = self->pipe;
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp20_ = _tmp19_->playbin;
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp21_ = noise_app_get_player ();
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp22_ = _tmp21_;
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp23_ = noise_playback_manager_get_current_media (_tmp22_);
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp24_ = _tmp23_;
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp25_ = noise_media_get_resume_pos (_tmp24_);
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp26_ = _tmp25_;
#line 82 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			gst_element_seek_simple (_tmp20_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp26_) * 1000000000);
#line 442 "CDPlayer.c"
		}
	}
#line 85 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	result = TRUE;
#line 85 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 449 "CDPlayer.c"
}


static void noise_plugins_cd_player_real_play (NoisePlayback* base) {
	NoisePluginsCDPlayer * self;
#line 89 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 90 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PLAYING);
#line 459 "CDPlayer.c"
}


static void noise_plugins_cd_player_real_pause (NoisePlayback* base) {
	NoisePluginsCDPlayer * self;
#line 93 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 94 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PAUSED);
#line 469 "CDPlayer.c"
}


static void noise_plugins_cd_player_real_set_state (NoisePlayback* base, GstState s) {
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	GstState _tmp2_;
#line 97 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 98 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 98 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 98 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = s;
#line 98 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	gst_element_set_state (_tmp1_, _tmp2_);
#line 488 "CDPlayer.c"
}


static void noise_plugins_cd_player_real_set_media (NoisePlayback* base, NoiseMedia* media) {
	NoisePluginsCDPlayer * self;
	NoiseMedia* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	NoisePipeline* _tmp3_;
	GstElement* _tmp4_;
	NoiseMedia* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	NoisePlaybackManager* _tmp10_;
	NoisePlaybackManager* _tmp11_;
	NoiseMedia* _tmp12_;
	NoiseMedia* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	NoisePipeline* _tmp16_;
	GstElement* _tmp17_;
	NoisePlaybackManager* _tmp18_;
	NoisePlaybackManager* _tmp19_;
	NoiseMedia* _tmp20_;
	NoiseMedia* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
#line 101 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 101 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_return_if_fail (media != NULL);
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_READY);
#line 103 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = media;
#line 103 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = noise_media_get_track (_tmp0_);
#line 103 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = _tmp1_;
#line 103 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_debug ("CDPlayer.vala:103: set track number to %u\n", _tmp2_);
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp3_ = self->pipe;
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp4_ = _tmp3_->playbin;
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp5_ = media;
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp6_ = noise_media_get_track (_tmp5_);
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp7_ = _tmp6_;
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp8_ = g_strdup_printf ("cdda://%u", _tmp7_);
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp9_ = _tmp8_;
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_object_set ((GObject*) _tmp4_, "uri", _tmp9_, NULL);
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_g_free0 (_tmp9_);
#line 106 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PLAYING);
#line 108 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp10_ = noise_app_get_player ();
#line 108 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp11_ = _tmp10_;
#line 108 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp12_ = noise_playback_manager_get_current_media (_tmp11_);
#line 108 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp13_ = _tmp12_;
#line 108 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp14_ = noise_media_get_resume_pos (_tmp13_);
#line 108 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp15_ = _tmp14_;
#line 108 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_debug ("CDPlayer.vala:108: setURI seeking to %d\n", _tmp15_);
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp16_ = self->pipe;
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp17_ = _tmp16_->playbin;
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp18_ = noise_app_get_player ();
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp19_ = _tmp18_;
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp20_ = noise_playback_manager_get_current_media (_tmp19_);
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp21_ = _tmp20_;
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp22_ = noise_media_get_resume_pos (_tmp21_);
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp23_ = _tmp22_;
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	gst_element_seek_simple (_tmp17_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp23_) * 1000000000);
#line 111 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_playback_play ((NoisePlayback*) self);
#line 586 "CDPlayer.c"
}


static void noise_plugins_cd_player_real_set_position (NoisePlayback* base, gint64 pos) {
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
#line 114 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = pos;
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp3_ = noise_playback_get_duration ((NoisePlayback*) self);
#line 115 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	gst_element_seek (_tmp1_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, _tmp2_, GST_SEEK_TYPE_NONE, _tmp3_);
#line 608 "CDPlayer.c"
}


static gint64 noise_plugins_cd_player_real_get_position (NoisePlayback* base) {
	NoisePluginsCDPlayer * self;
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
#line 121 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 122 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	rv = (gint64) 0;
#line 123 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	f = GST_FORMAT_TIME;
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	gst_element_query_position (_tmp1_, f, &_tmp2_);
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	rv = _tmp2_;
#line 127 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	result = rv;
#line 127 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 638 "CDPlayer.c"
}


static gint64 noise_plugins_cd_player_real_get_duration (NoisePlayback* base) {
	NoisePluginsCDPlayer * self;
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
#line 130 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 131 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	rv = (gint64) 0;
#line 132 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	f = GST_FORMAT_TIME;
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	gst_element_query_duration (_tmp1_, f, &_tmp2_);
#line 134 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	rv = _tmp2_;
#line 136 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	result = rv;
#line 136 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 668 "CDPlayer.c"
}


static void noise_plugins_cd_player_real_set_volume (NoisePlayback* base, gdouble val) {
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 139 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = val;
#line 140 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_object_set ((GObject*) _tmp1_, "volume", _tmp2_, NULL);
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp3_ = val;
#line 141 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self->priv->volume = _tmp3_;
#line 692 "CDPlayer.c"
}


static gdouble noise_plugins_cd_player_real_get_volume (NoisePlayback* base) {
	NoisePluginsCDPlayer * self;
	gdouble result = 0.0;
	gdouble _tmp0_;
#line 144 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 148 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->priv->volume;
#line 148 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	result = _tmp0_;
#line 148 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 708 "CDPlayer.c"
}


static void noise_plugins_cd_player_real_enable_equalizer (NoisePlayback* base) {
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
#line 152 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 153 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 153 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_pipeline_enableEqualizer (_tmp0_);
#line 721 "CDPlayer.c"
}


static void noise_plugins_cd_player_real_disable_equalizer (NoisePlayback* base) {
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
#line 156 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 157 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 157 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_pipeline_disableEqualizer (_tmp0_);
#line 734 "CDPlayer.c"
}


static void noise_plugins_cd_player_real_set_equalizer_gain (NoisePlayback* base, gint index, gint val) {
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	NoiseEqualizer* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 160 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->eq;
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = index;
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp3_ = val;
#line 161 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_equalizer_setGain (_tmp1_, _tmp2_, (gdouble) _tmp3_);
#line 756 "CDPlayer.c"
}


static gboolean noise_plugins_cd_player_bus_callback (NoisePluginsCDPlayer* self, GstBus* bus, GstMessage* message) {
	gboolean result = FALSE;
	GstMessage* _tmp0_;
	GstMessageType _tmp1_;
#line 165 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 165 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = message;
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->type;
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	switch (_tmp1_) {
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		case GST_MESSAGE_ERROR:
#line 778 "CDPlayer.c"
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GstMessage* _tmp2_;
			GError* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
			GError* _tmp5_;
			const gchar* _tmp6_;
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp2_ = message;
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			gst_message_parse_error (_tmp2_, &_tmp3_, &_tmp4_);
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_g_error_free0 (err);
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			err = _tmp3_;
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_g_free0 (debug);
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			debug = _tmp4_;
#line 171 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp5_ = err;
#line 171 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp6_ = _tmp5_->message;
#line 171 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			g_warning ("CDPlayer.vala:171: Error: %s\n", _tmp6_);
#line 172 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			g_signal_emit_by_name ((NoisePlayback*) self, "error-occured");
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_g_free0 (debug);
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_g_error_free0 (err);
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 813 "CDPlayer.c"
		}
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		case GST_MESSAGE_ELEMENT:
#line 817 "CDPlayer.c"
		{
			gboolean _tmp7_ = FALSE;
			gboolean _tmp8_ = FALSE;
			GstMessage* _tmp9_;
			GstStructure* _tmp10_;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp9_ = message;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp10_ = gst_message_get_structure (_tmp9_);
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			if (_tmp10_ != NULL) {
#line 829 "CDPlayer.c"
				GstMessage* _tmp11_;
				gboolean _tmp12_;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp11_ = message;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp12_ = gst_is_missing_plugin_message (_tmp11_);
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp8_ = _tmp12_;
#line 838 "CDPlayer.c"
			} else {
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp8_ = FALSE;
#line 842 "CDPlayer.c"
			}
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			if (_tmp8_) {
#line 846 "CDPlayer.c"
				gboolean _tmp13_ = FALSE;
				NoiseInstallGstreamerPluginsDialog* _tmp14_;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp14_ = self->priv->dialog;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				if (_tmp14_ == NULL) {
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp13_ = TRUE;
#line 855 "CDPlayer.c"
				} else {
					NoiseInstallGstreamerPluginsDialog* _tmp15_;
					gboolean _tmp16_;
					gboolean _tmp17_;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp15_ = self->priv->dialog;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp16_ = gtk_widget_get_visible ((GtkWidget*) _tmp15_);
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp17_ = _tmp16_;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp13_ = !_tmp17_;
#line 868 "CDPlayer.c"
				}
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp7_ = _tmp13_;
#line 872 "CDPlayer.c"
			} else {
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp7_ = FALSE;
#line 876 "CDPlayer.c"
			}
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			if (_tmp7_) {
#line 880 "CDPlayer.c"
				GstMessage* _tmp18_;
				NoiseInstallGstreamerPluginsDialog* _tmp19_;
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp18_ = message;
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp19_ = noise_install_gstreamer_plugins_dialog_new (_tmp18_);
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				g_object_ref_sink (_tmp19_);
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_g_object_unref0 (self->priv->dialog);
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				self->priv->dialog = _tmp19_;
#line 893 "CDPlayer.c"
			}
#line 178 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 897 "CDPlayer.c"
		}
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		case GST_MESSAGE_EOS:
#line 901 "CDPlayer.c"
		{
#line 180 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			g_signal_emit_by_name ((NoisePlayback*) self, "end-of-stream");
#line 181 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 907 "CDPlayer.c"
		}
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 911 "CDPlayer.c"
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstMessage* _tmp20_;
			GstState _tmp21_ = 0;
			GstState _tmp22_ = 0;
			GstState _tmp23_ = 0;
			GstState _tmp24_;
#line 186 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp20_ = message;
#line 186 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			gst_message_parse_state_changed (_tmp20_, &_tmp21_, &_tmp22_, &_tmp23_);
#line 186 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			oldstate = _tmp21_;
#line 186 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			newstate = _tmp22_;
#line 186 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			pending = _tmp23_;
#line 189 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp24_ = newstate;
#line 189 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			if (_tmp24_ != GST_STATE_PLAYING) {
#line 190 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				break;
#line 937 "CDPlayer.c"
			}
#line 192 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 941 "CDPlayer.c"
		}
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
		case GST_MESSAGE_TAG:
#line 945 "CDPlayer.c"
		{
			GstTagList* tag_list = NULL;
			GstMessage* _tmp25_;
			GstTagList* _tmp26_ = NULL;
			GstTagList* _tmp27_;
#line 196 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp25_ = message;
#line 196 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			gst_message_parse_tag (_tmp25_, &_tmp26_);
#line 196 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_gst_tag_list_unref0 (tag_list);
#line 196 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			tag_list = _tmp26_;
#line 197 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_tmp27_ = tag_list;
#line 197 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			if (_tmp27_ != NULL) {
#line 963 "CDPlayer.c"
				GstTagList* _tmp28_;
				guint _tmp29_;
#line 198 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp28_ = tag_list;
#line 198 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				_tmp29_ = gst_tag_list_get_tag_size (_tmp28_, GST_TAG_TITLE);
#line 198 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
				if (_tmp29_ > ((guint) 0)) {
#line 972 "CDPlayer.c"
					gchar* title = NULL;
					gchar* _tmp30_;
					GstTagList* _tmp31_;
					gchar* _tmp32_ = NULL;
					NoiseNotificationManager* _tmp33_;
					NoiseNotificationManager* _tmp34_;
					NoisePlaybackManager* _tmp35_;
					NoisePlaybackManager* _tmp36_;
					NoiseMedia* _tmp37_;
					NoiseMedia* _tmp38_;
					const gchar* _tmp39_;
					const gchar* _tmp40_;
					gchar* _tmp41_;
					gchar* _tmp42_;
					const gchar* _tmp43_;
					gchar* _tmp44_;
					gchar* _tmp45_;
#line 199 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp30_ = g_strdup ("");
#line 199 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					title = _tmp30_;
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp31_ = tag_list;
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					gst_tag_list_get_string (_tmp31_, GST_TAG_TITLE, &_tmp32_);
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_g_free0 (title);
#line 200 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					title = _tmp32_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp33_ = noise_notification_manager_get_default ();
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp34_ = _tmp33_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp35_ = noise_app_get_player ();
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp36_ = _tmp35_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp37_ = noise_playback_manager_get_current_media (_tmp36_);
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp38_ = _tmp37_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp39_ = noise_media_get_album_artist (_tmp38_);
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp40_ = _tmp39_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp41_ = g_strconcat (_tmp40_, "\n", NULL);
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp42_ = _tmp41_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp43_ = title;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp44_ = g_strconcat (_tmp42_, _tmp43_, NULL);
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_tmp45_ = _tmp44_;
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					g_signal_emit_by_name (_tmp34_, "update-track", _tmp45_);
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_g_free0 (_tmp45_);
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_g_free0 (_tmp42_);
#line 201 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_g_object_unref0 (_tmp34_);
#line 198 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
					_g_free0 (title);
#line 1038 "CDPlayer.c"
				}
			}
#line 204 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			_gst_tag_list_unref0 (tag_list);
#line 204 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 1045 "CDPlayer.c"
		}
		default:
		{
#line 206 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 1051 "CDPlayer.c"
		}
	}
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	result = TRUE;
#line 209 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 1058 "CDPlayer.c"
}


static void noise_plugins_cd_player_class_init (NoisePluginsCDPlayerClass * klass) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_plugins_cd_player_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	g_type_class_add_private (klass, sizeof (NoisePluginsCDPlayerPrivate));
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_cd_player_finalize;
#line 1069 "CDPlayer.c"
}


static void noise_plugins_cd_player_noise_playback_interface_init (NoisePlaybackIface * iface) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	noise_plugins_cd_player_noise_playback_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->get_supported_uri = (GeeCollection* (*) (NoisePlayback *)) noise_plugins_cd_player_real_get_supported_uri;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->update_position = (gboolean (*) (NoisePlayback *)) noise_plugins_cd_player_real_update_position;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->play = (void (*) (NoisePlayback *)) noise_plugins_cd_player_real_play;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->pause = (void (*) (NoisePlayback *)) noise_plugins_cd_player_real_pause;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->set_state = (void (*) (NoisePlayback *, GstState)) noise_plugins_cd_player_real_set_state;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->set_media = (void (*) (NoisePlayback *, NoiseMedia*)) noise_plugins_cd_player_real_set_media;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->set_position = (void (*) (NoisePlayback *, gint64)) noise_plugins_cd_player_real_set_position;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->get_position = (gint64 (*) (NoisePlayback *)) noise_plugins_cd_player_real_get_position;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->get_duration = (gint64 (*) (NoisePlayback *)) noise_plugins_cd_player_real_get_duration;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->set_volume = (void (*) (NoisePlayback *, gdouble)) noise_plugins_cd_player_real_set_volume;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->get_volume = (gdouble (*) (NoisePlayback *)) noise_plugins_cd_player_real_get_volume;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->enable_equalizer = (void (*) (NoisePlayback *)) noise_plugins_cd_player_real_enable_equalizer;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->disable_equalizer = (void (*) (NoisePlayback *)) noise_plugins_cd_player_real_disable_equalizer;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	iface->set_equalizer_gain = (void (*) (NoisePlayback *, gint, gint)) noise_plugins_cd_player_real_set_equalizer_gain;
#line 1104 "CDPlayer.c"
}


static void noise_plugins_cd_player_instance_init (NoisePluginsCDPlayer * self) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self->priv = NOISE_PLUGINS_CD_PLAYER_GET_PRIVATE (self);
#line 37 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self->first_start = TRUE;
#line 38 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self->priv->volume = (gdouble) 1;
#line 1115 "CDPlayer.c"
}


static void noise_plugins_cd_player_finalize (GObject * obj) {
	NoisePluginsCDPlayer * self;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayer);
#line 31 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_g_object_unref0 (self->priv->dialog);
#line 33 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_g_free0 (self->priv->device);
#line 35 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	_g_object_unref0 (self->pipe);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDPlayer.vala"
	G_OBJECT_CLASS (noise_plugins_cd_player_parent_class)->finalize (obj);
#line 1131 "CDPlayer.c"
}


GType noise_plugins_cd_player_get_type (void) {
	return noise_plugins_cd_player_type_id;
}


GType noise_plugins_cd_player_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsCDPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_cd_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsCDPlayer), 0, (GInstanceInitFunc) noise_plugins_cd_player_instance_init, NULL };
	static const GInterfaceInfo noise_playback_info = { (GInterfaceInitFunc) noise_plugins_cd_player_noise_playback_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	noise_plugins_cd_player_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoisePluginsCDPlayer", &g_define_type_info, 0);
	g_type_module_add_interface (module, noise_plugins_cd_player_type_id, NOISE_TYPE_PLAYBACK, &noise_playback_info);
	return noise_plugins_cd_player_type_id;
}



