/* CDRipper.c generated by valac 0.38.10, the Vala compiler
 * generated from CDRipper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gst/gst.h>
#include <noise-core.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>


#define NOISE_TYPE_CD_RIPPER (noise_cd_ripper_get_type ())
#define NOISE_CD_RIPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_CD_RIPPER, NoiseCDRipper))
#define NOISE_CD_RIPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_CD_RIPPER, NoiseCDRipperClass))
#define NOISE_IS_CD_RIPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_CD_RIPPER))
#define NOISE_IS_CD_RIPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_CD_RIPPER))
#define NOISE_CD_RIPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_CD_RIPPER, NoiseCDRipperClass))

typedef struct _NoiseCDRipper NoiseCDRipper;
typedef struct _NoiseCDRipperClass NoiseCDRipperClass;
typedef struct _NoiseCDRipperPrivate NoiseCDRipperPrivate;
enum  {
	NOISE_CD_RIPPER_0_PROPERTY,
	NOISE_CD_RIPPER_NUM_PROPERTIES
};
static GParamSpec* noise_cd_ripper_properties[NOISE_CD_RIPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	NOISE_CD_RIPPER_MEDIA_RIPPED_SIGNAL,
	NOISE_CD_RIPPER_PROGRESS_NOTIFICATION_SIGNAL,
	NOISE_CD_RIPPER_ERROR_SIGNAL,
	NOISE_CD_RIPPER_NUM_SIGNALS
};
static guint noise_cd_ripper_signals[NOISE_CD_RIPPER_NUM_SIGNALS] = {0};

struct _NoiseCDRipper {
	GObject parent_instance;
	NoiseCDRipperPrivate * priv;
	GstPipeline* pipeline;
	GstElement* src;
	GstElement* queue;
	GstElement* filter;
	GstElement* sink;
	gint track_count;
	gint track_index;
};

struct _NoiseCDRipperClass {
	GObjectClass parent_class;
};

struct _NoiseCDRipperPrivate {
	NoiseMedia* current_media;
	gchar* _device;
	GstFormat _format;
};


static gpointer noise_cd_ripper_parent_class = NULL;
static GType noise_cd_ripper_type_id = 0;

GType noise_cd_ripper_get_type (void) G_GNUC_CONST;
#define NOISE_CD_RIPPER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_CD_RIPPER, NoiseCDRipperPrivate))
NoiseCDRipper* noise_cd_ripper_new (GMount* mount, gint count);
NoiseCDRipper* noise_cd_ripper_construct (GType object_type, GMount* mount, gint count);
gboolean noise_cd_ripper_initialize (NoiseCDRipper* self);
static gboolean noise_cd_ripper_bus_callback (NoiseCDRipper* self, GstBus* bus, GstMessage* message);
static gboolean _noise_cd_ripper_bus_callback_gst_bus_func (GstBus* bus, GstMessage* message, gpointer self);
gboolean noise_cd_ripper_do_position_update (NoiseCDRipper* self);
static gboolean _noise_cd_ripper_do_position_update_gsource_func (gpointer self);
gint64 noise_cd_ripper_get_position (NoiseCDRipper* self);
gint64 noise_cd_ripper_get_duration (NoiseCDRipper* self);
static inline const gchar* _dynamic_get_location0 (GstElement* obj);
void noise_cd_ripper_rip_media (NoiseCDRipper* self, guint track, NoiseMedia* s);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void noise_cd_ripper_finalize (GObject * obj);


NoiseCDRipper* noise_cd_ripper_construct (GType object_type, GMount* mount, gint count) {
	NoiseCDRipper * self = NULL;
	GMount* _tmp0_;
	GVolume* _tmp1_;
	GVolume* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self = (NoiseCDRipper*) g_object_new (object_type, NULL);
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = mount;
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp1_ = g_mount_get_volume (_tmp0_);
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp2_ = _tmp1_;
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp3_ = g_volume_get_identifier (_tmp2_, G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE);
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_free0 (self->priv->_device);
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self->priv->_device = _tmp3_;
#line 47 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (_tmp2_);
#line 48 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp4_ = count;
#line 48 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self->track_count = _tmp4_;
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	return self;
#line 145 "CDRipper.c"
}


NoiseCDRipper* noise_cd_ripper_new (GMount* mount, gint count) {
#line 46 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	return noise_cd_ripper_construct (NOISE_TYPE_CD_RIPPER, mount, count);
#line 152 "CDRipper.c"
}


static gboolean _noise_cd_ripper_bus_callback_gst_bus_func (GstBus* bus, GstMessage* message, gpointer self) {
	gboolean result;
	result = noise_cd_ripper_bus_callback ((NoiseCDRipper*) self, bus, message);
#line 89 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 161 "CDRipper.c"
}


static gboolean _noise_cd_ripper_do_position_update_gsource_func (gpointer self) {
	gboolean result;
	result = noise_cd_ripper_do_position_update ((NoiseCDRipper*) self);
#line 91 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 170 "CDRipper.c"
}


gboolean noise_cd_ripper_initialize (NoiseCDRipper* self) {
	gboolean result = FALSE;
	GstPipeline* _tmp0_;
	GstElement* src = NULL;
	GstElement* _tmp7_;
	const gchar* _tmp8_;
	GValue _tmp9_ = {0};
	GstElement* _tmp10_;
	GstElement* _tmp11_;
	GstElement* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GstElement* _tmp16_;
	GstElement* _tmp20_;
	GObjectClass* _tmp21_;
	GParamSpec* _tmp22_;
	GstElement* _tmp25_;
	GObjectClass* _tmp26_;
	GParamSpec* _tmp27_;
	GstElement* _tmp30_;
	GstFormat _tmp31_;
	GstPipeline* _tmp32_;
	GstElement* _tmp33_;
	GstElement* _tmp34_;
	GstElement* _tmp35_;
	GstElement* _tmp36_;
	GstElement* _tmp37_;
	GstElement* _tmp38_;
	GstElement* _tmp39_;
	GstElement* _tmp40_;
	gboolean _tmp41_;
	GstPipeline* _tmp42_;
	GstBus* _tmp43_;
	GError * _inner_error_ = NULL;
#line 51 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = (GstPipeline*) gst_pipeline_new ("pipeline");
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_object_ref_sink (_tmp0_);
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->pipeline);
#line 52 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self->pipeline = _tmp0_;
#line 53 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	src = NULL;
#line 221 "CDRipper.c"
	{
		GstElement* _tmp1_ = NULL;
		GstElement* _tmp2_;
		GstElement* _tmp3_;
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp2_ = gst_element_make_from_uri (GST_URI_SRC, "cdda://", NULL, &_inner_error_);
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		if (_tmp2_ != NULL) {
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			g_object_ref_sink (_tmp2_);
#line 232 "CDRipper.c"
		}
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp1_ = _tmp2_;
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 238 "CDRipper.c"
			goto __catch4_g_error;
		}
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp3_ = _tmp1_;
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp1_ = NULL;
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		if (_tmp3_ != NULL) {
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			g_object_ref_sink (_tmp3_);
#line 249 "CDRipper.c"
		}
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (src);
#line 55 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		src = _tmp3_;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (_tmp1_);
#line 257 "CDRipper.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		e = _inner_error_;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_inner_error_ = NULL;
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp4_ = e;
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp5_ = _tmp4_->message;
#line 57 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_warning ("CDRipper.vala:57: %s", _tmp5_);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_g_error_free0 (e);
#line 277 "CDRipper.c"
	}
	__finally4:
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 282 "CDRipper.c"
		gboolean _tmp6_ = FALSE;
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (src);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_clear_error (&_inner_error_);
#line 54 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		return _tmp6_;
#line 292 "CDRipper.c"
	}
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp7_ = src;
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp8_ = self->priv->_device;
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_value_init (&_tmp9_, G_TYPE_STRING);
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_value_set_string (&_tmp9_, _tmp8_);
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_object_set_property ((GObject*) _tmp7_, "device", &_tmp9_);
#line 59 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 60 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp10_ = gst_element_factory_make ("queue", "queue");
#line 60 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp10_ != NULL) {
#line 60 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_object_ref_sink (_tmp10_);
#line 312 "CDRipper.c"
	}
#line 60 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->queue);
#line 60 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self->queue = _tmp10_;
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp11_ = gst_element_factory_make ("lamemp3enc", "lamemp3enc");
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp11_ != NULL) {
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_object_ref_sink (_tmp11_);
#line 324 "CDRipper.c"
	}
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->filter);
#line 61 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self->filter = _tmp11_;
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp12_ = gst_element_factory_make ("filesink", "filesink");
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp12_ != NULL) {
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_object_ref_sink (_tmp12_);
#line 336 "CDRipper.c"
	}
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->sink);
#line 62 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self->sink = _tmp12_;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp16_ = src;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp16_ == NULL) {
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp15_ = TRUE;
#line 348 "CDRipper.c"
	} else {
		GstElement* _tmp17_;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp17_ = self->queue;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp15_ = _tmp17_ == NULL;
#line 355 "CDRipper.c"
	}
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp15_) {
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp14_ = TRUE;
#line 361 "CDRipper.c"
	} else {
		GstElement* _tmp18_;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp18_ = self->filter;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp14_ = _tmp18_ == NULL;
#line 368 "CDRipper.c"
	}
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp14_) {
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp13_ = TRUE;
#line 374 "CDRipper.c"
	} else {
		GstElement* _tmp19_;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp19_ = self->sink;
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp13_ = _tmp19_ == NULL;
#line 381 "CDRipper.c"
	}
#line 64 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp13_) {
#line 65 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_critical ("CDRipper.vala:65: Could not create GST Elements for ripping.\n");
#line 66 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		result = FALSE;
#line 66 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (src);
#line 66 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		return result;
#line 393 "CDRipper.c"
	}
#line 69 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp20_ = src;
#line 69 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp21_ = G_OBJECT_GET_CLASS ((GObject*) _tmp20_);
#line 69 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp22_ = g_object_class_find_property (_tmp21_, "paranoia-mode");
#line 69 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp22_ != NULL) {
#line 403 "CDRipper.c"
		GstElement* _tmp23_;
		GValue _tmp24_ = {0};
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp23_ = src;
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_value_init (&_tmp24_, G_TYPE_INT);
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_value_set_int (&_tmp24_, 0xff);
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_object_set_property ((GObject*) _tmp23_, "paranoia-mode", &_tmp24_);
#line 70 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		G_IS_VALUE (&_tmp24_) ? (g_value_unset (&_tmp24_), NULL) : NULL;
#line 416 "CDRipper.c"
	}
#line 75 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp25_ = src;
#line 75 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp26_ = G_OBJECT_GET_CLASS ((GObject*) _tmp25_);
#line 75 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp27_ = g_object_class_find_property (_tmp26_, "read-speed");
#line 75 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp27_ != NULL) {
#line 426 "CDRipper.c"
		GstElement* _tmp28_;
		GValue _tmp29_ = {0};
#line 76 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp28_ = src;
#line 76 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_value_init (&_tmp29_, G_TYPE_INT);
#line 76 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_value_set_int (&_tmp29_, 0xffff);
#line 76 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_object_set_property ((GObject*) _tmp28_, "read-speed", &_tmp29_);
#line 76 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		G_IS_VALUE (&_tmp29_) ? (g_value_unset (&_tmp29_), NULL) : NULL;
#line 439 "CDRipper.c"
	}
#line 79 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp30_ = self->queue;
#line 79 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_object_set ((GObject*) _tmp30_, "max-size-time", 120 * GST_SECOND, NULL);
#line 81 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp31_ = gst_format_get_by_nick ("track");
#line 81 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self->priv->_format = _tmp31_;
#line 83 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp32_ = self->pipeline;
#line 83 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp33_ = src;
#line 83 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp34_ = self->queue;
#line 83 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp35_ = self->filter;
#line 83 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp36_ = self->sink;
#line 83 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	gst_bin_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gst_bin_get_type (), GstBin), _tmp33_, _tmp34_, _tmp35_, _tmp36_, NULL);
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp37_ = src;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp38_ = self->queue;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp39_ = self->filter;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp40_ = self->sink;
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp41_ = gst_element_link_many (_tmp37_, _tmp38_, _tmp39_, _tmp40_, NULL);
#line 84 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (!_tmp41_) {
#line 85 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		g_critical ("CDRipper.vala:85: CD Ripper link_many failed\n");
#line 86 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		result = FALSE;
#line 86 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (src);
#line 86 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		return result;
#line 481 "CDRipper.c"
	}
#line 89 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp42_ = self->pipeline;
#line 89 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp43_ = ((GstElement*) _tmp42_)->bus;
#line 89 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	gst_bus_add_watch_full (_tmp43_, G_PRIORITY_DEFAULT, _noise_cd_ripper_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 91 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _noise_cd_ripper_do_position_update_gsource_func, g_object_ref (self), g_object_unref);
#line 93 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	result = TRUE;
#line 93 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (src);
#line 93 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 497 "CDRipper.c"
}


gboolean noise_cd_ripper_do_position_update (NoiseCDRipper* self) {
	gboolean result = FALSE;
	gdouble track_position = 0.0;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gdouble track_number = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gint64 _tmp6_;
#line 96 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 97 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = noise_cd_ripper_get_position (self);
#line 97 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp1_ = noise_cd_ripper_get_duration (self);
#line 97 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	track_position = ((gdouble) _tmp0_) / ((gdouble) _tmp1_);
#line 98 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp2_ = self->track_index;
#line 98 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp3_ = self->track_count;
#line 98 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	track_number = ((gdouble) _tmp2_) / ((gdouble) _tmp3_);
#line 99 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp4_ = track_position;
#line 99 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp5_ = track_number;
#line 99 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_signal_emit (self, noise_cd_ripper_signals[NOISE_CD_RIPPER_PROGRESS_NOTIFICATION_SIGNAL], 0, _tmp4_ * _tmp5_);
#line 101 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp6_ = noise_cd_ripper_get_duration (self);
#line 101 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp6_ <= ((gint64) 0)) {
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		result = FALSE;
#line 102 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		return result;
#line 540 "CDRipper.c"
	} else {
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		result = TRUE;
#line 104 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		return result;
#line 546 "CDRipper.c"
	}
}


gint64 noise_cd_ripper_get_position (NoiseCDRipper* self) {
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
#line 107 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 108 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	rv = (gint64) 0;
#line 109 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	f = GST_FORMAT_TIME;
#line 111 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = self->src;
#line 111 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	gst_element_query_position (_tmp0_, f, &_tmp1_);
#line 111 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	rv = _tmp1_;
#line 113 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	result = rv;
#line 113 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 573 "CDRipper.c"
}


gint64 noise_cd_ripper_get_duration (NoiseCDRipper* self) {
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
#line 116 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 117 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	rv = (gint64) 0;
#line 118 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	f = GST_FORMAT_TIME;
#line 120 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = self->src;
#line 120 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	gst_element_query_duration (_tmp0_, f, &_tmp1_);
#line 120 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	rv = _tmp1_;
#line 122 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	result = rv;
#line 122 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 599 "CDRipper.c"
}


static inline const gchar* _dynamic_get_location0 (GstElement* obj) {
	const gchar* result;
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_object_get (obj, "location", &result, NULL);
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 609 "CDRipper.c"
}


static gboolean noise_cd_ripper_bus_callback (NoiseCDRipper* self, GstBus* bus, GstMessage* message) {
	gboolean result = FALSE;
	GstMessage* _tmp0_;
	GstMessageType _tmp1_;
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 125 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = message;
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp1_ = _tmp0_->type;
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	switch (_tmp1_) {
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		case GST_MESSAGE_ERROR:
#line 631 "CDRipper.c"
		{
			GstMessage* _tmp2_;
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp2_ = message;
#line 146 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			g_signal_emit (self, noise_cd_ripper_signals[NOISE_CD_RIPPER_ERROR_SIGNAL], 0, "error", _tmp2_);
#line 147 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			break;
#line 640 "CDRipper.c"
		}
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		case GST_MESSAGE_ELEMENT:
#line 644 "CDRipper.c"
		{
			GstMessage* _tmp3_;
#line 149 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			g_critical ("CDRipper.vala:149: missing element\n");
#line 150 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp3_ = message;
#line 150 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			g_signal_emit (self, noise_cd_ripper_signals[NOISE_CD_RIPPER_ERROR_SIGNAL], 0, "missing element", _tmp3_);
#line 152 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			break;
#line 655 "CDRipper.c"
		}
#line 126 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		case GST_MESSAGE_EOS:
#line 659 "CDRipper.c"
		{
			GstPipeline* _tmp4_;
			NoiseMedia* _tmp5_;
			GstElement* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			NoiseMedia* _tmp13_;
#line 154 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp4_ = self->pipeline;
#line 154 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			gst_element_set_state ((GstElement*) _tmp4_, GST_STATE_NULL);
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp5_ = self->priv->current_media;
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp6_ = self->sink;
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp7_ = _dynamic_get_location0 (_tmp6_);
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp8_ = _tmp7_;
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp9_ = g_file_new_for_path (_tmp8_);
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp10_ = _tmp9_;
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp11_ = g_file_get_uri (_tmp10_);
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp12_ = _tmp11_;
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			noise_media_set_uri (_tmp5_, _tmp12_);
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_g_free0 (_tmp12_);
#line 155 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_g_object_unref0 (_tmp10_);
#line 156 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			_tmp13_ = self->priv->current_media;
#line 156 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			g_signal_emit (self, noise_cd_ripper_signals[NOISE_CD_RIPPER_MEDIA_RIPPED_SIGNAL], 0, _tmp13_, TRUE);
#line 158 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			break;
#line 703 "CDRipper.c"
		}
		default:
		{
#line 160 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
			break;
#line 709 "CDRipper.c"
		}
	}
#line 163 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	result = TRUE;
#line 163 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 716 "CDRipper.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	return self ? g_object_ref (self) : NULL;
#line 723 "CDRipper.c"
}


void noise_cd_ripper_rip_media (NoiseCDRipper* self, guint track, NoiseMedia* s) {
	GFile* f = NULL;
	NoiseMedia* _tmp0_;
	GFile* _tmp1_;
	GstElement* _tmp2_;
	GstElement* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GstElement* _tmp7_;
	guint _tmp8_;
	NoiseMedia* _tmp9_;
	gint _tmp13_;
	NoiseMedia* _tmp14_;
	NoiseMedia* _tmp15_;
	NoiseMedia* _tmp16_;
	GThemedIcon* _tmp17_;
	GThemedIcon* _tmp18_;
	GstPipeline* _tmp19_;
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_if_fail (self != NULL);
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_if_fail (s != NULL);
#line 167 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = s;
#line 167 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp1_ = noise_file_utils_get_new_destination (_tmp0_);
#line 167 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	f = _tmp1_;
#line 169 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp2_ = self->sink;
#line 169 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	gst_element_set_state (_tmp2_, GST_STATE_NULL);
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp3_ = self->sink;
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp4_ = f;
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp5_ = g_file_get_path (_tmp4_);
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp6_ = _tmp5_;
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_object_set ((GObject*) _tmp3_, "location", _tmp6_, NULL);
#line 170 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_free0 (_tmp6_);
#line 171 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp7_ = self->src;
#line 171 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp8_ = track;
#line 171 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_object_set ((GObject*) _tmp7_, "track", _tmp8_, NULL);
#line 172 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp9_ = self->priv->current_media;
#line 172 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp9_ != NULL) {
#line 782 "CDRipper.c"
		NoiseMedia* _tmp10_;
		GThemedIcon* _tmp11_;
		GThemedIcon* _tmp12_;
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp10_ = self->priv->current_media;
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp11_ = (GThemedIcon*) g_themed_icon_new ("process-completed-symbolic");
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_tmp12_ = _tmp11_;
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		noise_media_set_unique_status_image (_tmp10_, (GIcon*) _tmp12_);
#line 173 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (_tmp12_);
#line 796 "CDRipper.c"
	}
#line 174 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp13_ = self->track_index;
#line 174 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self->track_index = _tmp13_ + 1;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp14_ = s;
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->priv->current_media);
#line 175 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self->priv->current_media = _tmp15_;
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp16_ = self->priv->current_media;
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp17_ = (GThemedIcon*) g_themed_icon_new ("view-refresh-symbolic");
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp18_ = _tmp17_;
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	noise_media_set_unique_status_image (_tmp16_, (GIcon*) _tmp18_);
#line 176 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (_tmp18_);
#line 178 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_tmp19_ = self->pipeline;
#line 178 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	gst_element_set_state ((GstElement*) _tmp19_, GST_STATE_PLAYING);
#line 166 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (f);
#line 826 "CDRipper.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		data1 = closure->data;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		data2 = param_values->data[0].v_pointer;
#line 845 "CDRipper.c"
	} else {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		data2 = closure->data;
#line 851 "CDRipper.c"
	}
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 857 "CDRipper.c"
}


static void g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_POINTER) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		data1 = closure->data;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		data2 = param_values->data[0].v_pointer;
#line 876 "CDRipper.c"
	} else {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
		data2 = closure->data;
#line 882 "CDRipper.c"
	}
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	callback = (GMarshalFunc_VOID__STRING_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boxed (param_values + 2), data2);
#line 888 "CDRipper.c"
}


static void noise_cd_ripper_class_init (NoiseCDRipperClass * klass) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	noise_cd_ripper_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	g_type_class_add_private (klass, sizeof (NoiseCDRipperPrivate));
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_cd_ripper_finalize;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	noise_cd_ripper_signals[NOISE_CD_RIPPER_MEDIA_RIPPED_SIGNAL] = g_signal_new ("media-ripped", NOISE_TYPE_CD_RIPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, NOISE_TYPE_MEDIA, G_TYPE_BOOLEAN);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	noise_cd_ripper_signals[NOISE_CD_RIPPER_PROGRESS_NOTIFICATION_SIGNAL] = g_signal_new ("progress-notification", NOISE_TYPE_CD_RIPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	noise_cd_ripper_signals[NOISE_CD_RIPPER_ERROR_SIGNAL] = g_signal_new ("error", NOISE_TYPE_CD_RIPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_POINTER, G_TYPE_NONE, 2, G_TYPE_STRING, gst_message_get_type ());
#line 905 "CDRipper.c"
}


static void noise_cd_ripper_instance_init (NoiseCDRipper * self) {
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self->priv = NOISE_CD_RIPPER_GET_PRIVATE (self);
#line 912 "CDRipper.c"
}


static void noise_cd_ripper_finalize (GObject * obj) {
	NoiseCDRipper * self;
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_CD_RIPPER, NoiseCDRipper);
#line 30 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->pipeline);
#line 31 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->src);
#line 32 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->queue);
#line 33 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->filter);
#line 34 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->sink);
#line 36 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->priv->current_media);
#line 37 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	_g_free0 (self->priv->_device);
#line 29 "/builddir/build/BUILD/music-0.4.2/plugins/Devices/CDRom/CDRipper.vala"
	G_OBJECT_CLASS (noise_cd_ripper_parent_class)->finalize (obj);
#line 936 "CDRipper.c"
}


GType noise_cd_ripper_get_type (void) {
	return noise_cd_ripper_type_id;
}


GType noise_cd_ripper_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (NoiseCDRipperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_cd_ripper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseCDRipper), 0, (GInstanceInitFunc) noise_cd_ripper_instance_init, NULL };
	noise_cd_ripper_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoiseCDRipper", &g_define_type_info, 0);
	return noise_cd_ripper_type_id;
}



