/* MediaEditor.c generated by valac 0.38.10, the Vala compiler
 * generated from MediaEditor.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <noise-core.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define NOISE_TYPE_MEDIA_EDITOR (noise_media_editor_get_type ())
#define NOISE_MEDIA_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA_EDITOR, NoiseMediaEditor))
#define NOISE_MEDIA_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA_EDITOR, NoiseMediaEditorClass))
#define NOISE_IS_MEDIA_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA_EDITOR))
#define NOISE_IS_MEDIA_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA_EDITOR))
#define NOISE_MEDIA_EDITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA_EDITOR, NoiseMediaEditorClass))

typedef struct _NoiseMediaEditor NoiseMediaEditor;
typedef struct _NoiseMediaEditorClass NoiseMediaEditorClass;
typedef struct _NoiseMediaEditorPrivate NoiseMediaEditorPrivate;

#define GRANITE_WIDGETS_TYPE_RATING (granite_widgets_rating_get_type ())
#define GRANITE_WIDGETS_RATING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_RATING, GraniteWidgetsRating))
#define GRANITE_WIDGETS_RATING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_RATING, GraniteWidgetsRatingClass))
#define GRANITE_WIDGETS_IS_RATING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_RATING))
#define GRANITE_WIDGETS_IS_RATING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_RATING))
#define GRANITE_WIDGETS_RATING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_RATING, GraniteWidgetsRatingClass))

typedef struct _GraniteWidgetsRating GraniteWidgetsRating;
typedef struct _GraniteWidgetsRatingClass GraniteWidgetsRatingClass;
enum  {
	NOISE_MEDIA_EDITOR_0_PROPERTY,
	NOISE_MEDIA_EDITOR_NUM_PROPERTIES
};
static GParamSpec* noise_media_editor_properties[NOISE_MEDIA_EDITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _NoiseMediaEditor {
	GtkDialog parent_instance;
	NoiseMediaEditorPrivate * priv;
};

struct _NoiseMediaEditorClass {
	GtkDialogClass parent_class;
};

struct _NoiseMediaEditorPrivate {
	GtkEntry* title_entry;
	GtkEntry* artist_entry;
	GtkEntry* album_artist_entry;
	GtkEntry* album_entry;
	GtkEntry* genre_entry;
	GtkEntry* composer_entry;
	GtkEntry* grouping_entry;
	GtkTextView* comment_textview;
	GtkScrolledWindow* comment_scrolledwindow;
	GtkSpinButton* track_spinbutton;
	GtkSpinButton* disk_spinbutton;
	GtkSpinButton* year_spinbutton;
	GraniteWidgetsRating* rating_widget;
	GtkButton* previous_button;
	GtkButton* next_button;
	GtkButton* save_button;
	GtkButton* close_button;
	GeeTreeSet* media_list;
	GeeHashMap* temp_list;
	NoiseMedia* current_media;
};


static gpointer noise_media_editor_parent_class = NULL;

GType noise_media_editor_get_type (void) G_GNUC_CONST;
GType granite_widgets_rating_get_type (void) G_GNUC_CONST;
#define NOISE_MEDIA_EDITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_MEDIA_EDITOR, NoiseMediaEditorPrivate))
NoiseMediaEditor* noise_media_editor_new (GeeTreeSet* given_media);
NoiseMediaEditor* noise_media_editor_construct (GType object_type, GeeTreeSet* given_media);
static void noise_media_editor_set_media (NoiseMediaEditor* self, NoiseMedia* m);
static void noise_media_editor_format_label (NoiseMediaEditor* self, GtkLabel* label);
static void noise_media_editor_previous_track (NoiseMediaEditor* self);
static void noise_media_editor_save_track (NoiseMediaEditor* self);
static void noise_media_editor_next_track (NoiseMediaEditor* self);
gint granite_widgets_rating_get_rating (GraniteWidgetsRating* self);
static void noise_media_editor_save_and_exit (NoiseMediaEditor* self);
void granite_widgets_rating_set_rating (GraniteWidgetsRating* self, gint value);
static GObject * noise_media_editor_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gint64* _int64_dup (gint64* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
GraniteWidgetsRating* granite_widgets_rating_new (gboolean centered, GtkIconSize size, gboolean symbolic);
GraniteWidgetsRating* granite_widgets_rating_construct (GType object_type, gboolean centered, GtkIconSize size, gboolean symbolic);
static void _noise_media_editor_previous_track_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _noise_media_editor_next_track_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _noise_media_editor___lambda51_ (NoiseMediaEditor* self);
static void __noise_media_editor___lambda51__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _noise_media_editor_save_and_exit_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void noise_media_editor_finalize (GObject * obj);


NoiseMediaEditor* noise_media_editor_construct (GType object_type, GeeTreeSet* given_media) {
	NoiseMediaEditor * self = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* _tmp2_;
	gpointer _tmp3_;
	NoiseMedia* _tmp4_;
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_return_val_if_fail (given_media != NULL, NULL);
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self = (NoiseMediaEditor*) g_object_new (object_type, NULL);
#line 54 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp0_ = self->priv->media_list;
#line 54 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp1_ = given_media;
#line 54 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gee_collection_add_all ((GeeCollection*) _tmp0_, (GeeCollection*) _tmp1_);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp2_ = self->priv->media_list;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp3_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp2_);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp4_ = (NoiseMedia*) _tmp3_;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_set_media (self, _tmp4_);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (_tmp4_);
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	return self;
#line 175 "MediaEditor.c"
}


NoiseMediaEditor* noise_media_editor_new (GeeTreeSet* given_media) {
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	return noise_media_editor_construct (NOISE_TYPE_MEDIA_EDITOR, given_media);
#line 182 "MediaEditor.c"
}


static void noise_media_editor_format_label (NoiseMediaEditor* self, GtkLabel* label) {
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkLabel* _tmp9_;
#line 179 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 179 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_return_if_fail (label != NULL);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp0_ = label;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp1_ = label;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp2_ = label;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp3_ = gtk_label_get_label (_tmp2_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp4_ = _tmp3_;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp5_ = g_markup_escape_text (_tmp4_, (gssize) -1);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp6_ = _tmp5_;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp7_ = g_strdup_printf ("<b>%s</b>", _tmp6_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp8_ = _tmp7_;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_label_set_label (_tmp1_, _tmp8_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_free0 (_tmp8_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_free0 (_tmp6_);
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp9_ = label;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_label_set_use_markup (_tmp9_, TRUE);
#line 231 "MediaEditor.c"
}


static void noise_media_editor_previous_track (NoiseMediaEditor* self) {
	GeeBidirIterator* iterator = NULL;
	GeeTreeSet* _tmp0_;
	NoiseMedia* _tmp1_;
	GeeIterator* _tmp2_;
	GeeBidirIterator* _tmp3_;
	gboolean _tmp4_;
#line 185 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 186 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp0_ = self->priv->media_list;
#line 186 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp1_ = self->priv->current_media;
#line 186 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp2_ = gee_abstract_sorted_set_iterator_at ((GeeAbstractSortedSet*) _tmp0_, _tmp1_);
#line 186 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	iterator = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_BIDIR_ITERATOR, GeeBidirIterator);
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp3_ = iterator;
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp4_ = gee_bidir_iterator_has_previous (_tmp3_);
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	if (_tmp4_) {
#line 258 "MediaEditor.c"
		GeeBidirIterator* _tmp5_;
		GeeBidirIterator* _tmp6_;
		gpointer _tmp7_;
		NoiseMedia* _tmp8_;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		noise_media_editor_save_track (self);
#line 189 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp5_ = iterator;
#line 189 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		gee_bidir_iterator_previous (_tmp5_);
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp6_ = iterator;
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp7_ = gee_iterator_get ((GeeIterator*) _tmp6_);
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp8_ = (NoiseMedia*) _tmp7_;
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		noise_media_editor_set_media (self, _tmp8_);
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_g_object_unref0 (_tmp8_);
#line 279 "MediaEditor.c"
	} else {
		GtkButton* _tmp9_;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp9_ = self->priv->previous_button;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 286 "MediaEditor.c"
	}
#line 185 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (iterator);
#line 290 "MediaEditor.c"
}


static void noise_media_editor_next_track (NoiseMediaEditor* self) {
	GeeIterator* iterator = NULL;
	GeeTreeSet* _tmp0_;
	NoiseMedia* _tmp1_;
	GeeIterator* _tmp2_;
	GeeIterator* _tmp3_;
	gboolean _tmp4_;
#line 196 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 197 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp0_ = self->priv->media_list;
#line 197 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp1_ = self->priv->current_media;
#line 197 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp2_ = gee_abstract_sorted_set_iterator_at ((GeeAbstractSortedSet*) _tmp0_, _tmp1_);
#line 197 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	iterator = _tmp2_;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp3_ = iterator;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp4_ = gee_iterator_has_next (_tmp3_);
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	if (_tmp4_) {
#line 317 "MediaEditor.c"
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
		gpointer _tmp7_;
		NoiseMedia* _tmp8_;
#line 199 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		noise_media_editor_save_track (self);
#line 200 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp5_ = iterator;
#line 200 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		gee_iterator_next (_tmp5_);
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp6_ = iterator;
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp7_ = gee_iterator_get (_tmp6_);
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp8_ = (NoiseMedia*) _tmp7_;
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		noise_media_editor_set_media (self, _tmp8_);
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_g_object_unref0 (_tmp8_);
#line 338 "MediaEditor.c"
	} else {
		GtkButton* _tmp9_;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp9_ = self->priv->next_button;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 345 "MediaEditor.c"
	}
#line 196 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (iterator);
#line 349 "MediaEditor.c"
}


static void noise_media_editor_save_track (NoiseMediaEditor* self) {
	NoiseMedia* m = NULL;
	NoiseMedia* _tmp0_;
	NoiseMedia* _tmp1_;
	GtkEntry* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkEntry* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GtkEntry* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GtkEntry* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GtkEntry* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GtkEntry* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GtkEntry* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GtkTextView* _tmp23_;
	GtkTextBuffer* _tmp24_;
	GtkTextBuffer* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkSpinButton* _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	GtkSpinButton* _tmp32_;
	gdouble _tmp33_;
	gdouble _tmp34_;
	GtkSpinButton* _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	GraniteWidgetsRating* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	GeeHashMap* _tmp41_;
	NoiseMedia* _tmp42_;
	gint64 _tmp43_;
	gint64 _tmp44_;
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp0_ = self->priv->current_media;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp1_ = noise_media_copy (_tmp0_);
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	m = _tmp1_;
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp2_ = self->priv->title_entry;
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp3_ = gtk_entry_get_text (_tmp2_);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp4_ = _tmp3_;
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_title (m, _tmp4_);
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp5_ = self->priv->artist_entry;
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp6_ = gtk_entry_get_text (_tmp5_);
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp7_ = _tmp6_;
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_artist (m, _tmp7_);
#line 211 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp8_ = self->priv->album_artist_entry;
#line 211 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp9_ = gtk_entry_get_text (_tmp8_);
#line 211 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp10_ = _tmp9_;
#line 211 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_album_artist (m, _tmp10_);
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp11_ = self->priv->album_entry;
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp12_ = gtk_entry_get_text (_tmp11_);
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp13_ = _tmp12_;
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_album (m, _tmp13_);
#line 213 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp14_ = self->priv->genre_entry;
#line 213 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp15_ = gtk_entry_get_text (_tmp14_);
#line 213 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp16_ = _tmp15_;
#line 213 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_genre (m, _tmp16_);
#line 214 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp17_ = self->priv->composer_entry;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp18_ = gtk_entry_get_text (_tmp17_);
#line 214 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp19_ = _tmp18_;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_composer (m, _tmp19_);
#line 215 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp20_ = self->priv->grouping_entry;
#line 215 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp21_ = gtk_entry_get_text (_tmp20_);
#line 215 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp22_ = _tmp21_;
#line 215 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_grouping (m, _tmp22_);
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp23_ = self->priv->comment_textview;
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp24_ = gtk_text_view_get_buffer (_tmp23_);
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp25_ = _tmp24_;
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_get (_tmp25_, "text", &_tmp26_, NULL);
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp27_ = _tmp26_;
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp28_ = _tmp27_;
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_comment (m, _tmp28_);
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_free0 (_tmp28_);
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp29_ = self->priv->track_spinbutton;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp30_ = gtk_spin_button_get_value (_tmp29_);
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp31_ = _tmp30_;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_track (m, (guint) ((gint) _tmp31_));
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp32_ = self->priv->disk_spinbutton;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp33_ = gtk_spin_button_get_value (_tmp32_);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp34_ = _tmp33_;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_album_number (m, (guint) ((gint) _tmp34_));
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp35_ = self->priv->year_spinbutton;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp36_ = gtk_spin_button_get_value (_tmp35_);
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp37_ = _tmp36_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_year (m, (guint) ((gint) _tmp37_));
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp38_ = self->priv->rating_widget;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp39_ = granite_widgets_rating_get_rating (_tmp38_);
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp40_ = _tmp39_;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_set_rating (m, (guint) _tmp40_);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp41_ = self->priv->temp_list;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp42_ = self->priv->current_media;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp43_ = noise_media_get_rowid (_tmp42_);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp44_ = _tmp43_;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp41_, &_tmp44_, m);
#line 207 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (m);
#line 524 "MediaEditor.c"
}


static void noise_media_editor_save_and_exit (NoiseMediaEditor* self) {
	GeeTreeSet* _tmp64_;
	GeeHashMap* _tmp65_;
#line 225 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 226 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_save_track (self);
#line 535 "MediaEditor.c"
	{
		GeeIterator* _m_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp0_ = self->priv->media_list;
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_m_it = _tmp1_;
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		while (TRUE) {
#line 548 "MediaEditor.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GeeHashMap* _tmp6_;
			NoiseMedia* _tmp7_;
			gint64 _tmp8_;
			gint64 _tmp9_;
			gboolean _tmp10_;
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			_tmp2_ = _m_it;
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			if (!_tmp3_) {
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				break;
#line 567 "MediaEditor.c"
			}
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			_tmp4_ = _m_it;
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			m = (NoiseMedia*) _tmp5_;
#line 228 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			_tmp6_ = self->priv->temp_list;
#line 228 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			_tmp7_ = m;
#line 228 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			_tmp8_ = noise_media_get_rowid (_tmp7_);
#line 228 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			_tmp9_ = _tmp8_;
#line 228 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			_tmp10_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp6_, &_tmp9_);
#line 228 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			if (_tmp10_) {
#line 587 "MediaEditor.c"
				NoiseMedia* copy = NULL;
				GeeHashMap* _tmp11_;
				NoiseMedia* _tmp12_;
				gint64 _tmp13_;
				gint64 _tmp14_;
				gpointer _tmp15_;
				NoiseMedia* _tmp16_;
				NoiseMedia* _tmp17_;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				NoiseMedia* _tmp20_;
				NoiseMedia* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				NoiseMedia* _tmp24_;
				NoiseMedia* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				NoiseMedia* _tmp28_;
				NoiseMedia* _tmp29_;
				const gchar* _tmp30_;
				const gchar* _tmp31_;
				NoiseMedia* _tmp32_;
				NoiseMedia* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
				NoiseMedia* _tmp36_;
				NoiseMedia* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				NoiseMedia* _tmp40_;
				NoiseMedia* _tmp41_;
				const gchar* _tmp42_;
				const gchar* _tmp43_;
				NoiseMedia* _tmp44_;
				NoiseMedia* _tmp45_;
				const gchar* _tmp46_;
				const gchar* _tmp47_;
				NoiseMedia* _tmp48_;
				NoiseMedia* _tmp49_;
				guint _tmp50_;
				guint _tmp51_;
				NoiseMedia* _tmp52_;
				NoiseMedia* _tmp53_;
				guint _tmp54_;
				guint _tmp55_;
				NoiseMedia* _tmp56_;
				NoiseMedia* _tmp57_;
				guint _tmp58_;
				guint _tmp59_;
				NoiseMedia* _tmp60_;
				NoiseMedia* _tmp61_;
				guint _tmp62_;
				guint _tmp63_;
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp11_ = self->priv->temp_list;
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp12_ = m;
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp13_ = noise_media_get_rowid (_tmp12_);
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp14_ = _tmp13_;
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp15_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, &_tmp14_);
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				copy = (NoiseMedia*) _tmp15_;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp16_ = m;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp17_ = copy;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp18_ = noise_media_get_title (_tmp17_);
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp19_ = _tmp18_;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_title (_tmp16_, _tmp19_);
#line 231 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp20_ = m;
#line 231 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp21_ = copy;
#line 231 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp22_ = noise_media_get_artist (_tmp21_);
#line 231 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp23_ = _tmp22_;
#line 231 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_artist (_tmp20_, _tmp23_);
#line 232 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp24_ = m;
#line 232 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp25_ = copy;
#line 232 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp26_ = noise_media_get_album_artist (_tmp25_);
#line 232 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp27_ = _tmp26_;
#line 232 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_album_artist (_tmp24_, _tmp27_);
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp28_ = m;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp29_ = copy;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp30_ = noise_media_get_album (_tmp29_);
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp31_ = _tmp30_;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_album (_tmp28_, _tmp31_);
#line 234 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp32_ = m;
#line 234 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp33_ = copy;
#line 234 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp34_ = noise_media_get_genre (_tmp33_);
#line 234 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp35_ = _tmp34_;
#line 234 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_genre (_tmp32_, _tmp35_);
#line 235 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp36_ = m;
#line 235 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp37_ = copy;
#line 235 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp38_ = noise_media_get_composer (_tmp37_);
#line 235 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp39_ = _tmp38_;
#line 235 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_composer (_tmp36_, _tmp39_);
#line 236 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp40_ = m;
#line 236 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp41_ = copy;
#line 236 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp42_ = noise_media_get_grouping (_tmp41_);
#line 236 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp43_ = _tmp42_;
#line 236 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_grouping (_tmp40_, _tmp43_);
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp44_ = m;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp45_ = copy;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp46_ = noise_media_get_comment (_tmp45_);
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp47_ = _tmp46_;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_comment (_tmp44_, _tmp47_);
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp48_ = m;
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp49_ = copy;
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp50_ = noise_media_get_track (_tmp49_);
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp51_ = _tmp50_;
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_track (_tmp48_, _tmp51_);
#line 239 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp52_ = m;
#line 239 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp53_ = copy;
#line 239 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp54_ = noise_media_get_album_number (_tmp53_);
#line 239 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp55_ = _tmp54_;
#line 239 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_album_number (_tmp52_, _tmp55_);
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp56_ = m;
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp57_ = copy;
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp58_ = noise_media_get_year (_tmp57_);
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp59_ = _tmp58_;
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_year (_tmp56_, _tmp59_);
#line 241 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp60_ = m;
#line 241 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp61_ = copy;
#line 241 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp62_ = noise_media_get_rating (_tmp61_);
#line 241 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_tmp63_ = _tmp62_;
#line 241 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				noise_media_set_rating (_tmp60_, _tmp63_);
#line 228 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
				_g_object_unref0 (copy);
#line 776 "MediaEditor.c"
			}
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
			_g_object_unref0 (m);
#line 780 "MediaEditor.c"
		}
#line 227 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_g_object_unref0 (_m_it);
#line 784 "MediaEditor.c"
	}
#line 245 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp64_ = self->priv->media_list;
#line 245 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp64_);
#line 246 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->current_media);
#line 246 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->current_media = NULL;
#line 247 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp65_ = self->priv->temp_list;
#line 247 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp65_);
#line 248 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 800 "MediaEditor.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	return self ? g_object_ref (self) : NULL;
#line 807 "MediaEditor.c"
}


static void noise_media_editor_set_media (NoiseMediaEditor* self, NoiseMedia* m) {
	NoiseMedia* _tmp0_;
	NoiseMedia* _tmp1_;
	NoiseMedia* considered_media = NULL;
	NoiseMedia* _tmp2_;
	NoiseMedia* _tmp3_;
	GeeHashMap* _tmp4_;
	NoiseMedia* _tmp5_;
	gint64 _tmp6_;
	gint64 _tmp7_;
	gboolean _tmp8_;
	GtkEntry* _tmp14_;
	NoiseMedia* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GtkEntry* _tmp18_;
	NoiseMedia* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GtkEntry* _tmp22_;
	NoiseMedia* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	GtkEntry* _tmp26_;
	NoiseMedia* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	GtkEntry* _tmp30_;
	NoiseMedia* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	GtkEntry* _tmp34_;
	NoiseMedia* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	GtkEntry* _tmp38_;
	NoiseMedia* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	GtkTextView* _tmp42_;
	GtkTextBuffer* _tmp43_;
	GtkTextBuffer* _tmp44_;
	NoiseMedia* _tmp45_;
	const gchar* _tmp46_;
	const gchar* _tmp47_;
	GtkSpinButton* _tmp48_;
	NoiseMedia* _tmp49_;
	guint _tmp50_;
	guint _tmp51_;
	GtkSpinButton* _tmp52_;
	NoiseMedia* _tmp53_;
	guint _tmp54_;
	guint _tmp55_;
	GtkSpinButton* _tmp56_;
	NoiseMedia* _tmp57_;
	guint _tmp58_;
	guint _tmp59_;
	GraniteWidgetsRating* _tmp60_;
	NoiseMedia* _tmp61_;
	guint _tmp62_;
	guint _tmp63_;
	GeeBidirIterator* iterator = NULL;
	GeeTreeSet* _tmp64_;
	NoiseMedia* _tmp65_;
	GeeIterator* _tmp66_;
	GtkButton* _tmp67_;
	gboolean _tmp68_;
	GtkButton* _tmp69_;
	gboolean _tmp70_;
#line 251 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_return_if_fail (self != NULL);
#line 251 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_return_if_fail (m != NULL);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp0_ = m;
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->current_media);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->current_media = _tmp1_;
#line 253 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp2_ = self->priv->current_media;
#line 253 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 253 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	considered_media = _tmp3_;
#line 254 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp4_ = self->priv->temp_list;
#line 254 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp5_ = self->priv->current_media;
#line 254 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp6_ = noise_media_get_rowid (_tmp5_);
#line 254 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp7_ = _tmp6_;
#line 254 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp8_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp4_, &_tmp7_);
#line 254 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	if (_tmp8_) {
#line 910 "MediaEditor.c"
		GeeHashMap* _tmp9_;
		NoiseMedia* _tmp10_;
		gint64 _tmp11_;
		gint64 _tmp12_;
		gpointer _tmp13_;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp9_ = self->priv->temp_list;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp10_ = self->priv->current_media;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp11_ = noise_media_get_rowid (_tmp10_);
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp12_ = _tmp11_;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, &_tmp12_);
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		_g_object_unref0 (considered_media);
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
		considered_media = (NoiseMedia*) _tmp13_;
#line 930 "MediaEditor.c"
	}
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp14_ = self->priv->title_entry;
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp15_ = considered_media;
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp16_ = noise_media_get_title (_tmp15_);
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp17_ = _tmp16_;
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text (_tmp14_, _tmp17_);
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp18_ = self->priv->artist_entry;
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp19_ = considered_media;
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp20_ = noise_media_get_artist (_tmp19_);
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp21_ = _tmp20_;
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text (_tmp18_, _tmp21_);
#line 260 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp22_ = self->priv->album_artist_entry;
#line 260 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp23_ = considered_media;
#line 260 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp24_ = noise_media_get_album_artist (_tmp23_);
#line 260 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp25_ = _tmp24_;
#line 260 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text (_tmp22_, _tmp25_);
#line 261 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp26_ = self->priv->album_entry;
#line 261 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp27_ = considered_media;
#line 261 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp28_ = noise_media_get_album (_tmp27_);
#line 261 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp29_ = _tmp28_;
#line 261 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text (_tmp26_, _tmp29_);
#line 262 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp30_ = self->priv->genre_entry;
#line 262 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp31_ = considered_media;
#line 262 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp32_ = noise_media_get_genre (_tmp31_);
#line 262 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp33_ = _tmp32_;
#line 262 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text (_tmp30_, _tmp33_);
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp34_ = self->priv->composer_entry;
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp35_ = considered_media;
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp36_ = noise_media_get_composer (_tmp35_);
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp37_ = _tmp36_;
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text (_tmp34_, _tmp37_);
#line 264 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp38_ = self->priv->grouping_entry;
#line 264 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp39_ = considered_media;
#line 264 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp40_ = noise_media_get_grouping (_tmp39_);
#line 264 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp41_ = _tmp40_;
#line 264 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_entry_set_text (_tmp38_, _tmp41_);
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp42_ = self->priv->comment_textview;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp43_ = gtk_text_view_get_buffer (_tmp42_);
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp44_ = _tmp43_;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp45_ = considered_media;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp46_ = noise_media_get_comment (_tmp45_);
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp47_ = _tmp46_;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_set (_tmp44_, "text", _tmp47_, NULL);
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp48_ = self->priv->track_spinbutton;
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp49_ = considered_media;
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp50_ = noise_media_get_track (_tmp49_);
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp51_ = _tmp50_;
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_spin_button_set_value (_tmp48_, (gdouble) _tmp51_);
#line 267 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp52_ = self->priv->disk_spinbutton;
#line 267 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp53_ = considered_media;
#line 267 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp54_ = noise_media_get_album_number (_tmp53_);
#line 267 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp55_ = _tmp54_;
#line 267 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_spin_button_set_value (_tmp52_, (gdouble) _tmp55_);
#line 268 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp56_ = self->priv->year_spinbutton;
#line 268 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp57_ = considered_media;
#line 268 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp58_ = noise_media_get_year (_tmp57_);
#line 268 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp59_ = _tmp58_;
#line 268 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_spin_button_set_value (_tmp56_, (gdouble) _tmp59_);
#line 269 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp60_ = self->priv->rating_widget;
#line 269 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp61_ = considered_media;
#line 269 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp62_ = noise_media_get_rating (_tmp61_);
#line 269 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp63_ = _tmp62_;
#line 269 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	granite_widgets_rating_set_rating (_tmp60_, (gint) _tmp63_);
#line 270 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp64_ = self->priv->media_list;
#line 270 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp65_ = self->priv->current_media;
#line 270 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp66_ = gee_abstract_sorted_set_iterator_at ((GeeAbstractSortedSet*) _tmp64_, _tmp65_);
#line 270 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	iterator = G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, GEE_TYPE_BIDIR_ITERATOR, GeeBidirIterator);
#line 271 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp67_ = self->priv->previous_button;
#line 271 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp68_ = gee_bidir_iterator_has_previous (iterator);
#line 271 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp67_, _tmp68_);
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp69_ = self->priv->next_button;
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp70_ = gee_iterator_has_next ((GeeIterator*) iterator);
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp69_, _tmp70_);
#line 251 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (iterator);
#line 251 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (considered_media);
#line 1080 "MediaEditor.c"
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	dup = g_new0 (gint64, 1);
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	memcpy (dup, self, sizeof (gint64));
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	return dup;
#line 1092 "MediaEditor.c"
}


static void _noise_media_editor_previous_track_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 173 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_previous_track ((NoiseMediaEditor*) self);
#line 1099 "MediaEditor.c"
}


static void _noise_media_editor_next_track_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_next_track ((NoiseMediaEditor*) self);
#line 1106 "MediaEditor.c"
}


static void _noise_media_editor___lambda51_ (NoiseMediaEditor* self) {
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 1113 "MediaEditor.c"
}


static void __noise_media_editor___lambda51__gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_noise_media_editor___lambda51_ ((NoiseMediaEditor*) self);
#line 1120 "MediaEditor.c"
}


static void _noise_media_editor_save_and_exit_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_save_and_exit ((NoiseMediaEditor*) self);
#line 1127 "MediaEditor.c"
}


static GObject * noise_media_editor_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	NoiseMediaEditor * self;
	GeeTreeSet* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GeeHashMap* _tmp3_;
	NoiseLibraryWindow* _tmp4_;
	NoiseLibraryWindow* _tmp5_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp6_;
	GtkGrid* _tmp7_;
	GtkGrid* _tmp8_;
	GtkGrid* _tmp9_;
	GtkGrid* _tmp10_;
	GtkGrid* _tmp11_;
	GtkLabel* title_label = NULL;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* artist_label = NULL;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* album_artist_label = NULL;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* album_label = NULL;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* genre_label = NULL;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* composer_label = NULL;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* grouping_label = NULL;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* comment_label = NULL;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* track_label = NULL;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* disk_label = NULL;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* year_label = NULL;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* rating_label = NULL;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkEntry* _tmp36_;
	GtkEntry* _tmp37_;
	GtkEntry* _tmp38_;
	GtkEntry* _tmp39_;
	GtkEntry* _tmp40_;
	GtkEntry* _tmp41_;
	GtkEntry* _tmp42_;
	GtkTextView* _tmp43_;
	GtkTextView* _tmp44_;
	GtkScrolledWindow* _tmp45_;
	GtkScrolledWindow* _tmp46_;
	GtkScrolledWindow* _tmp47_;
	GtkTextView* _tmp48_;
	GtkSpinButton* _tmp49_;
	GtkSpinButton* _tmp50_;
	GDateTime* local_time = NULL;
	GDateTime* _tmp51_;
	GDateTime* _tmp52_;
	gint _tmp53_;
	GtkSpinButton* _tmp54_;
	GraniteWidgetsRating* _tmp55_;
	GraniteWidgetsRating* _tmp56_;
	GtkFrame* comment_frame = NULL;
	GtkFrame* _tmp57_;
	GtkFrame* _tmp58_;
	GtkFrame* _tmp59_;
	GtkScrolledWindow* _tmp60_;
	GtkGrid* _tmp61_;
	GtkLabel* _tmp62_;
	GtkGrid* _tmp63_;
	GtkEntry* _tmp64_;
	GtkGrid* _tmp65_;
	GtkLabel* _tmp66_;
	GtkGrid* _tmp67_;
	GtkEntry* _tmp68_;
	GtkGrid* _tmp69_;
	GtkLabel* _tmp70_;
	GtkGrid* _tmp71_;
	GtkEntry* _tmp72_;
	GtkGrid* _tmp73_;
	GtkLabel* _tmp74_;
	GtkGrid* _tmp75_;
	GtkEntry* _tmp76_;
	GtkGrid* _tmp77_;
	GtkLabel* _tmp78_;
	GtkGrid* _tmp79_;
	GtkEntry* _tmp80_;
	GtkGrid* _tmp81_;
	GtkLabel* _tmp82_;
	GtkGrid* _tmp83_;
	GtkEntry* _tmp84_;
	GtkGrid* _tmp85_;
	GtkLabel* _tmp86_;
	GtkGrid* _tmp87_;
	GtkEntry* _tmp88_;
	GtkGrid* _tmp89_;
	GtkLabel* _tmp90_;
	GtkGrid* _tmp91_;
	GtkSpinButton* _tmp92_;
	GtkGrid* _tmp93_;
	GtkLabel* _tmp94_;
	GtkGrid* _tmp95_;
	GtkSpinButton* _tmp96_;
	GtkGrid* _tmp97_;
	GtkLabel* _tmp98_;
	GtkGrid* _tmp99_;
	GtkSpinButton* _tmp100_;
	GtkGrid* _tmp101_;
	GtkLabel* _tmp102_;
	GtkGrid* _tmp103_;
	GraniteWidgetsRating* _tmp104_;
	GtkGrid* _tmp105_;
	GtkLabel* _tmp106_;
	GtkGrid* _tmp107_;
	GtkFrame* _tmp108_;
	GtkButton* _tmp109_;
	GtkButton* _tmp110_;
	GtkGrid* arrows_grid = NULL;
	GtkGrid* _tmp111_;
	GtkGrid* _tmp112_;
	GtkGrid* _tmp113_;
	GtkGrid* _tmp114_;
	GtkStyleContext* _tmp115_;
	GtkGrid* _tmp116_;
	GtkButton* _tmp117_;
	GtkGrid* _tmp118_;
	GtkButton* _tmp119_;
	GtkButton* _tmp120_;
	GtkButton* _tmp121_;
	GtkStyleContext* _tmp122_;
	GtkButton* _tmp123_;
	GtkButtonBox* buttons = NULL;
	GtkButtonBox* _tmp124_;
	GtkButtonBox* _tmp125_;
	GtkButtonBox* _tmp126_;
	GtkButtonBox* _tmp127_;
	GtkButtonBox* _tmp128_;
	GtkGrid* _tmp129_;
	GtkButtonBox* _tmp130_;
	GtkButton* _tmp131_;
	GtkButtonBox* _tmp132_;
	GtkButton* _tmp133_;
	GtkButtonBox* _tmp134_;
	GtkGrid* _tmp135_;
	GtkButtonBox* _tmp136_;
	GtkGrid* _tmp137_;
	GtkGrid* _tmp138_;
	GtkButtonBox* _tmp139_;
	GtkContainer* content = NULL;
	GtkBox* _tmp140_;
	GtkContainer* _tmp141_;
	GtkContainer* _tmp142_;
	GtkGrid* _tmp143_;
	GtkButton* _tmp144_;
	GtkButton* _tmp145_;
	GtkButton* _tmp146_;
	GtkButton* _tmp147_;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	parent_class = G_OBJECT_CLASS (noise_media_editor_parent_class);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_MEDIA_EDITOR, NoiseMediaEditor);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->media_list);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->media_list = _tmp0_;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp1_ = g_int64_hash;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp2_ = g_int64_equal;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeHashDataFunc) _tmp1_, NULL, NULL, (GeeEqualDataFunc) _tmp2_, NULL, NULL, NULL, NULL, NULL);
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->temp_list);
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->temp_list = _tmp3_;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp4_ = noise_app_get_main_window ();
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp5_ = _tmp4_;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) _tmp5_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_window_set_default_geometry ((GtkWindow*) self, 600, 400);
#line 64 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp6_ = (GtkGrid*) gtk_grid_new ();
#line 64 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp6_);
#line 64 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	grid = _tmp6_;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp7_ = grid;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_set ((GtkWidget*) _tmp7_, "expand", TRUE, NULL);
#line 66 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp8_ = grid;
#line 66 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp8_, 12);
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp9_ = grid;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp9_, 12);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp10_ = grid;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_set_column_spacing (_tmp10_, 12);
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp11_ = grid;
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_set_row_spacing (_tmp11_, 6);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp12_ = (GtkLabel*) gtk_label_new (_ ("Title:"));
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp12_);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	title_label = _tmp12_;
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp13_ = title_label;
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp13_);
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp14_ = (GtkLabel*) gtk_label_new (_ ("Artist:"));
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp14_);
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	artist_label = _tmp14_;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp15_ = artist_label;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp15_);
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp16_ = (GtkLabel*) gtk_label_new (_ ("Album Artist:"));
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp16_);
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	album_artist_label = _tmp16_;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp17_ = album_artist_label;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp17_);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp18_ = (GtkLabel*) gtk_label_new (_ ("Album:"));
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp18_);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	album_label = _tmp18_;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp19_ = album_label;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp19_);
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp20_ = (GtkLabel*) gtk_label_new (_ ("Genre:"));
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp20_);
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	genre_label = _tmp20_;
#line 80 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp21_ = genre_label;
#line 80 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp21_);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp22_ = (GtkLabel*) gtk_label_new (_ ("Composer:"));
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp22_);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	composer_label = _tmp22_;
#line 82 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp23_ = composer_label;
#line 82 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp23_);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp24_ = (GtkLabel*) gtk_label_new (_ ("Grouping:"));
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp24_);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	grouping_label = _tmp24_;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp25_ = grouping_label;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp25_);
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp26_ = (GtkLabel*) gtk_label_new (_ ("Comment:"));
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp26_);
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	comment_label = _tmp26_;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp27_ = comment_label;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp27_);
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp28_ = (GtkLabel*) gtk_label_new (_ ("Track:"));
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp28_);
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	track_label = _tmp28_;
#line 88 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp29_ = track_label;
#line 88 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp29_);
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp30_ = (GtkLabel*) gtk_label_new (_ ("Disk:"));
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp30_);
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	disk_label = _tmp30_;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp31_ = disk_label;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp31_);
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp32_ = (GtkLabel*) gtk_label_new (_ ("Year:"));
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp32_);
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	year_label = _tmp32_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp33_ = year_label;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp33_);
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp34_ = (GtkLabel*) gtk_label_new (_ ("Rating:"));
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp34_);
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	rating_label = _tmp34_;
#line 94 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp35_ = rating_label;
#line 94 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_format_label (self, _tmp35_);
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp36_ = (GtkEntry*) gtk_entry_new ();
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp36_);
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->title_entry);
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->title_entry = _tmp36_;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp37_ = (GtkEntry*) gtk_entry_new ();
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp37_);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->artist_entry);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->artist_entry = _tmp37_;
#line 98 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp38_ = (GtkEntry*) gtk_entry_new ();
#line 98 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp38_);
#line 98 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->album_artist_entry);
#line 98 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->album_artist_entry = _tmp38_;
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp39_ = (GtkEntry*) gtk_entry_new ();
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp39_);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->album_entry);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->album_entry = _tmp39_;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp40_ = (GtkEntry*) gtk_entry_new ();
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp40_);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->genre_entry);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->genre_entry = _tmp40_;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp41_ = (GtkEntry*) gtk_entry_new ();
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp41_);
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->composer_entry);
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->composer_entry = _tmp41_;
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp42_ = (GtkEntry*) gtk_entry_new ();
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp42_);
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->grouping_entry);
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->grouping_entry = _tmp42_;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp43_ = (GtkTextView*) gtk_text_view_new ();
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp43_);
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->comment_textview);
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->comment_textview = _tmp43_;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp44_ = self->priv->comment_textview;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_text_view_set_wrap_mode (_tmp44_, GTK_WRAP_WORD_CHAR);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp45_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp45_);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->comment_scrolledwindow);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->comment_scrolledwindow = _tmp45_;
#line 106 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp46_ = self->priv->comment_scrolledwindow;
#line 106 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_scrolled_window_set_policy (_tmp46_, GTK_POLICY_EXTERNAL, GTK_POLICY_AUTOMATIC);
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp47_ = self->priv->comment_scrolledwindow;
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp48_ = self->priv->comment_textview;
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp49_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 500, (gdouble) 1);
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp49_);
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->track_spinbutton);
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->track_spinbutton = _tmp49_;
#line 109 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp50_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 500, (gdouble) 1);
#line 109 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp50_);
#line 109 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->disk_spinbutton);
#line 109 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->disk_spinbutton = _tmp50_;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp51_ = g_date_time_new_now_local ();
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	local_time = _tmp51_;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp52_ = local_time;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp53_ = g_date_time_get_year (_tmp52_);
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp54_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) _tmp53_, (gdouble) 1);
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp54_);
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->year_spinbutton);
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->year_spinbutton = _tmp54_;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp55_ = granite_widgets_rating_new (FALSE, GTK_ICON_SIZE_MENU, FALSE);
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp55_);
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->rating_widget);
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->rating_widget = _tmp55_;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp56_ = self->priv->rating_widget;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp56_, TRUE);
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp57_ = (GtkFrame*) gtk_frame_new (NULL);
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp57_);
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	comment_frame = _tmp57_;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp58_ = comment_frame;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_set ((GtkWidget*) _tmp58_, "expand", TRUE, NULL);
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp59_ = comment_frame;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp60_ = self->priv->comment_scrolledwindow;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_container_add ((GtkContainer*) _tmp59_, (GtkWidget*) _tmp60_);
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp61_ = grid;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp62_ = title_label;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp61_, (GtkWidget*) _tmp62_, 0, 0, 1, 1);
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp63_ = grid;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp64_ = self->priv->title_entry;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp63_, (GtkWidget*) _tmp64_, 0, 1, 1, 1);
#line 121 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp65_ = grid;
#line 121 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp66_ = artist_label;
#line 121 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp65_, (GtkWidget*) _tmp66_, 1, 0, 1, 1);
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp67_ = grid;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp68_ = self->priv->artist_entry;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp67_, (GtkWidget*) _tmp68_, 1, 1, 1, 1);
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp69_ = grid;
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp70_ = album_label;
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp69_, (GtkWidget*) _tmp70_, 0, 2, 1, 1);
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp71_ = grid;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp72_ = self->priv->album_entry;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, 0, 3, 1, 1);
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp73_ = grid;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp74_ = album_artist_label;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp73_, (GtkWidget*) _tmp74_, 1, 2, 1, 1);
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp75_ = grid;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp76_ = self->priv->album_artist_entry;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp75_, (GtkWidget*) _tmp76_, 1, 3, 1, 1);
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp77_ = grid;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp78_ = composer_label;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp77_, (GtkWidget*) _tmp78_, 0, 4, 1, 1);
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp79_ = grid;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp80_ = self->priv->composer_entry;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 0, 5, 1, 1);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp81_ = grid;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp82_ = grouping_label;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp82_, 1, 4, 1, 1);
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp83_ = grid;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp84_ = self->priv->grouping_entry;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp83_, (GtkWidget*) _tmp84_, 1, 5, 1, 1);
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp85_ = grid;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp86_ = genre_label;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp85_, (GtkWidget*) _tmp86_, 0, 6, 1, 1);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp87_ = grid;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp88_ = self->priv->genre_entry;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp87_, (GtkWidget*) _tmp88_, 0, 7, 1, 1);
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp89_ = grid;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp90_ = year_label;
#line 133 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp89_, (GtkWidget*) _tmp90_, 1, 6, 1, 1);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp91_ = grid;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp92_ = self->priv->year_spinbutton;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp91_, (GtkWidget*) _tmp92_, 1, 7, 1, 1);
#line 135 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp93_ = grid;
#line 135 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp94_ = track_label;
#line 135 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp93_, (GtkWidget*) _tmp94_, 1, 8, 1, 1);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp95_ = grid;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp96_ = self->priv->track_spinbutton;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp95_, (GtkWidget*) _tmp96_, 1, 9, 1, 1);
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp97_ = grid;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp98_ = disk_label;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp97_, (GtkWidget*) _tmp98_, 1, 10, 1, 1);
#line 138 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp99_ = grid;
#line 138 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp100_ = self->priv->disk_spinbutton;
#line 138 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp99_, (GtkWidget*) _tmp100_, 1, 11, 1, 1);
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp101_ = grid;
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp102_ = rating_label;
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp101_, (GtkWidget*) _tmp102_, 1, 12, 1, 1);
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp103_ = grid;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp104_ = self->priv->rating_widget;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp103_, (GtkWidget*) _tmp104_, 1, 13, 1, 1);
#line 141 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp105_ = grid;
#line 141 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp106_ = comment_label;
#line 141 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp105_, (GtkWidget*) _tmp106_, 0, 8, 1, 1);
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp107_ = grid;
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp108_ = comment_frame;
#line 142 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp107_, (GtkWidget*) _tmp108_, 0, 9, 1, 5);
#line 144 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp109_ = (GtkButton*) gtk_button_new_from_icon_name ("go-previous-symbolic", GTK_ICON_SIZE_BUTTON);
#line 144 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp109_);
#line 144 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->previous_button);
#line 144 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->previous_button = _tmp109_;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp110_ = (GtkButton*) gtk_button_new_from_icon_name ("go-next-symbolic", GTK_ICON_SIZE_BUTTON);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp110_);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->next_button);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->next_button = _tmp110_;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp111_ = (GtkGrid*) gtk_grid_new ();
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp111_);
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	arrows_grid = _tmp111_;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp112_ = arrows_grid;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp112_, GTK_ORIENTATION_HORIZONTAL);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp113_ = arrows_grid;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_set_column_homogeneous (_tmp113_, TRUE);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp114_ = arrows_grid;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp115_ = gtk_widget_get_style_context ((GtkWidget*) _tmp114_);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_style_context_add_class (_tmp115_, GTK_STYLE_CLASS_LINKED);
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp116_ = arrows_grid;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp117_ = self->priv->previous_button;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_container_add ((GtkContainer*) _tmp116_, (GtkWidget*) _tmp117_);
#line 152 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp118_ = arrows_grid;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp119_ = self->priv->next_button;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_container_add ((GtkContainer*) _tmp118_, (GtkWidget*) _tmp119_);
#line 154 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp120_ = (GtkButton*) gtk_button_new_with_label (_ ("Save"));
#line 154 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp120_);
#line 154 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->save_button);
#line 154 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->save_button = _tmp120_;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp121_ = self->priv->save_button;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp122_ = gtk_widget_get_style_context ((GtkWidget*) _tmp121_);
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_style_context_add_class (_tmp122_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 156 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp123_ = (GtkButton*) gtk_button_new_with_label (_ ("Close"));
#line 156 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp123_);
#line 156 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->close_button);
#line 156 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv->close_button = _tmp123_;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp124_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_ref_sink (_tmp124_);
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	buttons = _tmp124_;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp125_ = buttons;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_object_set (_tmp125_, "layout-style", GTK_BUTTONBOX_END, NULL);
#line 160 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp126_ = buttons;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_box_set_spacing ((GtkBox*) _tmp126_, 6);
#line 161 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp127_ = buttons;
#line 161 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp127_, 6);
#line 163 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp128_ = buttons;
#line 163 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp129_ = arrows_grid;
#line 163 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_box_pack_start ((GtkBox*) _tmp128_, (GtkWidget*) _tmp129_, FALSE, FALSE, (guint) 0);
#line 164 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp130_ = buttons;
#line 164 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp131_ = self->priv->close_button;
#line 164 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_box_pack_end ((GtkBox*) _tmp130_, (GtkWidget*) _tmp131_, FALSE, FALSE, (guint) 0);
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp132_ = buttons;
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp133_ = self->priv->save_button;
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_box_pack_end ((GtkBox*) _tmp132_, (GtkWidget*) _tmp133_, FALSE, FALSE, (guint) 0);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp134_ = buttons;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp135_ = arrows_grid;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_button_box_set_child_secondary (_tmp134_, (GtkWidget*) _tmp135_, TRUE);
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp136_ = buttons;
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp137_ = arrows_grid;
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_button_box_set_child_non_homogeneous (_tmp136_, (GtkWidget*) _tmp137_, TRUE);
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp138_ = grid;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp139_ = buttons;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_grid_attach (_tmp138_, (GtkWidget*) _tmp139_, 0, 14, 2, 1);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp140_ = (GtkBox*) gtk_dialog_get_content_area ((GtkDialog*) self);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp141_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp140_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp140_) : NULL);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	content = _tmp141_;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp142_ = content;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp143_ = grid;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	gtk_container_add (_tmp142_, (GtkWidget*) _tmp143_);
#line 173 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp144_ = self->priv->previous_button;
#line 173 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_signal_connect_object (_tmp144_, "clicked", (GCallback) _noise_media_editor_previous_track_gtk_button_clicked, self, 0);
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp145_ = self->priv->next_button;
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_signal_connect_object (_tmp145_, "clicked", (GCallback) _noise_media_editor_next_track_gtk_button_clicked, self, 0);
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp146_ = self->priv->close_button;
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_signal_connect_object (_tmp146_, "clicked", (GCallback) __noise_media_editor___lambda51__gtk_button_clicked, self, 0);
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_tmp147_ = self->priv->save_button;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_signal_connect_object (_tmp147_, "clicked", (GCallback) _noise_media_editor_save_and_exit_gtk_button_clicked, self, 0);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (content);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (buttons);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (arrows_grid);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (comment_frame);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_date_time_unref0 (local_time);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (rating_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (year_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (disk_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (track_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (comment_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (grouping_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (composer_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (genre_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (album_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (album_artist_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (artist_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (title_label);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (grid);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	return obj;
#line 1957 "MediaEditor.c"
}


static void noise_media_editor_class_init (NoiseMediaEditorClass * klass) {
#line 29 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	noise_media_editor_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	g_type_class_add_private (klass, sizeof (NoiseMediaEditorPrivate));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_media_editor_constructor;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_media_editor_finalize;
#line 1970 "MediaEditor.c"
}


static void noise_media_editor_instance_init (NoiseMediaEditor * self) {
#line 29 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self->priv = NOISE_MEDIA_EDITOR_GET_PRIVATE (self);
#line 1977 "MediaEditor.c"
}


static void noise_media_editor_finalize (GObject * obj) {
	NoiseMediaEditor * self;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_MEDIA_EDITOR, NoiseMediaEditor);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->title_entry);
#line 31 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->artist_entry);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->album_artist_entry);
#line 33 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->album_entry);
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->genre_entry);
#line 35 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->composer_entry);
#line 36 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->grouping_entry);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->comment_textview);
#line 38 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->comment_scrolledwindow);
#line 39 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->track_spinbutton);
#line 40 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->disk_spinbutton);
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->year_spinbutton);
#line 42 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->rating_widget);
#line 44 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->previous_button);
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->next_button);
#line 46 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->save_button);
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->close_button);
#line 49 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->media_list);
#line 50 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->temp_list);
#line 51 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	_g_object_unref0 (self->priv->current_media);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/Dialogs/MediaEditor.vala"
	G_OBJECT_CLASS (noise_media_editor_parent_class)->finalize (obj);
#line 2027 "MediaEditor.c"
}


GType noise_media_editor_get_type (void) {
	static volatile gsize noise_media_editor_type_id__volatile = 0;
	if (g_once_init_enter (&noise_media_editor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseMediaEditorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_media_editor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseMediaEditor), 0, (GInstanceInitFunc) noise_media_editor_instance_init, NULL };
		GType noise_media_editor_type_id;
		noise_media_editor_type_id = g_type_register_static (gtk_dialog_get_type (), "NoiseMediaEditor", &g_define_type_info, 0);
		g_once_init_leave (&noise_media_editor_type_id__volatile, noise_media_editor_type_id);
	}
	return noise_media_editor_type_id__volatile;
}



