/* GStreamerTagger.c generated by valac 0.38.10, the Vala compiler
 * generated from GStreamerTagger.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gst/pbutils/pbutils.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gst/gst.h>
#include <noise-core.h>
#include <float.h>
#include <math.h>
#include <time.h>


#define NOISE_TYPE_GSTREAMER_TAGGER (noise_gstreamer_tagger_get_type ())
#define NOISE_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTagger))
#define NOISE_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTaggerClass))
#define NOISE_IS_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GSTREAMER_TAGGER))
#define NOISE_IS_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GSTREAMER_TAGGER))
#define NOISE_GSTREAMER_TAGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTaggerClass))

typedef struct _NoiseGStreamerTagger NoiseGStreamerTagger;
typedef struct _NoiseGStreamerTaggerClass NoiseGStreamerTaggerClass;
typedef struct _NoiseGStreamerTaggerPrivate NoiseGStreamerTaggerPrivate;
enum  {
	NOISE_GSTREAMER_TAGGER_0_PROPERTY,
	NOISE_GSTREAMER_TAGGER_NUM_PROPERTIES
};
static GParamSpec* noise_gstreamer_tagger_properties[NOISE_GSTREAMER_TAGGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _gst_date_time_unref0(var) ((var == NULL) ? NULL : (var = (gst_date_time_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
enum  {
	NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL,
	NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL,
	NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL,
	NOISE_GSTREAMER_TAGGER_NUM_SIGNALS
};
static guint noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_NUM_SIGNALS] = {0};

struct _NoiseGStreamerTagger {
	GObject parent_instance;
	NoiseGStreamerTaggerPrivate * priv;
};

struct _NoiseGStreamerTaggerClass {
	GObjectClass parent_class;
};

struct _NoiseGStreamerTaggerPrivate {
	GstDiscoverer* d;
	GeeLinkedList* uri_queue;
	GRecMutex __lock_uri_queue;
	GCancellable* cancellable;
};


static gpointer noise_gstreamer_tagger_parent_class = NULL;

GType noise_gstreamer_tagger_get_type (void) G_GNUC_CONST;
#define NOISE_GSTREAMER_TAGGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTaggerPrivate))
#define NOISE_GSTREAMER_TAGGER_DISCOVERER_TIMEOUT 5
NoiseGStreamerTagger* noise_gstreamer_tagger_new (GCancellable* cancellable);
NoiseGStreamerTagger* noise_gstreamer_tagger_construct (GType object_type, GCancellable* cancellable);
static void noise_gstreamer_tagger_import_media (NoiseGStreamerTagger* self, GstDiscovererInfo* info, GError* err);
static void _noise_gstreamer_tagger_import_media_gst_discoverer_discovered (GstDiscoverer* _sender, GstDiscovererInfo* info, GError* err, gpointer self);
static void noise_gstreamer_tagger_file_set_finished (NoiseGStreamerTagger* self);
static void _noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished (GstDiscoverer* _sender, gpointer self);
static void noise_gstreamer_tagger_import_next_file_set (NoiseGStreamerTagger* self);
void noise_gstreamer_tagger_discoverer_import_media (NoiseGStreamerTagger* self, GeeCollection* uris);
static void* __lambda7_ (NoiseGStreamerTagger* self);
static gpointer ___lambda7__gthread_func (gpointer self);
static GDate* _g_date_dup (GDate* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void noise_gstreamer_tagger_finalize (GObject * obj);


static gpointer _g_object_ref0 (gpointer self) {
#line 42 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	return self ? g_object_ref (self) : NULL;
#line 119 "GStreamerTagger.c"
}


static void _noise_gstreamer_tagger_import_media_gst_discoverer_discovered (GstDiscoverer* _sender, GstDiscovererInfo* info, GError* err, gpointer self) {
#line 48 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_import_media ((NoiseGStreamerTagger*) self, info, err);
#line 126 "GStreamerTagger.c"
}


static void _noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished (GstDiscoverer* _sender, gpointer self) {
#line 49 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_file_set_finished ((NoiseGStreamerTagger*) self);
#line 133 "GStreamerTagger.c"
}


NoiseGStreamerTagger* noise_gstreamer_tagger_construct (GType object_type, GCancellable* cancellable) {
	NoiseGStreamerTagger * self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	GError * _inner_error_ = NULL;
#line 41 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	self = (NoiseGStreamerTagger*) g_object_new (object_type, NULL);
#line 42 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = cancellable;
#line 42 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 42 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 42 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	self->priv->cancellable = _tmp1_;
#line 43 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp2_ = self->priv->cancellable;
#line 43 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	if (_tmp2_ == NULL) {
#line 157 "GStreamerTagger.c"
		GCancellable* _tmp3_;
#line 44 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp3_ = g_cancellable_new ();
#line 44 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_object_unref0 (self->priv->cancellable);
#line 44 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		self->priv->cancellable = _tmp3_;
#line 165 "GStreamerTagger.c"
	}
	{
		GstDiscoverer* _tmp4_ = NULL;
		GstDiscoverer* _tmp5_;
		GstDiscoverer* _tmp6_;
		GstDiscoverer* _tmp7_;
		GstDiscoverer* _tmp8_;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp5_ = gst_discoverer_new ((GstClockTime) (NOISE_GSTREAMER_TAGGER_DISCOVERER_TIMEOUT * GST_SECOND), &_inner_error_);
#line 47 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp4_ = _tmp5_;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 179 "GStreamerTagger.c"
			goto __catch78_g_error;
		}
#line 47 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp6_ = _tmp4_;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp4_ = NULL;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_object_unref0 (self->priv->d);
#line 47 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		self->priv->d = _tmp6_;
#line 48 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp7_ = self->priv->d;
#line 48 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_signal_connect_object (_tmp7_, "discovered", (GCallback) _noise_gstreamer_tagger_import_media_gst_discoverer_discovered, self, 0);
#line 49 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp8_ = self->priv->d;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_signal_connect_object (_tmp8_, "finished", (GCallback) _noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished, self, 0);
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_object_unref0 (_tmp4_);
#line 200 "GStreamerTagger.c"
	}
	goto __finally78;
	__catch78_g_error:
	{
		GError* err = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		err = _inner_error_;
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_inner_error_ = NULL;
#line 51 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp9_ = err;
#line 51 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp10_ = _tmp9_->message;
#line 51 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_critical ("GStreamerTagger.vala:51: Could not create Gst discoverer object: %s", _tmp10_);
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_error_free0 (err);
#line 220 "GStreamerTagger.c"
	}
	__finally78:
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_clear_error (&_inner_error_);
#line 46 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		return NULL;
#line 231 "GStreamerTagger.c"
	}
#line 41 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	return self;
#line 235 "GStreamerTagger.c"
}


NoiseGStreamerTagger* noise_gstreamer_tagger_new (GCancellable* cancellable) {
#line 41 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	return noise_gstreamer_tagger_construct (NOISE_TYPE_GSTREAMER_TAGGER, cancellable);
#line 242 "GStreamerTagger.c"
}


static void noise_gstreamer_tagger_file_set_finished (NoiseGStreamerTagger* self) {
	GCancellable* _tmp0_;
	gboolean _tmp1_;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 56 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = self->priv->cancellable;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp1_ = g_cancellable_is_cancelled (_tmp0_);
#line 56 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	if (_tmp1_) {
#line 257 "GStreamerTagger.c"
		GstDiscoverer* _tmp2_;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_debug ("GStreamerTagger.vala:57: import cancelled");
#line 58 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp2_ = self->priv->d;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		gst_discoverer_stop (_tmp2_);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
#line 267 "GStreamerTagger.c"
	} else {
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp3_ = self->priv->uri_queue;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 60 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp5_ = _tmp4_;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp5_ == 0) {
#line 280 "GStreamerTagger.c"
			GstDiscoverer* _tmp6_;
#line 61 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_debug ("GStreamerTagger.vala:61: queue finished");
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp6_ = self->priv->d;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			gst_discoverer_stop (_tmp6_);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
#line 290 "GStreamerTagger.c"
		} else {
#line 65 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_gstreamer_tagger_import_next_file_set (self);
#line 294 "GStreamerTagger.c"
		}
	}
}


static void noise_gstreamer_tagger_import_next_file_set (NoiseGStreamerTagger* self) {
	GError * _inner_error_ = NULL;
#line 69 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 304 "GStreamerTagger.c"
	{
		GeeLinkedList* _tmp0_;
#line 70 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp0_ = self->priv->uri_queue;
#line 70 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_rec_mutex_lock (&self->priv->__lock_uri_queue);
#line 311 "GStreamerTagger.c"
		{
			{
				gchar* uri = NULL;
				GeeLinkedList* _tmp1_;
				gpointer _tmp2_;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp1_ = self->priv->uri_queue;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp2_ = gee_deque_poll_head ((GeeDeque*) _tmp1_);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				uri = (gchar*) _tmp2_;
#line 323 "GStreamerTagger.c"
				{
					gboolean _tmp3_ = FALSE;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp3_ = TRUE;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					while (TRUE) {
#line 330 "GStreamerTagger.c"
						const gchar* _tmp6_;
						GstDiscoverer* _tmp7_;
						const gchar* _tmp8_;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						if (!_tmp3_) {
#line 336 "GStreamerTagger.c"
							GeeLinkedList* _tmp4_;
							gpointer _tmp5_;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
							_tmp4_ = self->priv->uri_queue;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
							_tmp5_ = gee_deque_poll_head ((GeeDeque*) _tmp4_);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
							_g_free0 (uri);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
							uri = (gchar*) _tmp5_;
#line 347 "GStreamerTagger.c"
						}
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						_tmp3_ = FALSE;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						_tmp6_ = uri;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						if (!(_tmp6_ != NULL)) {
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
							break;
#line 357 "GStreamerTagger.c"
						}
#line 72 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						_tmp7_ = self->priv->d;
#line 72 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						_tmp8_ = uri;
#line 72 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						gst_discoverer_discover_uri_async (_tmp7_, _tmp8_);
#line 365 "GStreamerTagger.c"
					}
				}
#line 71 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_g_free0 (uri);
#line 370 "GStreamerTagger.c"
			}
		}
		__finally79:
		{
			GeeLinkedList* _tmp9_;
#line 70 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp9_ = self->priv->uri_queue;
#line 70 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
#line 380 "GStreamerTagger.c"
		}
#line 70 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 70 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 70 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_clear_error (&_inner_error_);
#line 70 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			return;
#line 390 "GStreamerTagger.c"
		}
	}
}


static void* __lambda7_ (NoiseGStreamerTagger* self) {
	void* result = NULL;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_import_next_file_set (self);
#line 85 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	result = NULL;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	return result;
#line 404 "GStreamerTagger.c"
}


static gpointer ___lambda7__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda7_ ((NoiseGStreamerTagger*) self);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_object_unref (self);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	return result;
#line 415 "GStreamerTagger.c"
}


void noise_gstreamer_tagger_discoverer_import_media (NoiseGStreamerTagger* self, GeeCollection* uris) {
	GstDiscoverer* _tmp4_;
	GThread* _tmp5_;
	GThread* _tmp6_;
	GError * _inner_error_ = NULL;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (uris != NULL);
#line 428 "GStreamerTagger.c"
	{
		GeeLinkedList* _tmp0_;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp0_ = self->priv->uri_queue;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_rec_mutex_lock (&self->priv->__lock_uri_queue);
#line 435 "GStreamerTagger.c"
		{
			GeeLinkedList* _tmp1_;
			GeeCollection* _tmp2_;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp1_ = self->priv->uri_queue;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp2_ = uris;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			gee_collection_add_all ((GeeCollection*) _tmp1_, _tmp2_);
#line 445 "GStreamerTagger.c"
		}
		__finally80:
		{
			GeeLinkedList* _tmp3_;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp3_ = self->priv->uri_queue;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
#line 454 "GStreamerTagger.c"
		}
#line 78 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 78 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_clear_error (&_inner_error_);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			return;
#line 464 "GStreamerTagger.c"
		}
	}
#line 82 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp4_ = self->priv->d;
#line 82 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	gst_discoverer_start (_tmp4_);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp5_ = g_thread_new (NULL, ___lambda7__gthread_func, g_object_ref (self));
#line 83 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp6_ = _tmp5_;
#line 83 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_g_thread_unref0 (_tmp6_);
#line 477 "GStreamerTagger.c"
}


static GDate* _g_date_dup (GDate* self) {
	GDate* dup;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	dup = g_new0 (GDate, 1);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	memcpy (dup, self, sizeof (GDate));
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	return dup;
#line 489 "GStreamerTagger.c"
}


static gpointer __g_date_dup0 (gpointer self) {
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	return self ? _g_date_dup (self) : NULL;
#line 496 "GStreamerTagger.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 241 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 503 "GStreamerTagger.c"
}


static inline void _g_list_free__g_object_unref0_ (GList* self) {
#line 241 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 510 "GStreamerTagger.c"
}


static void noise_gstreamer_tagger_import_media (NoiseGStreamerTagger* self, GstDiscovererInfo* info, GError* err) {
	GCancellable* _tmp0_;
	gboolean _tmp1_;
	gchar* uri = NULL;
	GstDiscovererInfo* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean gstreamer_discovery_successful = FALSE;
	GstDiscovererInfo* _tmp9_;
	GstDiscovererResult _tmp10_;
	gboolean _tmp18_;
	NoiseMedia* m = NULL;
	const gchar* _tmp21_;
	NoiseMedia* _tmp22_;
	guint64 duration = 0ULL;
	GstDiscovererInfo* _tmp23_;
	GstClockTime _tmp24_;
	GstTagList* tags = NULL;
	GstDiscovererInfo* _tmp25_;
	GstTagList* _tmp26_;
	GstTagList* _tmp27_;
	NoiseMedia* _tmp130_;
	guint64 _tmp131_;
	guint _tmp132_;
	GstDiscovererInfo* _tmp133_;
	GList* _tmp134_;
	NoiseMedia* _tmp161_;
	NoiseMedia* _tmp162_;
	GFile* _tmp163_;
	GFile* _tmp164_;
	guint64 _tmp165_;
	NoiseMedia* _tmp166_;
	time_t _tmp167_;
	NoiseMedia* _tmp168_;
	GError * _inner_error_ = NULL;
#line 89 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 89 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (info != NULL);
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = self->priv->cancellable;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp1_ = g_cancellable_is_cancelled (_tmp0_);
#line 90 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	if (_tmp1_) {
#line 559 "GStreamerTagger.c"
		GstDiscoverer* _tmp2_;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp2_ = self->priv->d;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		gst_discoverer_stop (_tmp2_);
#line 565 "GStreamerTagger.c"
		{
			GeeLinkedList* _tmp3_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp3_ = self->priv->uri_queue;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_rec_mutex_lock (&self->priv->__lock_uri_queue);
#line 572 "GStreamerTagger.c"
			{
				GeeLinkedList* _tmp4_;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp4_ = self->priv->uri_queue;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp4_);
#line 579 "GStreamerTagger.c"
			}
			__finally81:
			{
				GeeLinkedList* _tmp5_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp5_ = self->priv->uri_queue;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
#line 588 "GStreamerTagger.c"
			}
#line 92 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 92 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				g_clear_error (&_inner_error_);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				return;
#line 598 "GStreamerTagger.c"
			}
		}
#line 96 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		return;
#line 605 "GStreamerTagger.c"
	}
#line 100 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp6_ = info;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp7_ = gst_discoverer_info_get_uri (_tmp6_);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	uri = _tmp8_;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	gstreamer_discovery_successful = FALSE;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp9_ = info;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp10_ = gst_discoverer_info_get_result (_tmp9_);
#line 103 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	switch (_tmp10_) {
#line 103 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_OK:
#line 625 "GStreamerTagger.c"
		{
#line 105 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			gstreamer_discovery_successful = TRUE;
#line 106 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			break;
#line 631 "GStreamerTagger.c"
		}
#line 103 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_URI_INVALID:
#line 635 "GStreamerTagger.c"
		{
			const gchar* _tmp11_;
#line 109 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp11_ = uri;
#line 109 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:109: GStreamer could not import '%s': invalid URI" \
".", _tmp11_);
#line 110 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			break;
#line 644 "GStreamerTagger.c"
		}
#line 103 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_ERROR:
#line 648 "GStreamerTagger.c"
		{
			const gchar* _tmp12_;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp12_ = uri;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp13_ = err;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp14_ = _tmp13_->message;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:113: GStreamer could not import '%s': %s", _tmp12_, _tmp14_);
#line 114 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			break;
#line 663 "GStreamerTagger.c"
		}
#line 103 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_TIMEOUT:
#line 667 "GStreamerTagger.c"
		{
			const gchar* _tmp15_;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp15_ = uri;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:117: GStreamer could not import '%s': Discovery t" \
"imed out.", _tmp15_);
#line 118 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			break;
#line 676 "GStreamerTagger.c"
		}
#line 103 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_BUSY:
#line 680 "GStreamerTagger.c"
		{
			const gchar* _tmp16_;
#line 121 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp16_ = uri;
#line 121 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:121: GStreamer could not import '%s': Already dis" \
"covering a file.", _tmp16_);
#line 122 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			break;
#line 689 "GStreamerTagger.c"
		}
#line 103 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_MISSING_PLUGINS:
#line 693 "GStreamerTagger.c"
		{
			const gchar* _tmp17_;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp17_ = uri;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:125: GStreamer could not import '%s': Missing plu" \
"gins.", _tmp17_);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			break;
#line 702 "GStreamerTagger.c"
		}
		default:
#line 103 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		break;
#line 707 "GStreamerTagger.c"
	}
#line 135 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp18_ = gstreamer_discovery_successful;
#line 135 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	if (!_tmp18_) {
#line 713 "GStreamerTagger.c"
		const gchar* _tmp19_;
		GError* _tmp20_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp19_ = uri;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp20_ = err;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL], 0, _tmp19_, _tmp20_);
#line 137 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (uri);
#line 137 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		return;
#line 726 "GStreamerTagger.c"
	}
#line 140 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp21_ = uri;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp22_ = noise_media_new (_tmp21_);
#line 140 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	m = _tmp22_;
#line 142 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp23_ = info;
#line 142 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp24_ = gst_discoverer_info_get_duration (_tmp23_);
#line 142 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	duration = (guint64) _tmp24_;
#line 146 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp25_ = info;
#line 146 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp26_ = gst_discoverer_info_get_tags (_tmp25_);
#line 146 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	tags = _tmp26_;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp27_ = tags;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	if (_tmp27_ != NULL) {
#line 750 "GStreamerTagger.c"
		gchar* title = NULL;
		GstTagList* _tmp28_;
		gchar* _tmp29_ = NULL;
		gboolean _tmp30_;
		gchar* artist = NULL;
		GstTagList* _tmp33_;
		gchar* _tmp34_ = NULL;
		gboolean _tmp35_;
		gchar* composer = NULL;
		GstTagList* _tmp38_;
		gchar* _tmp39_ = NULL;
		gboolean _tmp40_;
		gchar* album_artist = NULL;
		GstTagList* _tmp43_;
		gchar* _tmp44_ = NULL;
		gboolean _tmp45_;
		gchar* album = NULL;
		GstTagList* _tmp48_;
		gchar* _tmp49_ = NULL;
		gboolean _tmp50_;
		gchar* grouping = NULL;
		GstTagList* _tmp53_;
		gchar* _tmp54_ = NULL;
		gboolean _tmp55_;
		gchar* genre = NULL;
		GstTagList* _tmp58_;
		gchar* _tmp59_ = NULL;
		gboolean _tmp60_;
		gchar* comment = NULL;
		GstTagList* _tmp63_;
		gchar* _tmp64_ = NULL;
		gboolean _tmp65_;
		gchar* lyrics = NULL;
		GstTagList* _tmp68_;
		gchar* _tmp69_ = NULL;
		gboolean _tmp70_;
		guint track_number = 0U;
		GstTagList* _tmp73_;
		guint _tmp74_ = 0U;
		gboolean _tmp75_;
		guint track_count = 0U;
		GstTagList* _tmp78_;
		guint _tmp79_ = 0U;
		gboolean _tmp80_;
		guint album_number = 0U;
		GstTagList* _tmp83_;
		guint _tmp84_ = 0U;
		gboolean _tmp85_;
		guint album_count = 0U;
		GstTagList* _tmp88_;
		guint _tmp89_ = 0U;
		gboolean _tmp90_;
		guint bitrate = 0U;
		GstTagList* _tmp93_;
		guint _tmp94_ = 0U;
		gboolean _tmp95_;
		guint rating = 0U;
		GstTagList* _tmp98_;
		guint _tmp99_ = 0U;
		gboolean _tmp100_;
		GstDateTime* datetime = NULL;
		GstTagList* _tmp103_;
		GstDateTime* _tmp104_ = NULL;
		gboolean _tmp105_;
		gdouble bpm = 0.0;
		GstTagList* _tmp119_;
		gdouble _tmp120_ = 0.0;
		gboolean _tmp121_;
		guint64 _tmp126_;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp28_ = tags;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp30_ = gst_tag_list_get_string (_tmp28_, GST_TAG_TITLE, &_tmp29_);
#line 151 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (title);
#line 151 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		title = _tmp29_;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp30_) {
#line 830 "GStreamerTagger.c"
			NoiseMedia* _tmp31_;
			const gchar* _tmp32_;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp31_ = m;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp32_ = title;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_title (_tmp31_, _tmp32_);
#line 839 "GStreamerTagger.c"
		}
#line 155 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp33_ = tags;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp35_ = gst_tag_list_get_string (_tmp33_, GST_TAG_ARTIST, &_tmp34_);
#line 155 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (artist);
#line 155 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		artist = _tmp34_;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp35_) {
#line 851 "GStreamerTagger.c"
			NoiseMedia* _tmp36_;
			const gchar* _tmp37_;
#line 156 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp36_ = m;
#line 156 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp37_ = artist;
#line 156 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_artist (_tmp36_, _tmp37_);
#line 860 "GStreamerTagger.c"
		}
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp38_ = tags;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp40_ = gst_tag_list_get_string (_tmp38_, GST_TAG_COMPOSER, &_tmp39_);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (composer);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		composer = _tmp39_;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp40_) {
#line 872 "GStreamerTagger.c"
			NoiseMedia* _tmp41_;
			const gchar* _tmp42_;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp41_ = m;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp42_ = composer;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_composer (_tmp41_, _tmp42_);
#line 881 "GStreamerTagger.c"
		}
#line 163 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp43_ = tags;
#line 163 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp45_ = gst_tag_list_get_string (_tmp43_, GST_TAG_ALBUM_ARTIST, &_tmp44_);
#line 163 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album_artist);
#line 163 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		album_artist = _tmp44_;
#line 163 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp45_) {
#line 893 "GStreamerTagger.c"
			NoiseMedia* _tmp46_;
			const gchar* _tmp47_;
#line 164 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp46_ = m;
#line 164 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp47_ = album_artist;
#line 164 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album_artist (_tmp46_, _tmp47_);
#line 902 "GStreamerTagger.c"
		}
#line 167 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp48_ = tags;
#line 167 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp50_ = gst_tag_list_get_string (_tmp48_, GST_TAG_ALBUM, &_tmp49_);
#line 167 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album);
#line 167 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		album = _tmp49_;
#line 167 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp50_) {
#line 914 "GStreamerTagger.c"
			NoiseMedia* _tmp51_;
			const gchar* _tmp52_;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp51_ = m;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp52_ = album;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album (_tmp51_, _tmp52_);
#line 923 "GStreamerTagger.c"
		}
#line 171 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp53_ = tags;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp55_ = gst_tag_list_get_string (_tmp53_, GST_TAG_GROUPING, &_tmp54_);
#line 171 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (grouping);
#line 171 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		grouping = _tmp54_;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp55_) {
#line 935 "GStreamerTagger.c"
			NoiseMedia* _tmp56_;
			const gchar* _tmp57_;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp56_ = m;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp57_ = grouping;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_grouping (_tmp56_, _tmp57_);
#line 944 "GStreamerTagger.c"
		}
#line 175 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp58_ = tags;
#line 175 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp60_ = gst_tag_list_get_string (_tmp58_, GST_TAG_GENRE, &_tmp59_);
#line 175 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (genre);
#line 175 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		genre = _tmp59_;
#line 175 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp60_) {
#line 956 "GStreamerTagger.c"
			NoiseMedia* _tmp61_;
			const gchar* _tmp62_;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp61_ = m;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp62_ = genre;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_genre (_tmp61_, _tmp62_);
#line 965 "GStreamerTagger.c"
		}
#line 179 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp63_ = tags;
#line 179 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp65_ = gst_tag_list_get_string (_tmp63_, GST_TAG_COMMENT, &_tmp64_);
#line 179 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (comment);
#line 179 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		comment = _tmp64_;
#line 179 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp65_) {
#line 977 "GStreamerTagger.c"
			NoiseMedia* _tmp66_;
			const gchar* _tmp67_;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp66_ = m;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp67_ = comment;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_comment (_tmp66_, _tmp67_);
#line 986 "GStreamerTagger.c"
		}
#line 183 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp68_ = tags;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp70_ = gst_tag_list_get_string (_tmp68_, GST_TAG_LYRICS, &_tmp69_);
#line 183 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (lyrics);
#line 183 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		lyrics = _tmp69_;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp70_) {
#line 998 "GStreamerTagger.c"
			NoiseMedia* _tmp71_;
			const gchar* _tmp72_;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp71_ = m;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp72_ = lyrics;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_lyrics (_tmp71_, _tmp72_);
#line 1007 "GStreamerTagger.c"
		}
#line 187 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp73_ = tags;
#line 187 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp75_ = gst_tag_list_get_uint (_tmp73_, GST_TAG_TRACK_NUMBER, &_tmp74_);
#line 187 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		track_number = _tmp74_;
#line 187 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp75_) {
#line 1017 "GStreamerTagger.c"
			NoiseMedia* _tmp76_;
			guint _tmp77_;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp76_ = m;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp77_ = track_number;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_track (_tmp76_, _tmp77_);
#line 1026 "GStreamerTagger.c"
		}
#line 191 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp78_ = tags;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp80_ = gst_tag_list_get_uint (_tmp78_, GST_TAG_TRACK_COUNT, &_tmp79_);
#line 191 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		track_count = _tmp79_;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp80_) {
#line 1036 "GStreamerTagger.c"
			NoiseMedia* _tmp81_;
			guint _tmp82_;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp81_ = m;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp82_ = track_count;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_track_count (_tmp81_, _tmp82_);
#line 1045 "GStreamerTagger.c"
		}
#line 195 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp83_ = tags;
#line 195 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp85_ = gst_tag_list_get_uint (_tmp83_, GST_TAG_ALBUM_VOLUME_NUMBER, &_tmp84_);
#line 195 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		album_number = _tmp84_;
#line 195 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp85_) {
#line 1055 "GStreamerTagger.c"
			NoiseMedia* _tmp86_;
			guint _tmp87_;
#line 196 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp86_ = m;
#line 196 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp87_ = album_number;
#line 196 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album_number (_tmp86_, _tmp87_);
#line 1064 "GStreamerTagger.c"
		}
#line 199 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp88_ = tags;
#line 199 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp90_ = gst_tag_list_get_uint (_tmp88_, GST_TAG_ALBUM_VOLUME_COUNT, &_tmp89_);
#line 199 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		album_count = _tmp89_;
#line 199 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp90_) {
#line 1074 "GStreamerTagger.c"
			NoiseMedia* _tmp91_;
			guint _tmp92_;
#line 200 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp91_ = m;
#line 200 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp92_ = album_count;
#line 200 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album_count (_tmp91_, _tmp92_);
#line 1083 "GStreamerTagger.c"
		}
#line 203 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp93_ = tags;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp95_ = gst_tag_list_get_uint (_tmp93_, GST_TAG_BITRATE, &_tmp94_);
#line 203 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		bitrate = _tmp94_;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp95_) {
#line 1093 "GStreamerTagger.c"
			NoiseMedia* _tmp96_;
			guint _tmp97_;
#line 204 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp96_ = m;
#line 204 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp97_ = bitrate;
#line 204 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_bitrate (_tmp96_, _tmp97_ / 1000);
#line 1102 "GStreamerTagger.c"
		}
#line 207 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp98_ = tags;
#line 207 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp100_ = gst_tag_list_get_uint (_tmp98_, GST_TAG_USER_RATING, &_tmp99_);
#line 207 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		rating = _tmp99_;
#line 207 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp100_) {
#line 1112 "GStreamerTagger.c"
			NoiseMedia* _tmp101_;
			guint _tmp102_;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp101_ = m;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp102_ = rating;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_rating (_tmp101_, _tmp102_);
#line 1121 "GStreamerTagger.c"
		}
#line 214 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp103_ = tags;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp105_ = gst_tag_list_get_date_time (_tmp103_, GST_TAG_DATE_TIME, &_tmp104_);
#line 214 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_gst_date_time_unref0 (datetime);
#line 214 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		datetime = _tmp104_;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp105_) {
#line 1133 "GStreamerTagger.c"
			GstDateTime* _tmp106_;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp106_ = datetime;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			if (_tmp106_ != NULL) {
#line 1139 "GStreamerTagger.c"
				NoiseMedia* _tmp107_;
				GstDateTime* _tmp108_;
				gint _tmp109_;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp107_ = m;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp108_ = datetime;
#line 218 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp109_ = gst_date_time_get_year (_tmp108_);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				noise_media_set_year (_tmp107_, (guint) _tmp109_);
#line 1151 "GStreamerTagger.c"
			} else {
				GDate* date = NULL;
				GstTagList* _tmp110_;
				GDate _tmp111_ = {0};
				gboolean _tmp112_;
				GDate _tmp113_;
				GDate* _tmp114_;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp110_ = tags;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp112_ = gst_tag_list_get_date (_tmp110_, GST_TAG_DATE, &_tmp111_);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_g_free0 (date);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp113_ = _tmp111_;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp114_ = __g_date_dup0 (&_tmp113_);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				date = _tmp114_;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				if (_tmp112_) {
#line 1173 "GStreamerTagger.c"
					GDate* _tmp115_;
#line 224 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp115_ = date;
#line 224 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					if (_tmp115_ != NULL) {
#line 1179 "GStreamerTagger.c"
						NoiseMedia* _tmp116_;
						GDate* _tmp117_;
						GDateYear _tmp118_;
#line 225 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						_tmp116_ = m;
#line 225 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						_tmp117_ = date;
#line 225 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						_tmp118_ = g_date_get_year (_tmp117_);
#line 225 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
						noise_media_set_year (_tmp116_, (guint) _tmp118_);
#line 1191 "GStreamerTagger.c"
					}
				}
#line 217 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_g_free0 (date);
#line 1196 "GStreamerTagger.c"
			}
		}
#line 232 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp119_ = tags;
#line 232 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp121_ = gst_tag_list_get_double (_tmp119_, GST_TAG_BEATS_PER_MINUTE, &_tmp120_);
#line 232 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		bpm = _tmp120_;
#line 232 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp121_) {
#line 1207 "GStreamerTagger.c"
			NoiseMedia* _tmp122_;
			gdouble _tmp123_;
			gdouble _tmp124_;
			gdouble _tmp125_;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp122_ = m;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp123_ = bpm;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp124_ = bpm;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp125_ = CLAMP (_tmp123_, (gdouble) 0, _tmp124_);
#line 233 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			noise_media_set_bpm (_tmp122_, (guint) _tmp125_);
#line 1222 "GStreamerTagger.c"
		}
#line 235 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_tmp126_ = duration;
#line 235 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		if (_tmp126_ == ((guint64) 0)) {
#line 1228 "GStreamerTagger.c"
			GstTagList* _tmp127_;
			guint64 _tmp128_ = 0ULL;
			gboolean _tmp129_;
#line 236 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp127_ = tags;
#line 236 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp129_ = gst_tag_list_get_uint64 (_tmp127_, GST_TAG_DURATION, &_tmp128_);
#line 236 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			duration = _tmp128_;
#line 236 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			if (!_tmp129_) {
#line 237 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				duration = (guint64) 0;
#line 1242 "GStreamerTagger.c"
			}
		}
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_gst_date_time_unref0 (datetime);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (lyrics);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (comment);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (genre);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (grouping);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album_artist);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (composer);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (artist);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		_g_free0 (title);
#line 1265 "GStreamerTagger.c"
	}
#line 240 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp130_ = m;
#line 240 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp131_ = duration;
#line 240 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp132_ = noise_time_utils_nanoseconds_to_miliseconds (_tmp131_);
#line 240 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	noise_media_set_length (_tmp130_, _tmp132_);
#line 241 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp133_ = info;
#line 241 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp134_ = gst_discoverer_info_get_audio_streams (_tmp133_);
#line 1279 "GStreamerTagger.c"
	{
		GList* stream_info_collection = NULL;
		GList* stream_info_it = NULL;
#line 241 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		stream_info_collection = _tmp134_;
#line 241 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		for (stream_info_it = stream_info_collection; stream_info_it != NULL; stream_info_it = stream_info_it->next) {
#line 1287 "GStreamerTagger.c"
			GstDiscovererStreamInfo* _tmp135_;
			GstDiscovererStreamInfo* stream_info = NULL;
#line 241 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			_tmp135_ = _g_object_ref0 ((GstDiscovererStreamInfo*) stream_info_it->data);
#line 241 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
			stream_info = _tmp135_;
#line 1294 "GStreamerTagger.c"
			{
				GstDiscovererAudioInfo* audio_stream = NULL;
				GstDiscovererStreamInfo* _tmp136_;
				GstDiscovererAudioInfo* _tmp137_;
				GstDiscovererAudioInfo* _tmp138_;
				NoiseMedia* _tmp139_;
				guint _tmp140_;
				guint _tmp141_;
				NoiseMedia* _tmp150_;
				guint _tmp151_;
				guint _tmp152_;
#line 242 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp136_ = stream_info;
#line 242 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp137_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp136_, gst_discoverer_audio_info_get_type ()) ? ((GstDiscovererAudioInfo*) _tmp136_) : NULL);
#line 242 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				audio_stream = _tmp137_;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp138_ = audio_stream;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				if (_tmp138_ == NULL) {
#line 244 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_g_object_unref0 (audio_stream);
#line 244 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_g_object_unref0 (stream_info);
#line 244 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					continue;
#line 1322 "GStreamerTagger.c"
				}
#line 246 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp139_ = m;
#line 246 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp140_ = noise_media_get_samplerate (_tmp139_);
#line 246 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp141_ = _tmp140_;
#line 246 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				if (_tmp141_ == ((guint) 0)) {
#line 1332 "GStreamerTagger.c"
					NoiseMedia* _tmp142_;
					GstDiscovererAudioInfo* _tmp143_;
					guint _tmp144_;
					NoiseMedia* _tmp145_;
					guint _tmp146_;
					guint _tmp147_;
					gchar* _tmp148_;
					gchar* _tmp149_;
#line 247 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:247: Getting sample rate from stream info");
#line 248 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp142_ = m;
#line 248 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp143_ = audio_stream;
#line 248 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp144_ = gst_discoverer_audio_info_get_sample_rate (_tmp143_);
#line 248 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					noise_media_set_samplerate (_tmp142_, _tmp144_);
#line 249 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp145_ = m;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp146_ = noise_media_get_samplerate (_tmp145_);
#line 249 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp147_ = _tmp146_;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp148_ = g_strdup_printf ("%u", _tmp147_);
#line 249 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp149_ = _tmp148_;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:249: Sample rate = %s", _tmp149_);
#line 249 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_g_free0 (_tmp149_);
#line 1365 "GStreamerTagger.c"
				}
#line 252 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp150_ = m;
#line 252 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp151_ = noise_media_get_bitrate (_tmp150_);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_tmp152_ = _tmp151_;
#line 252 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				if (_tmp152_ == ((guint) 0)) {
#line 1375 "GStreamerTagger.c"
					NoiseMedia* _tmp153_;
					GstDiscovererAudioInfo* _tmp154_;
					guint _tmp155_;
					NoiseMedia* _tmp156_;
					guint _tmp157_;
					guint _tmp158_;
					gchar* _tmp159_;
					gchar* _tmp160_;
#line 253 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:253: Getting bitrate from stream info");
#line 254 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp153_ = m;
#line 254 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp154_ = audio_stream;
#line 254 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp155_ = gst_discoverer_audio_info_get_bitrate (_tmp154_);
#line 254 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					noise_media_set_bitrate (_tmp153_, _tmp155_);
#line 255 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp156_ = m;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp157_ = noise_media_get_bitrate (_tmp156_);
#line 255 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp158_ = _tmp157_;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp159_ = g_strdup_printf ("%u", _tmp158_);
#line 255 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_tmp160_ = _tmp159_;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:255: Bitrate = %s", _tmp160_);
#line 255 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
					_g_free0 (_tmp160_);
#line 1408 "GStreamerTagger.c"
				}
#line 258 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_g_object_unref0 (audio_stream);
#line 258 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				_g_object_unref0 (stream_info);
#line 258 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
				break;
#line 1416 "GStreamerTagger.c"
			}
		}
#line 241 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		__g_list_free__g_object_unref0_0 (stream_info_collection);
#line 1421 "GStreamerTagger.c"
	}
#line 261 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp161_ = m;
#line 261 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp162_ = m;
#line 261 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp163_ = noise_media_get_file (_tmp162_);
#line 261 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp164_ = _tmp163_;
#line 261 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp165_ = noise_file_utils_get_size (_tmp164_, NULL);
#line 261 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	noise_media_set_file_size (_tmp161_, _tmp165_);
#line 262 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp166_ = m;
#line 262 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp167_ = time (NULL);
#line 262 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	noise_media_set_date_added (_tmp166_, (guint) ((gint) _tmp167_));
#line 263 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp168_ = m;
#line 263 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL], 0, _tmp168_);
#line 89 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (m);
#line 89 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_g_free0 (uri);
#line 1449 "GStreamerTagger.c"
}


static void g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_POINTER) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (n_param_values == 3);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		data1 = closure->data;
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		data2 = param_values->data[0].v_pointer;
#line 1468 "GStreamerTagger.c"
	} else {
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		data1 = param_values->data[0].v_pointer;
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
		data2 = closure->data;
#line 1474 "GStreamerTagger.c"
	}
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	callback = (GMarshalFunc_VOID__STRING_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_pointer (param_values + 2), data2);
#line 1480 "GStreamerTagger.c"
}


static void noise_gstreamer_tagger_class_init (NoiseGStreamerTaggerClass * klass) {
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_parent_class = g_type_class_peek_parent (klass);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_type_class_add_private (klass, sizeof (NoiseGStreamerTaggerPrivate));
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_gstreamer_tagger_finalize;
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL] = g_signal_new ("media-imported", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_MEDIA);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL] = g_signal_new ("import-error", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_POINTER, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_POINTER);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL] = g_signal_new ("queue-finished", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1497 "GStreamerTagger.c"
}


static void noise_gstreamer_tagger_instance_init (NoiseGStreamerTagger * self) {
	GeeLinkedList* _tmp0_;
	GCancellable* _tmp1_;
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	self->priv = NOISE_GSTREAMER_TAGGER_GET_PRIVATE (self);
#line 38 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_rec_mutex_init (&self->priv->__lock_uri_queue);
#line 38 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 38 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	self->priv->uri_queue = _tmp0_;
#line 39 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_tmp1_ = g_cancellable_new ();
#line 39 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	self->priv->cancellable = _tmp1_;
#line 1516 "GStreamerTagger.c"
}


static void noise_gstreamer_tagger_finalize (GObject * obj) {
	NoiseGStreamerTagger * self;
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTagger);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->d);
#line 38 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	g_rec_mutex_clear (&self->priv->__lock_uri_queue);
#line 38 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->uri_queue);
#line 39 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/GStreamer/GStreamerTagger.vala"
	G_OBJECT_CLASS (noise_gstreamer_tagger_parent_class)->finalize (obj);
#line 1534 "GStreamerTagger.c"
}


GType noise_gstreamer_tagger_get_type (void) {
	static volatile gsize noise_gstreamer_tagger_type_id__volatile = 0;
	if (g_once_init_enter (&noise_gstreamer_tagger_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseGStreamerTaggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_gstreamer_tagger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseGStreamerTagger), 0, (GInstanceInitFunc) noise_gstreamer_tagger_instance_init, NULL };
		GType noise_gstreamer_tagger_type_id;
		noise_gstreamer_tagger_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseGStreamerTagger", &g_define_type_info, 0);
		g_once_init_leave (&noise_gstreamer_tagger_type_id__volatile, noise_gstreamer_tagger_type_id);
	}
	return noise_gstreamer_tagger_type_id__volatile;
}



