/* LocalSmartPlaylist.c generated by valac 0.38.10, the Vala compiler
 * generated from LocalSmartPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <noise-core.h>
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>


#define NOISE_TYPE_LOCAL_SMART_PLAYLIST (noise_local_smart_playlist_get_type ())
#define NOISE_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist))
#define NOISE_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylistClass))
#define NOISE_IS_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_SMART_PLAYLIST))
#define NOISE_IS_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_SMART_PLAYLIST))
#define NOISE_LOCAL_SMART_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylistClass))

typedef struct _NoiseLocalSmartPlaylist NoiseLocalSmartPlaylist;
typedef struct _NoiseLocalSmartPlaylistClass NoiseLocalSmartPlaylistClass;
typedef struct _NoiseLocalSmartPlaylistPrivate NoiseLocalSmartPlaylistPrivate;
enum  {
	NOISE_LOCAL_SMART_PLAYLIST_0_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY,
	NOISE_LOCAL_SMART_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define __g_slist_free___vala_GValue_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free___vala_GValue_free0_ (var), NULL)))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))

struct _NoiseLocalSmartPlaylist {
	NoiseSmartPlaylist parent_instance;
	NoiseLocalSmartPlaylistPrivate * priv;
};

struct _NoiseLocalSmartPlaylistClass {
	NoiseSmartPlaylistClass parent_class;
};

struct _NoiseLocalSmartPlaylistPrivate {
	GdaConnection* connection;
	gchar* _name;
};


static gpointer noise_local_smart_playlist_parent_class = NULL;

GType noise_local_smart_playlist_get_type (void) G_GNUC_CONST;
#define NOISE_LOCAL_SMART_PLAYLIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylistPrivate))
#define NOISE_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR "<query_sep>"
#define NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR "<val_sep>"
NoiseLocalSmartPlaylist* noise_local_smart_playlist_new (gint64 rowid, GdaConnection* connection);
NoiseLocalSmartPlaylist* noise_local_smart_playlist_construct (GType object_type, gint64 rowid, GdaConnection* connection);
GValue* noise_database_query_field (gint64 rowid, GdaConnection* connection, const gchar* table, const gchar* field);
#define NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME "smart_playlists"
static void _vala_GValue_free (GValue* self);
void noise_local_smart_playlist_queries_from_string (NoiseLocalSmartPlaylist* self, const gchar* q);
static void noise_local_smart_playlist_real_analyse_all (NoiseSmartPlaylist* base);
static gint64* _int64_dup (gint64* self);
#define NOISE_DATABASE_MEDIA_TABLE_NAME "media"
GdaSqlBuilderId noise_database_process_smart_query (GdaSqlBuilder* builder, NoiseSmartQuery* sq);
static void _vala_array_add2 (GdaSqlBuilderId* * array, int* length, int* size, GdaSqlBuilderId value);
static void noise_local_smart_playlist_real_clear_queries (NoiseSmartPlaylist* base);
void noise_database_set_field (gint64 rowid, GdaConnection* connection, const gchar* table, const gchar* field, GValue* value);
static void noise_local_smart_playlist_real_add_query (NoiseSmartPlaylist* base, NoiseSmartQuery* s);
static gchar* noise_local_smart_playlist_queries_to_string (NoiseLocalSmartPlaylist* self);
static void noise_local_smart_playlist_real_add_queries (NoiseSmartPlaylist* base, GeeCollection* queries);
void noise_local_smart_playlist_add_defaults (GdaConnection* connection);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void noise_local_smart_playlist_finalize (GObject * obj);
static void _vala_noise_local_smart_playlist_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_local_smart_playlist_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gpointer _g_object_ref0 (gpointer self) {
#line 84 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	return self ? g_object_ref (self) : NULL;
#line 123 "LocalSmartPlaylist.c"
}


static void _vala_GValue_free (GValue* self) {
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_unset (self);
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_free (self);
#line 132 "LocalSmartPlaylist.c"
}


NoiseLocalSmartPlaylist* noise_local_smart_playlist_construct (GType object_type, gint64 rowid, GdaConnection* connection) {
	NoiseLocalSmartPlaylist * self = NULL;
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
	GdaConnection* _tmp2_;
	GdaConnection* _tmp3_;
	gint64 _tmp4_;
	gchar* queries_str = NULL;
	gint64 _tmp5_;
	GdaConnection* _tmp6_;
	GValue* _tmp7_;
	GValue* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 82 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_libraries_manager;
#line 83 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_->local_library;
#line 83 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) noise_smart_playlist_construct (object_type, _tmp1_);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = connection;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (self->priv->connection);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->connection = _tmp3_;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = rowid;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_playlist_set_rowid ((NoisePlaylist*) self, _tmp4_);
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = rowid;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp6_ = connection;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp7_ = noise_database_query_field (_tmp5_, _tmp6_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries");
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp8_ = _tmp7_;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp9_ = g_value_get_string (_tmp8_);
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp11_ = _tmp10_;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp8_);
#line 86 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	queries_str = _tmp11_;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_local_smart_playlist_queries_from_string (self, queries_str);
#line 82 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (queries_str);
#line 82 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	return self;
#line 195 "LocalSmartPlaylist.c"
}


NoiseLocalSmartPlaylist* noise_local_smart_playlist_new (gint64 rowid, GdaConnection* connection) {
#line 82 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	return noise_local_smart_playlist_construct (NOISE_TYPE_LOCAL_SMART_PLAYLIST, rowid, connection);
#line 202 "LocalSmartPlaylist.c"
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
#line 98 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	dup = g_new0 (gint64, 1);
#line 98 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	memcpy (dup, self, sizeof (gint64));
#line 98 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	return dup;
#line 214 "LocalSmartPlaylist.c"
}


static void _vala_array_add2 (GdaSqlBuilderId* * array, int* length, int* size, GdaSqlBuilderId value) {
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	if ((*length) == (*size)) {
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		*array = g_renew (GdaSqlBuilderId, *array, *size);
#line 225 "LocalSmartPlaylist.c"
	}
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	(*array)[(*length)++] = value;
#line 229 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_real_analyse_all (NoiseSmartPlaylist* base) {
	NoiseLocalSmartPlaylist * self;
	GeeTreeSet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeTreeSet* rowids = NULL;
	GeeTreeSet* _tmp10_;
	GError * _inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = ((NoiseSmartPlaylist*) self)->queries;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 91 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	if (_tmp2_) {
#line 251 "LocalSmartPlaylist.c"
		GeeCollection* meds = NULL;
		NoiseLibrary* _tmp3_;
		NoiseLibrary* _tmp4_;
		GeeCollection* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp3_ = noise_smart_playlist_get_library ((NoiseSmartPlaylist*) self);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp4_ = _tmp3_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp5_ = noise_library_get_medias (_tmp4_);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		meds = _tmp5_;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp6_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 93 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp7_ = _tmp6_;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp8_ = meds;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gee_array_list_add_all (_tmp7_, _tmp8_);
#line 94 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp9_ = meds;
#line 94 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_signal_emit_by_name ((NoisePlaylist*) self, "media-added", _tmp9_);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (meds);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		return;
#line 284 "LocalSmartPlaylist.c"
	}
#line 98 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp10_ = gee_tree_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 98 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	rowids = _tmp10_;
#line 290 "LocalSmartPlaylist.c"
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp11_;
		GdaSqlBuilder* _tmp12_;
		GdaSqlBuilder* _tmp13_;
		GdaSqlBuilderId* ids = NULL;
		gint ids_length1;
		gint _ids_size_;
		GdaSqlOperatorType sql_operator_type = 0;
		NoiseSmartPlaylistConditionalType _tmp24_;
		NoiseSmartPlaylistConditionalType _tmp25_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp26_;
		GdaSqlOperatorType _tmp27_;
		GdaSqlBuilderId* _tmp28_;
		gint _tmp28__length1;
		GdaSqlBuilderId _tmp29_;
		GdaSqlBuilder* _tmp30_;
		GdaSqlBuilderId _tmp31_;
		GdaStatement* statm = NULL;
		GdaSqlBuilder* _tmp32_;
		GdaStatement* _tmp33_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp34_;
		GdaStatement* _tmp35_;
		GdaDataModel* _tmp36_;
		GdaDataModelIter* data_model_iter = NULL;
		GdaDataModel* _tmp37_;
		GdaDataModelIter* _tmp38_;
		GdaDataModelIter* _tmp39_;
		GeeCollection* meds = NULL;
		NoiseLibrary* _tmp47_;
		NoiseLibrary* _tmp48_;
		GeeTreeSet* _tmp49_;
		GeeCollection* _tmp50_;
		GeeArrayList* _tmp51_;
		GeeArrayList* _tmp52_;
		GeeCollection* _tmp53_;
		GeeCollection* _tmp54_;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp11_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		sql = _tmp11_;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp12_ = sql;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gda_sql_builder_select_add_target (_tmp12_, NOISE_DATABASE_MEDIA_TABLE_NAME, NULL);
#line 102 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp13_ = sql;
#line 102 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gda_sql_builder_select_add_field (_tmp13_, "rowid", NULL, NULL);
#line 103 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		ids = NULL;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		ids_length1 = 0;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_ids_size_ = ids_length1;
#line 348 "LocalSmartPlaylist.c"
		{
			GeeIterator* _q_it = NULL;
			GeeTreeSet* _tmp14_;
			GeeIterator* _tmp15_;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp14_ = ((NoiseSmartPlaylist*) self)->queries;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_q_it = _tmp15_;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			while (TRUE) {
#line 361 "LocalSmartPlaylist.c"
				GeeIterator* _tmp16_;
				gboolean _tmp17_;
				NoiseSmartQuery* q = NULL;
				GeeIterator* _tmp18_;
				gpointer _tmp19_;
				GdaSqlBuilderId* _tmp20_;
				gint _tmp20__length1;
				GdaSqlBuilder* _tmp21_;
				NoiseSmartQuery* _tmp22_;
				GdaSqlBuilderId _tmp23_;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp16_ = _q_it;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp17_ = gee_iterator_next (_tmp16_);
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				if (!_tmp17_) {
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					break;
#line 380 "LocalSmartPlaylist.c"
				}
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp18_ = _q_it;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp19_ = gee_iterator_get (_tmp18_);
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				q = (NoiseSmartQuery*) _tmp19_;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp20_ = ids;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp20__length1 = ids_length1;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp21_ = sql;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp22_ = q;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp23_ = noise_database_process_smart_query (_tmp21_, _tmp22_);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_vala_array_add2 (&ids, &ids_length1, &_ids_size_, _tmp23_);
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_g_object_unref0 (q);
#line 402 "LocalSmartPlaylist.c"
			}
#line 104 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (_q_it);
#line 406 "LocalSmartPlaylist.c"
		}
#line 108 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		sql_operator_type = GDA_SQL_OPERATOR_TYPE_AND;
#line 109 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp24_ = noise_smart_playlist_get_conditional ((NoiseSmartPlaylist*) self);
#line 109 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp25_ = _tmp24_;
#line 109 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		if (_tmp25_ == NOISE_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY) {
#line 110 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			sql_operator_type = GDA_SQL_OPERATOR_TYPE_OR;
#line 418 "LocalSmartPlaylist.c"
		}
#line 113 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp26_ = sql;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp27_ = sql_operator_type;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp28_ = ids;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp28__length1 = ids_length1;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp29_ = gda_sql_builder_add_cond_v (_tmp26_, _tmp27_, _tmp28_, _tmp28__length1);
#line 113 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		id_cond = _tmp29_;
#line 114 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp30_ = sql;
#line 114 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp31_ = id_cond;
#line 114 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gda_sql_builder_set_where (_tmp30_, _tmp31_);
#line 116 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp32_ = sql;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp33_ = gda_sql_builder_get_statement (_tmp32_, &_inner_error_);
#line 116 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		statm = _tmp33_;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 116 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			ids = (g_free (ids), NULL);
#line 116 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (sql);
#line 450 "LocalSmartPlaylist.c"
			goto __catch62_g_error;
		}
#line 117 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp34_ = self->priv->connection;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp35_ = statm;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp36_ = gda_connection_statement_execute_select (_tmp34_, _tmp35_, NULL, &_inner_error_);
#line 117 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		data_model = _tmp36_;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 117 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (statm);
#line 117 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			ids = (g_free (ids), NULL);
#line 117 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (sql);
#line 469 "LocalSmartPlaylist.c"
			goto __catch62_g_error;
		}
#line 118 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp37_ = data_model;
#line 118 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp38_ = gda_data_model_create_iter (_tmp37_);
#line 118 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		data_model_iter = _tmp38_;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp39_ = data_model_iter;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gda_data_model_iter_move_to_row (_tmp39_, -1);
#line 120 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		while (TRUE) {
#line 484 "LocalSmartPlaylist.c"
			GdaDataModelIter* _tmp40_;
			gboolean _tmp41_;
			GValue* val = NULL;
			GdaDataModelIter* _tmp42_;
			GValue* _tmp43_;
			GeeTreeSet* _tmp44_;
			GValue* _tmp45_;
			gint64 _tmp46_;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp40_ = data_model_iter;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp41_ = gda_data_model_iter_move_next (_tmp40_);
#line 120 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			if (!_tmp41_) {
#line 120 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				break;
#line 501 "LocalSmartPlaylist.c"
			}
#line 121 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp42_ = data_model_iter;
#line 121 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp43_ = gda_data_model_iter_get_value_at (_tmp42_, 0);
#line 121 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			val = _tmp43_;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp44_ = rowids;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp45_ = val;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp46_ = g_value_get_int64 (_tmp45_);
#line 122 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp44_, &_tmp46_);
#line 517 "LocalSmartPlaylist.c"
		}
#line 125 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp47_ = noise_smart_playlist_get_library ((NoiseSmartPlaylist*) self);
#line 125 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp48_ = _tmp47_;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp49_ = rowids;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp50_ = noise_library_medias_from_ids (_tmp48_, (GeeCollection*) _tmp49_);
#line 125 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		meds = _tmp50_;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp51_ = noise_playlist_get_medias ((NoisePlaylist*) self);
#line 126 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp52_ = _tmp51_;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp53_ = meds;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gee_array_list_add_all (_tmp52_, _tmp53_);
#line 127 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp54_ = meds;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_signal_emit_by_name ((NoisePlaylist*) self, "media-added", _tmp54_);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (meds);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (data_model_iter);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (data_model);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (statm);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		ids = (g_free (ids), NULL);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (sql);
#line 553 "LocalSmartPlaylist.c"
	}
	goto __finally62;
	__catch62_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
		GError* _tmp57_;
		const gchar* _tmp58_;
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		e = _inner_error_;
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_inner_error_ = NULL;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp55_ = noise_playlist_get_name ((NoisePlaylist*) self);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp56_ = _tmp55_;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp57_ = e;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp58_ = _tmp57_->message;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("LocalSmartPlaylist.vala:129: Could not query media for smart playlist " \
"%s: %s", _tmp56_, _tmp58_);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_g_error_free0 (e);
#line 579 "LocalSmartPlaylist.c"
	}
	__finally62:
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (rowids);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_clear_error (&_inner_error_);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		return;
#line 592 "LocalSmartPlaylist.c"
	}
#line 90 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (rowids);
#line 596 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_real_clear_queries (NoiseSmartPlaylist* base) {
	NoiseLocalSmartPlaylist * self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue _tmp3_ = {0};
#line 133 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (noise_local_smart_playlist_parent_class)->clear_queries (G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist));
#line 135 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 135 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 135 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 135 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp3_, G_TYPE_STRING);
#line 135 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_string (&_tmp3_, "");
#line 135 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp3_);
#line 135 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
#line 624 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_real_add_query (NoiseSmartPlaylist* base, NoiseSmartQuery* s) {
	NoiseLocalSmartPlaylist * self;
	NoiseSmartQuery* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	gchar* _tmp4_;
	GValue _tmp5_ = {0};
#line 138 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 138 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (s != NULL);
#line 139 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = s;
#line 139 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (noise_local_smart_playlist_parent_class)->add_query (G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist), _tmp0_);
#line 140 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 140 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = self->priv->connection;
#line 140 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = noise_local_smart_playlist_queries_to_string (self);
#line 140 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp5_, G_TYPE_STRING);
#line 140 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_take_string (&_tmp5_, _tmp4_);
#line 140 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp2_, _tmp3_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp5_);
#line 140 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp5_) ? (g_value_unset (&_tmp5_), NULL) : NULL;
#line 660 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_real_add_queries (NoiseSmartPlaylist* base, GeeCollection* queries) {
	NoiseLocalSmartPlaylist * self;
	GeeCollection* _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	gchar* _tmp4_;
	GValue _tmp5_ = {0};
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (queries != NULL);
#line 144 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = queries;
#line 144 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (noise_local_smart_playlist_parent_class)->add_queries (G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist), _tmp0_);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = self->priv->connection;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = noise_local_smart_playlist_queries_to_string (self);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp5_, G_TYPE_STRING);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_take_string (&_tmp5_, _tmp4_);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp2_, _tmp3_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "queries", &_tmp5_);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp5_) ? (g_value_unset (&_tmp5_), NULL) : NULL;
#line 696 "LocalSmartPlaylist.c"
}


static gchar* noise_local_smart_playlist_queries_to_string (NoiseLocalSmartPlaylist* self) {
	gchar* result = NULL;
	GString* sb = NULL;
	GString* _tmp0_;
	GString* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = g_string_new ("");
#line 149 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	sb = _tmp0_;
#line 713 "LocalSmartPlaylist.c"
	{
		GeeIterator* _q_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp1_ = ((NoiseSmartPlaylist*) self)->queries;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_q_it = _tmp2_;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		while (TRUE) {
#line 726 "LocalSmartPlaylist.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_;
			NoiseSmartQuery* q = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			GString* _tmp7_;
			gssize _tmp8_;
			GString* _tmp10_;
			NoiseSmartQuery* _tmp11_;
			NoiseSmartQueryFieldType _tmp12_;
			NoiseSmartQueryFieldType _tmp13_;
			GString* _tmp14_;
			GString* _tmp15_;
			NoiseSmartQuery* _tmp16_;
			NoiseSmartQueryComparatorType _tmp17_;
			NoiseSmartQueryComparatorType _tmp18_;
			GString* _tmp19_;
			NoiseSmartQuery* _tmp20_;
			GValue _tmp21_ = {0};
			GValue _tmp22_;
			GType _tmp23_;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp3_ = _q_it;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			if (!_tmp4_) {
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				break;
#line 756 "LocalSmartPlaylist.c"
			}
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp5_ = _q_it;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			q = (NoiseSmartQuery*) _tmp6_;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp7_ = sb;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp8_ = _tmp7_->len;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			if (_tmp8_ != ((gssize) 0)) {
#line 770 "LocalSmartPlaylist.c"
				GString* _tmp9_;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp9_ = sb;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				g_string_append (_tmp9_, NOISE_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR);
#line 776 "LocalSmartPlaylist.c"
			}
#line 155 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp10_ = sb;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp11_ = q;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp12_ = noise_smart_query_get_field (_tmp11_);
#line 155 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp13_ = _tmp12_;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append_printf (_tmp10_, "%d", (gint) _tmp13_);
#line 156 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp14_ = sb;
#line 156 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append (_tmp14_, NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp15_ = sb;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp16_ = q;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp17_ = noise_smart_query_get_comparator (_tmp16_);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp18_ = _tmp17_;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append_printf (_tmp15_, "%d", (gint) _tmp18_);
#line 158 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp19_ = sb;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			g_string_append (_tmp19_, NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp20_ = q;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			noise_smart_query_get_value (_tmp20_, &_tmp21_);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp22_ = _tmp21_;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp23_ = G_VALUE_TYPE (&_tmp22_);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			if (_tmp23_ == G_TYPE_STRING) {
#line 816 "LocalSmartPlaylist.c"
				GString* _tmp24_;
				NoiseSmartQuery* _tmp25_;
				GValue _tmp26_ = {0};
				GValue _tmp27_;
				const gchar* _tmp28_;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp24_ = sb;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp25_ = q;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				noise_smart_query_get_value (_tmp25_, &_tmp26_);
#line 160 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp27_ = _tmp26_;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp28_ = g_value_get_string (&_tmp27_);
#line 160 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				g_string_append (_tmp24_, _tmp28_);
#line 834 "LocalSmartPlaylist.c"
			} else {
				GString* _tmp29_;
				NoiseSmartQuery* _tmp30_;
				GValue _tmp31_ = {0};
				GValue _tmp32_;
				gint _tmp33_;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp29_ = sb;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp30_ = q;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				noise_smart_query_get_value (_tmp30_, &_tmp31_);
#line 162 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp32_ = _tmp31_;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp33_ = g_value_get_int (&_tmp32_);
#line 162 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				g_string_append_printf (_tmp29_, "%d", _tmp33_);
#line 853 "LocalSmartPlaylist.c"
			}
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_g_object_unref0 (q);
#line 857 "LocalSmartPlaylist.c"
		}
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_g_object_unref0 (_q_it);
#line 861 "LocalSmartPlaylist.c"
	}
#line 166 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp34_ = sb;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp35_ = _tmp34_->str;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp36_ = g_strdup (_tmp35_);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp36_;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_g_string_free0 (sb);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 875 "LocalSmartPlaylist.c"
}


void noise_local_smart_playlist_queries_from_string (NoiseLocalSmartPlaylist* self, const gchar* q) {
	gchar** queries_in_string = NULL;
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint queries_in_string_length1;
	gint _queries_in_string_size_;
	GeeTreeSet* new_queries = NULL;
	GeeTreeSet* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GeeTreeSet* _tmp36_;
#line 169 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 169 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (q != NULL);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = q;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, NOISE_LOCAL_SMART_PLAYLIST_QUERY_SEPARATOR, 0);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	queries_in_string = _tmp2_;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	queries_in_string_length1 = _vala_array_length (_tmp1_);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_queries_in_string_size_ = queries_in_string_length1;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = gee_tree_set_new (NOISE_TYPE_SMART_QUERY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 171 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	new_queries = _tmp3_;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = queries_in_string;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4__length1 = queries_in_string_length1;
#line 913 "LocalSmartPlaylist.c"
	{
		gchar** query_string_collection = NULL;
		gint query_string_collection_length1 = 0;
		gint _query_string_collection_size_ = 0;
		gint query_string_it = 0;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		query_string_collection = _tmp4_;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		query_string_collection_length1 = _tmp4__length1;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		for (query_string_it = 0; query_string_it < _tmp4__length1; query_string_it = query_string_it + 1) {
#line 925 "LocalSmartPlaylist.c"
			gchar* _tmp5_;
			gchar* query_string = NULL;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			_tmp5_ = g_strdup (query_string_collection[query_string_it]);
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			query_string = _tmp5_;
#line 932 "LocalSmartPlaylist.c"
			{
				const gchar* _tmp6_;
				gchar** pieces_of_query = NULL;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gint pieces_of_query_length1;
				gint _pieces_of_query_size_;
				gint _tmp10_;
				NoiseSmartQuery* sq = NULL;
				NoiseSmartQuery* _tmp11_;
				NoiseSmartQuery* _tmp12_;
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
				gint _tmp15_;
				NoiseSmartQuery* _tmp16_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				const gchar* _tmp18_;
				gint _tmp19_;
				NoiseSmartQuery* _tmp20_;
				NoiseSmartQueryFieldType _tmp21_;
				NoiseSmartQueryFieldType _tmp22_;
				GeeTreeSet* _tmp34_;
				NoiseSmartQuery* _tmp35_;
#line 173 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp6_ = query_string;
#line 173 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				if (g_strcmp0 (_tmp6_, "") == 0) {
#line 174 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					_g_free0 (query_string);
#line 174 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					continue;
#line 967 "LocalSmartPlaylist.c"
				}
#line 176 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp7_ = query_string;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, NOISE_LOCAL_SMART_PLAYLIST_VALUE_SEPARATOR, 3);
#line 176 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query = _tmp9_;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query_length1 = _vala_array_length (_tmp8_);
#line 176 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_pieces_of_query_size_ = pieces_of_query_length1;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp10_ = 3;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query = g_renew (gchar*, pieces_of_query, 3);
#line 177 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				(_tmp10_ > pieces_of_query_length1) ? memset (pieces_of_query + pieces_of_query_length1, 0, sizeof (gchar*) * (_tmp10_ - pieces_of_query_length1)) : NULL;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query_length1 = _tmp10_;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_pieces_of_query_size_ = _tmp10_;
#line 179 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp11_ = noise_smart_query_new ();
#line 179 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				sq = _tmp11_;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp12_ = sq;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp13_ = pieces_of_query;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp13__length1 = pieces_of_query_length1;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp14_ = _tmp13_[0];
#line 180 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp15_ = atoi (_tmp14_);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				noise_smart_query_set_field (_tmp12_, (NoiseSmartQueryFieldType) _tmp15_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp16_ = sq;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp17_ = pieces_of_query;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp17__length1 = pieces_of_query_length1;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp18_ = _tmp17_[1];
#line 181 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp19_ = atoi (_tmp18_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				noise_smart_query_set_comparator (_tmp16_, (NoiseSmartQueryComparatorType) _tmp19_);
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp20_ = sq;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp21_ = noise_smart_query_get_field (_tmp20_);
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp22_ = _tmp21_;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				switch (_tmp22_) {
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_ALBUM:
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_ARTIST:
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_COMPOSER:
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_COMMENT:
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_GENRE:
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_GROUPING:
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_TITLE:
#line 182 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
					case NOISE_SMART_QUERY_FIELD_TYPE_URI:
#line 1041 "LocalSmartPlaylist.c"
					{
						GValue val = {0};
						GValue _tmp23_ = {0};
						gchar** _tmp24_;
						gint _tmp24__length1;
						const gchar* _tmp25_;
						NoiseSmartQuery* _tmp26_;
						GValue _tmp27_;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_init (&_tmp23_, G_TYPE_STRING);
#line 191 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						val = _tmp23_;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp24_ = pieces_of_query;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp24__length1 = pieces_of_query_length1;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp25_ = _tmp24_[2];
#line 192 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_set_string (&val, _tmp25_);
#line 193 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp26_ = sq;
#line 193 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp27_ = val;
#line 193 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						noise_smart_query_set_value (_tmp26_, &_tmp27_);
#line 194 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 194 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						break;
#line 1072 "LocalSmartPlaylist.c"
					}
					default:
					{
						GValue val = {0};
						GValue _tmp28_ = {0};
						gchar** _tmp29_;
						gint _tmp29__length1;
						const gchar* _tmp30_;
						gint _tmp31_;
						NoiseSmartQuery* _tmp32_;
						GValue _tmp33_;
#line 196 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_init (&_tmp28_, G_TYPE_INT);
#line 196 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						val = _tmp28_;
#line 197 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp29_ = pieces_of_query;
#line 197 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp29__length1 = pieces_of_query_length1;
#line 197 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp30_ = _tmp29_[2];
#line 197 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp31_ = atoi (_tmp30_);
#line 197 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						g_value_set_int (&val, _tmp31_);
#line 198 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp32_ = sq;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						_tmp33_ = val;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						noise_smart_query_set_value (_tmp32_, &_tmp33_);
#line 199 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 199 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
						break;
#line 1108 "LocalSmartPlaylist.c"
					}
				}
#line 202 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp34_ = new_queries;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_tmp35_ = sq;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, _tmp35_);
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_g_object_unref0 (sq);
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				pieces_of_query = (_vala_array_free (pieces_of_query, pieces_of_query_length1, (GDestroyNotify) g_free), NULL);
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
				_g_free0 (query_string);
#line 1123 "LocalSmartPlaylist.c"
			}
		}
	}
#line 204 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp36_ = new_queries;
#line 204 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_smart_playlist_add_queries ((NoiseSmartPlaylist*) self, (GeeCollection*) _tmp36_);
#line 169 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (new_queries);
#line 169 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	queries_in_string = (_vala_array_free (queries_in_string, queries_in_string_length1, (GDestroyNotify) g_free), NULL);
#line 1135 "LocalSmartPlaylist.c"
}


static void __vala_GValue_free0_ (gpointer var) {
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 1142 "LocalSmartPlaylist.c"
}


static inline void _g_slist_free___vala_GValue_free0_ (GSList* self) {
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
#line 1149 "LocalSmartPlaylist.c"
}


static void _g_free0_ (gpointer var) {
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	var = (g_free (var), NULL);
#line 1156 "LocalSmartPlaylist.c"
}


static inline void _g_slist_free__g_free0_ (GSList* self) {
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 1163 "LocalSmartPlaylist.c"
}


void noise_local_smart_playlist_add_defaults (GdaConnection* connection) {
	GError * _inner_error_ = NULL;
#line 207 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_return_if_fail (connection != NULL);
#line 1171 "LocalSmartPlaylist.c"
	{
		GSList* col_names = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GSList* values = NULL;
		GValue* _tmp5_ = NULL;
		GValue* _tmp6_ = NULL;
		GValue* _tmp7_ = NULL;
		GValue* _tmp8_ = NULL;
		GValue* _tmp9_ = NULL;
		GdaConnection* _tmp10_;
		GSList* _tmp11_;
		GSList* _tmp12_;
		GValue* _tmp13_ = NULL;
		GValue* _tmp14_ = NULL;
		GValue* _tmp15_ = NULL;
		GValue* _tmp16_ = NULL;
		GValue* _tmp17_ = NULL;
		GdaConnection* _tmp18_;
		GSList* _tmp19_;
		GSList* _tmp20_;
		GValue* _tmp21_ = NULL;
		GValue* _tmp22_ = NULL;
		GValue* _tmp23_ = NULL;
		GValue* _tmp24_ = NULL;
		GValue* _tmp25_ = NULL;
		GdaConnection* _tmp26_;
		GSList* _tmp27_;
		GSList* _tmp28_;
		GValue* _tmp29_ = NULL;
		GValue* _tmp30_ = NULL;
		GValue* _tmp31_ = NULL;
		GValue* _tmp32_ = NULL;
		GValue* _tmp33_ = NULL;
		GdaConnection* _tmp34_;
		GSList* _tmp35_;
		GSList* _tmp36_;
		GValue* _tmp37_ = NULL;
		GValue* _tmp38_ = NULL;
		GValue* _tmp39_ = NULL;
		GValue* _tmp40_ = NULL;
		GValue* _tmp41_ = NULL;
		GdaConnection* _tmp42_;
		GSList* _tmp43_;
		GSList* _tmp44_;
		GValue* _tmp45_ = NULL;
		GValue* _tmp46_ = NULL;
		GValue* _tmp47_ = NULL;
		GValue* _tmp48_ = NULL;
		GValue* _tmp49_ = NULL;
		GdaConnection* _tmp50_;
		GSList* _tmp51_;
		GSList* _tmp52_;
#line 209 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = NULL;
#line 210 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp0_ = g_strdup ("name");
#line 210 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp0_);
#line 211 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp1_ = g_strdup ("queries");
#line 211 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp1_);
#line 212 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp2_ = g_strdup ("and_or");
#line 212 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp2_);
#line 213 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp3_ = g_strdup ("limited");
#line 213 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp3_);
#line 214 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp4_ = g_strdup ("limit_amount");
#line 214 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		col_names = g_slist_append (col_names, _tmp4_);
#line 216 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp5_ = g_new0 (GValue, 1);
#line 217 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp5_, G_TYPE_STRING);
#line 217 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp5_, _ ("Favorite Songs"));
#line 217 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp5_);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp6_ = g_new0 (GValue, 1);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp6_, G_TYPE_STRING);
#line 218 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp6_, "10<val_sep>2<val_sep>4<query_sep>12<val_sep>0<val_sep>0<query_sep>11<v" \
"al_sep>6<val_sep>3");
#line 218 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp6_);
#line 219 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp7_ = g_new0 (GValue, 1);
#line 219 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp7_, G_TYPE_INT);
#line 219 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp7_, 1);
#line 219 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp7_);
#line 220 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp8_ = g_new0 (GValue, 1);
#line 220 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp8_, G_TYPE_INT);
#line 220 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp8_, 1);
#line 220 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp8_);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp9_ = g_new0 (GValue, 1);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp9_, G_TYPE_INT);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp9_, 50);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp9_);
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp10_ = connection;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp11_ = col_names;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp12_ = values;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (_tmp10_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp11_, _tmp12_, &_inner_error_);
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free___vala_GValue_free0_0 (values);
#line 222 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free__g_free0_0 (col_names);
#line 1306 "LocalSmartPlaylist.c"
			goto __catch63_g_error;
		}
#line 224 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		__g_slist_free___vala_GValue_free0_0 (values);
#line 224 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 225 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp13_ = g_new0 (GValue, 1);
#line 225 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp13_, G_TYPE_STRING);
#line 225 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp13_, _ ("Recently Added"));
#line 225 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp13_);
#line 226 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp14_ = g_new0 (GValue, 1);
#line 226 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp14_, G_TYPE_STRING);
#line 226 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp14_, "5<val_sep>7<val_sep>7");
#line 226 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp14_);
#line 227 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp15_ = g_new0 (GValue, 1);
#line 227 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp15_, G_TYPE_INT);
#line 227 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp15_, 1);
#line 227 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp15_);
#line 228 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp16_ = g_new0 (GValue, 1);
#line 228 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp16_, G_TYPE_INT);
#line 228 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp16_, 1);
#line 228 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp16_);
#line 229 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp17_ = g_new0 (GValue, 1);
#line 229 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp17_, G_TYPE_INT);
#line 229 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp17_, 50);
#line 229 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp17_);
#line 230 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp18_ = connection;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp19_ = col_names;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp20_ = values;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (_tmp18_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp19_, _tmp20_, &_inner_error_);
#line 230 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 230 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free___vala_GValue_free0_0 (values);
#line 230 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free__g_free0_0 (col_names);
#line 1367 "LocalSmartPlaylist.c"
			goto __catch63_g_error;
		}
#line 232 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		__g_slist_free___vala_GValue_free0_0 (values);
#line 232 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp21_ = g_new0 (GValue, 1);
#line 233 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp21_, G_TYPE_STRING);
#line 233 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp21_, _ ("Recent Favorites"));
#line 233 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp21_);
#line 234 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp22_ = g_new0 (GValue, 1);
#line 234 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp22_, G_TYPE_STRING);
#line 234 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp22_, "10<val_sep>2<val_sep>4<query_sep>12<val_sep>0<val_sep>0<query_sep>8<va" \
"l_sep>7<val_sep>7");
#line 234 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp22_);
#line 235 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp23_ = g_new0 (GValue, 1);
#line 235 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp23_, G_TYPE_INT);
#line 235 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp23_, 1);
#line 235 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp23_);
#line 236 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp24_ = g_new0 (GValue, 1);
#line 236 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp24_, G_TYPE_INT);
#line 236 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp24_, 1);
#line 236 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp24_);
#line 237 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp25_ = g_new0 (GValue, 1);
#line 237 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp25_, G_TYPE_INT);
#line 237 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp25_, 50);
#line 237 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp25_);
#line 238 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp26_ = connection;
#line 238 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp27_ = col_names;
#line 238 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp28_ = values;
#line 238 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (_tmp26_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp27_, _tmp28_, &_inner_error_);
#line 238 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 238 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free___vala_GValue_free0_0 (values);
#line 238 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free__g_free0_0 (col_names);
#line 1428 "LocalSmartPlaylist.c"
			goto __catch63_g_error;
		}
#line 240 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		__g_slist_free___vala_GValue_free0_0 (values);
#line 240 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 241 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp29_ = g_new0 (GValue, 1);
#line 241 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp29_, G_TYPE_STRING);
#line 241 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp29_, _ ("Never Played"));
#line 241 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp29_);
#line 242 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp30_ = g_new0 (GValue, 1);
#line 242 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp30_, G_TYPE_STRING);
#line 242 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp30_, "10<val_sep>0<val_sep>0");
#line 242 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp30_);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp31_ = g_new0 (GValue, 1);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp31_, G_TYPE_INT);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp31_, 0);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp31_);
#line 244 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp32_ = g_new0 (GValue, 1);
#line 244 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp32_, G_TYPE_INT);
#line 244 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp32_, 1);
#line 244 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp32_);
#line 245 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp33_ = g_new0 (GValue, 1);
#line 245 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp33_, G_TYPE_INT);
#line 245 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp33_, 50);
#line 245 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp33_);
#line 246 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp34_ = connection;
#line 246 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp35_ = col_names;
#line 246 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp36_ = values;
#line 246 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (_tmp34_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp35_, _tmp36_, &_inner_error_);
#line 246 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 246 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free___vala_GValue_free0_0 (values);
#line 246 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free__g_free0_0 (col_names);
#line 1489 "LocalSmartPlaylist.c"
			goto __catch63_g_error;
		}
#line 248 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		__g_slist_free___vala_GValue_free0_0 (values);
#line 248 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp37_ = g_new0 (GValue, 1);
#line 249 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp37_, G_TYPE_STRING);
#line 249 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp37_, _ ("Over Played"));
#line 249 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp37_);
#line 250 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp38_ = g_new0 (GValue, 1);
#line 250 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp38_, G_TYPE_STRING);
#line 250 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp38_, "10<val_sep>6<val_sep>10");
#line 250 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp38_);
#line 251 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp39_ = g_new0 (GValue, 1);
#line 251 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp39_, G_TYPE_INT);
#line 251 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp39_, 1);
#line 251 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp39_);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp40_ = g_new0 (GValue, 1);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp40_, G_TYPE_INT);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp40_, 1);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp40_);
#line 253 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp41_ = g_new0 (GValue, 1);
#line 253 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp41_, G_TYPE_INT);
#line 253 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp41_, 50);
#line 253 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp41_);
#line 254 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp42_ = connection;
#line 254 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp43_ = col_names;
#line 254 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp44_ = values;
#line 254 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (_tmp42_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp43_, _tmp44_, &_inner_error_);
#line 254 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 254 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free___vala_GValue_free0_0 (values);
#line 254 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free__g_free0_0 (col_names);
#line 1550 "LocalSmartPlaylist.c"
			goto __catch63_g_error;
		}
#line 256 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		__g_slist_free___vala_GValue_free0_0 (values);
#line 256 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = NULL;
#line 257 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp45_ = g_new0 (GValue, 1);
#line 257 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp45_, G_TYPE_STRING);
#line 257 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp45_, _ ("Not Recently Played"));
#line 257 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp45_);
#line 258 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp46_ = g_new0 (GValue, 1);
#line 258 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp46_, G_TYPE_STRING);
#line 258 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (_tmp46_, "8<val_sep>8<val_sep>7");
#line 258 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp46_);
#line 259 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp47_ = g_new0 (GValue, 1);
#line 259 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp47_, G_TYPE_INT);
#line 259 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp47_, 1);
#line 259 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp47_);
#line 260 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp48_ = g_new0 (GValue, 1);
#line 260 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp48_, G_TYPE_INT);
#line 260 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp48_, 1);
#line 260 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp48_);
#line 261 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp49_ = g_new0 (GValue, 1);
#line 261 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_init (_tmp49_, G_TYPE_INT);
#line 261 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_int (_tmp49_, 50);
#line 261 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		values = g_slist_append (values, _tmp49_);
#line 262 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp50_ = connection;
#line 262 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp51_ = col_names;
#line 262 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp52_ = values;
#line 262 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		gda_connection_insert_row_into_table_v (_tmp50_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, _tmp51_, _tmp52_, &_inner_error_);
#line 262 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 262 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free___vala_GValue_free0_0 (values);
#line 262 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
			__g_slist_free__g_free0_0 (col_names);
#line 1611 "LocalSmartPlaylist.c"
			goto __catch63_g_error;
		}
#line 208 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		__g_slist_free___vala_GValue_free0_0 (values);
#line 208 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		__g_slist_free__g_free0_0 (col_names);
#line 1618 "LocalSmartPlaylist.c"
	}
	goto __finally63;
	__catch63_g_error:
	{
		GError* e = NULL;
		GError* _tmp53_;
		const gchar* _tmp54_;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		e = _inner_error_;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_inner_error_ = NULL;
#line 264 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp53_ = e;
#line 264 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp54_ = _tmp53_->message;
#line 264 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("LocalSmartPlaylist.vala:264: Could not initialize smart playlists: %s", _tmp54_);
#line 208 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_g_error_free0 (e);
#line 1638 "LocalSmartPlaylist.c"
	}
	__finally63:
#line 208 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 208 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 208 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_clear_error (&_inner_error_);
#line 208 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		return;
#line 1649 "LocalSmartPlaylist.c"
	}
}


static const gchar* noise_local_smart_playlist_real_get_name (NoisePlaylist* base) {
	const gchar* result;
	NoiseLocalSmartPlaylist* self;
	const gchar* _tmp0_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue* _tmp5_;
	GValue* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
#line 39 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 40 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = self->priv->_name;
#line 40 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	if (_tmp0_ != NULL) {
#line 1671 "LocalSmartPlaylist.c"
		const gchar* _tmp1_;
#line 41 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		_tmp1_ = self->priv->_name;
#line 41 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		result = _tmp1_;
#line 41 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		return result;
#line 1679 "LocalSmartPlaylist.c"
	}
#line 43 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 43 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = _tmp2_;
#line 43 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = self->priv->connection;
#line 43 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = noise_database_query_field (_tmp3_, _tmp4_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "name");
#line 43 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp6_ = _tmp5_;
#line 43 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp7_ = g_value_dup_string (_tmp6_);
#line 43 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 43 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->_name = _tmp7_;
#line 43 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp6_);
#line 44 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp8_ = self->priv->_name;
#line 44 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp8_;
#line 44 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1705 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_real_set_name (NoisePlaylist* base, const gchar* value) {
	NoiseLocalSmartPlaylist* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	const gchar* _tmp5_;
	GValue _tmp6_ = {0};
#line 47 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 48 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = value;
#line 48 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 48 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 48 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->_name = _tmp1_;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 49 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = _tmp2_;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = self->priv->connection;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = value;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp6_, G_TYPE_STRING);
#line 49 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_string (&_tmp6_, _tmp5_);
#line 49 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp3_, _tmp4_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "name", &_tmp6_);
#line 49 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY]);
#line 1746 "LocalSmartPlaylist.c"
}


static NoiseSmartPlaylistConditionalType noise_local_smart_playlist_real_get_conditional (NoiseSmartPlaylist* base) {
	NoiseSmartPlaylistConditionalType result;
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	gint _tmp5_;
	NoiseSmartPlaylistConditionalType _tmp6_;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 56 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "and_or");
#line 56 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = _tmp3_;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = g_value_get_int (_tmp4_);
#line 56 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp6_ = (NoiseSmartPlaylistConditionalType) _tmp5_;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp4_);
#line 56 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp6_;
#line 56 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1782 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_real_set_conditional (NoiseSmartPlaylist* base, NoiseSmartPlaylistConditionalType value) {
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	NoiseSmartPlaylistConditionalType _tmp3_;
	GValue _tmp4_ = {0};
#line 58 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = value;
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp4_, NOISE_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_enum (&_tmp4_, _tmp3_);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "and_or", &_tmp4_);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY]);
#line 1813 "LocalSmartPlaylist.c"
}


static guint noise_local_smart_playlist_real_get_limit_amount (NoiseSmartPlaylist* base) {
	guint result;
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	gint _tmp5_;
	guint _tmp6_;
#line 64 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 65 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limit_amount");
#line 65 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = _tmp3_;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp5_ = g_value_get_int (_tmp4_);
#line 65 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp6_ = (guint) _tmp5_;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (_tmp4_);
#line 65 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	result = _tmp6_;
#line 65 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1849 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_real_set_limit_amount (NoiseSmartPlaylist* base, guint value) {
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	guint _tmp3_;
	GValue _tmp4_ = {0};
#line 67 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = value;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp4_, G_TYPE_UINT);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_uint (&_tmp4_, _tmp3_);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limit_amount", &_tmp4_);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY]);
#line 1880 "LocalSmartPlaylist.c"
}


static gboolean noise_local_smart_playlist_real_get_limit (NoiseSmartPlaylist* base) {
	gboolean result;
	NoiseLocalSmartPlaylist* self;
	GValue* val = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	gint _tmp4_;
#line 73 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 74 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limited");
#line 74 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	val = _tmp3_;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp4_ = g_value_get_int (val);
#line 75 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	result = (gboolean) _tmp4_;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	__vala_GValue_free0 (val);
#line 75 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	return result;
#line 1913 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_real_set_limit (NoiseSmartPlaylist* base, gboolean value) {
	NoiseLocalSmartPlaylist* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	gboolean _tmp3_;
	GValue _tmp4_ = {0};
#line 77 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = (NoiseLocalSmartPlaylist*) base;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp0_ = noise_playlist_get_rowid ((NoisePlaylist*) self);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp2_ = self->priv->connection;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_tmp3_ = value;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_init (&_tmp4_, G_TYPE_BOOLEAN);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_value_set_boolean (&_tmp4_, _tmp3_);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_database_set_field (_tmp1_, _tmp2_, NOISE_DATABASE_SMART_PLAYLISTS_TABLE_NAME, "limited", &_tmp4_);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY]);
#line 1944 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_class_init (NoiseLocalSmartPlaylistClass * klass) {
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	noise_local_smart_playlist_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_type_class_add_private (klass, sizeof (NoiseLocalSmartPlaylistPrivate));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	((NoiseSmartPlaylistClass *) klass)->analyse_all = (void (*) (NoiseSmartPlaylist *)) noise_local_smart_playlist_real_analyse_all;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	((NoiseSmartPlaylistClass *) klass)->clear_queries = (void (*) (NoiseSmartPlaylist *)) noise_local_smart_playlist_real_clear_queries;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	((NoiseSmartPlaylistClass *) klass)->add_query = (void (*) (NoiseSmartPlaylist *, NoiseSmartQuery*)) noise_local_smart_playlist_real_add_query;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	((NoiseSmartPlaylistClass *) klass)->add_queries = (void (*) (NoiseSmartPlaylist *, GeeCollection*)) noise_local_smart_playlist_real_add_queries;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_PLAYLIST_CLASS (klass)->get_name = noise_local_smart_playlist_real_get_name;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_PLAYLIST_CLASS (klass)->set_name = noise_local_smart_playlist_real_set_name;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->get_conditional = noise_local_smart_playlist_real_get_conditional;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->set_conditional = noise_local_smart_playlist_real_set_conditional;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->get_limit_amount = noise_local_smart_playlist_real_get_limit_amount;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->set_limit_amount = noise_local_smart_playlist_real_set_limit_amount;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->get_limit = noise_local_smart_playlist_real_get_limit;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	NOISE_SMART_PLAYLIST_CLASS (klass)->set_limit = noise_local_smart_playlist_real_set_limit;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_local_smart_playlist_get_property;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_local_smart_playlist_set_property;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_local_smart_playlist_finalize;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY] = g_param_spec_enum ("conditional", "conditional", "conditional", NOISE_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY] = g_param_spec_uint ("limit-amount", "limit-amount", "limit-amount", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY, noise_local_smart_playlist_properties[NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY] = g_param_spec_boolean ("limit", "limit", "limit", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1991 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_instance_init (NoiseLocalSmartPlaylist * self) {
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv = NOISE_LOCAL_SMART_PLAYLIST_GET_PRIVATE (self);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self->priv->_name = NULL;
#line 2000 "LocalSmartPlaylist.c"
}


static void noise_local_smart_playlist_finalize (GObject * obj) {
	NoiseLocalSmartPlaylist * self;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_g_object_unref0 (self->priv->connection);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	_g_free0 (self->priv->_name);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	G_OBJECT_CLASS (noise_local_smart_playlist_parent_class)->finalize (obj);
#line 2014 "LocalSmartPlaylist.c"
}


GType noise_local_smart_playlist_get_type (void) {
	static volatile gsize noise_local_smart_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&noise_local_smart_playlist_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseLocalSmartPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_local_smart_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseLocalSmartPlaylist), 0, (GInstanceInitFunc) noise_local_smart_playlist_instance_init, NULL };
		GType noise_local_smart_playlist_type_id;
		noise_local_smart_playlist_type_id = g_type_register_static (NOISE_TYPE_SMART_PLAYLIST, "NoiseLocalSmartPlaylist", &g_define_type_info, 0);
		g_once_init_leave (&noise_local_smart_playlist_type_id__volatile, noise_local_smart_playlist_type_id);
	}
	return noise_local_smart_playlist_type_id__volatile;
}


static void _vala_noise_local_smart_playlist_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	switch (property_id) {
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_string (value, noise_playlist_get_name ((NoisePlaylist*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_enum (value, noise_smart_playlist_get_conditional ((NoiseSmartPlaylist*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_uint (value, noise_smart_playlist_get_limit_amount ((NoiseSmartPlaylist*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		g_value_set_boolean (value, noise_smart_playlist_get_limit ((NoiseSmartPlaylist*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2059 "LocalSmartPlaylist.c"
		default:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2065 "LocalSmartPlaylist.c"
	}
}


static void _vala_noise_local_smart_playlist_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoiseLocalSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_SMART_PLAYLIST, NoiseLocalSmartPlaylist);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
	switch (property_id) {
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_NAME_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		noise_playlist_set_name ((NoisePlaylist*) self, g_value_get_string (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		noise_smart_playlist_set_conditional ((NoiseSmartPlaylist*) self, g_value_get_enum (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		noise_smart_playlist_set_limit_amount ((NoiseSmartPlaylist*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		case NOISE_LOCAL_SMART_PLAYLIST_LIMIT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		noise_smart_playlist_set_limit ((NoiseSmartPlaylist*) self, g_value_get_boolean (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2099 "LocalSmartPlaylist.c"
		default:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalSmartPlaylist.vala"
		break;
#line 2105 "LocalSmartPlaylist.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



