/* BrowserColumnModel.c generated by valac 0.38.10, the Vala compiler
 * generated from BrowserColumnModel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <stdarg.h>
#include <noise-core.h>


#define NOISE_TYPE_BROWSER_COLUMN_MODEL (noise_browser_column_model_get_type ())
#define NOISE_BROWSER_COLUMN_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModel))
#define NOISE_BROWSER_COLUMN_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModelClass))
#define NOISE_IS_BROWSER_COLUMN_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_BROWSER_COLUMN_MODEL))
#define NOISE_IS_BROWSER_COLUMN_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_BROWSER_COLUMN_MODEL))
#define NOISE_BROWSER_COLUMN_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModelClass))

typedef struct _NoiseBrowserColumnModel NoiseBrowserColumnModel;
typedef struct _NoiseBrowserColumnModelClass NoiseBrowserColumnModelClass;
typedef struct _NoiseBrowserColumnModelPrivate NoiseBrowserColumnModelPrivate;

#define NOISE_BROWSER_COLUMN_TYPE_CATEGORY (noise_browser_column_category_get_type ())
enum  {
	NOISE_BROWSER_COLUMN_MODEL_0_PROPERTY,
	NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY,
	NOISE_BROWSER_COLUMN_MODEL_NUM_PROPERTIES
};
static GParamSpec* noise_browser_column_model_properties[NOISE_BROWSER_COLUMN_MODEL_NUM_PROPERTIES];
#define _g_sequence_free0(var) ((var == NULL) ? NULL : (var = (g_sequence_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NoiseBrowserColumnModel {
	GObject parent_instance;
	NoiseBrowserColumnModelPrivate * priv;
};

struct _NoiseBrowserColumnModelClass {
	GObjectClass parent_class;
};

typedef enum  {
	NOISE_BROWSER_COLUMN_CATEGORY_RATING,
	NOISE_BROWSER_COLUMN_CATEGORY_GROUPING,
	NOISE_BROWSER_COLUMN_CATEGORY_YEAR,
	NOISE_BROWSER_COLUMN_CATEGORY_GENRE,
	NOISE_BROWSER_COLUMN_CATEGORY_COMPOSER,
	NOISE_BROWSER_COLUMN_CATEGORY_ARTIST,
	NOISE_BROWSER_COLUMN_CATEGORY_ALBUM,
	NOISE_BROWSER_COLUMN_CATEGORY_N_CATEGORIES
} NoiseBrowserColumnCategory;

struct _NoiseBrowserColumnModelPrivate {
	gint stamp;
	GSequence* rows;
	GtkTreeIter* first_iter;
	gint sort_column_id;
	GtkSortType sort_direction;
	GtkTreeIterCompareFunc default_sort_func;
	gpointer default_sort_func_target;
	NoiseBrowserColumnCategory category;
};


static gpointer noise_browser_column_model_parent_class = NULL;
static GtkTreeModelIface * noise_browser_column_model_gtk_tree_model_parent_iface = NULL;
static GtkTreeSortableIface * noise_browser_column_model_gtk_tree_sortable_parent_iface = NULL;

GType noise_browser_column_model_get_type (void) G_GNUC_CONST;
GType noise_browser_column_category_get_type (void) G_GNUC_CONST;
#define NOISE_BROWSER_COLUMN_MODEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModelPrivate))
NoiseBrowserColumnModel* noise_browser_column_model_new (NoiseBrowserColumnCategory category);
NoiseBrowserColumnModel* noise_browser_column_model_construct (GType object_type, NoiseBrowserColumnCategory category);
static void _g_free0_ (gpointer var);
static GtkTreeModelFlags noise_browser_column_model_real_get_flags (GtkTreeModel* base);
static gboolean noise_browser_column_model_real_get_iter (GtkTreeModel* base, GtkTreeIter* iter, GtkTreePath* path);
static gint noise_browser_column_model_real_get_n_columns (GtkTreeModel* base);
static GType noise_browser_column_model_real_get_column_type (GtkTreeModel* base, gint col);
static GtkTreePath* noise_browser_column_model_real_get_path (GtkTreeModel* base, GtkTreeIter* iter);
static void noise_browser_column_model_real_get_value (GtkTreeModel* base, GtkTreeIter* iter, gint column, GValue* val);
static gboolean noise_browser_column_model_real_iter_children (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* parent);
static gboolean noise_browser_column_model_real_iter_has_child (GtkTreeModel* base, GtkTreeIter* iter);
static gint noise_browser_column_model_real_iter_n_children (GtkTreeModel* base, GtkTreeIter* iter);
static gboolean noise_browser_column_model_real_iter_next (GtkTreeModel* base, GtkTreeIter* iter);
static gboolean noise_browser_column_model_real_iter_nth_child (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* parent, gint n);
static gboolean noise_browser_column_model_real_iter_parent (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* child);
static void noise_browser_column_model_real_ref_node (GtkTreeModel* base, GtkTreeIter* iter);
static void noise_browser_column_model_real_unref_node (GtkTreeModel* base, GtkTreeIter* iter);
void noise_browser_column_model_append (NoiseBrowserColumnModel* self, GtkTreeIter* iter);
void noise_browser_column_model_append_items (NoiseBrowserColumnModel* self, GeeCollection* strings, gboolean emit);
static void noise_browser_column_model_add_first_element (NoiseBrowserColumnModel* self);
static void noise_browser_column_model_update_first_item (NoiseBrowserColumnModel* self);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static gchar* noise_browser_column_model_get_first_item_text (NoiseBrowserColumnModel* self, gint n_items);
gint noise_browser_column_model_get_n_items (NoiseBrowserColumnModel* self);
void noise_browser_column_model_set (NoiseBrowserColumnModel* self, GtkTreeIter* iter, ...);
void noise_browser_column_model_remove (NoiseBrowserColumnModel* self, GtkTreeIter* iter);
static gboolean noise_browser_column_model_real_get_sort_column_id (GtkTreeSortable* base, gint* sort_column_id, GtkSortType* order);
static gboolean noise_browser_column_model_real_has_default_sort_func (GtkTreeSortable* base);
static void noise_browser_column_model_real_set_default_sort_func (GtkTreeSortable* base, GtkTreeIterCompareFunc sort_func, void* sort_func_target, GDestroyNotify sort_func_target_destroy_notify);
static void noise_browser_column_model_real_set_sort_column_id (GtkTreeSortable* base, gint sort_column_id, GtkSortType order);
gint noise_browser_column_model_sequenceIterCompareFunc (NoiseBrowserColumnModel* self, GSequenceIter* a, GSequenceIter* b);
static gint _noise_browser_column_model_sequenceIterCompareFunc_gsequence_iter_compare_func (GSequenceIter* a, GSequenceIter* b, gpointer self);
static void noise_browser_column_model_real_set_sort_func (GtkTreeSortable* base, gint sort_column_id, GtkTreeIterCompareFunc sort_func, void* sort_func_target, GDestroyNotify sort_func_target_destroy_notify);
static void noise_browser_column_model_finalize (GObject * obj);
static void _vala_noise_browser_column_model_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


/** Initialize data storage, columns, etc. **/
static void _g_free0_ (gpointer var) {
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	var = (g_free (var), NULL);
#line 148 "BrowserColumnModel.c"
}


NoiseBrowserColumnModel* noise_browser_column_model_construct (GType object_type, NoiseBrowserColumnCategory category) {
	NoiseBrowserColumnModel * self = NULL;
	GSequence* _tmp0_;
	NoiseBrowserColumnCategory _tmp1_;
#line 52 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) g_object_new (object_type, NULL);
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = g_sequence_new (_g_free0_);
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_sequence_free0 (self->priv->rows);
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->rows = _tmp0_;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = category;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->category = _tmp1_;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_column_id = -2;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_direction = GTK_SORT_ASCENDING;
#line 52 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return self;
#line 174 "BrowserColumnModel.c"
}


NoiseBrowserColumnModel* noise_browser_column_model_new (NoiseBrowserColumnCategory category) {
#line 52 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return noise_browser_column_model_construct (NOISE_TYPE_BROWSER_COLUMN_MODEL, category);
#line 181 "BrowserColumnModel.c"
}


/** Returns a set of flags supported by this interface **/
static GtkTreeModelFlags noise_browser_column_model_real_get_flags (GtkTreeModel* base) {
	NoiseBrowserColumnModel * self;
	GtkTreeModelFlags result = 0;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = GTK_TREE_MODEL_LIST_ONLY;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 195 "BrowserColumnModel.c"
}


/** Sets iter to a valid iterator pointing to path **/
static gboolean noise_browser_column_model_real_get_iter (GtkTreeModel* base, GtkTreeIter* iter, GtkTreePath* path) {
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gint path_index = 0;
	GtkTreePath* _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	GSequence* _tmp6_;
	gint _tmp7_;
	GSequenceIter* seq_iter = NULL;
	GSequence* _tmp12_;
	gint _tmp13_;
	GSequenceIter* _tmp14_;
	GSequenceIter* _tmp15_;
	gint _tmp16_;
	GSequenceIter* _tmp17_;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = path;
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = gtk_tree_path_get_indices_with_depth (_tmp0_, &_tmp1_);
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = _tmp2_[0];
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	path_index = _tmp3_;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = self->priv->rows;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = g_sequence_get_length (_tmp6_);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp7_ == 0) {
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp5_ = TRUE;
#line 242 "BrowserColumnModel.c"
	} else {
		gint _tmp8_;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp8_ = path_index;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp5_ = _tmp8_ < 0;
#line 249 "BrowserColumnModel.c"
	}
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp5_) {
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = TRUE;
#line 255 "BrowserColumnModel.c"
	} else {
		gint _tmp9_;
		GSequence* _tmp10_;
		gint _tmp11_;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp9_ = path_index;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp10_ = self->priv->rows;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp11_ = g_sequence_get_length (_tmp10_);
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = _tmp9_ >= _tmp11_;
#line 268 "BrowserColumnModel.c"
	}
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp4_) {
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (iter) {
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*iter = _vala_iter;
#line 278 "BrowserColumnModel.c"
		}
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 282 "BrowserColumnModel.c"
	}
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp12_ = self->priv->rows;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp13_ = path_index;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp14_ = g_sequence_get_iter_at_pos (_tmp12_, _tmp13_);
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	seq_iter = _tmp14_;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp15_ = seq_iter;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp15_ == NULL) {
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (iter) {
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*iter = _vala_iter;
#line 302 "BrowserColumnModel.c"
		}
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 306 "BrowserColumnModel.c"
	}
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp16_ = self->priv->stamp;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.stamp = _tmp16_;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp17_ = seq_iter;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.user_data = _tmp17_;
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 322 "BrowserColumnModel.c"
	}
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 326 "BrowserColumnModel.c"
}


/** Returns the number of columns supported by tree_model. **/
static gint noise_browser_column_model_real_get_n_columns (GtkTreeModel* base) {
	NoiseBrowserColumnModel * self;
	gint result = 0;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = 1;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 340 "BrowserColumnModel.c"
}


static GType noise_browser_column_model_real_get_column_type (GtkTreeModel* base, gint col) {
	NoiseBrowserColumnModel * self;
	GType result = 0UL;
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = G_TYPE_STRING;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 353 "BrowserColumnModel.c"
}


/** Returns a newly-created Gtk.TreePath referenced by iter. **/
static GtkTreePath* noise_browser_column_model_real_get_path (GtkTreeModel* base, GtkTreeIter* iter) {
	NoiseBrowserColumnModel * self;
	GtkTreePath* result = NULL;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* _tmp6_;
#line 94 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 94 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = _tmp0_.user_data;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = g_sequence_iter_get_position ((GSequenceIter*) _tmp1_);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = g_strdup_printf ("%i", _tmp2_);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = _tmp3_;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = gtk_tree_path_new_from_string (_tmp4_);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = _tmp5_;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_free0 (_tmp4_);
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = _tmp6_;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 392 "BrowserColumnModel.c"
}


/** Initializes and sets value to that at column. **/
static void noise_browser_column_model_real_get_value (GtkTreeModel* base, GtkTreeIter* iter, gint column, GValue* val) {
	NoiseBrowserColumnModel * self;
	GValue _vala_val = {0};
	GValue _tmp0_ = {0};
	GValue _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GtkTreeIter _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GtkTreeIter _tmp9_;
	void* _tmp10_;
	gboolean _tmp11_;
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_value_init (&_tmp0_, G_TYPE_STRING);
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_val = _tmp0_;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = _vala_val;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = *iter;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = _tmp4_.stamp;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = self->priv->stamp;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp5_ != _tmp6_) {
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = TRUE;
#line 432 "BrowserColumnModel.c"
	} else {
		gint _tmp7_;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp7_ = column;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = _tmp7_ < 0;
#line 439 "BrowserColumnModel.c"
	}
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp3_) {
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = TRUE;
#line 445 "BrowserColumnModel.c"
	} else {
		gint _tmp8_;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp8_ = column;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = _tmp8_ >= 1;
#line 452 "BrowserColumnModel.c"
	}
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp2_) {
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (val) {
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*val = _vala_val;
#line 460 "BrowserColumnModel.c"
		} else {
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 464 "BrowserColumnModel.c"
		}
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return;
#line 468 "BrowserColumnModel.c"
	}
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp9_ = *iter;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp10_ = _tmp9_.user_data;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp11_ = g_sequence_iter_is_end ((GSequenceIter*) _tmp10_);
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (!_tmp11_) {
#line 478 "BrowserColumnModel.c"
		GtkTreeIter _tmp12_;
		void* _tmp13_;
		gconstpointer _tmp14_;
		GValue _tmp15_ = {0};
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp12_ = *iter;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp13_ = _tmp12_.user_data;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp14_ = g_sequence_get ((GSequenceIter*) _tmp13_);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_value_init (&_tmp15_, G_TYPE_STRING);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_value_set_string (&_tmp15_, (const gchar*) _tmp14_);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_vala_val = _tmp15_;
#line 497 "BrowserColumnModel.c"
	}
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (val) {
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*val = _vala_val;
#line 503 "BrowserColumnModel.c"
	} else {
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 507 "BrowserColumnModel.c"
	}
}


/** Sets iter to point to the first child of parent. **/
static gboolean noise_browser_column_model_real_iter_children (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* parent) {
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
#line 109 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = FALSE;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 527 "BrowserColumnModel.c"
	}
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 531 "BrowserColumnModel.c"
}


/** Returns true if iter has children, false otherwise. **/
static gboolean noise_browser_column_model_real_iter_has_child (GtkTreeModel* base, GtkTreeIter* iter) {
	NoiseBrowserColumnModel * self;
	gboolean result = FALSE;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = FALSE;
#line 118 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 547 "BrowserColumnModel.c"
}


/** Returns the number of children that iter has. **/
static gint noise_browser_column_model_real_iter_n_children (GtkTreeModel* base, GtkTreeIter* iter) {
	NoiseBrowserColumnModel * self;
	gint result = 0;
	GtkTreeIter* _tmp0_;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = iter;
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_ == NULL) {
#line 562 "BrowserColumnModel.c"
		GSequence* _tmp1_;
		gint _tmp2_;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = self->priv->rows;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = g_sequence_get_length (_tmp1_);
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = _tmp2_;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 573 "BrowserColumnModel.c"
	}
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = 0;
#line 126 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 579 "BrowserColumnModel.c"
}


/** Sets iter to point to the node following it at the current level. **/
static gboolean noise_browser_column_model_real_iter_next (GtkTreeModel* base, GtkTreeIter* iter) {
	NoiseBrowserColumnModel * self;
	gboolean result = FALSE;
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	GSequenceIter* _tmp5_;
	GtkTreeIter _tmp6_;
	void* _tmp7_;
	gboolean _tmp8_;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = _tmp0_.stamp;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = self->priv->stamp;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_ != _tmp2_) {
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 612 "BrowserColumnModel.c"
	}
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = *iter;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = _tmp3_.user_data;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = g_sequence_iter_next ((GSequenceIter*) _tmp4_);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(*iter).user_data = _tmp5_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = *iter;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = _tmp6_.user_data;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp8_ = g_sequence_iter_is_end ((GSequenceIter*) _tmp7_);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp8_) {
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 634 "BrowserColumnModel.c"
	}
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 640 "BrowserColumnModel.c"
}


/** Sets iter to be the child of parent, using the given index. **/
static gboolean noise_browser_column_model_real_iter_nth_child (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* parent, gint n) {
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	gint _tmp7_;
	GSequence* _tmp8_;
	gint _tmp9_;
	GSequenceIter* _tmp10_;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 144 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = n;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp2_ < 0) {
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = TRUE;
#line 666 "BrowserColumnModel.c"
	} else {
		gint _tmp3_;
		GSequence* _tmp4_;
		gint _tmp5_;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = n;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = self->priv->rows;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp5_ = g_sequence_get_length (_tmp4_);
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = _tmp3_ >= _tmp5_;
#line 679 "BrowserColumnModel.c"
	}
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_) {
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = TRUE;
#line 685 "BrowserColumnModel.c"
	} else {
		GtkTreeIter* _tmp6_;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp6_ = parent;
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = _tmp6_ != NULL;
#line 692 "BrowserColumnModel.c"
	}
#line 145 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_) {
#line 146 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 146 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (iter) {
#line 146 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*iter = _vala_iter;
#line 702 "BrowserColumnModel.c"
		}
#line 146 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 706 "BrowserColumnModel.c"
	}
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = self->priv->stamp;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.stamp = _tmp7_;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp8_ = self->priv->rows;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp9_ = n;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp10_ = g_sequence_get_iter_at_pos (_tmp8_, _tmp9_);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.user_data = _tmp10_;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 726 "BrowserColumnModel.c"
	}
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 730 "BrowserColumnModel.c"
}


/** Sets iter to be the parent of child. **/
static gboolean noise_browser_column_model_real_iter_parent (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* child) {
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (child != NULL, FALSE);
#line 156 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = FALSE;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 751 "BrowserColumnModel.c"
	}
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 755 "BrowserColumnModel.c"
}


/** Lets the tree ref the node. **/
static void noise_browser_column_model_real_ref_node (GtkTreeModel* base, GtkTreeIter* iter) {
	NoiseBrowserColumnModel * self;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 766 "BrowserColumnModel.c"
}


/** Lets the tree unref the node. **/
static void noise_browser_column_model_real_unref_node (GtkTreeModel* base, GtkTreeIter* iter) {
	NoiseBrowserColumnModel * self;
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 777 "BrowserColumnModel.c"
}


/** simply adds iter to the model **/
void noise_browser_column_model_append (NoiseBrowserColumnModel* self, GtkTreeIter* iter) {
	GtkTreeIter _vala_iter = {0};
	GSequenceIter* added = NULL;
	GSequence* _tmp0_;
	gchar* _tmp1_;
	GSequenceIter* _tmp2_;
	gint _tmp3_;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->rows;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = g_strdup ("");
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = g_sequence_append (_tmp0_, _tmp1_);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	added = _tmp2_;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = self->priv->stamp;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.stamp = _tmp3_;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.user_data = added;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 811 "BrowserColumnModel.c"
	}
}


/** convenience method to insert strings into the model. No iters returned. **/
void noise_browser_column_model_append_items (NoiseBrowserColumnModel* self, GeeCollection* strings, gboolean emit) {
	GtkTreeIter* _tmp0_;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (strings != NULL);
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->first_iter;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_ == NULL) {
#line 178 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		noise_browser_column_model_add_first_element (self);
#line 829 "BrowserColumnModel.c"
	}
	{
		GeeIterator* _s_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = strings;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_s_it = _tmp2_;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		while (TRUE) {
#line 843 "BrowserColumnModel.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_;
			gchar* s = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			GSequenceIter* added = NULL;
			GSequence* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			GSequenceIter* _tmp10_;
			gboolean _tmp11_;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp3_ = _s_it;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (!_tmp4_) {
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				break;
#line 863 "BrowserColumnModel.c"
			}
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp5_ = _s_it;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			s = (gchar*) _tmp6_;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp7_ = self->priv->rows;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp8_ = s;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp10_ = g_sequence_append (_tmp7_, _tmp9_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			added = _tmp10_;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp11_ = emit;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp11_) {
#line 885 "BrowserColumnModel.c"
				GtkTreePath* path = NULL;
				GSequenceIter* _tmp12_;
				gint _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				GtkTreePath* _tmp16_;
				GtkTreePath* _tmp17_;
				GtkTreeIter iter = {0};
				gint _tmp18_;
				GSequenceIter* _tmp19_;
				GtkTreePath* _tmp20_;
				GtkTreeIter _tmp21_;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp12_ = added;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp13_ = g_sequence_iter_get_position (_tmp12_);
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp14_ = g_strdup_printf ("%i", _tmp13_);
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp15_ = _tmp14_;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp16_ = gtk_tree_path_new_from_string (_tmp15_);
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp17_ = _tmp16_;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (_tmp15_);
#line 184 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				path = _tmp17_;
#line 185 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				memset (&iter, 0, sizeof (GtkTreeIter));
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp18_ = self->priv->stamp;
#line 187 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				iter.stamp = _tmp18_;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp19_ = added;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				iter.user_data = _tmp19_;
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp20_ = path;
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp21_ = iter;
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				gtk_tree_model_row_inserted ((GtkTreeModel*) self, _tmp20_, &_tmp21_);
#line 183 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_gtk_tree_path_free0 (path);
#line 932 "BrowserColumnModel.c"
			}
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_g_free0 (s);
#line 936 "BrowserColumnModel.c"
		}
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_g_object_unref0 (_s_it);
#line 940 "BrowserColumnModel.c"
	}
#line 194 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	noise_browser_column_model_update_first_item (self);
#line 944 "BrowserColumnModel.c"
}


static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self) {
	GtkTreeIter* dup;
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	dup = g_new0 (GtkTreeIter, 1);
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memcpy (dup, self, sizeof (GtkTreeIter));
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return dup;
#line 956 "BrowserColumnModel.c"
}


static gpointer __gtk_tree_iter_dup0 (gpointer self) {
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return self ? _gtk_tree_iter_dup (self) : NULL;
#line 963 "BrowserColumnModel.c"
}


static void noise_browser_column_model_add_first_element (NoiseBrowserColumnModel* self) {
	GSequenceIter* added = NULL;
	GSequence* _tmp0_;
	gchar* _tmp1_;
	GSequenceIter* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkTreeIter* _tmp4_;
	GtkTreeIter* _tmp5_;
	gint _tmp6_;
	GtkTreeIter* _tmp7_;
#line 198 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 199 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->rows;
#line 199 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = g_strdup ("All");
#line 199 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = g_sequence_append (_tmp0_, _tmp1_);
#line 199 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	added = _tmp2_;
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_tmp3_, 0, sizeof (GtkTreeIter));
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = __gtk_tree_iter_dup0 (&_tmp3_);
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_free0 (self->priv->first_iter);
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->first_iter = _tmp4_;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = self->priv->first_iter;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = self->priv->stamp;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(*_tmp5_).stamp = _tmp6_;
#line 204 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = self->priv->first_iter;
#line 204 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(*_tmp7_).user_data = added;
#line 1005 "BrowserColumnModel.c"
}


static void noise_browser_column_model_update_first_item (NoiseBrowserColumnModel* self) {
	GtkTreeIter* _tmp0_;
	void* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
#line 208 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->first_iter;
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = (*_tmp0_).user_data;
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = noise_browser_column_model_get_n_items (self);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = _tmp2_;
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = noise_browser_column_model_get_first_item_text (self, _tmp3_);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_sequence_set ((GSequenceIter*) _tmp1_, _tmp4_);
#line 1029 "BrowserColumnModel.c"
}


static gchar* noise_browser_column_model_get_first_item_text (NoiseBrowserColumnModel* self, gint n_items) {
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
	NoiseBrowserColumnCategory _tmp1_;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 215 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = g_strdup ("");
#line 215 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	rv = _tmp0_;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = self->priv->category;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	switch (_tmp1_) {
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_GENRE:
#line 1050 "BrowserColumnModel.c"
		{
			gint _tmp2_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp2_ = n_items;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp2_ == 1) {
#line 1057 "BrowserColumnModel.c"
				gchar* _tmp3_;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp3_ = g_strdup (_ ("All Genres"));
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp3_;
#line 1065 "BrowserColumnModel.c"
			} else {
				gint _tmp4_;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp4_ = n_items;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp4_ > 1) {
#line 1072 "BrowserColumnModel.c"
					gint _tmp5_;
					gchar* _tmp6_;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp5_ = n_items;
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp6_ = g_strdup_printf (_ ("All %i Genres"), _tmp5_);
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 222 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp6_;
#line 1083 "BrowserColumnModel.c"
				} else {
					gchar* _tmp7_;
#line 224 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp7_ = g_strdup (_ ("No Genres"));
#line 224 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 224 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp7_;
#line 1092 "BrowserColumnModel.c"
				}
			}
#line 225 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1097 "BrowserColumnModel.c"
		}
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_ARTIST:
#line 1101 "BrowserColumnModel.c"
		{
			gint _tmp8_;
#line 228 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp8_ = n_items;
#line 228 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp8_ == 1) {
#line 1108 "BrowserColumnModel.c"
				gchar* _tmp9_;
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp9_ = g_strdup (_ ("All Artists"));
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp9_;
#line 1116 "BrowserColumnModel.c"
			} else {
				gint _tmp10_;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp10_ = n_items;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp10_ > 1) {
#line 1123 "BrowserColumnModel.c"
					gint _tmp11_;
					gchar* _tmp12_;
#line 231 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp11_ = n_items;
#line 231 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp12_ = g_strdup_printf (_ ("All %i Artists"), _tmp11_);
#line 231 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 231 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp12_;
#line 1134 "BrowserColumnModel.c"
				} else {
					gchar* _tmp13_;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp13_ = g_strdup (_ ("No Artists"));
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp13_;
#line 1143 "BrowserColumnModel.c"
				}
			}
#line 234 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1148 "BrowserColumnModel.c"
		}
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_ALBUM:
#line 1152 "BrowserColumnModel.c"
		{
			gint _tmp14_;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp14_ = n_items;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp14_ == 1) {
#line 1159 "BrowserColumnModel.c"
				gchar* _tmp15_;
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp15_ = g_strdup (_ ("All Albums"));
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp15_;
#line 1167 "BrowserColumnModel.c"
			} else {
				gint _tmp16_;
#line 239 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp16_ = n_items;
#line 239 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp16_ > 1) {
#line 1174 "BrowserColumnModel.c"
					gint _tmp17_;
					gchar* _tmp18_;
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp17_ = n_items;
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp18_ = g_strdup_printf (_ ("All %i Albums"), _tmp17_);
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp18_;
#line 1185 "BrowserColumnModel.c"
				} else {
					gchar* _tmp19_;
#line 242 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp19_ = g_strdup (_ ("No Albums"));
#line 242 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 242 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp19_;
#line 1194 "BrowserColumnModel.c"
				}
			}
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1199 "BrowserColumnModel.c"
		}
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_YEAR:
#line 1203 "BrowserColumnModel.c"
		{
			gint _tmp20_;
#line 246 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp20_ = n_items;
#line 246 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp20_ == 1) {
#line 1210 "BrowserColumnModel.c"
				gchar* _tmp21_;
#line 247 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp21_ = g_strdup (_ ("All Years"));
#line 247 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 247 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp21_;
#line 1218 "BrowserColumnModel.c"
			} else {
				gint _tmp22_;
#line 248 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp22_ = n_items;
#line 248 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp22_ > 1) {
#line 1225 "BrowserColumnModel.c"
					gint _tmp23_;
					gchar* _tmp24_;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp23_ = n_items;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp24_ = g_strdup_printf (_ ("All %i Years"), _tmp23_);
#line 249 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 249 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp24_;
#line 1236 "BrowserColumnModel.c"
				} else {
					gchar* _tmp25_;
#line 251 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp25_ = g_strdup (_ ("No Years"));
#line 251 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 251 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp25_;
#line 1245 "BrowserColumnModel.c"
				}
			}
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1250 "BrowserColumnModel.c"
		}
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_RATING:
#line 1254 "BrowserColumnModel.c"
		{
			gint _tmp26_;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp26_ = n_items;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp26_ >= 1) {
#line 1261 "BrowserColumnModel.c"
				gchar* _tmp27_;
#line 256 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp27_ = g_strdup (_ ("All Ratings"));
#line 256 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 256 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp27_;
#line 1269 "BrowserColumnModel.c"
			} else {
				gchar* _tmp28_;
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp28_ = g_strdup (_ ("No Ratings"));
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 258 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp28_;
#line 1278 "BrowserColumnModel.c"
			}
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1282 "BrowserColumnModel.c"
		}
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_GROUPING:
#line 1286 "BrowserColumnModel.c"
		{
			gint _tmp29_;
#line 262 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp29_ = n_items;
#line 262 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp29_ == 1) {
#line 1293 "BrowserColumnModel.c"
				gchar* _tmp30_;
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp30_ = g_strdup (_ ("All Groupings"));
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp30_;
#line 1301 "BrowserColumnModel.c"
			} else {
				gint _tmp31_;
#line 264 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp31_ = n_items;
#line 264 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp31_ > 1) {
#line 1308 "BrowserColumnModel.c"
					gint _tmp32_;
					gchar* _tmp33_;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp32_ = n_items;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp33_ = g_strdup_printf (_ ("All %i Groupings"), _tmp32_);
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp33_;
#line 1319 "BrowserColumnModel.c"
				} else {
					gchar* _tmp34_;
#line 267 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp34_ = g_strdup (_ ("No Groupings"));
#line 267 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 267 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp34_;
#line 1328 "BrowserColumnModel.c"
				}
			}
#line 268 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1333 "BrowserColumnModel.c"
		}
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_COMPOSER:
#line 1337 "BrowserColumnModel.c"
		{
			gint _tmp35_;
#line 271 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp35_ = n_items;
#line 271 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp35_ == 1) {
#line 1344 "BrowserColumnModel.c"
				gchar* _tmp36_;
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp36_ = g_strdup (_ ("All Composers"));
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp36_;
#line 1352 "BrowserColumnModel.c"
			} else {
				gint _tmp37_;
#line 273 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp37_ = n_items;
#line 273 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp37_ > 1) {
#line 1359 "BrowserColumnModel.c"
					gint _tmp38_;
					gchar* _tmp39_;
#line 274 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp38_ = n_items;
#line 274 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp39_ = g_strdup_printf (_ ("All %i Composers"), _tmp38_);
#line 274 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 274 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp39_;
#line 1370 "BrowserColumnModel.c"
				} else {
					gchar* _tmp40_;
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp40_ = g_strdup (_ ("No Composers"));
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp40_;
#line 1379 "BrowserColumnModel.c"
				}
			}
#line 277 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1384 "BrowserColumnModel.c"
		}
		default:
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		break;
#line 1389 "BrowserColumnModel.c"
	}
#line 280 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = rv;
#line 280 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1395 "BrowserColumnModel.c"
}


void noise_browser_column_model_set (NoiseBrowserColumnModel* self, GtkTreeIter* iter, ...) {
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	va_list args = {0};
#line 284 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 284 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 285 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 285 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = _tmp0_.stamp;
#line 285 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = self->priv->stamp;
#line 285 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_ != _tmp2_) {
#line 286 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return;
#line 1418 "BrowserColumnModel.c"
	}
#line 288 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	va_start (args, iter);
#line 290 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	while (TRUE) {
#line 1424 "BrowserColumnModel.c"
		gint col = 0;
		gint _tmp3_;
		gboolean _tmp4_ = FALSE;
		gint _tmp5_;
#line 291 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = va_arg (args, gint);
#line 291 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		col = _tmp3_;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp5_ = col;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (_tmp5_ < 0) {
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp4_ = TRUE;
#line 1439 "BrowserColumnModel.c"
		} else {
			gint _tmp6_;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp6_ = col;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp4_ = _tmp6_ >= 1;
#line 1446 "BrowserColumnModel.c"
		}
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (_tmp4_) {
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			va_end (args);
#line 293 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			return;
#line 1454 "BrowserColumnModel.c"
		} else {
			gint _tmp7_;
#line 294 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp7_ = col;
#line 294 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp7_ == 0) {
#line 1461 "BrowserColumnModel.c"
				gchar* val = NULL;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				GtkTreeIter _tmp10_;
				void* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 295 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp8_ = va_arg (args, gchar*);
#line 295 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 295 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				val = _tmp9_;
#line 296 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp10_ = *iter;
#line 296 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp11_ = _tmp10_.user_data;
#line 296 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp12_ = val;
#line 296 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 296 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				g_sequence_set ((GSequenceIter*) _tmp11_, _tmp13_);
#line 294 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (val);
#line 1487 "BrowserColumnModel.c"
			}
		}
	}
#line 284 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	va_end (args);
#line 1493 "BrowserColumnModel.c"
}


void noise_browser_column_model_remove (NoiseBrowserColumnModel* self, GtkTreeIter* iter) {
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GSequenceIter* sequence_iter = NULL;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	GtkTreePath* path = NULL;
	GSequenceIter* _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkTreePath* _tmp9_;
	GtkTreePath* _tmp10_;
	GSequenceIter* _tmp11_;
	GtkTreePath* _tmp12_;
#line 301 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 301 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 302 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 302 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = _tmp0_.stamp;
#line 302 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = self->priv->stamp;
#line 302 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_ != _tmp2_) {
#line 303 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return;
#line 1527 "BrowserColumnModel.c"
	}
#line 305 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = *iter;
#line 305 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = _tmp3_.user_data;
#line 305 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sequence_iter = (GSequenceIter*) _tmp4_;
#line 306 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = sequence_iter;
#line 306 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = g_sequence_iter_get_position (_tmp5_);
#line 306 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = g_strdup_printf ("%i", _tmp6_);
#line 306 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp8_ = _tmp7_;
#line 306 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp9_ = gtk_tree_path_new_from_string (_tmp8_);
#line 306 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp10_ = _tmp9_;
#line 306 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_free0 (_tmp8_);
#line 306 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	path = _tmp10_;
#line 307 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp11_ = sequence_iter;
#line 307 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_sequence_remove (_tmp11_);
#line 308 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp12_ = path;
#line 308 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	gtk_tree_model_row_deleted ((GtkTreeModel*) self, _tmp12_);
#line 301 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_gtk_tree_path_free0 (path);
#line 1561 "BrowserColumnModel.c"
}


/** Fills in sort_column_id and order with the current sort column and the order. **/
static gboolean noise_browser_column_model_real_get_sort_column_id (GtkTreeSortable* base, gint* sort_column_id, GtkSortType* order) {
	NoiseBrowserColumnModel * self;
	gint _vala_sort_column_id = 0;
	GtkSortType _vala_order = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	GtkSortType _tmp1_;
#line 312 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 313 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->sort_column_id;
#line 313 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_sort_column_id = _tmp0_;
#line 314 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = self->priv->sort_direction;
#line 314 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_order = _tmp1_;
#line 316 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 316 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (sort_column_id) {
#line 316 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*sort_column_id = _vala_sort_column_id;
#line 1589 "BrowserColumnModel.c"
	}
#line 316 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (order) {
#line 316 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*order = _vala_order;
#line 1595 "BrowserColumnModel.c"
	}
#line 316 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1599 "BrowserColumnModel.c"
}


/** Returns true if the model has a default sort function. **/
static gboolean noise_browser_column_model_real_has_default_sort_func (GtkTreeSortable* base) {
	NoiseBrowserColumnModel * self;
	gboolean result = FALSE;
	GtkTreeIterCompareFunc _tmp0_;
	void* _tmp0__target;
#line 320 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 321 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->default_sort_func;
#line 321 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0__target = self->priv->default_sort_func_target;
#line 321 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = _tmp0_ != NULL;
#line 321 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1619 "BrowserColumnModel.c"
}


/** Sets the default comparison function used when sorting to be sort_func. **/
static void noise_browser_column_model_real_set_default_sort_func (GtkTreeSortable* base, GtkTreeIterCompareFunc sort_func, void* sort_func_target, GDestroyNotify sort_func_target_destroy_notify) {
	NoiseBrowserColumnModel * self;
	GtkTreeIterCompareFunc _tmp0_;
	void* _tmp0__target;
#line 325 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 326 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = sort_func;
#line 326 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0__target = sort_func_target;
#line 326 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->default_sort_func = _tmp0_;
#line 326 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->default_sort_func_target = _tmp0__target;
#line 325 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
#line 325 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func = NULL;
#line 325 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target = NULL;
#line 325 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target_destroy_notify = NULL;
#line 1646 "BrowserColumnModel.c"
}


/** Sets the current sort column to be sort_column_id. **/
static gint _noise_browser_column_model_sequenceIterCompareFunc_gsequence_iter_compare_func (GSequenceIter* a, GSequenceIter* b, gpointer self) {
	gint result;
	result = noise_browser_column_model_sequenceIterCompareFunc ((NoiseBrowserColumnModel*) self, a, b);
#line 338 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1656 "BrowserColumnModel.c"
}


static void noise_browser_column_model_real_set_sort_column_id (GtkTreeSortable* base, gint sort_column_id, GtkSortType order) {
	NoiseBrowserColumnModel * self;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean changed = FALSE;
	gint _tmp5_;
	GtkSortType _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_;
#line 330 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = self->priv->sort_column_id;
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = sort_column_id;
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_ != _tmp2_) {
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = TRUE;
#line 1680 "BrowserColumnModel.c"
	} else {
		GtkSortType _tmp3_;
		GtkSortType _tmp4_;
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = order;
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = self->priv->sort_direction;
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = _tmp3_ != _tmp4_;
#line 1690 "BrowserColumnModel.c"
	}
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	changed = _tmp0_;
#line 333 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = sort_column_id;
#line 333 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_column_id = _tmp5_;
#line 334 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = order;
#line 334 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_direction = _tmp6_;
#line 336 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp8_ = changed;
#line 336 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp8_) {
#line 1706 "BrowserColumnModel.c"
		gint _tmp9_;
#line 336 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp9_ = sort_column_id;
#line 336 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp7_ = _tmp9_ >= 0;
#line 1712 "BrowserColumnModel.c"
	} else {
#line 336 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp7_ = FALSE;
#line 1716 "BrowserColumnModel.c"
	}
#line 336 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp7_) {
#line 1720 "BrowserColumnModel.c"
		GSequence* _tmp10_;
#line 338 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp10_ = self->priv->rows;
#line 338 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_sequence_sort_iter (_tmp10_, _noise_browser_column_model_sequenceIterCompareFunc_gsequence_iter_compare_func, self);
#line 340 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		gtk_tree_sortable_sort_column_changed ((GtkTreeSortable*) self);
#line 1728 "BrowserColumnModel.c"
	}
}


static void noise_browser_column_model_real_set_sort_func (GtkTreeSortable* base, gint sort_column_id, GtkTreeIterCompareFunc sort_func, void* sort_func_target, GDestroyNotify sort_func_target_destroy_notify) {
	NoiseBrowserColumnModel * self;
#line 344 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 344 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
#line 344 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func = NULL;
#line 344 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target = NULL;
#line 344 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target_destroy_notify = NULL;
#line 1745 "BrowserColumnModel.c"
}


/** Custom function to use built in sort in Sequence to our advantage **/
gint noise_browser_column_model_sequenceIterCompareFunc (NoiseBrowserColumnModel* self, GSequenceIter* a, GSequenceIter* b) {
	gint result = 0;
	gint rv = 0;
	gint _tmp0_;
	gint _tmp1_;
	GtkSortType _tmp21_;
#line 350 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 350 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 350 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	rv = 1;
#line 353 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->sort_column_id;
#line 353 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_ < 0) {
#line 354 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = 0;
#line 354 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 1772 "BrowserColumnModel.c"
	}
#line 356 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = self->priv->sort_column_id;
#line 356 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_ == 0) {
#line 1778 "BrowserColumnModel.c"
		GSequenceIter* first_sequence_iter = NULL;
		GtkTreeIter* _tmp2_;
		void* _tmp3_;
		GSequenceIter* _tmp4_;
		GSequenceIter* _tmp5_;
#line 357 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = self->priv->first_iter;
#line 357 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = (*_tmp2_).user_data;
#line 357 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		first_sequence_iter = (GSequenceIter*) _tmp3_;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = a;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp5_ = first_sequence_iter;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (_tmp4_ == _tmp5_) {
#line 361 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			rv = -1;
#line 1798 "BrowserColumnModel.c"
		} else {
			GSequenceIter* _tmp6_;
			GSequenceIter* _tmp7_;
#line 363 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp6_ = b;
#line 363 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp7_ = first_sequence_iter;
#line 363 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp6_ == _tmp7_) {
#line 364 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = 1;
#line 1810 "BrowserColumnModel.c"
			} else {
				gboolean _tmp8_ = FALSE;
				NoiseBrowserColumnCategory _tmp9_;
#line 367 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp9_ = self->priv->category;
#line 367 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp9_ == NOISE_BROWSER_COLUMN_CATEGORY_ARTIST) {
#line 367 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp8_ = TRUE;
#line 1820 "BrowserColumnModel.c"
				} else {
					NoiseBrowserColumnCategory _tmp10_;
#line 367 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp10_ = self->priv->category;
#line 367 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp8_ = _tmp10_ == NOISE_BROWSER_COLUMN_CATEGORY_ALBUM;
#line 1827 "BrowserColumnModel.c"
				}
#line 367 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp8_) {
#line 1831 "BrowserColumnModel.c"
					GSequenceIter* _tmp11_;
					gconstpointer _tmp12_;
					GSequenceIter* _tmp13_;
					gconstpointer _tmp14_;
					gint _tmp15_;
#line 368 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp11_ = a;
#line 368 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp12_ = g_sequence_get (_tmp11_);
#line 368 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp13_ = b;
#line 368 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp14_ = g_sequence_get (_tmp13_);
#line 368 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp15_ = noise_string_compare ((const gchar*) _tmp12_, (const gchar*) _tmp14_);
#line 368 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp15_;
#line 1849 "BrowserColumnModel.c"
				} else {
					GSequenceIter* _tmp16_;
					gconstpointer _tmp17_;
					GSequenceIter* _tmp18_;
					gconstpointer _tmp19_;
					gint _tmp20_;
#line 370 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp16_ = a;
#line 370 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp17_ = g_sequence_get (_tmp16_);
#line 370 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp18_ = b;
#line 370 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp19_ = g_sequence_get (_tmp18_);
#line 370 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp20_ = noise_string_compare ((const gchar*) _tmp17_, (const gchar*) _tmp19_);
#line 370 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp20_;
#line 1868 "BrowserColumnModel.c"
				}
			}
		}
	}
#line 374 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp21_ = self->priv->sort_direction;
#line 374 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp21_ == GTK_SORT_DESCENDING) {
#line 1877 "BrowserColumnModel.c"
		gint _tmp22_ = 0;
		gint _tmp23_;
#line 375 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp23_ = rv;
#line 375 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (_tmp23_ > 0) {
#line 375 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp22_ = -1;
#line 1886 "BrowserColumnModel.c"
		} else {
#line 375 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp22_ = 1;
#line 1890 "BrowserColumnModel.c"
		}
#line 375 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		rv = _tmp22_;
#line 1894 "BrowserColumnModel.c"
	}
#line 377 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = rv;
#line 377 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1900 "BrowserColumnModel.c"
}


gint noise_browser_column_model_get_n_items (NoiseBrowserColumnModel* self) {
	gint result;
	GSequence* _tmp0_;
	gint _tmp1_;
#line 36 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->rows;
#line 36 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = g_sequence_get_length (_tmp0_);
#line 36 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = _tmp1_ - 1;
#line 36 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1918 "BrowserColumnModel.c"
}


static void noise_browser_column_model_class_init (NoiseBrowserColumnModelClass * klass) {
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	noise_browser_column_model_parent_class = g_type_class_peek_parent (klass);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_type_class_add_private (klass, sizeof (NoiseBrowserColumnModelPrivate));
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_browser_column_model_get_property;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_browser_column_model_finalize;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY, noise_browser_column_model_properties[NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY] = g_param_spec_int ("n-items", "n-items", "n-items", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1933 "BrowserColumnModel.c"
}


static void noise_browser_column_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface) {
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	noise_browser_column_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_flags = (GtkTreeModelFlags (*) (GtkTreeModel *)) noise_browser_column_model_real_get_flags;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_iter = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreePath*)) noise_browser_column_model_real_get_iter;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_n_columns = (gint (*) (GtkTreeModel *)) noise_browser_column_model_real_get_n_columns;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_column_type = (GType (*) (GtkTreeModel *, gint)) noise_browser_column_model_real_get_column_type;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_path = (GtkTreePath* (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_get_path;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_value = (void (*) (GtkTreeModel *, GtkTreeIter*, gint, GValue*)) noise_browser_column_model_real_get_value;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_children = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreeIter*)) noise_browser_column_model_real_iter_children;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_has_child = (gboolean (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_iter_has_child;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_n_children = (gint (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_iter_n_children;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_next = (gboolean (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_iter_next;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_nth_child = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreeIter*, gint)) noise_browser_column_model_real_iter_nth_child;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_parent = (gboolean (*) (GtkTreeModel *, GtkTreeIter*, GtkTreeIter*)) noise_browser_column_model_real_iter_parent;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->ref_node = (void (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_ref_node;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->unref_node = (void (*) (GtkTreeModel *, GtkTreeIter*)) noise_browser_column_model_real_unref_node;
#line 1968 "BrowserColumnModel.c"
}


static void noise_browser_column_model_gtk_tree_sortable_interface_init (GtkTreeSortableIface * iface) {
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	noise_browser_column_model_gtk_tree_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_sort_column_id = (gboolean (*) (GtkTreeSortable *, gint*, GtkSortType*)) noise_browser_column_model_real_get_sort_column_id;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->has_default_sort_func = (gboolean (*) (GtkTreeSortable *)) noise_browser_column_model_real_has_default_sort_func;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->set_default_sort_func = (void (*) (GtkTreeSortable *, GtkTreeIterCompareFunc, void*, GDestroyNotify)) noise_browser_column_model_real_set_default_sort_func;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->set_sort_column_id = (void (*) (GtkTreeSortable *, gint, GtkSortType)) noise_browser_column_model_real_set_sort_column_id;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->set_sort_func = (void (*) (GtkTreeSortable *, gint, GtkTreeIterCompareFunc, void*, GDestroyNotify)) noise_browser_column_model_real_set_sort_func;
#line 1985 "BrowserColumnModel.c"
}


static void noise_browser_column_model_instance_init (NoiseBrowserColumnModel * self) {
	guint32 _tmp0_;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv = NOISE_BROWSER_COLUMN_MODEL_GET_PRIVATE (self);
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = g_random_int ();
#line 34 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->stamp = (gint) _tmp0_;
#line 1997 "BrowserColumnModel.c"
}


static void noise_browser_column_model_finalize (GObject * obj) {
	NoiseBrowserColumnModel * self;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModel);
#line 39 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_sequence_free0 (self->priv->rows);
#line 42 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_free0 (self->priv->first_iter);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_OBJECT_CLASS (noise_browser_column_model_parent_class)->finalize (obj);
#line 2011 "BrowserColumnModel.c"
}


GType noise_browser_column_model_get_type (void) {
	static volatile gsize noise_browser_column_model_type_id__volatile = 0;
	if (g_once_init_enter (&noise_browser_column_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseBrowserColumnModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_browser_column_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseBrowserColumnModel), 0, (GInstanceInitFunc) noise_browser_column_model_instance_init, NULL };
		static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) noise_browser_column_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gtk_tree_sortable_info = { (GInterfaceInitFunc) noise_browser_column_model_gtk_tree_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_browser_column_model_type_id;
		noise_browser_column_model_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseBrowserColumnModel", &g_define_type_info, 0);
		g_type_add_interface_static (noise_browser_column_model_type_id, GTK_TYPE_TREE_MODEL, &gtk_tree_model_info);
		g_type_add_interface_static (noise_browser_column_model_type_id, GTK_TYPE_TREE_SORTABLE, &gtk_tree_sortable_info);
		g_once_init_leave (&noise_browser_column_model_type_id__volatile, noise_browser_column_model_type_id);
	}
	return noise_browser_column_model_type_id__volatile;
}


static void _vala_noise_browser_column_model_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseBrowserColumnModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModel);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	switch (property_id) {
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY:
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_value_set_int (value, noise_browser_column_model_get_n_items (self));
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		break;
#line 2042 "BrowserColumnModel.c"
		default:
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/builddir/build/BUILD/music-0.4.2/src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		break;
#line 2048 "BrowserColumnModel.c"
	}
}



