/* ViewSelector.c generated by valac 0.38.10, the Vala compiler
 * generated from ViewSelector.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <glib/gi18n-lib.h>


#define NOISE_WIDGETS_TYPE_VIEW_SELECTOR (noise_widgets_view_selector_get_type ())
#define NOISE_WIDGETS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector))
#define NOISE_WIDGETS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_VIEW_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))

typedef struct _NoiseWidgetsViewSelector NoiseWidgetsViewSelector;
typedef struct _NoiseWidgetsViewSelectorClass NoiseWidgetsViewSelectorClass;
typedef struct _NoiseWidgetsViewSelectorPrivate NoiseWidgetsViewSelectorPrivate;

#define NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE (noise_widgets_view_selector_mode_get_type ())
enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_0_PROPERTY,
	NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY,
	NOISE_WIDGETS_VIEW_SELECTOR_NUM_PROPERTIES
};
static GParamSpec* noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL,
	NOISE_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL,
	NOISE_WIDGETS_VIEW_SELECTOR_NUM_SIGNALS
};
static guint noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_NUM_SIGNALS] = {0};

struct _NoiseWidgetsViewSelector {
	GtkToolItem parent_instance;
	NoiseWidgetsViewSelectorPrivate * priv;
};

struct _NoiseWidgetsViewSelectorClass {
	GtkToolItemClass parent_class;
};

typedef enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID = 0,
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST = 1,
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN = 2
} NoiseWidgetsViewSelectorMode;

struct _NoiseWidgetsViewSelectorPrivate {
	GraniteWidgetsModeButton* mode_button;
	NoiseWidgetsViewSelectorMode mode;
};


static gpointer noise_widgets_view_selector_parent_class = NULL;

GType noise_widgets_view_selector_get_type (void) G_GNUC_CONST;
GType noise_widgets_view_selector_mode_get_type (void) G_GNUC_CONST;
#define NOISE_WIDGETS_VIEW_SELECTOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorPrivate))
NoiseWidgetsViewSelector* noise_widgets_view_selector_new (void);
NoiseWidgetsViewSelector* noise_widgets_view_selector_construct (GType object_type);
static void __lambda42_ (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_selected (NoiseWidgetsViewSelector* self, NoiseWidgetsViewSelectorMode value);
static void ___lambda42__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender, GtkWidget* widget, gpointer self);
static void noise_widgets_view_selector_set_mode_visible (NoiseWidgetsViewSelector* self, NoiseWidgetsViewSelectorMode mode, gboolean visible);
static gboolean noise_widgets_view_selector_get_mode_visible (NoiseWidgetsViewSelector* self, NoiseWidgetsViewSelectorMode mode);
void noise_widgets_view_selector_set_sensitive (NoiseWidgetsViewSelector* self, gboolean sensitive);
gboolean noise_widgets_view_selector_get_sensitive (NoiseWidgetsViewSelector* self);
gboolean noise_widgets_view_selector_get_column_browser_toggle_active (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_column_browser_toggle_active (NoiseWidgetsViewSelector* self, gboolean active);
gboolean noise_widgets_view_selector_get_column_browser_toggle_visible (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_column_browser_toggle_visible (NoiseWidgetsViewSelector* self, gboolean val);
NoiseWidgetsViewSelectorMode noise_widgets_view_selector_get_selected (NoiseWidgetsViewSelector* self);
static void noise_widgets_view_selector_finalize (GObject * obj);
static void _vala_noise_widgets_view_selector_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_widgets_view_selector_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType noise_widgets_view_selector_mode_get_type (void) {
	static volatile gsize noise_widgets_view_selector_mode_type_id__volatile = 0;
	if (g_once_init_enter (&noise_widgets_view_selector_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID, "NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID", "grid"}, {NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST, "NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST", "list"}, {NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN, "NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN", "column"}, {0, NULL, NULL}};
		GType noise_widgets_view_selector_mode_type_id;
		noise_widgets_view_selector_mode_type_id = g_enum_register_static ("NoiseWidgetsViewSelectorMode", values);
		g_once_init_leave (&noise_widgets_view_selector_mode_type_id__volatile, noise_widgets_view_selector_mode_type_id);
	}
	return noise_widgets_view_selector_mode_type_id__volatile;
}


static void __lambda42_ (NoiseWidgetsViewSelector* self) {
	gint new_mode = 0;
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp2_ = _tmp1_;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	new_mode = _tmp2_;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp3_ = new_mode;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	if (_tmp3_ <= 2) {
#line 140 "ViewSelector.c"
		gint _tmp4_;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp4_ = new_mode;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		noise_widgets_view_selector_set_selected (self, (NoiseWidgetsViewSelectorMode) _tmp4_);
#line 146 "ViewSelector.c"
	} else {
		GraniteWidgetsModeButton* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp5_ = self->priv->mode_button;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp6_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp5_);
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp7_ = _tmp6_;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		if (_tmp7_) {
#line 159 "ViewSelector.c"
			NoiseWidgetsViewSelectorMode _tmp8_;
#line 88 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
			_tmp8_ = self->priv->mode;
#line 88 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
			noise_widgets_view_selector_set_selected (self, _tmp8_);
#line 165 "ViewSelector.c"
		}
	}
}


static void ___lambda42__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender, GtkWidget* widget, gpointer self) {
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	__lambda42_ ((NoiseWidgetsViewSelector*) self);
#line 174 "ViewSelector.c"
}


NoiseWidgetsViewSelector* noise_widgets_view_selector_construct (GType object_type) {
	NoiseWidgetsViewSelector * self = NULL;
	GraniteWidgetsModeButton* _tmp0_;
	GraniteWidgetsModeButton* _tmp1_;
	GraniteWidgetsModeButton* _tmp2_;
	GtkImage* image = NULL;
	GtkImage* _tmp3_;
	GraniteWidgetsModeButton* _tmp4_;
	GtkImage* list = NULL;
	GtkImage* _tmp5_;
	GraniteWidgetsModeButton* _tmp6_;
	GtkImage* column = NULL;
	GtkImage* _tmp7_;
	GraniteWidgetsModeButton* _tmp8_;
	GraniteWidgetsModeButton* _tmp9_;
	GraniteWidgetsModeButton* _tmp10_;
	GraniteWidgetsModeButton* _tmp11_;
	GraniteWidgetsModeButton* _tmp12_;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	self = (NoiseWidgetsViewSelector*) g_object_new (object_type, NULL);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 90, -1);
#line 61 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = granite_widgets_mode_button_new ();
#line 61 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp0_);
#line 61 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_g_object_unref0 (self->priv->mode_button);
#line 61 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	self->priv->mode_button = _tmp0_;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp1_ = self->priv->mode_button;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp2_ = self->priv->mode_button;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_START);
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("view-grid-symbolic", GTK_ICON_SIZE_MENU);
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp3_);
#line 65 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	image = _tmp3_;
#line 66 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) image, _ ("View as Albums"));
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp4_ = self->priv->mode_button;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_append (_tmp4_, (GtkWidget*) image);
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("view-list-symbolic", GTK_ICON_SIZE_MENU);
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp5_);
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	list = _tmp5_;
#line 70 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) list, _ ("View as List"));
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp6_ = self->priv->mode_button;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_append (_tmp6_, (GtkWidget*) list);
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp7_ = (GtkImage*) gtk_image_new_from_icon_name ("view-column-symbolic", GTK_ICON_SIZE_MENU);
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_object_ref_sink (_tmp7_);
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	column = _tmp7_;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) column, _ ("View in Columns"));
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp8_ = self->priv->mode_button;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_append (_tmp8_, (GtkWidget*) column);
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp9_ = self->priv->mode_button;
#line 78 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_append_text (_tmp9_, "");
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp10_ = self->priv->mode_button;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_set_item_visible (_tmp10_, 3, FALSE);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp11_ = self->priv->mode_button;
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp11_);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp12_ = self->priv->mode_button;
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_signal_connect_object (_tmp12_, "mode-changed", (GCallback) ___lambda42__granite_widgets_mode_button_mode_changed, self, 0);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_g_object_unref0 (column);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_g_object_unref0 (list);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_g_object_unref0 (image);
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	return self;
#line 276 "ViewSelector.c"
}


NoiseWidgetsViewSelector* noise_widgets_view_selector_new (void) {
#line 57 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	return noise_widgets_view_selector_construct (NOISE_WIDGETS_TYPE_VIEW_SELECTOR);
#line 283 "ViewSelector.c"
}


static void noise_widgets_view_selector_set_mode_visible (NoiseWidgetsViewSelector* self, NoiseWidgetsViewSelectorMode mode, gboolean visible) {
	GraniteWidgetsModeButton* _tmp0_;
	NoiseWidgetsViewSelectorMode _tmp1_;
	gboolean _tmp2_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp1_ = mode;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp2_ = visible;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_set_item_visible (_tmp0_, (gint) _tmp1_, _tmp2_);
#line 301 "ViewSelector.c"
}


static gboolean noise_widgets_view_selector_get_mode_visible (NoiseWidgetsViewSelector* self, NoiseWidgetsViewSelectorMode mode) {
	gboolean result = FALSE;
	GraniteWidgetsModeButton* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	NoiseWidgetsViewSelectorMode _tmp3_;
	gconstpointer _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp2_ = _tmp1_;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp3_ = mode;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp4_ = g_list_nth_data (_tmp2_, (guint) ((gint) _tmp3_));
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp5_ = gtk_widget_get_visible ((GtkWidget*) _tmp4_);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp6_ = _tmp5_;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp7_ = _tmp6_;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_g_list_free0 (_tmp2_);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	result = _tmp7_;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	return result;
#line 339 "ViewSelector.c"
}


void noise_widgets_view_selector_set_sensitive (NoiseWidgetsViewSelector* self, gboolean sensitive) {
	GraniteWidgetsModeButton* _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
	GraniteWidgetsModeButton* _tmp5_;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp1_ = sensitive;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp1_);
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp3_ = sensitive;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	if (_tmp3_) {
#line 361 "ViewSelector.c"
		NoiseWidgetsViewSelectorMode _tmp4_;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp4_ = self->priv->mode;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp2_ = (gint) _tmp4_;
#line 367 "ViewSelector.c"
	} else {
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp2_ = 3;
#line 371 "ViewSelector.c"
	}
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp5_ = self->priv->mode_button;
#line 104 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_set_active (_tmp5_, _tmp2_);
#line 377 "ViewSelector.c"
}


gboolean noise_widgets_view_selector_get_sensitive (NoiseWidgetsViewSelector* self) {
	gboolean result = FALSE;
	GraniteWidgetsModeButton* _tmp0_;
	gboolean _tmp1_;
#line 107 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode_button;
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp0_);
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	result = _tmp1_;
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	return result;
#line 395 "ViewSelector.c"
}


gboolean noise_widgets_view_selector_get_column_browser_toggle_active (NoiseWidgetsViewSelector* self) {
	gboolean result = FALSE;
	NoiseWidgetsViewSelectorMode _tmp0_;
#line 115 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	result = _tmp0_ == NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	return result;
#line 410 "ViewSelector.c"
}


void noise_widgets_view_selector_set_column_browser_toggle_active (NoiseWidgetsViewSelector* self, gboolean active) {
	gboolean _tmp0_;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = active;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	if (_tmp0_) {
#line 121 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		noise_widgets_view_selector_set_selected (self, NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN);
#line 424 "ViewSelector.c"
	} else {
		gboolean _tmp1_;
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp1_ = noise_widgets_view_selector_get_column_browser_toggle_active (self);
#line 122 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		if (_tmp1_) {
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
			noise_widgets_view_selector_set_selected (self, NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST);
#line 433 "ViewSelector.c"
		}
	}
}


gboolean noise_widgets_view_selector_get_column_browser_toggle_visible (NoiseWidgetsViewSelector* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = noise_widgets_view_selector_get_mode_visible (self, NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN);
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	result = _tmp0_;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	return result;
#line 450 "ViewSelector.c"
}


void noise_widgets_view_selector_set_column_browser_toggle_visible (NoiseWidgetsViewSelector* self, gboolean val) {
	gboolean _tmp0_;
#line 131 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = val;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	noise_widgets_view_selector_set_mode_visible (self, NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN, _tmp0_);
#line 462 "ViewSelector.c"
}


NoiseWidgetsViewSelectorMode noise_widgets_view_selector_get_selected (NoiseWidgetsViewSelector* self) {
	NoiseWidgetsViewSelectorMode result;
	NoiseWidgetsViewSelectorMode _tmp0_ = 0;
	NoiseWidgetsViewSelectorMode _tmp1_;
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp1_ = self->priv->mode;
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	if (_tmp1_ != NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN) {
#line 476 "ViewSelector.c"
		NoiseWidgetsViewSelectorMode _tmp2_;
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp2_ = self->priv->mode;
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp0_ = _tmp2_;
#line 482 "ViewSelector.c"
	} else {
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp0_ = NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST;
#line 486 "ViewSelector.c"
	}
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	result = _tmp0_;
#line 41 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	return result;
#line 492 "ViewSelector.c"
}


void noise_widgets_view_selector_set_selected (NoiseWidgetsViewSelector* self, NoiseWidgetsViewSelectorMode value) {
	NoiseWidgetsViewSelectorMode _tmp0_;
	NoiseWidgetsViewSelectorMode _tmp1_;
	NoiseWidgetsViewSelectorMode _tmp2_;
	GraniteWidgetsModeButton* _tmp3_;
	NoiseWidgetsViewSelectorMode _tmp4_;
	gboolean is_column_mode = FALSE;
	NoiseWidgetsViewSelectorMode _tmp5_;
	gboolean _tmp6_;
	NoiseWidgetsViewSelectorMode _tmp7_ = 0;
	gboolean _tmp8_;
#line 42 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_return_if_fail (self != NULL);
#line 43 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp0_ = self->priv->mode;
#line 43 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp1_ = value;
#line 43 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	if (_tmp0_ == _tmp1_) {
#line 44 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		return;
#line 517 "ViewSelector.c"
	}
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp2_ = value;
#line 45 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	self->priv->mode = _tmp2_;
#line 46 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp3_ = self->priv->mode_button;
#line 46 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp4_ = value;
#line 46 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	granite_widgets_mode_button_set_active (_tmp3_, (gint) _tmp4_);
#line 48 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp5_ = value;
#line 48 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	is_column_mode = _tmp5_ == NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp6_ = is_column_mode;
#line 49 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_signal_emit (self, noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL], 0, _tmp6_);
#line 50 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_tmp8_ = is_column_mode;
#line 50 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	if (_tmp8_) {
#line 50 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp7_ = NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST;
#line 543 "ViewSelector.c"
	} else {
		NoiseWidgetsViewSelectorMode _tmp9_;
#line 50 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp9_ = value;
#line 50 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		_tmp7_ = _tmp9_;
#line 550 "ViewSelector.c"
	}
#line 50 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_signal_emit (self, noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL], 0, _tmp7_);
#line 42 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY]);
#line 556 "ViewSelector.c"
}


static void noise_widgets_view_selector_class_init (NoiseWidgetsViewSelectorClass * klass) {
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	noise_widgets_view_selector_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_type_class_add_private (klass, sizeof (NoiseWidgetsViewSelectorPrivate));
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_widgets_view_selector_get_property;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_widgets_view_selector_set_property;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_widgets_view_selector_finalize;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY, noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY] = g_param_spec_enum ("selected", "selected", "selected", NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL] = g_signal_new ("mode-changed", NOISE_WIDGETS_TYPE_VIEW_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL] = g_signal_new ("column-browser-toggled", NOISE_WIDGETS_TYPE_VIEW_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 577 "ViewSelector.c"
}


static void noise_widgets_view_selector_instance_init (NoiseWidgetsViewSelector * self) {
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	self->priv = NOISE_WIDGETS_VIEW_SELECTOR_GET_PRIVATE (self);
#line 584 "ViewSelector.c"
}


static void noise_widgets_view_selector_finalize (GObject * obj) {
	NoiseWidgetsViewSelector * self;
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector);
#line 54 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	_g_object_unref0 (self->priv->mode_button);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	G_OBJECT_CLASS (noise_widgets_view_selector_parent_class)->finalize (obj);
#line 596 "ViewSelector.c"
}


GType noise_widgets_view_selector_get_type (void) {
	static volatile gsize noise_widgets_view_selector_type_id__volatile = 0;
	if (g_once_init_enter (&noise_widgets_view_selector_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseWidgetsViewSelectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_widgets_view_selector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseWidgetsViewSelector), 0, (GInstanceInitFunc) noise_widgets_view_selector_instance_init, NULL };
		GType noise_widgets_view_selector_type_id;
		noise_widgets_view_selector_type_id = g_type_register_static (gtk_tool_item_get_type (), "NoiseWidgetsViewSelector", &g_define_type_info, 0);
		g_once_init_leave (&noise_widgets_view_selector_type_id__volatile, noise_widgets_view_selector_type_id);
	}
	return noise_widgets_view_selector_type_id__volatile;
}


static void _vala_noise_widgets_view_selector_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	switch (property_id) {
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		case NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY:
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		g_value_set_enum (value, noise_widgets_view_selector_get_selected (self));
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		break;
#line 623 "ViewSelector.c"
		default:
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		break;
#line 629 "ViewSelector.c"
	}
}


static void _vala_noise_widgets_view_selector_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoiseWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
	switch (property_id) {
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		case NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY:
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		noise_widgets_view_selector_set_selected (self, g_value_get_enum (value));
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		break;
#line 645 "ViewSelector.c"
		default:
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "/builddir/build/BUILD/music-0.4.2/src/Widgets/ViewSelector.vala"
		break;
#line 651 "ViewSelector.c"
	}
}



