/* LocalMedia.c generated by valac 0.38.10, the Vala compiler
 * generated from LocalMedia.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <noise-core.h>
#include <stdlib.h>
#include <string.h>
#include <libgda/libgda.h>


#define NOISE_TYPE_LOCAL_MEDIA (noise_local_media_get_type ())
#define NOISE_LOCAL_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia))
#define NOISE_LOCAL_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMediaClass))
#define NOISE_IS_LOCAL_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_MEDIA))
#define NOISE_IS_LOCAL_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_MEDIA))
#define NOISE_LOCAL_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMediaClass))

typedef struct _NoiseLocalMedia NoiseLocalMedia;
typedef struct _NoiseLocalMediaClass NoiseLocalMediaClass;
typedef struct _NoiseLocalMediaPrivate NoiseLocalMediaPrivate;
enum  {
	NOISE_LOCAL_MEDIA_0_PROPERTY,
	NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY,
	NOISE_LOCAL_MEDIA_TITLE_PROPERTY,
	NOISE_LOCAL_MEDIA_TRACK_PROPERTY,
	NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY,
	NOISE_LOCAL_MEDIA_ARTIST_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY,
	NOISE_LOCAL_MEDIA_GROUPING_PROPERTY,
	NOISE_LOCAL_MEDIA_GENRE_PROPERTY,
	NOISE_LOCAL_MEDIA_COMMENT_PROPERTY,
	NOISE_LOCAL_MEDIA_LYRICS_PROPERTY,
	NOISE_LOCAL_MEDIA_YEAR_PROPERTY,
	NOISE_LOCAL_MEDIA_BITRATE_PROPERTY,
	NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY,
	NOISE_LOCAL_MEDIA_LENGTH_PROPERTY,
	NOISE_LOCAL_MEDIA_RATING_PROPERTY,
	NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY,
	NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY,
	NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY,
	NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY,
	NOISE_LOCAL_MEDIA_NUM_PROPERTIES
};
static GParamSpec* noise_local_media_properties[NOISE_LOCAL_MEDIA_NUM_PROPERTIES];
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define __g_slist_free___vala_GValue_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free___vala_GValue_free0_ (var), NULL)))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseLocalMedia {
	NoiseMedia parent_instance;
	NoiseLocalMediaPrivate * priv;
	guint* _year;
	guint* _bitrate;
	guint* _samplerate;
	guint* _length;
	guint* _play_count;
	guint* _skip_count;
	guint* _date_added;
	guint* _last_played;
	guint* _last_modified;
};

struct _NoiseLocalMediaClass {
	NoiseMediaClass parent_class;
};

struct _NoiseLocalMediaPrivate {
	guint64* _file_size;
	gchar* _title;
	guint* _track;
	guint* _track_count;
	gchar* _composer;
	gchar* _artist;
	gchar* _album_artist;
	gchar* _album;
	guint* _album_number;
	guint* _album_count;
	NoiseAlbum* _album_info;
	gchar* _grouping;
	gchar* _genre;
	gchar* _comment;
	gchar* _lyrics;
	gint _resume_pos;
	GdaConnection* connection;
};


static gpointer noise_local_media_parent_class = NULL;

GType noise_local_media_get_type (void) G_GNUC_CONST;
#define NOISE_LOCAL_MEDIA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMediaPrivate))
NoiseLocalMedia* noise_local_media_new (gint64 rowid, GdaConnection* connection);
NoiseLocalMedia* noise_local_media_construct (GType object_type, gint64 rowid, GdaConnection* connection);
GValue* noise_database_query_field (gint64 rowid, GdaConnection* connection, const gchar* table, const gchar* field);
#define NOISE_DATABASE_MEDIA_TABLE_NAME "media"
static void _vala_GValue_free (GValue* self);
NoiseLocalMedia* noise_local_media_new_from_media (GdaConnection* connection, NoiseMedia* m);
NoiseLocalMedia* noise_local_media_construct_from_media (GType object_type, GdaConnection* connection, NoiseMedia* m);
#define NOISE_DATABASE_MEDIA_ROWID "+26"
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static guint64 noise_local_media_common_uint64_getter (NoiseLocalMedia* self, const gchar* field, guint64** temp);
static guint64* _uint64_dup (guint64* self);
static void noise_local_media_common_uint64_setter (NoiseLocalMedia* self, const gchar* field, guint64 value, guint64** temp);
void noise_database_set_field (gint64 rowid, GdaConnection* connection, const gchar* table, const gchar* field, GValue* value);
static guint noise_local_media_common_uint_getter (NoiseLocalMedia* self, const gchar* field, guint** temp);
static guint* _uint_dup (guint* self);
static void noise_local_media_common_uint_setter (NoiseLocalMedia* self, const gchar* field, guint value, guint** temp);
static gchar* noise_local_media_common_string_getter (NoiseLocalMedia* self, const gchar* field, gchar* * temp);
static void noise_local_media_common_string_setter (NoiseLocalMedia* self, const gchar* field, const gchar* value, gchar* * temp);
static void noise_local_media_finalize (GObject * obj);
static void _vala_noise_local_media_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_local_media_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
#line 307 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return self ? g_object_ref (self) : NULL;
#line 161 "LocalMedia.c"
}


static void _vala_GValue_free (GValue* self) {
#line 305 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_value_unset (self);
#line 305 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_free (self);
#line 170 "LocalMedia.c"
}


NoiseLocalMedia* noise_local_media_construct (GType object_type, gint64 rowid, GdaConnection* connection) {
	NoiseLocalMedia * self = NULL;
	gint64 _tmp0_;
	GdaConnection* _tmp1_;
	GdaConnection* _tmp2_;
	GValue* query = NULL;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue* _tmp5_;
	GValue* _tmp6_;
#line 305 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 306 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = rowid;
#line 306 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) g_object_new (object_type, "rowid", _tmp0_, NULL);
#line 307 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = connection;
#line 307 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 307 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_object_unref0 (self->priv->connection);
#line 307 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->connection = _tmp2_;
#line 308 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp3_ = rowid;
#line 308 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp4_ = connection;
#line 308 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp5_ = noise_database_query_field (_tmp3_, _tmp4_, NOISE_DATABASE_MEDIA_TABLE_NAME, "uri");
#line 308 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	query = _tmp5_;
#line 309 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp6_ = query;
#line 309 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (_tmp6_ != NULL) {
#line 210 "LocalMedia.c"
		GValue* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 310 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp7_ = query;
#line 310 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp8_ = g_value_dup_string (_tmp7_);
#line 310 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp9_ = _tmp8_;
#line 310 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_uri ((NoiseMedia*) self, _tmp9_);
#line 310 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_free0 (_tmp9_);
#line 224 "LocalMedia.c"
	}
#line 305 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	__vala_GValue_free0 (query);
#line 305 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return self;
#line 230 "LocalMedia.c"
}


NoiseLocalMedia* noise_local_media_new (gint64 rowid, GdaConnection* connection) {
#line 305 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return noise_local_media_construct (NOISE_TYPE_LOCAL_MEDIA, rowid, connection);
#line 237 "LocalMedia.c"
}


static void __vala_GValue_free0_ (gpointer var) {
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 244 "LocalMedia.c"
}


static inline void _g_slist_free___vala_GValue_free0_ (GSList* self) {
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
#line 251 "LocalMedia.c"
}


static void _g_free0_ (gpointer var) {
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	var = (g_free (var), NULL);
#line 258 "LocalMedia.c"
}


static inline void _g_slist_free__g_free0_ (GSList* self) {
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 265 "LocalMedia.c"
}


NoiseLocalMedia* noise_local_media_construct_from_media (GType object_type, GdaConnection* connection, NoiseMedia* m) {
	NoiseLocalMedia * self = NULL;
	GValue* query = NULL;
	gint64 _tmp151_;
	gint64 _tmp152_;
	GdaConnection* _tmp153_;
	GValue* _tmp154_;
	GValue* _tmp155_;
	GError * _inner_error_ = NULL;
#line 315 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 315 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (m != NULL, NULL);
#line 282 "LocalMedia.c"
	{
		GdaSqlBuilder* builder = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		NoiseMedia* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GValue* _tmp6_ = NULL;
		GdaSet* last_insert_row = NULL;
		GdaStatement* _tmp7_ = NULL;
		GdaSqlBuilder* _tmp8_;
		GdaStatement* _tmp9_;
		GdaConnection* _tmp10_;
		GdaSet* _tmp11_ = NULL;
		gint64 _rowid = 0LL;
		GdaSet* _tmp12_;
		GValue* _tmp13_;
		gint64 _tmp14_;
		gint64 _tmp15_;
		GdaConnection* _tmp16_;
		GdaConnection* _tmp17_;
		GSList* col_names = NULL;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		GSList* values = NULL;
		NoiseMedia* _tmp43_;
		guint64 _tmp44_;
		guint64 _tmp45_;
		GValue* _tmp46_ = NULL;
		NoiseMedia* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		GValue* _tmp50_ = NULL;
		NoiseMedia* _tmp51_;
		const gchar* _tmp52_;
		const gchar* _tmp53_;
		GValue* _tmp54_ = NULL;
		NoiseMedia* _tmp55_;
		const gchar* _tmp56_;
		const gchar* _tmp57_;
		GValue* _tmp58_ = NULL;
		NoiseMedia* _tmp59_;
		const gchar* _tmp60_;
		const gchar* _tmp61_;
		GValue* _tmp62_ = NULL;
		NoiseMedia* _tmp63_;
		const gchar* _tmp64_;
		const gchar* _tmp65_;
		GValue* _tmp66_ = NULL;
		NoiseMedia* _tmp67_;
		const gchar* _tmp68_;
		const gchar* _tmp69_;
		GValue* _tmp70_ = NULL;
		NoiseMedia* _tmp71_;
		const gchar* _tmp72_;
		const gchar* _tmp73_;
		GValue* _tmp74_ = NULL;
		NoiseMedia* _tmp75_;
		const gchar* _tmp76_;
		const gchar* _tmp77_;
		GValue* _tmp78_ = NULL;
		NoiseMedia* _tmp79_;
		const gchar* _tmp80_;
		const gchar* _tmp81_;
		GValue* _tmp82_ = NULL;
		NoiseMedia* _tmp83_;
		gboolean _tmp84_;
		gboolean _tmp85_;
		GValue* _tmp86_ = NULL;
		NoiseMedia* _tmp87_;
		guint _tmp88_;
		guint _tmp89_;
		GValue* _tmp90_ = NULL;
		NoiseMedia* _tmp91_;
		guint _tmp92_;
		guint _tmp93_;
		GValue* _tmp94_ = NULL;
		NoiseMedia* _tmp95_;
		guint _tmp96_;
		guint _tmp97_;
		GValue* _tmp98_ = NULL;
		NoiseMedia* _tmp99_;
		guint _tmp100_;
		guint _tmp101_;
		GValue* _tmp102_ = NULL;
		NoiseMedia* _tmp103_;
		guint _tmp104_;
		guint _tmp105_;
		GValue* _tmp106_ = NULL;
		NoiseMedia* _tmp107_;
		guint _tmp108_;
		guint _tmp109_;
		GValue* _tmp110_ = NULL;
		NoiseMedia* _tmp111_;
		guint _tmp112_;
		guint _tmp113_;
		GValue* _tmp114_ = NULL;
		NoiseMedia* _tmp115_;
		guint _tmp116_;
		guint _tmp117_;
		GValue* _tmp118_ = NULL;
		NoiseMedia* _tmp119_;
		guint _tmp120_;
		guint _tmp121_;
		GValue* _tmp122_ = NULL;
		NoiseMedia* _tmp123_;
		guint _tmp124_;
		guint _tmp125_;
		GValue* _tmp126_ = NULL;
		NoiseMedia* _tmp127_;
		guint _tmp128_;
		guint _tmp129_;
		GValue* _tmp130_ = NULL;
		NoiseMedia* _tmp131_;
		guint _tmp132_;
		guint _tmp133_;
		GValue* _tmp134_ = NULL;
		NoiseMedia* _tmp135_;
		guint _tmp136_;
		guint _tmp137_;
		GValue* _tmp138_ = NULL;
		NoiseMedia* _tmp139_;
		guint _tmp140_;
		guint _tmp141_;
		GValue* _tmp142_ = NULL;
		GdaConnection* _tmp143_;
		GdaSet* _tmp144_;
		GValue* _tmp145_;
		GSList* _tmp146_;
		GSList* _tmp147_;
		GValue _tmp148_;
#line 317 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
#line 317 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		builder = _tmp0_;
#line 318 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp1_ = builder;
#line 318 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		gda_sql_builder_set_table (_tmp1_, NOISE_DATABASE_MEDIA_TABLE_NAME);
#line 319 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp2_ = builder;
#line 319 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp3_ = m;
#line 319 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp4_ = noise_media_get_uri (_tmp3_);
#line 319 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp5_ = _tmp4_;
#line 319 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp6_ = g_new0 (GValue, 1);
#line 319 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp6_, G_TYPE_STRING);
#line 319 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_take_string (_tmp6_, _tmp5_);
#line 319 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		gda_sql_builder_add_field_value_as_gvalue (_tmp2_, "uri", _tmp6_);
#line 319 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (_tmp6_);
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp8_ = builder;
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp9_ = gda_sql_builder_get_statement (_tmp8_, &_inner_error_);
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp7_ = _tmp9_;
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (last_insert_row);
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (builder);
#line 476 "LocalMedia.c"
			goto __catch61_g_error;
		}
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp10_ = connection;
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		gda_connection_statement_execute_non_select (_tmp10_, _tmp7_, NULL, &_tmp11_, &_inner_error_);
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (last_insert_row);
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		last_insert_row = _tmp11_;
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (_tmp7_);
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (last_insert_row);
#line 321 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (builder);
#line 495 "LocalMedia.c"
			goto __catch61_g_error;
		}
#line 322 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp12_ = last_insert_row;
#line 322 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp13_ = gda_set_get_holder_value (_tmp12_, NOISE_DATABASE_MEDIA_ROWID);
#line 322 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp14_ = g_value_get_int64 (_tmp13_);
#line 322 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_rowid = _tmp14_;
#line 323 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp15_ = _rowid;
#line 323 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		self = (NoiseLocalMedia*) g_object_new (object_type, "rowid", _tmp15_, NULL);
#line 324 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp16_ = connection;
#line 324 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp17_ = _g_object_ref0 (_tmp16_);
#line 324 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (self->priv->connection);
#line 324 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		self->priv->connection = _tmp17_;
#line 325 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = NULL;
#line 326 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp18_ = g_strdup ("file_size");
#line 326 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp18_);
#line 327 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp19_ = g_strdup ("title");
#line 327 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp19_);
#line 328 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp20_ = g_strdup ("artist");
#line 328 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp20_);
#line 329 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp21_ = g_strdup ("composer");
#line 329 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp21_);
#line 330 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp22_ = g_strdup ("album_artist");
#line 330 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp22_);
#line 331 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp23_ = g_strdup ("album");
#line 331 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp23_);
#line 332 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp24_ = g_strdup ("grouping");
#line 332 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp24_);
#line 333 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp25_ = g_strdup ("genre");
#line 333 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp25_);
#line 334 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp26_ = g_strdup ("comment");
#line 334 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp26_);
#line 335 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp27_ = g_strdup ("lyrics");
#line 335 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp27_);
#line 336 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp28_ = g_strdup ("has_embedded");
#line 336 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp28_);
#line 337 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp29_ = g_strdup ("year");
#line 337 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp29_);
#line 338 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp30_ = g_strdup ("track");
#line 338 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp30_);
#line 339 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp31_ = g_strdup ("track_count");
#line 339 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp31_);
#line 340 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp32_ = g_strdup ("album_number");
#line 340 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp32_);
#line 341 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp33_ = g_strdup ("album_count");
#line 341 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp33_);
#line 342 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp34_ = g_strdup ("bitrate");
#line 342 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp34_);
#line 343 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp35_ = g_strdup ("length");
#line 343 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp35_);
#line 344 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp36_ = g_strdup ("samplerate");
#line 344 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp36_);
#line 345 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp37_ = g_strdup ("rating");
#line 345 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp37_);
#line 346 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp38_ = g_strdup ("playcount");
#line 346 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp38_);
#line 347 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp39_ = g_strdup ("skipcount");
#line 347 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp39_);
#line 348 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp40_ = g_strdup ("dateadded");
#line 348 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp40_);
#line 349 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp41_ = g_strdup ("lastplayed");
#line 349 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp41_);
#line 350 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp42_ = g_strdup ("lastmodified");
#line 350 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp42_);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = NULL;
#line 352 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp43_ = m;
#line 352 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp44_ = noise_media_get_file_size (_tmp43_);
#line 352 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp45_ = _tmp44_;
#line 352 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp46_ = g_new0 (GValue, 1);
#line 352 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp46_, G_TYPE_UINT64);
#line 352 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint64 (_tmp46_, _tmp45_);
#line 352 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp46_);
#line 353 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp47_ = m;
#line 353 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp48_ = noise_media_get_title (_tmp47_);
#line 353 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp49_ = _tmp48_;
#line 353 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp50_ = g_new0 (GValue, 1);
#line 353 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp50_, G_TYPE_STRING);
#line 353 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp50_, _tmp49_);
#line 353 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp50_);
#line 354 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp51_ = m;
#line 354 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp52_ = noise_media_get_artist (_tmp51_);
#line 354 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp53_ = _tmp52_;
#line 354 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp54_ = g_new0 (GValue, 1);
#line 354 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp54_, G_TYPE_STRING);
#line 354 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp54_, _tmp53_);
#line 354 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp54_);
#line 355 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp55_ = m;
#line 355 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp56_ = noise_media_get_composer (_tmp55_);
#line 355 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp57_ = _tmp56_;
#line 355 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp58_ = g_new0 (GValue, 1);
#line 355 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp58_, G_TYPE_STRING);
#line 355 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp58_, _tmp57_);
#line 355 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp58_);
#line 356 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp59_ = m;
#line 356 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp60_ = noise_media_get_album_artist (_tmp59_);
#line 356 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp61_ = _tmp60_;
#line 356 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp62_ = g_new0 (GValue, 1);
#line 356 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp62_, G_TYPE_STRING);
#line 356 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp62_, _tmp61_);
#line 356 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp62_);
#line 357 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp63_ = m;
#line 357 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp64_ = noise_media_get_album (_tmp63_);
#line 357 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp65_ = _tmp64_;
#line 357 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp66_ = g_new0 (GValue, 1);
#line 357 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp66_, G_TYPE_STRING);
#line 357 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp66_, _tmp65_);
#line 357 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp66_);
#line 358 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp67_ = m;
#line 358 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp68_ = noise_media_get_grouping (_tmp67_);
#line 358 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp69_ = _tmp68_;
#line 358 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp70_ = g_new0 (GValue, 1);
#line 358 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp70_, G_TYPE_STRING);
#line 358 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp70_, _tmp69_);
#line 358 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp70_);
#line 359 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp71_ = m;
#line 359 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp72_ = noise_media_get_genre (_tmp71_);
#line 359 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp73_ = _tmp72_;
#line 359 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp74_ = g_new0 (GValue, 1);
#line 359 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp74_, G_TYPE_STRING);
#line 359 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp74_, _tmp73_);
#line 359 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp74_);
#line 360 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp75_ = m;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp76_ = noise_media_get_comment (_tmp75_);
#line 360 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp77_ = _tmp76_;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp78_ = g_new0 (GValue, 1);
#line 360 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp78_, G_TYPE_STRING);
#line 360 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp78_, _tmp77_);
#line 360 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp78_);
#line 361 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp79_ = m;
#line 361 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp80_ = noise_media_get_lyrics (_tmp79_);
#line 361 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp81_ = _tmp80_;
#line 361 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp82_ = g_new0 (GValue, 1);
#line 361 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp82_, G_TYPE_STRING);
#line 361 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp82_, _tmp81_);
#line 361 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp82_);
#line 362 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp83_ = m;
#line 362 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp84_ = noise_media_get_has_embedded (_tmp83_);
#line 362 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp85_ = _tmp84_;
#line 362 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp86_ = g_new0 (GValue, 1);
#line 362 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp86_, G_TYPE_BOOLEAN);
#line 362 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_boolean (_tmp86_, _tmp85_);
#line 362 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp86_);
#line 363 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp87_ = m;
#line 363 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp88_ = noise_media_get_year (_tmp87_);
#line 363 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp89_ = _tmp88_;
#line 363 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp90_ = g_new0 (GValue, 1);
#line 363 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp90_, G_TYPE_UINT);
#line 363 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp90_, _tmp89_);
#line 363 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp90_);
#line 364 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp91_ = m;
#line 364 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp92_ = noise_media_get_track (_tmp91_);
#line 364 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp93_ = _tmp92_;
#line 364 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp94_ = g_new0 (GValue, 1);
#line 364 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp94_, G_TYPE_UINT);
#line 364 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp94_, _tmp93_);
#line 364 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp94_);
#line 365 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp95_ = m;
#line 365 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp96_ = noise_media_get_track_count (_tmp95_);
#line 365 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp97_ = _tmp96_;
#line 365 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp98_ = g_new0 (GValue, 1);
#line 365 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp98_, G_TYPE_UINT);
#line 365 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp98_, _tmp97_);
#line 365 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp98_);
#line 366 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp99_ = m;
#line 366 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp100_ = noise_media_get_album_number (_tmp99_);
#line 366 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp101_ = _tmp100_;
#line 366 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp102_ = g_new0 (GValue, 1);
#line 366 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp102_, G_TYPE_UINT);
#line 366 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp102_, _tmp101_);
#line 366 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp102_);
#line 367 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp103_ = m;
#line 367 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp104_ = noise_media_get_album_count (_tmp103_);
#line 367 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp105_ = _tmp104_;
#line 367 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp106_ = g_new0 (GValue, 1);
#line 367 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp106_, G_TYPE_UINT);
#line 367 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp106_, _tmp105_);
#line 367 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp106_);
#line 368 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp107_ = m;
#line 368 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp108_ = noise_media_get_bitrate (_tmp107_);
#line 368 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp109_ = _tmp108_;
#line 368 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp110_ = g_new0 (GValue, 1);
#line 368 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp110_, G_TYPE_UINT);
#line 368 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp110_, _tmp109_);
#line 368 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp110_);
#line 369 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp111_ = m;
#line 369 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp112_ = noise_media_get_length (_tmp111_);
#line 369 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp113_ = _tmp112_;
#line 369 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp114_ = g_new0 (GValue, 1);
#line 369 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp114_, G_TYPE_UINT);
#line 369 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp114_, _tmp113_);
#line 369 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp114_);
#line 370 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp115_ = m;
#line 370 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp116_ = noise_media_get_samplerate (_tmp115_);
#line 370 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp117_ = _tmp116_;
#line 370 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp118_ = g_new0 (GValue, 1);
#line 370 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp118_, G_TYPE_UINT);
#line 370 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp118_, _tmp117_);
#line 370 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp118_);
#line 371 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp119_ = m;
#line 371 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp120_ = noise_media_get_rating (_tmp119_);
#line 371 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp121_ = _tmp120_;
#line 371 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp122_ = g_new0 (GValue, 1);
#line 371 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp122_, G_TYPE_UINT);
#line 371 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp122_, _tmp121_);
#line 371 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp122_);
#line 372 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp123_ = m;
#line 372 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp124_ = noise_media_get_play_count (_tmp123_);
#line 372 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp125_ = _tmp124_;
#line 372 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp126_ = g_new0 (GValue, 1);
#line 372 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp126_, G_TYPE_UINT);
#line 372 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp126_, _tmp125_);
#line 372 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp126_);
#line 373 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp127_ = m;
#line 373 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp128_ = noise_media_get_skip_count (_tmp127_);
#line 373 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp129_ = _tmp128_;
#line 373 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp130_ = g_new0 (GValue, 1);
#line 373 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp130_, G_TYPE_UINT);
#line 373 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp130_, _tmp129_);
#line 373 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp130_);
#line 374 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp131_ = m;
#line 374 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp132_ = noise_media_get_date_added (_tmp131_);
#line 374 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp133_ = _tmp132_;
#line 374 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp134_ = g_new0 (GValue, 1);
#line 374 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp134_, G_TYPE_UINT);
#line 374 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp134_, _tmp133_);
#line 374 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp134_);
#line 375 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp135_ = m;
#line 375 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp136_ = noise_media_get_last_played (_tmp135_);
#line 375 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp137_ = _tmp136_;
#line 375 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp138_ = g_new0 (GValue, 1);
#line 375 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp138_, G_TYPE_UINT);
#line 375 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp138_, _tmp137_);
#line 375 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp138_);
#line 376 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp139_ = m;
#line 376 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp140_ = noise_media_get_last_modified (_tmp139_);
#line 376 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp141_ = _tmp140_;
#line 376 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp142_ = g_new0 (GValue, 1);
#line 376 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp142_, G_TYPE_UINT);
#line 376 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp142_, _tmp141_);
#line 376 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp142_);
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp143_ = connection;
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp144_ = last_insert_row;
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp145_ = gda_set_get_holder_value (_tmp144_, NOISE_DATABASE_MEDIA_ROWID);
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp146_ = col_names;
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp147_ = values;
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp148_ = *_tmp145_;
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		gda_connection_update_row_in_table_v (_tmp143_, NOISE_DATABASE_MEDIA_TABLE_NAME, "rowid", &_tmp148_, _tmp146_, _tmp147_, &_inner_error_);
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
			__g_slist_free___vala_GValue_free0_0 (values);
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
			__g_slist_free__g_free0_0 (col_names);
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (_tmp7_);
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (last_insert_row);
#line 377 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (builder);
#line 998 "LocalMedia.c"
			goto __catch61_g_error;
		}
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		__g_slist_free___vala_GValue_free0_0 (values);
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		__g_slist_free__g_free0_0 (col_names);
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (_tmp7_);
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (last_insert_row);
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (builder);
#line 1011 "LocalMedia.c"
	}
	goto __finally61;
	__catch61_g_error:
	{
		GError* e = NULL;
		GError* _tmp149_;
		const gchar* _tmp150_;
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		e = _inner_error_;
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_inner_error_ = NULL;
#line 379 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp149_ = e;
#line 379 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp150_ = _tmp149_->message;
#line 379 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_warning ("LocalMedia.vala:379: Could not save media: %s", _tmp150_);
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_error_free0 (e);
#line 1031 "LocalMedia.c"
	}
	__finally61:
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_clear_error (&_inner_error_);
#line 316 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		return NULL;
#line 1042 "LocalMedia.c"
	}
#line 382 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp151_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 382 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp152_ = _tmp151_;
#line 382 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp153_ = connection;
#line 382 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp154_ = noise_database_query_field (_tmp152_, _tmp153_, NOISE_DATABASE_MEDIA_TABLE_NAME, "uri");
#line 382 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	query = _tmp154_;
#line 383 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp155_ = query;
#line 383 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (_tmp155_ != NULL) {
#line 1058 "LocalMedia.c"
		GValue* _tmp156_;
		gchar* _tmp157_;
		gchar* _tmp158_;
#line 384 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp156_ = query;
#line 384 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp157_ = g_value_dup_string (_tmp156_);
#line 384 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp158_ = _tmp157_;
#line 384 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_uri ((NoiseMedia*) self, _tmp158_);
#line 384 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_free0 (_tmp158_);
#line 1072 "LocalMedia.c"
	}
#line 315 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	__vala_GValue_free0 (query);
#line 315 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return self;
#line 1078 "LocalMedia.c"
}


NoiseLocalMedia* noise_local_media_new_from_media (GdaConnection* connection, NoiseMedia* m) {
#line 315 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return noise_local_media_construct_from_media (NOISE_TYPE_LOCAL_MEDIA, connection, m);
#line 1085 "LocalMedia.c"
}


static guint64* _uint64_dup (guint64* self) {
	guint64* dup;
#line 397 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	dup = g_new0 (guint64, 1);
#line 397 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	memcpy (dup, self, sizeof (guint64));
#line 397 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return dup;
#line 1097 "LocalMedia.c"
}


static gpointer __uint64_dup0 (gpointer self) {
#line 397 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return self ? _uint64_dup (self) : NULL;
#line 1104 "LocalMedia.c"
}


static guint64 noise_local_media_common_uint64_getter (NoiseLocalMedia* self, const gchar* field, guint64** temp) {
	guint64 result = 0ULL;
	guint64* _tmp0_;
	GValue* query = NULL;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	const gchar* _tmp5_;
	GValue* _tmp6_;
	GValue* _tmp7_;
#line 391 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 391 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (field != NULL, 0ULL);
#line 392 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = *temp;
#line 392 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (_tmp0_ != NULL) {
#line 1126 "LocalMedia.c"
		guint64* _tmp1_;
#line 393 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp1_ = *temp;
#line 393 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		result = *_tmp1_;
#line 393 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		return result;
#line 1134 "LocalMedia.c"
	}
#line 395 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 395 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp3_ = _tmp2_;
#line 395 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp4_ = self->priv->connection;
#line 395 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp5_ = field;
#line 395 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp6_ = noise_database_query_field (_tmp3_, _tmp4_, NOISE_DATABASE_MEDIA_TABLE_NAME, _tmp5_);
#line 395 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	query = _tmp6_;
#line 396 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp7_ = query;
#line 396 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (_tmp7_ != NULL) {
#line 1152 "LocalMedia.c"
		GValue* _tmp8_;
		gint _tmp9_;
		guint64 _tmp10_;
		guint64* _tmp11_;
		guint64* _tmp12_;
#line 397 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp8_ = query;
#line 397 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp9_ = g_value_get_int (_tmp8_);
#line 397 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp10_ = (guint64) _tmp9_;
#line 397 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp11_ = __uint64_dup0 (&_tmp10_);
#line 397 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_free0 (*temp);
#line 397 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		*temp = _tmp11_;
#line 398 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp12_ = *temp;
#line 398 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		result = *_tmp12_;
#line 398 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 398 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		return result;
#line 1178 "LocalMedia.c"
	} else {
#line 400 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		result = (guint64) 0;
#line 400 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 400 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		return result;
#line 1186 "LocalMedia.c"
	}
#line 391 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	__vala_GValue_free0 (query);
#line 1190 "LocalMedia.c"
}


static void noise_local_media_common_uint64_setter (NoiseLocalMedia* self, const gchar* field, guint64 value, guint64** temp) {
	guint64 _tmp0_;
	guint64* _tmp1_;
	GValue val = {0};
	GValue _tmp2_ = {0};
	guint64 _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	GdaConnection* _tmp6_;
	const gchar* _tmp7_;
	GValue _tmp8_;
#line 403 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (self != NULL);
#line 403 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (field != NULL);
#line 404 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 404 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = __uint64_dup0 (&_tmp0_);
#line 404 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (*temp);
#line 404 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	*temp = _tmp1_;
#line 405 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_value_init (&_tmp2_, G_TYPE_UINT64);
#line 405 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	val = _tmp2_;
#line 406 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp3_ = value;
#line 406 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_value_set_uint64 (&val, _tmp3_);
#line 407 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp4_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 407 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp5_ = _tmp4_;
#line 407 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp6_ = self->priv->connection;
#line 407 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp7_ = field;
#line 407 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp8_ = val;
#line 407 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_database_set_field (_tmp5_, _tmp6_, NOISE_DATABASE_MEDIA_TABLE_NAME, _tmp7_, &_tmp8_);
#line 403 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 1239 "LocalMedia.c"
}


static guint* _uint_dup (guint* self) {
	guint* dup;
#line 416 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	dup = g_new0 (guint, 1);
#line 416 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	memcpy (dup, self, sizeof (guint));
#line 416 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return dup;
#line 1251 "LocalMedia.c"
}


static gpointer __uint_dup0 (gpointer self) {
#line 416 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return self ? _uint_dup (self) : NULL;
#line 1258 "LocalMedia.c"
}


static guint noise_local_media_common_uint_getter (NoiseLocalMedia* self, const gchar* field, guint** temp) {
	guint result = 0U;
	guint* _tmp0_;
	GValue* query = NULL;
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	const gchar* _tmp5_;
	GValue* _tmp6_;
	GValue* _tmp7_;
#line 410 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 410 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (field != NULL, 0U);
#line 411 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = *temp;
#line 411 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (_tmp0_ != NULL) {
#line 1280 "LocalMedia.c"
		guint* _tmp1_;
#line 412 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp1_ = *temp;
#line 412 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		result = *_tmp1_;
#line 412 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		return result;
#line 1288 "LocalMedia.c"
	}
#line 414 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 414 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp3_ = _tmp2_;
#line 414 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp4_ = self->priv->connection;
#line 414 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp5_ = field;
#line 414 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp6_ = noise_database_query_field (_tmp3_, _tmp4_, NOISE_DATABASE_MEDIA_TABLE_NAME, _tmp5_);
#line 414 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	query = _tmp6_;
#line 415 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp7_ = query;
#line 415 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (_tmp7_ != NULL) {
#line 1306 "LocalMedia.c"
		GValue* _tmp8_;
		gint _tmp9_;
		guint _tmp10_;
		guint* _tmp11_;
		guint* _tmp12_;
#line 416 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp8_ = query;
#line 416 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp9_ = g_value_get_int (_tmp8_);
#line 416 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp10_ = (guint) _tmp9_;
#line 416 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp11_ = __uint_dup0 (&_tmp10_);
#line 416 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_free0 (*temp);
#line 416 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		*temp = _tmp11_;
#line 417 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp12_ = *temp;
#line 417 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		result = *_tmp12_;
#line 417 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 417 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		return result;
#line 1332 "LocalMedia.c"
	} else {
#line 419 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		result = (guint) 0;
#line 419 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 419 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		return result;
#line 1340 "LocalMedia.c"
	}
#line 410 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	__vala_GValue_free0 (query);
#line 1344 "LocalMedia.c"
}


static void noise_local_media_common_uint_setter (NoiseLocalMedia* self, const gchar* field, guint value, guint** temp) {
	guint _tmp0_;
	guint* _tmp1_;
	GValue val = {0};
	GValue _tmp2_ = {0};
	guint _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	GdaConnection* _tmp6_;
	const gchar* _tmp7_;
	GValue _tmp8_;
#line 422 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (self != NULL);
#line 422 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (field != NULL);
#line 423 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 423 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = __uint_dup0 (&_tmp0_);
#line 423 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (*temp);
#line 423 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	*temp = _tmp1_;
#line 424 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_value_init (&_tmp2_, G_TYPE_UINT);
#line 424 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	val = _tmp2_;
#line 425 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp3_ = value;
#line 425 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_value_set_uint (&val, _tmp3_);
#line 426 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp4_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 426 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp5_ = _tmp4_;
#line 426 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp6_ = self->priv->connection;
#line 426 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp7_ = field;
#line 426 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp8_ = val;
#line 426 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_database_set_field (_tmp5_, _tmp6_, NOISE_DATABASE_MEDIA_TABLE_NAME, _tmp7_, &_tmp8_);
#line 422 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 1393 "LocalMedia.c"
}


static gchar* noise_local_media_common_string_getter (NoiseLocalMedia* self, const gchar* field, gchar* * temp) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	GValue* query = NULL;
	gint64 _tmp3_;
	gint64 _tmp4_;
	GdaConnection* _tmp5_;
	const gchar* _tmp6_;
	GValue* _tmp7_;
	GValue* _tmp8_;
#line 429 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 429 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (field != NULL, NULL);
#line 430 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = *temp;
#line 430 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (_tmp0_ != NULL) {
#line 1415 "LocalMedia.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 431 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp1_ = *temp;
#line 431 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 431 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		result = _tmp2_;
#line 431 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		return result;
#line 1426 "LocalMedia.c"
	}
#line 433 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp3_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 433 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp4_ = _tmp3_;
#line 433 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp5_ = self->priv->connection;
#line 433 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp6_ = field;
#line 433 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp7_ = noise_database_query_field (_tmp4_, _tmp5_, NOISE_DATABASE_MEDIA_TABLE_NAME, _tmp6_);
#line 433 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	query = _tmp7_;
#line 434 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp8_ = query;
#line 434 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (_tmp8_ != NULL) {
#line 1444 "LocalMedia.c"
		GValue* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 435 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp9_ = query;
#line 435 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp10_ = g_value_dup_string (_tmp9_);
#line 435 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_g_free0 (*temp);
#line 435 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		*temp = _tmp10_;
#line 436 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp11_ = self->priv->_composer;
#line 436 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 436 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		result = _tmp12_;
#line 436 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 436 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		return result;
#line 1467 "LocalMedia.c"
	} else {
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 438 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp13_ = noise_media_UNKNOWN;
#line 438 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 438 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		result = _tmp14_;
#line 438 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 438 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		return result;
#line 1481 "LocalMedia.c"
	}
#line 429 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	__vala_GValue_free0 (query);
#line 1485 "LocalMedia.c"
}


static void noise_local_media_common_string_setter (NoiseLocalMedia* self, const gchar* field, const gchar* value, gchar* * temp) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GValue val = {0};
	GValue _tmp2_ = {0};
	const gchar* _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	GdaConnection* _tmp6_;
	const gchar* _tmp7_;
	GValue _tmp8_;
#line 441 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (self != NULL);
#line 441 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (field != NULL);
#line 441 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (value != NULL);
#line 442 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 442 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 442 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (*temp);
#line 442 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	*temp = _tmp1_;
#line 443 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_value_init (&_tmp2_, G_TYPE_STRING);
#line 443 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	val = _tmp2_;
#line 444 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp3_ = value;
#line 444 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_value_set_string (&val, _tmp3_);
#line 445 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp4_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 445 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp5_ = _tmp4_;
#line 445 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp6_ = self->priv->connection;
#line 445 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp7_ = field;
#line 445 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp8_ = val;
#line 445 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_database_set_field (_tmp5_, _tmp6_, NOISE_DATABASE_MEDIA_TABLE_NAME, _tmp7_, &_tmp8_);
#line 441 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 1536 "LocalMedia.c"
}


static guint64 noise_local_media_real_get_file_size (NoiseMedia* base) {
	guint64 result;
	NoiseLocalMedia* self;
	guint64* _tmp0_;
#line 32 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 33 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint64_getter (self, "file_size", &self->priv->_file_size);
#line 34 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_file_size;
#line 34 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 34 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1554 "LocalMedia.c"
}


static void noise_local_media_real_set_file_size (NoiseMedia* base, guint64 value) {
	NoiseLocalMedia* self;
	guint64 _tmp0_;
#line 36 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint64_setter (self, "file_size", _tmp0_, &self->priv->_file_size);
#line 36 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY]);
#line 1569 "LocalMedia.c"
}


static const gchar* noise_local_media_real_get_title (NoiseMedia* base) {
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 46 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "title", &self->priv->_title);
#line 47 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 48 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_title;
#line 48 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 48 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1593 "LocalMedia.c"
}


static void noise_local_media_real_set_title (NoiseMedia* base, const gchar* value) {
	NoiseLocalMedia* self;
	const gchar* _tmp0_;
#line 50 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 51 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 51 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "title", _tmp0_, &self->priv->_title);
#line 50 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_TITLE_PROPERTY]);
#line 1608 "LocalMedia.c"
}


static guint noise_local_media_real_get_track (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 57 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "track", &self->priv->_track);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_track;
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 59 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1626 "LocalMedia.c"
}


static void noise_local_media_real_set_track (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 61 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "track", _tmp0_, &self->priv->_track);
#line 61 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_PROPERTY]);
#line 1641 "LocalMedia.c"
}


static guint noise_local_media_real_get_track_count (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 69 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "track_count", &self->priv->_track_count);
#line 70 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_track_count;
#line 70 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 70 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1659 "LocalMedia.c"
}


static void noise_local_media_real_set_track_count (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 72 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 73 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 73 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "track_count", _tmp0_, &self->priv->_track_count);
#line 72 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY]);
#line 1674 "LocalMedia.c"
}


static const gchar* noise_local_media_real_get_composer (NoiseMedia* base) {
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 80 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "composer", &self->priv->_composer);
#line 80 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 80 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_composer;
#line 81 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 81 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1698 "LocalMedia.c"
}


static void noise_local_media_real_set_composer (NoiseMedia* base, const gchar* value) {
	NoiseLocalMedia* self;
	const gchar* _tmp0_;
#line 83 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "composer", _tmp0_, &self->priv->_composer);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY]);
#line 1713 "LocalMedia.c"
}


static const gchar* noise_local_media_real_get_artist (NoiseMedia* base) {
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "artist", &self->priv->_artist);
#line 91 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_artist;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1737 "LocalMedia.c"
}


static void noise_local_media_real_set_artist (NoiseMedia* base, const gchar* value) {
	NoiseLocalMedia* self;
	const gchar* _tmp0_;
#line 94 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "artist", _tmp0_, &self->priv->_artist);
#line 94 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ARTIST_PROPERTY]);
#line 1752 "LocalMedia.c"
}


static const gchar* noise_local_media_real_get_album_artist (NoiseMedia* base) {
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 102 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "album_artist", &self->priv->_album_artist);
#line 102 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 102 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 103 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_album_artist;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1776 "LocalMedia.c"
}


static void noise_local_media_real_set_album_artist (NoiseMedia* base, const gchar* value) {
	NoiseLocalMedia* self;
	const gchar* _tmp0_;
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 106 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 106 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "album_artist", _tmp0_, &self->priv->_album_artist);
#line 105 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY]);
#line 1791 "LocalMedia.c"
}


static const gchar* noise_local_media_real_get_album (NoiseMedia* base) {
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "album", &self->priv->_album);
#line 113 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 113 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 114 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_album;
#line 114 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 114 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1815 "LocalMedia.c"
}


static void noise_local_media_real_set_album (NoiseMedia* base, const gchar* value) {
	NoiseLocalMedia* self;
	const gchar* _tmp0_;
#line 116 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "album", _tmp0_, &self->priv->_album);
#line 116 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_PROPERTY]);
#line 1830 "LocalMedia.c"
}


static guint noise_local_media_real_get_album_number (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 123 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "album_number", &self->priv->_album_number);
#line 125 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_album_number;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1848 "LocalMedia.c"
}


static void noise_local_media_real_set_album_number (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 127 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 128 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "album_number", _tmp0_, &self->priv->_album_number);
#line 127 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY]);
#line 1863 "LocalMedia.c"
}


static guint noise_local_media_real_get_album_count (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 134 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 135 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "album_count", &self->priv->_album_count);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_album_count;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 136 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1881 "LocalMedia.c"
}


static void noise_local_media_real_set_album_count (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 138 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 139 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 139 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "album_count", _tmp0_, &self->priv->_album_count);
#line 138 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY]);
#line 1896 "LocalMedia.c"
}


static NoiseAlbum* noise_local_media_real_get_album_info (NoiseMedia* base) {
	NoiseAlbum* result;
	NoiseLocalMedia* self;
	NoiseAlbum* _tmp0_;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_album_info;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp0_;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1912 "LocalMedia.c"
}


static void noise_local_media_real_set_album_info (NoiseMedia* base, NoiseAlbum* value) {
	NoiseLocalMedia* self;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (noise_local_media_real_get_album_info (base) != value) {
#line 1922 "LocalMedia.c"
		NoiseAlbum* _tmp0_;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp0_ = value;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		self->priv->_album_info = _tmp0_;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY]);
#line 1930 "LocalMedia.c"
	}
}


static const gchar* noise_local_media_real_get_grouping (NoiseMedia* base) {
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 146 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "grouping", &self->priv->_grouping);
#line 147 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_grouping;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1955 "LocalMedia.c"
}


static void noise_local_media_real_set_grouping (NoiseMedia* base, const gchar* value) {
	NoiseLocalMedia* self;
	const gchar* _tmp0_;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "grouping", _tmp0_, &self->priv->_grouping);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_GROUPING_PROPERTY]);
#line 1970 "LocalMedia.c"
}


static const gchar* noise_local_media_real_get_genre (NoiseMedia* base) {
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "genre", &self->priv->_genre);
#line 158 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_genre;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 1994 "LocalMedia.c"
}


static void noise_local_media_real_set_genre (NoiseMedia* base, const gchar* value) {
	NoiseLocalMedia* self;
	const gchar* _tmp0_;
#line 161 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 162 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "genre", _tmp0_, &self->priv->_genre);
#line 161 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_GENRE_PROPERTY]);
#line 2009 "LocalMedia.c"
}


static const gchar* noise_local_media_real_get_comment (NoiseMedia* base) {
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 169 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "comment", &self->priv->_comment);
#line 169 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 169 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_comment;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2033 "LocalMedia.c"
}


static void noise_local_media_real_set_comment (NoiseMedia* base, const gchar* value) {
	NoiseLocalMedia* self;
	const gchar* _tmp0_;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 173 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 173 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "comment", _tmp0_, &self->priv->_comment);
#line 172 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMMENT_PROPERTY]);
#line 2048 "LocalMedia.c"
}


static const gchar* noise_local_media_real_get_lyrics (NoiseMedia* base) {
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 179 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "lyrics", &self->priv->_lyrics);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 181 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_lyrics;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2072 "LocalMedia.c"
}


static void noise_local_media_real_set_lyrics (NoiseMedia* base, const gchar* value) {
	NoiseLocalMedia* self;
	const gchar* _tmp0_;
#line 183 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 184 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "lyrics", _tmp0_, &self->priv->_lyrics);
#line 183 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LYRICS_PROPERTY]);
#line 2087 "LocalMedia.c"
}


static guint noise_local_media_real_get_year (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 190 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "year", &self->_year);
#line 192 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_year;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 192 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2105 "LocalMedia.c"
}


static void noise_local_media_real_set_year (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 194 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 195 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 195 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "year", _tmp0_, &self->_year);
#line 194 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_YEAR_PROPERTY]);
#line 2120 "LocalMedia.c"
}


static guint noise_local_media_real_get_bitrate (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 201 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 202 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "bitrate", &self->_bitrate);
#line 203 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_bitrate;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 203 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2138 "LocalMedia.c"
}


static void noise_local_media_real_set_bitrate (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 205 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 206 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 206 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "bitrate", _tmp0_, &self->_bitrate);
#line 205 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_BITRATE_PROPERTY]);
#line 2153 "LocalMedia.c"
}


static guint noise_local_media_real_get_samplerate (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 212 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 213 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "samplerate", &self->_samplerate);
#line 214 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_samplerate;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2171 "LocalMedia.c"
}


static void noise_local_media_real_set_samplerate (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 216 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "samplerate", _tmp0_, &self->_samplerate);
#line 216 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY]);
#line 2186 "LocalMedia.c"
}


static guint noise_local_media_real_get_length (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 223 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 224 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "length", &self->_length);
#line 225 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_length;
#line 225 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 225 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2204 "LocalMedia.c"
}


static void noise_local_media_real_set_length (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 227 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 228 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 228 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "length", _tmp0_, &self->_length);
#line 227 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LENGTH_PROPERTY]);
#line 2219 "LocalMedia.c"
}


static guint noise_local_media_real_get_rating (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 234 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "rating", &((NoiseMedia*) self)->_rating);
#line 235 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = ((NoiseMedia*) self)->_rating;
#line 235 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp0_;
#line 235 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2237 "LocalMedia.c"
}


static void noise_local_media_real_set_rating (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
	guint _tmp1_;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 238 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 238 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp1_ = CLAMP (_tmp0_, (guint) 0, (guint) 5);
#line 238 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "rating", _tmp1_, &((NoiseMedia*) self)->_rating);
#line 237 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_RATING_PROPERTY]);
#line 2255 "LocalMedia.c"
}


static guint noise_local_media_real_get_play_count (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 247 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 248 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "playcount", &self->_play_count);
#line 249 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_play_count;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2273 "LocalMedia.c"
}


static void noise_local_media_real_set_play_count (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 251 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 252 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 252 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "playcount", _tmp0_, &self->_play_count);
#line 251 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY]);
#line 2288 "LocalMedia.c"
}


static guint noise_local_media_real_get_skip_count (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 258 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 259 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "skipcount", &self->_skip_count);
#line 260 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_skip_count;
#line 260 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 260 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2306 "LocalMedia.c"
}


static void noise_local_media_real_set_skip_count (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 262 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 263 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 263 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "skipcount", _tmp0_, &self->_skip_count);
#line 262 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY]);
#line 2321 "LocalMedia.c"
}


static guint noise_local_media_real_get_date_added (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 269 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 270 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "dateadded", &self->_date_added);
#line 271 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_date_added;
#line 271 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 271 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2339 "LocalMedia.c"
}


static void noise_local_media_real_set_date_added (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 273 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 274 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 274 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "dateadded", _tmp0_, &self->_date_added);
#line 273 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY]);
#line 2354 "LocalMedia.c"
}


static guint noise_local_media_real_get_last_played (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 280 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 281 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "lastplayed", &self->_last_played);
#line 282 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_last_played;
#line 282 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 282 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2372 "LocalMedia.c"
}


static void noise_local_media_real_set_last_played (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 284 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 285 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 285 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "lastplayed", _tmp0_, &self->_last_played);
#line 284 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY]);
#line 2387 "LocalMedia.c"
}


static guint noise_local_media_real_get_last_modified (NoiseMedia* base) {
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 291 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "lastmodified", &self->_last_modified);
#line 293 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_last_modified;
#line 293 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 293 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2405 "LocalMedia.c"
}


static void noise_local_media_real_set_last_modified (NoiseMedia* base, guint value) {
	NoiseLocalMedia* self;
	guint _tmp0_;
#line 295 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 296 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = value;
#line 296 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "lastmodified", _tmp0_, &self->_last_modified);
#line 295 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY]);
#line 2420 "LocalMedia.c"
}


static gint noise_local_media_real_get_resume_pos (NoiseMedia* base) {
	gint result;
	NoiseLocalMedia* self;
	gint _tmp0_;
#line 300 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 300 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_resume_pos;
#line 300 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	result = _tmp0_;
#line 300 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	return result;
#line 2436 "LocalMedia.c"
}


static void noise_local_media_real_set_resume_pos (NoiseMedia* base, gint value) {
	NoiseLocalMedia* self;
#line 300 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 300 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	if (noise_local_media_real_get_resume_pos (base) != value) {
#line 2446 "LocalMedia.c"
		gint _tmp0_;
#line 300 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		_tmp0_ = value;
#line 300 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		self->priv->_resume_pos = _tmp0_;
#line 300 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY]);
#line 2454 "LocalMedia.c"
	}
}


static void noise_local_media_class_init (NoiseLocalMediaClass * klass) {
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	noise_local_media_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_type_class_add_private (klass, sizeof (NoiseLocalMediaPrivate));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_file_size = noise_local_media_real_get_file_size;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_file_size = noise_local_media_real_set_file_size;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_title = noise_local_media_real_get_title;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_title = noise_local_media_real_set_title;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_track = noise_local_media_real_get_track;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_track = noise_local_media_real_set_track;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_track_count = noise_local_media_real_get_track_count;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_track_count = noise_local_media_real_set_track_count;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_composer = noise_local_media_real_get_composer;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_composer = noise_local_media_real_set_composer;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_artist = noise_local_media_real_get_artist;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_artist = noise_local_media_real_set_artist;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_artist = noise_local_media_real_get_album_artist;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_artist = noise_local_media_real_set_album_artist;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_album = noise_local_media_real_get_album;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_album = noise_local_media_real_set_album;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_number = noise_local_media_real_get_album_number;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_number = noise_local_media_real_set_album_number;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_count = noise_local_media_real_get_album_count;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_count = noise_local_media_real_set_album_count;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_info = noise_local_media_real_get_album_info;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_info = noise_local_media_real_set_album_info;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_grouping = noise_local_media_real_get_grouping;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_grouping = noise_local_media_real_set_grouping;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_genre = noise_local_media_real_get_genre;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_genre = noise_local_media_real_set_genre;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_comment = noise_local_media_real_get_comment;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_comment = noise_local_media_real_set_comment;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_lyrics = noise_local_media_real_get_lyrics;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_lyrics = noise_local_media_real_set_lyrics;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_year = noise_local_media_real_get_year;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_year = noise_local_media_real_set_year;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_bitrate = noise_local_media_real_get_bitrate;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_bitrate = noise_local_media_real_set_bitrate;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_samplerate = noise_local_media_real_get_samplerate;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_samplerate = noise_local_media_real_set_samplerate;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_length = noise_local_media_real_get_length;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_length = noise_local_media_real_set_length;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_rating = noise_local_media_real_get_rating;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_rating = noise_local_media_real_set_rating;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_play_count = noise_local_media_real_get_play_count;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_play_count = noise_local_media_real_set_play_count;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_skip_count = noise_local_media_real_get_skip_count;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_skip_count = noise_local_media_real_set_skip_count;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_date_added = noise_local_media_real_get_date_added;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_date_added = noise_local_media_real_set_date_added;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_last_played = noise_local_media_real_get_last_played;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_last_played = noise_local_media_real_set_last_played;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_last_modified = noise_local_media_real_get_last_modified;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_last_modified = noise_local_media_real_set_last_modified;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_resume_pos = noise_local_media_real_get_resume_pos;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_resume_pos = noise_local_media_real_set_resume_pos;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_local_media_get_property;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_local_media_set_property;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_local_media_finalize;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY] = g_param_spec_uint64 ("file-size", "file-size", "file-size", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_TITLE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_TRACK_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_PROPERTY] = g_param_spec_uint ("track", "track", "track", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY] = g_param_spec_uint ("track-count", "track-count", "track-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY] = g_param_spec_string ("composer", "composer", "composer", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ARTIST_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY] = g_param_spec_string ("album-artist", "album-artist", "album-artist", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_PROPERTY] = g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY] = g_param_spec_uint ("album-number", "album-number", "album-number", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY] = g_param_spec_uint ("album-count", "album-count", "album-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY] = g_param_spec_object ("album-info", "album-info", "album-info", NOISE_TYPE_ALBUM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_GROUPING_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_GROUPING_PROPERTY] = g_param_spec_string ("grouping", "grouping", "grouping", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_GENRE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_COMMENT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LYRICS_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LYRICS_PROPERTY] = g_param_spec_string ("lyrics", "lyrics", "lyrics", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_YEAR_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_YEAR_PROPERTY] = g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_BITRATE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_BITRATE_PROPERTY] = g_param_spec_uint ("bitrate", "bitrate", "bitrate", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY] = g_param_spec_uint ("samplerate", "samplerate", "samplerate", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LENGTH_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_RATING_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_RATING_PROPERTY] = g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY] = g_param_spec_uint ("play-count", "play-count", "play-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY] = g_param_spec_uint ("skip-count", "skip-count", "skip-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY] = g_param_spec_uint ("date-added", "date-added", "date-added", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY] = g_param_spec_uint ("last-played", "last-played", "last-played", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY] = g_param_spec_uint ("last-modified", "last-modified", "last-modified", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY] = g_param_spec_int ("resume-pos", "resume-pos", "resume-pos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2626 "LocalMedia.c"
}


static void noise_local_media_instance_init (NoiseLocalMedia * self) {
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv = NOISE_LOCAL_MEDIA_GET_PRIVATE (self);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_file_size = NULL;
#line 44 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_title = NULL;
#line 55 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_track = NULL;
#line 66 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_track_count = NULL;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_composer = NULL;
#line 88 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_artist = NULL;
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_album_artist = NULL;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_album = NULL;
#line 121 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_album_number = NULL;
#line 132 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_album_count = NULL;
#line 143 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_album_info = NULL;
#line 144 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_grouping = NULL;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_genre = NULL;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_comment = NULL;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_lyrics = NULL;
#line 188 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->_year = NULL;
#line 199 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->_bitrate = NULL;
#line 210 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->_samplerate = NULL;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->_length = NULL;
#line 245 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->_play_count = NULL;
#line 256 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->_skip_count = NULL;
#line 267 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->_date_added = NULL;
#line 278 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->_last_played = NULL;
#line 289 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->_last_modified = NULL;
#line 300 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self->priv->_resume_pos = 0;
#line 2683 "LocalMedia.c"
}


static void noise_local_media_finalize (GObject * obj) {
	NoiseLocalMedia * self;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia);
#line 30 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_file_size);
#line 44 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_title);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_track);
#line 66 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_track_count);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_composer);
#line 88 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_artist);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_album_artist);
#line 110 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_album);
#line 121 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_album_number);
#line 132 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_album_count);
#line 144 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_grouping);
#line 155 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_genre);
#line 166 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_comment);
#line 177 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_lyrics);
#line 188 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_year);
#line 199 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_bitrate);
#line 210 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_samplerate);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_length);
#line 245 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_play_count);
#line 256 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_skip_count);
#line 267 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_date_added);
#line 278 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_last_played);
#line 289 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_last_modified);
#line 302 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	_g_object_unref0 (self->priv->connection);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	G_OBJECT_CLASS (noise_local_media_parent_class)->finalize (obj);
#line 2741 "LocalMedia.c"
}


GType noise_local_media_get_type (void) {
	static volatile gsize noise_local_media_type_id__volatile = 0;
	if (g_once_init_enter (&noise_local_media_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseLocalMediaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_local_media_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseLocalMedia), 0, (GInstanceInitFunc) noise_local_media_instance_init, NULL };
		GType noise_local_media_type_id;
		noise_local_media_type_id = g_type_register_static (NOISE_TYPE_MEDIA, "NoiseLocalMedia", &g_define_type_info, 0);
		g_once_init_leave (&noise_local_media_type_id__volatile, noise_local_media_type_id);
	}
	return noise_local_media_type_id__volatile;
}


static void _vala_noise_local_media_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseLocalMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	switch (property_id) {
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint64 (value, noise_media_get_file_size ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TITLE_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_title ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TRACK_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_track ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_track_count ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_composer ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ARTIST_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_artist ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_album_artist ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_album ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_album_number ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_album_count ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_object (value, noise_media_get_album_info ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_GROUPING_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_grouping ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_GENRE_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_genre ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_COMMENT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_comment ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LYRICS_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_lyrics ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_YEAR_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_year ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_BITRATE_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_bitrate ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_samplerate ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LENGTH_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_length ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_RATING_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_rating ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_play_count ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_skip_count ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_date_added ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_last_played ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_last_modified ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		g_value_set_int (value, noise_media_get_resume_pos ((NoiseMedia*) self));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 2918 "LocalMedia.c"
		default:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 2924 "LocalMedia.c"
	}
}


static void _vala_noise_local_media_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoiseLocalMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
	switch (property_id) {
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_file_size ((NoiseMedia*) self, g_value_get_uint64 (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TITLE_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_title ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TRACK_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_track ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_track_count ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_composer ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ARTIST_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_artist ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_album_artist ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_album ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_album_number ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_album_count ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_album_info ((NoiseMedia*) self, g_value_get_object (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_GROUPING_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_grouping ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_GENRE_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_genre ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_COMMENT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_comment ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LYRICS_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_lyrics ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_YEAR_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_year ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_BITRATE_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_bitrate ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_samplerate ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LENGTH_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_length ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_RATING_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_rating ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_play_count ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_skip_count ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_date_added ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_last_played ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_last_modified ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		noise_media_set_resume_pos ((NoiseMedia*) self, g_value_get_int (value));
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 3090 "LocalMedia.c"
		default:
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/builddir/build/BUILD/music-0.4.2/src/LocalBackend/LocalMedia.vala"
		break;
#line 3096 "LocalMedia.c"
	}
}



