/* SourceListView.c generated by valac 0.38.10, the Vala compiler
 * generated from SourceListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/* Add an interface so that SourceListItem and SourceListExpandableItem still share a common*/
/* ancestor that is compatible with the SourceList widget.*/

#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <noise-core.h>
#include <gee.h>


#define NOISE_TYPE_SOURCE_LIST_ENTRY (noise_source_list_entry_get_type ())
#define NOISE_SOURCE_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_ENTRY, NoiseSourceListEntry))
#define NOISE_IS_SOURCE_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_ENTRY))
#define NOISE_SOURCE_LIST_ENTRY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_SOURCE_LIST_ENTRY, NoiseSourceListEntryIface))

typedef struct _NoiseSourceListEntry NoiseSourceListEntry;
typedef struct _NoiseSourceListEntryIface NoiseSourceListEntryIface;

#define NOISE_TYPE_SOURCE_LIST_ITEM (noise_source_list_item_get_type ())
#define NOISE_SOURCE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem))
#define NOISE_SOURCE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItemClass))
#define NOISE_IS_SOURCE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_ITEM))
#define NOISE_IS_SOURCE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_ITEM))
#define NOISE_SOURCE_LIST_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItemClass))

typedef struct _NoiseSourceListItem NoiseSourceListItem;
typedef struct _NoiseSourceListItemClass NoiseSourceListItemClass;
typedef struct _NoiseSourceListItemPrivate NoiseSourceListItemPrivate;

#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())
enum  {
	NOISE_SOURCE_LIST_ITEM_0_PROPERTY,
	NOISE_SOURCE_LIST_ITEM_PAGE_NUMBER_PROPERTY,
	NOISE_SOURCE_LIST_ITEM_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block13Data Block13Data;
enum  {
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_NUM_SIGNALS
};
static guint noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_NUM_SIGNALS] = {0};

#define NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM (noise_source_list_expandable_item_get_type ())
#define NOISE_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem))
#define NOISE_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItemClass))
#define NOISE_IS_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM))
#define NOISE_IS_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM))
#define NOISE_SOURCE_LIST_EXPANDABLE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItemClass))

typedef struct _NoiseSourceListExpandableItem NoiseSourceListExpandableItem;
typedef struct _NoiseSourceListExpandableItemClass NoiseSourceListExpandableItemClass;
typedef struct _NoiseSourceListExpandableItemPrivate NoiseSourceListExpandableItemPrivate;
enum  {
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_0_PROPERTY,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_PAGE_NUMBER_PROPERTY,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_expandable_item_properties[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES];
typedef struct _Block14Data Block14Data;
enum  {
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS
};
static guint noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS] = {0};

#define NOISE_TYPE_PLAY_LIST_CATEGORY (noise_play_list_category_get_type ())
#define NOISE_PLAY_LIST_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategory))
#define NOISE_PLAY_LIST_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategoryClass))
#define NOISE_IS_PLAY_LIST_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAY_LIST_CATEGORY))
#define NOISE_IS_PLAY_LIST_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAY_LIST_CATEGORY))
#define NOISE_PLAY_LIST_CATEGORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategoryClass))

typedef struct _NoisePlayListCategory NoisePlayListCategory;
typedef struct _NoisePlayListCategoryClass NoisePlayListCategoryClass;
typedef struct _NoisePlayListCategoryPrivate NoisePlayListCategoryPrivate;
enum  {
	NOISE_PLAY_LIST_CATEGORY_0_PROPERTY,
	NOISE_PLAY_LIST_CATEGORY_NUM_PROPERTIES
};
static GParamSpec* noise_play_list_category_properties[NOISE_PLAY_LIST_CATEGORY_NUM_PROPERTIES];

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;

#define NOISE_TYPE_LOCAL_LIBRARY (noise_local_library_get_type ())
#define NOISE_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibrary))
#define NOISE_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))
#define NOISE_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))

typedef struct _NoiseLocalLibrary NoiseLocalLibrary;
typedef struct _NoiseLocalLibraryClass NoiseLocalLibraryClass;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NOISE_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL,
	NOISE_PLAY_LIST_CATEGORY_NUM_SIGNALS
};
static guint noise_play_list_category_signals[NOISE_PLAY_LIST_CATEGORY_NUM_SIGNALS] = {0};

#define NOISE_TYPE_SOURCE_LIST_ROOT (noise_source_list_root_get_type ())
#define NOISE_SOURCE_LIST_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_ROOT, NoiseSourceListRoot))
#define NOISE_SOURCE_LIST_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_ROOT, NoiseSourceListRootClass))
#define NOISE_IS_SOURCE_LIST_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_ROOT))
#define NOISE_IS_SOURCE_LIST_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_ROOT))
#define NOISE_SOURCE_LIST_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_ROOT, NoiseSourceListRootClass))

typedef struct _NoiseSourceListRoot NoiseSourceListRoot;
typedef struct _NoiseSourceListRootClass NoiseSourceListRootClass;
typedef struct _NoiseSourceListRootPrivate NoiseSourceListRootPrivate;
enum  {
	NOISE_SOURCE_LIST_ROOT_0_PROPERTY,
	NOISE_SOURCE_LIST_ROOT_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_root_properties[NOISE_SOURCE_LIST_ROOT_NUM_PROPERTIES];

#define NOISE_TYPE_SOURCE_LIST_VIEW (noise_source_list_view_get_type ())
#define NOISE_SOURCE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListView))
#define NOISE_SOURCE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListViewClass))
#define NOISE_IS_SOURCE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_VIEW))
#define NOISE_IS_SOURCE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_VIEW))
#define NOISE_SOURCE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListViewClass))

typedef struct _NoiseSourceListView NoiseSourceListView;
typedef struct _NoiseSourceListViewClass NoiseSourceListViewClass;
typedef struct _NoiseSourceListViewPrivate NoiseSourceListViewPrivate;
enum  {
	NOISE_SOURCE_LIST_VIEW_0_PROPERTY,
	NOISE_SOURCE_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_view_properties[NOISE_SOURCE_LIST_VIEW_NUM_PROPERTIES];
typedef struct _Block15Data Block15Data;
enum  {
	NOISE_SOURCE_LIST_VIEW_EDITED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_NUM_SIGNALS
};
static guint noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_NUM_SIGNALS] = {0};

struct _NoiseSourceListEntryIface {
	GTypeInterface parent_iface;
};

typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST
} NoiseViewWrapperHint;

struct _NoiseSourceListItem {
	GraniteWidgetsSourceListItem parent_instance;
	NoiseSourceListItemPrivate * priv;
	NoiseViewWrapperHint hint;
};

struct _NoiseSourceListItemClass {
	GraniteWidgetsSourceListItemClass parent_class;
};

struct _NoiseSourceListItemPrivate {
	gint _page_number;
	GtkMenu* playlistMenu;
	GtkMenuItem* playlistRename;
	GtkMenuItem* playlistEdit;
	GtkMenuItem* playlistRemove;
	GtkMenuItem* playlistSave;
	GtkMenuItem* playlistExport;
};

struct _Block13Data {
	int _ref_count_;
	NoiseSourceListItem* self;
	gint page_number;
};

struct _NoiseSourceListExpandableItem {
	GraniteWidgetsSourceListExpandableItem parent_instance;
	NoiseSourceListExpandableItemPrivate * priv;
	NoiseViewWrapperHint hint;
};

struct _NoiseSourceListExpandableItemClass {
	GraniteWidgetsSourceListExpandableItemClass parent_class;
};

struct _NoiseSourceListExpandableItemPrivate {
	gint _page_number;
	GtkMenu* deviceMenu;
	GtkMenuItem* deviceImportToLibrary;
	GtkMenuItem* deviceEject;
	GtkMenuItem* deviceAddPlaylist;
	GtkMenuItem* deviceAddSmartPlaylist;
	GtkMenuItem* deviceSync;
};

struct _Block14Data {
	int _ref_count_;
	NoiseSourceListExpandableItem* self;
	gint page_number;
};

struct _NoisePlayListCategory {
	GraniteWidgetsSourceListExpandableItem parent_instance;
	NoisePlayListCategoryPrivate * priv;
};

struct _NoisePlayListCategoryClass {
	GraniteWidgetsSourceListExpandableItemClass parent_class;
};

struct _NoisePlayListCategoryPrivate {
	GtkMenu* playlistMenu;
	GtkMenuItem* playlistNew;
	GtkMenuItem* smartPlaylistNew;
	GtkMenuItem* playlistImport;
};

struct _NoiseSourceListRoot {
	GraniteWidgetsSourceListExpandableItem parent_instance;
	NoiseSourceListRootPrivate * priv;
};

struct _NoiseSourceListRootClass {
	GraniteWidgetsSourceListExpandableItemClass parent_class;
};

struct _NoiseSourceListView {
	GraniteWidgetsSourceList parent_instance;
	NoiseSourceListViewPrivate * priv;
};

struct _NoiseSourceListViewClass {
	GraniteWidgetsSourceListClass parent_class;
};

struct _NoiseSourceListViewPrivate {
	GraniteWidgetsSourceListExpandableItem* library_category;
	GraniteWidgetsSourceListExpandableItem* devices_category;
	GraniteWidgetsSourceListExpandableItem* network_category;
	NoisePlayListCategory* playlists_category;
};

struct _Block15Data {
	int _ref_count_;
	NoiseSourceListView* self;
	NoiseSourceListItem* sourcelist_item;
	NoiseSourceListExpandableItem* expandable_item;
};


static gpointer noise_source_list_item_parent_class = NULL;
static NoiseSourceListEntryIface * noise_source_list_item_noise_source_list_entry_parent_iface = NULL;
static GraniteWidgetsSourceListDragDestIface * noise_source_list_item_granite_widgets_source_list_drag_dest_parent_iface = NULL;
static gpointer noise_source_list_expandable_item_parent_class = NULL;
static NoiseSourceListEntryIface * noise_source_list_expandable_item_noise_source_list_entry_parent_iface = NULL;
static gpointer noise_play_list_category_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * noise_play_list_category_granite_widgets_source_list_sortable_parent_iface = NULL;
static gpointer noise_source_list_root_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * noise_source_list_root_granite_widgets_source_list_sortable_parent_iface = NULL;
static gpointer noise_source_list_view_parent_class = NULL;

GType noise_source_list_entry_get_type (void) G_GNUC_CONST;
GType noise_source_list_item_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
#define NOISE_SOURCE_LIST_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItemPrivate))
NoiseSourceListItem* noise_source_list_item_new (gint page_number, const gchar* name, NoiseViewWrapperHint hint, GIcon* icon, GIcon* activatable_icon);
NoiseSourceListItem* noise_source_list_item_construct (GType object_type, gint page_number, const gchar* name, NoiseViewWrapperHint hint, GIcon* icon, GIcon* activatable_icon);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
void noise_source_list_item_set_page_number (NoiseSourceListItem* self, gint value);
static void ___lambda71_ (Block13Data* _data13_);
static void ____lambda71__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda72_ (Block13Data* _data13_);
static void ____lambda72__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda73_ (Block13Data* _data13_);
static void ____lambda73__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda74_ (Block13Data* _data13_);
static void ____lambda74__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda75_ (Block13Data* _data13_);
static void ____lambda75__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda76_ (Block13Data* _data13_);
static void ____lambda76__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda77_ (Block13Data* _data13_);
static void ____lambda77__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda78_ (Block13Data* _data13_);
static void ____lambda78__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda79_ (Block13Data* _data13_);
static void ____lambda79__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static GtkMenu* noise_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static gboolean noise_source_list_item_real_data_drop_possible (GraniteWidgetsSourceListDragDest* base, GdkDragContext* context, GtkSelectionData* data);
static GdkDragAction noise_source_list_item_real_data_received (GraniteWidgetsSourceListDragDest* base, GdkDragContext* context, GtkSelectionData* data);
gint noise_source_list_item_get_page_number (NoiseSourceListItem* self);
static void g_cclosure_user_marshal_VOID__INT_BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void noise_source_list_item_finalize (GObject * obj);
static void _vala_noise_source_list_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_source_list_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType noise_source_list_expandable_item_get_type (void) G_GNUC_CONST;
#define NOISE_SOURCE_LIST_EXPANDABLE_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItemPrivate))
NoiseSourceListExpandableItem* noise_source_list_expandable_item_new (gint page_number, const gchar* name, NoiseViewWrapperHint hint, GIcon* icon, GIcon* activatable_icon, GObject* give_more_information);
NoiseSourceListExpandableItem* noise_source_list_expandable_item_construct (GType object_type, gint page_number, const gchar* name, NoiseViewWrapperHint hint, GIcon* icon, GIcon* activatable_icon, GObject* give_more_information);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
void noise_source_list_expandable_item_set_page_number (NoiseSourceListExpandableItem* self, gint value);
static void ___lambda81_ (Block14Data* _data14_);
static void ____lambda81__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void ___lambda82_ (Block14Data* _data14_);
static void ____lambda82__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void _____lambda83_ (Block14Data* _data14_);
static void ______lambda83__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void _____lambda84_ (Block14Data* _data14_);
static void ______lambda84__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void _____lambda85_ (Block14Data* _data14_);
static void ______lambda85__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static GtkMenu* noise_source_list_expandable_item_real_get_context_menu (GraniteWidgetsSourceListItem* base);
gint noise_source_list_expandable_item_get_page_number (NoiseSourceListExpandableItem* self);
static void noise_source_list_expandable_item_finalize (GObject * obj);
static void _vala_noise_source_list_expandable_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_noise_source_list_expandable_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType noise_play_list_category_get_type (void) G_GNUC_CONST;
#define NOISE_PLAY_LIST_CATEGORY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategoryPrivate))
NoisePlayListCategory* noise_play_list_category_new (const gchar* name);
NoisePlayListCategory* noise_play_list_category_construct (GType object_type, const gchar* name);
static void __lambda6_ (NoisePlayListCategory* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
void noise_library_window_create_new_playlist (NoiseLibraryWindow* self, NoiseLibrary* library);
GType noise_local_library_get_type (void) G_GNUC_CONST;
NoiseLocalLibrary* noise_library_window_get_library_manager (NoiseLibraryWindow* self);
static void ___lambda6__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void __lambda29_ (NoisePlayListCategory* self);
void noise_library_window_show_smart_playlist_dialog (NoiseLibraryWindow* self, NoiseSmartPlaylist* smartplaylist);
static void ___lambda29__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void __lambda30_ (NoisePlayListCategory* self);
static void ___lambda30__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static GtkMenu* noise_play_list_category_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static gboolean noise_play_list_category_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint noise_play_list_category_real_compare (GraniteWidgetsSourceListSortable* base, GraniteWidgetsSourceListItem* a, GraniteWidgetsSourceListItem* b);
static void noise_play_list_category_finalize (GObject * obj);
GType noise_source_list_root_get_type (void) G_GNUC_CONST;
NoiseSourceListRoot* noise_source_list_root_new (void);
NoiseSourceListRoot* noise_source_list_root_construct (GType object_type);
static gboolean noise_source_list_root_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint noise_source_list_root_real_compare (GraniteWidgetsSourceListSortable* base, GraniteWidgetsSourceListItem* a, GraniteWidgetsSourceListItem* b);
GType noise_source_list_view_get_type (void) G_GNUC_CONST;
#define NOISE_SOURCE_LIST_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListViewPrivate))
NoiseSourceListView* noise_source_list_view_new (void);
NoiseSourceListView* noise_source_list_view_construct (GType object_type);
static void __lambda80_ (NoiseSourceListView* self);
static void ___lambda80__noise_play_list_category_playlist_import_clicked (NoisePlayListCategory* _sender, gpointer self);
void noise_source_list_view_change_playlist_category_visibility (NoiseSourceListView* self, gboolean visible);
NoiseSourceListEntry* noise_source_list_view_add_item (NoiseSourceListView* self, gint page_number, const gchar* name, NoiseViewWrapperHint hint, GIcon* icon, GIcon* activatable_icon, NoiseSourceListExpandableItem* into_expandable, GObject* give_more_information);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static void __lambda86_ (NoiseSourceListView* self);
static void ___lambda86__granite_widgets_source_list_item_activated (GraniteWidgetsSourceListItem* _sender, gpointer self);
static void __lambda87_ (Block15Data* _data15_, const gchar* new_name);
static void ___lambda87__granite_widgets_source_list_item_edited (GraniteWidgetsSourceListItem* _sender, const gchar* new_name, gpointer self);
static void __lambda88_ (Block15Data* _data15_, GraniteWidgetsSourceListItem* sl);
static void ___lambda88__granite_widgets_source_list_item_action_activated (GraniteWidgetsSourceListItem* _sender, gpointer self);
static void __lambda89_ (NoiseSourceListView* self, gint pn);
static void ___lambda89__noise_source_list_item_playlist_rename_clicked (NoiseSourceListItem* _sender, gint page_number, gpointer self);
static void __lambda90_ (NoiseSourceListView* self, gint pn);
static void ___lambda90__noise_source_list_item_playlist_edit_clicked (NoiseSourceListItem* _sender, gint page_number, gpointer self);
static void __lambda91_ (NoiseSourceListView* self, gint pn);
static void ___lambda91__noise_source_list_item_playlist_remove_clicked (NoiseSourceListItem* _sender, gint page_number, gpointer self);
static void __lambda92_ (NoiseSourceListView* self, gint pn);
static void ___lambda92__noise_source_list_item_playlist_save_clicked (NoiseSourceListItem* _sender, gint page_number, gpointer self);
static void __lambda93_ (NoiseSourceListView* self, gint pn);
static void ___lambda93__noise_source_list_item_playlist_export_clicked (NoiseSourceListItem* _sender, gint page_number, gpointer self);
static void __lambda94_ (NoiseSourceListView* self, gint pn, gchar** uris, int uris_length1);
static void ___lambda94__noise_source_list_item_playlist_media_added (NoiseSourceListItem* _sender, gint page_number, gchar** media, int media_length1, gpointer self);
static void __lambda95_ (Block15Data* _data15_, gint pn);
gint noise_source_list_view_get_device_from_item (NoiseSourceListView* self, NoiseSourceListExpandableItem* item);
static void ___lambda95__noise_source_list_expandable_item_device_import_clicked (NoiseSourceListExpandableItem* _sender, gint page_number, gpointer self);
static void __lambda96_ (NoiseSourceListView* self, gint pn);
static void ___lambda96__noise_source_list_expandable_item_device_eject_clicked (NoiseSourceListExpandableItem* _sender, gint page_number, gpointer self);
static void __lambda97_ (NoiseSourceListView* self, gint pn);
static void ___lambda97__noise_source_list_expandable_item_device_sync_clicked (NoiseSourceListExpandableItem* _sender, gint page_number, gpointer self);
static void __lambda98_ (NoiseSourceListView* self, gint pn);
static void ___lambda98__noise_source_list_expandable_item_device_new_playlist_clicked (NoiseSourceListExpandableItem* _sender, gint page_number, gpointer self);
static void __lambda99_ (NoiseSourceListView* self, gint pn);
static void ___lambda99__noise_source_list_expandable_item_device_new_smartplaylist_clicked (NoiseSourceListExpandableItem* _sender, gint page_number, gpointer self);
static void noise_source_list_view_real_item_selected (GraniteWidgetsSourceList* base, GraniteWidgetsSourceListItem* item);
void noise_source_list_view_remove_playlist (NoiseSourceListView* self, gint page_number);
void noise_source_list_view_enumerate_children_items (NoiseSourceListView* self, NoiseSourceListExpandableItem* exp_item, GeeTreeSet* * pages);
GeeCollection* noise_source_list_view_remove_device (NoiseSourceListView* self, gint page_number);
void noise_source_list_view_enumerate_children_pages (NoiseSourceListView* self, NoiseSourceListExpandableItem* exp_item, GeeTreeSet* * pages);
void noise_source_list_view_change_playlist_name (NoiseSourceListView* self, gint page_number, const gchar* new_name);
void noise_source_list_view_change_device_name (NoiseSourceListView* self, gint page_number, const gchar* new_name);
static void g_cclosure_user_marshal_VOID__INT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void noise_source_list_view_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void noise_source_list_entry_base_init (NoiseSourceListEntryIface * iface) {
#line 31 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	static gboolean initialized = FALSE;
#line 31 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (!initialized) {
#line 31 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		initialized = TRUE;
#line 482 "SourceListView.c"
	}
}


GType noise_source_list_entry_get_type (void) {
	static volatile gsize noise_source_list_entry_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListEntryIface), (GBaseInitFunc) noise_source_list_entry_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType noise_source_list_entry_type_id;
		noise_source_list_entry_type_id = g_type_register_static (G_TYPE_INTERFACE, "NoiseSourceListEntry", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (noise_source_list_entry_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
		g_once_init_leave (&noise_source_list_entry_type_id__volatile, noise_source_list_entry_type_id);
	}
	return noise_source_list_entry_type_id__volatile;
}


static Block13Data* block13_data_ref (Block13Data* _data13_) {
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return _data13_;
#line 505 "SourceListView.c"
}


static void block13_data_unref (void * _userdata_) {
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 514 "SourceListView.c"
		NoiseSourceListItem* self;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self = _data13_->self;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_slice_free (Block13Data, _data13_);
#line 522 "SourceListView.c"
	}
}


static void ___lambda71_ (Block13Data* _data13_) {
	NoiseSourceListItem* self;
	gint _tmp0_;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data13_->self;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data13_->page_number;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_);
#line 536 "SourceListView.c"
}


static void ____lambda71__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda71_ (self);
#line 543 "SourceListView.c"
}


static void ___lambda72_ (Block13Data* _data13_) {
	NoiseSourceListItem* self;
	gint _tmp0_;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data13_->self;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data13_->page_number;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 556 "SourceListView.c"
}


static void ____lambda72__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda72_ (self);
#line 563 "SourceListView.c"
}


static void ___lambda73_ (Block13Data* _data13_) {
	NoiseSourceListItem* self;
	gint _tmp0_;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data13_->self;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data13_->page_number;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, _tmp0_);
#line 576 "SourceListView.c"
}


static void ____lambda73__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda73_ (self);
#line 583 "SourceListView.c"
}


static void ___lambda74_ (Block13Data* _data13_) {
	NoiseSourceListItem* self;
	gint _tmp0_;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data13_->self;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data13_->page_number;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_);
#line 596 "SourceListView.c"
}


static void ____lambda74__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda74_ (self);
#line 603 "SourceListView.c"
}


static void ___lambda75_ (Block13Data* _data13_) {
	NoiseSourceListItem* self;
	gint _tmp0_;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data13_->self;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data13_->page_number;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL], 0, _tmp0_);
#line 616 "SourceListView.c"
}


static void ____lambda75__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda75_ (self);
#line 623 "SourceListView.c"
}


static void ___lambda76_ (Block13Data* _data13_) {
	NoiseSourceListItem* self;
	gint _tmp0_;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data13_->self;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data13_->page_number;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 636 "SourceListView.c"
}


static void ____lambda76__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda76_ (self);
#line 643 "SourceListView.c"
}


static void ___lambda77_ (Block13Data* _data13_) {
	NoiseSourceListItem* self;
	gint _tmp0_;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data13_->self;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data13_->page_number;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, _tmp0_);
#line 656 "SourceListView.c"
}


static void ____lambda77__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda77_ (self);
#line 663 "SourceListView.c"
}


static void ___lambda78_ (Block13Data* _data13_) {
	NoiseSourceListItem* self;
	gint _tmp0_;
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data13_->self;
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data13_->page_number;
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 676 "SourceListView.c"
}


static void ____lambda78__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda78_ (self);
#line 683 "SourceListView.c"
}


static void ___lambda79_ (Block13Data* _data13_) {
	NoiseSourceListItem* self;
	gint _tmp0_;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data13_->self;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data13_->page_number;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, _tmp0_);
#line 696 "SourceListView.c"
}


static void ____lambda79__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda79_ (self);
#line 703 "SourceListView.c"
}


NoiseSourceListItem* noise_source_list_item_construct (GType object_type, gint page_number, const gchar* name, NoiseViewWrapperHint hint, GIcon* icon, GIcon* activatable_icon) {
	NoiseSourceListItem * self = NULL;
	Block13Data* _data13_;
	gint _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	GIcon* _tmp3_;
	NoiseViewWrapperHint _tmp4_;
	GIcon* _tmp5_;
	NoiseViewWrapperHint _tmp7_;
	NoiseViewWrapperHint _tmp22_;
	NoiseViewWrapperHint _tmp41_;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data13_ = g_slice_new0 (Block13Data);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data13_->_ref_count_ = 1;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = page_number;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data13_->page_number = _tmp0_;
#line 59 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = name;
#line 59 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListItem*) granite_widgets_source_list_item_construct (object_type, _tmp1_);
#line 59 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data13_->self = g_object_ref (self);
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp2_ = _data13_->page_number;
#line 60 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_item_set_page_number (self, _tmp2_);
#line 61 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp3_ = icon;
#line 61 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) self, _tmp3_);
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp4_ = hint;
#line 62 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->hint = _tmp4_;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp5_ = activatable_icon;
#line 63 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp5_ != NULL) {
#line 753 "SourceListView.c"
		GIcon* _tmp6_;
#line 64 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp6_ = activatable_icon;
#line 64 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) self, _tmp6_);
#line 759 "SourceListView.c"
	}
#line 66 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp7_ = hint;
#line 66 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp7_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 765 "SourceListView.c"
		GtkMenu* _tmp8_;
		GtkMenuItem* _tmp9_;
		GtkMenuItem* _tmp10_;
		GtkMenuItem* _tmp11_;
		GtkMenu* _tmp12_;
		GtkMenuItem* _tmp13_;
		GtkMenu* _tmp14_;
		GtkMenuItem* _tmp15_;
		GtkMenu* _tmp16_;
		GtkMenuItem* _tmp17_;
		GtkMenu* _tmp18_;
		GtkMenuItem* _tmp19_;
		GtkMenuItem* _tmp20_;
		GtkMenuItem* _tmp21_;
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp8_ = (GtkMenu*) gtk_menu_new ();
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp8_);
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistMenu);
#line 67 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistMenu = _tmp8_;
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Rename"));
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp9_);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistRename);
#line 68 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistRename = _tmp9_;
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp10_);
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistRemove);
#line 69 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistRemove = _tmp10_;
#line 70 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Export…"));
#line 70 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp11_);
#line 70 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistExport);
#line 70 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistExport = _tmp11_;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp12_ = self->priv->playlistMenu;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp13_ = self->priv->playlistRename;
#line 71 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp12_, (GtkWidget*) _tmp13_);
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp14_ = self->priv->playlistMenu;
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp15_ = self->priv->playlistRemove;
#line 72 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp14_, (GtkWidget*) _tmp15_);
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp16_ = self->priv->playlistMenu;
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp17_ = self->priv->playlistExport;
#line 73 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp16_, (GtkWidget*) _tmp17_);
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp18_ = self->priv->playlistMenu;
#line 74 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp18_);
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp19_ = self->priv->playlistRename;
#line 75 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp19_, "activate", (GCallback) ____lambda71__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp20_ = self->priv->playlistRemove;
#line 76 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp20_, "activate", (GCallback) ____lambda72__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp21_ = self->priv->playlistExport;
#line 77 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp21_, "activate", (GCallback) ____lambda73__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 846 "SourceListView.c"
	}
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp22_ = hint;
#line 79 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp22_ == NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
#line 852 "SourceListView.c"
		GtkMenu* _tmp23_;
		GtkMenuItem* _tmp24_;
		GtkMenuItem* _tmp25_;
		GtkMenuItem* _tmp26_;
		GtkMenuItem* _tmp27_;
		GtkMenu* _tmp28_;
		GtkMenuItem* _tmp29_;
		GtkMenu* _tmp30_;
		GtkMenuItem* _tmp31_;
		GtkMenu* _tmp32_;
		GtkMenuItem* _tmp33_;
		GtkMenu* _tmp34_;
		GtkMenuItem* _tmp35_;
		GtkMenu* _tmp36_;
		GtkMenuItem* _tmp37_;
		GtkMenuItem* _tmp38_;
		GtkMenuItem* _tmp39_;
		GtkMenuItem* _tmp40_;
#line 80 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp23_ = (GtkMenu*) gtk_menu_new ();
#line 80 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp23_);
#line 80 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistMenu);
#line 80 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistMenu = _tmp23_;
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp24_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Rename"));
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp24_);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistRename);
#line 81 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistRename = _tmp24_;
#line 82 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp25_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Edit…"));
#line 82 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp25_);
#line 82 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistEdit);
#line 82 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistEdit = _tmp25_;
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp26_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp26_);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistRemove);
#line 83 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistRemove = _tmp26_;
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp27_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Export…"));
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp27_);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistExport);
#line 84 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistExport = _tmp27_;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp28_ = self->priv->playlistMenu;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp29_ = self->priv->playlistRename;
#line 85 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp28_, (GtkWidget*) _tmp29_);
#line 86 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp30_ = self->priv->playlistMenu;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp31_ = self->priv->playlistEdit;
#line 86 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp30_, (GtkWidget*) _tmp31_);
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp32_ = self->priv->playlistMenu;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp33_ = self->priv->playlistRemove;
#line 87 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp32_, (GtkWidget*) _tmp33_);
#line 88 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp34_ = self->priv->playlistMenu;
#line 88 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp35_ = self->priv->playlistExport;
#line 88 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp34_, (GtkWidget*) _tmp35_);
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp36_ = self->priv->playlistMenu;
#line 89 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp36_);
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp37_ = self->priv->playlistRename;
#line 90 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp37_, "activate", (GCallback) ____lambda74__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp38_ = self->priv->playlistEdit;
#line 91 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp38_, "activate", (GCallback) ____lambda75__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp39_ = self->priv->playlistRemove;
#line 92 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp39_, "activate", (GCallback) ____lambda76__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp40_ = self->priv->playlistExport;
#line 93 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp40_, "activate", (GCallback) ____lambda77__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 955 "SourceListView.c"
	}
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp41_ = hint;
#line 95 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp41_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 961 "SourceListView.c"
		GtkMenu* _tmp42_;
		GtkMenuItem* _tmp43_;
		GtkMenu* _tmp44_;
		GtkMenuItem* _tmp45_;
		GtkMenuItem* _tmp46_;
		GtkMenu* _tmp47_;
		GtkMenuItem* _tmp48_;
		GtkMenu* _tmp49_;
		GtkMenuItem* _tmp50_;
		GtkMenuItem* _tmp51_;
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp42_ = (GtkMenu*) gtk_menu_new ();
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp42_);
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistMenu);
#line 96 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistMenu = _tmp42_;
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp43_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Save as Playlist"));
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp43_);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistSave);
#line 97 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistSave = _tmp43_;
#line 98 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp44_ = self->priv->playlistMenu;
#line 98 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp45_ = self->priv->playlistSave;
#line 98 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp44_, (GtkWidget*) _tmp45_);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp46_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Export…"));
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp46_);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->playlistExport);
#line 99 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->playlistExport = _tmp46_;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp47_ = self->priv->playlistMenu;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp48_ = self->priv->playlistExport;
#line 100 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp47_, (GtkWidget*) _tmp48_);
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp49_ = self->priv->playlistMenu;
#line 101 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp49_);
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp50_ = self->priv->playlistSave;
#line 102 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp50_, "activate", (GCallback) ____lambda78__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp51_ = self->priv->playlistExport;
#line 103 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp51_, "activate", (GCallback) ____lambda79__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 1020 "SourceListView.c"
	}
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	block13_data_unref (_data13_);
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data13_ = NULL;
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return self;
#line 1028 "SourceListView.c"
}


NoiseSourceListItem* noise_source_list_item_new (gint page_number, const gchar* name, NoiseViewWrapperHint hint, GIcon* icon, GIcon* activatable_icon) {
#line 58 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return noise_source_list_item_construct (NOISE_TYPE_SOURCE_LIST_ITEM, page_number, name, hint, icon, activatable_icon);
#line 1035 "SourceListView.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return self ? g_object_ref (self) : NULL;
#line 1042 "SourceListView.c"
}


static GtkMenu* noise_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* base) {
	NoiseSourceListItem * self;
	GtkMenu* result = NULL;
	GtkMenu* _tmp0_;
#line 108 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListItem*) base;
#line 109 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->playlistMenu;
#line 109 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp0_ != NULL) {
#line 1056 "SourceListView.c"
		GtkMenu* _tmp1_;
		GtkWidget* _tmp2_;
		GtkMenu* _tmp4_;
		GtkMenu* _tmp5_;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp1_ = self->priv->playlistMenu;
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp2_ = gtk_menu_get_attach_widget (_tmp1_);
#line 110 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		if (_tmp2_ != NULL) {
#line 1067 "SourceListView.c"
			GtkMenu* _tmp3_;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp3_ = self->priv->playlistMenu;
#line 111 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			gtk_menu_detach (_tmp3_);
#line 1073 "SourceListView.c"
		}
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = self->priv->playlistMenu;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		result = _tmp5_;
#line 112 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		return result;
#line 1083 "SourceListView.c"
	}
#line 114 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = NULL;
#line 114 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 1089 "SourceListView.c"
}


static gboolean noise_source_list_item_real_data_drop_possible (GraniteWidgetsSourceListDragDest* base, GdkDragContext* context, GtkSelectionData* data) {
	NoiseSourceListItem * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	NoiseViewWrapperHint _tmp1_;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListItem*) base;
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 117 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (data != NULL, FALSE);
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = self->hint;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp1_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 1108 "SourceListView.c"
		GtkSelectionData* _tmp2_;
		GdkAtom _tmp3_;
		GdkAtom _tmp4_;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp2_ = data;
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp3_ = gtk_selection_data_get_target (_tmp2_);
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = gdk_atom_intern_static_string ("text/uri-list");
#line 120 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp0_ = _tmp3_ == _tmp4_;
#line 1120 "SourceListView.c"
	} else {
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp0_ = FALSE;
#line 1124 "SourceListView.c"
	}
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 119 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 1130 "SourceListView.c"
}


static GdkDragAction noise_source_list_item_real_data_received (GraniteWidgetsSourceListDragDest* base, GdkDragContext* context, GtkSelectionData* data) {
	NoiseSourceListItem * self;
	GdkDragAction result = 0;
	gint _tmp0_;
	GtkSelectionData* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListItem*) base;
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (context != NULL, 0);
#line 123 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (data != NULL, 0);
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_page_number;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = data;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp3_ = _tmp2_ = gtk_selection_data_get_uris (_tmp1_);
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp4_ = _tmp3_;
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL], 0, _tmp0_, _tmp4_, _vala_array_length (_tmp2_));
#line 124 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = GDK_ACTION_COPY;
#line 125 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 1167 "SourceListView.c"
}


gint noise_source_list_item_get_page_number (NoiseSourceListItem* self) {
	gint result;
	gint _tmp0_;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_page_number;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 1182 "SourceListView.c"
}


void noise_source_list_item_set_page_number (NoiseSourceListItem* self, gint value) {
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (noise_source_list_item_get_page_number (self) != value) {
#line 1191 "SourceListView.c"
		gint _tmp0_;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp0_ = value;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->_page_number = _tmp0_;
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_PAGE_NUMBER_PROPERTY]);
#line 1199 "SourceListView.c"
	}
}


static void g_cclosure_user_marshal_VOID__INT_BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_BOXED_INT) (gpointer data1, gint arg_1, gpointer arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__INT_BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (n_param_values == 4);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		data1 = closure->data;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		data2 = param_values->data[0].v_pointer;
#line 1219 "SourceListView.c"
	} else {
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		data2 = closure->data;
#line 1225 "SourceListView.c"
	}
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	callback = (GMarshalFunc_VOID__INT_BOXED_INT) (marshal_data ? marshal_data : cc->callback);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 1231 "SourceListView.c"
}


static void noise_source_list_item_class_init (NoiseSourceListItemClass * klass) {
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_item_parent_class = g_type_class_peek_parent (klass);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_type_class_add_private (klass, sizeof (NoiseSourceListItemPrivate));
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem *)) noise_source_list_item_real_get_context_menu;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_source_list_item_get_property;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_source_list_item_set_property;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_source_list_item_finalize;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SOURCE_LIST_ITEM_PAGE_NUMBER_PROPERTY, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_PAGE_NUMBER_PROPERTY] = g_param_spec_int ("page-number", "page-number", "page-number", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL] = g_signal_new ("playlist-rename-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL] = g_signal_new ("playlist-edit-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL] = g_signal_new ("playlist-remove-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL] = g_signal_new ("playlist-save-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-export-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("playlist-media-added", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_BOXED_INT, G_TYPE_NONE, 3, G_TYPE_INT, G_TYPE_STRV, G_TYPE_INT);
#line 1262 "SourceListView.c"
}


static void noise_source_list_item_noise_source_list_entry_interface_init (NoiseSourceListEntryIface * iface) {
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_item_noise_source_list_entry_parent_iface = g_type_interface_peek_parent (iface);
#line 1269 "SourceListView.c"
}


static void noise_source_list_item_granite_widgets_source_list_drag_dest_interface_init (GraniteWidgetsSourceListDragDestIface * iface) {
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_item_granite_widgets_source_list_drag_dest_parent_iface = g_type_interface_peek_parent (iface);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	iface->data_drop_possible = (gboolean (*) (GraniteWidgetsSourceListDragDest *, GdkDragContext*, GtkSelectionData*)) noise_source_list_item_real_data_drop_possible;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	iface->data_received = (GdkDragAction (*) (GraniteWidgetsSourceListDragDest *, GdkDragContext*, GtkSelectionData*)) noise_source_list_item_real_data_received;
#line 1280 "SourceListView.c"
}


static void noise_source_list_item_instance_init (NoiseSourceListItem * self) {
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv = NOISE_SOURCE_LIST_ITEM_GET_PRIVATE (self);
#line 47 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv->_page_number = -1;
#line 1289 "SourceListView.c"
}


static void noise_source_list_item_finalize (GObject * obj) {
	NoiseSourceListItem * self;
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
#line 51 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistMenu);
#line 52 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistRename);
#line 53 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistEdit);
#line 54 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistRemove);
#line 55 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistSave);
#line 56 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistExport);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (noise_source_list_item_parent_class)->finalize (obj);
#line 1311 "SourceListView.c"
}


/**
 * SourceList item. It stores the number of the corresponding page in the notebook widget.
 */
GType noise_source_list_item_get_type (void) {
	static volatile gsize noise_source_list_item_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListItem), 0, (GInstanceInitFunc) noise_source_list_item_instance_init, NULL };
		static const GInterfaceInfo noise_source_list_entry_info = { (GInterfaceInitFunc) noise_source_list_item_noise_source_list_entry_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo granite_widgets_source_list_drag_dest_info = { (GInterfaceInitFunc) noise_source_list_item_granite_widgets_source_list_drag_dest_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_source_list_item_type_id;
		noise_source_list_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, "NoiseSourceListItem", &g_define_type_info, 0);
		g_type_add_interface_static (noise_source_list_item_type_id, NOISE_TYPE_SOURCE_LIST_ENTRY, &noise_source_list_entry_info);
		g_type_add_interface_static (noise_source_list_item_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST, &granite_widgets_source_list_drag_dest_info);
		g_once_init_leave (&noise_source_list_item_type_id__volatile, noise_source_list_item_type_id);
	}
	return noise_source_list_item_type_id__volatile;
}


static void _vala_noise_source_list_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_ITEM_PAGE_NUMBER_PROPERTY:
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_value_set_int (value, noise_source_list_item_get_page_number (self));
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		break;
#line 1345 "SourceListView.c"
		default:
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		break;
#line 1351 "SourceListView.c"
	}
}


static void _vala_noise_source_list_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoiseSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_ITEM_PAGE_NUMBER_PROPERTY:
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		noise_source_list_item_set_page_number (self, g_value_get_int (value));
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		break;
#line 1367 "SourceListView.c"
		default:
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		break;
#line 1373 "SourceListView.c"
	}
}


static Block14Data* block14_data_ref (Block14Data* _data14_) {
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return _data14_;
#line 1383 "SourceListView.c"
}


static void block14_data_unref (void * _userdata_) {
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 1392 "SourceListView.c"
		NoiseSourceListExpandableItem* self;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self = _data14_->self;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self);
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_slice_free (Block14Data, _data14_);
#line 1400 "SourceListView.c"
	}
}


static void ___lambda81_ (Block14Data* _data14_) {
	NoiseSourceListExpandableItem* self;
	gint _tmp0_;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data14_->self;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data14_->page_number;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL], 0, _tmp0_);
#line 1414 "SourceListView.c"
}


static void ____lambda81__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda81_ (self);
#line 1421 "SourceListView.c"
}


static void ___lambda82_ (Block14Data* _data14_) {
	NoiseSourceListExpandableItem* self;
	gint _tmp0_;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data14_->self;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data14_->page_number;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL], 0, _tmp0_);
#line 1434 "SourceListView.c"
}


static void ____lambda82__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	___lambda82_ (self);
#line 1441 "SourceListView.c"
}


static void _____lambda83_ (Block14Data* _data14_) {
	NoiseSourceListExpandableItem* self;
	gint _tmp0_;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data14_->self;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data14_->page_number;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL], 0, _tmp0_);
#line 1454 "SourceListView.c"
}


static void ______lambda83__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_____lambda83_ (self);
#line 1461 "SourceListView.c"
}


static void _____lambda84_ (Block14Data* _data14_) {
	NoiseSourceListExpandableItem* self;
	gint _tmp0_;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data14_->self;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data14_->page_number;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL], 0, _tmp0_);
#line 1474 "SourceListView.c"
}


static void ______lambda84__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_____lambda84_ (self);
#line 1481 "SourceListView.c"
}


static void _____lambda85_ (Block14Data* _data14_) {
	NoiseSourceListExpandableItem* self;
	gint _tmp0_;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data14_->self;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data14_->page_number;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL], 0, _tmp0_);
#line 1494 "SourceListView.c"
}


static void ______lambda85__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_____lambda85_ (self);
#line 1501 "SourceListView.c"
}


NoiseSourceListExpandableItem* noise_source_list_expandable_item_construct (GType object_type, gint page_number, const gchar* name, NoiseViewWrapperHint hint, GIcon* icon, GIcon* activatable_icon, GObject* give_more_information) {
	NoiseSourceListExpandableItem * self = NULL;
	Block14Data* _data14_;
	gint _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	GIcon* _tmp3_;
	NoiseViewWrapperHint _tmp4_;
	GIcon* _tmp5_;
	NoiseViewWrapperHint _tmp7_;
	NoiseViewWrapperHint _tmp14_;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data14_ = g_slice_new0 (Block14Data);
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data14_->_ref_count_ = 1;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = page_number;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data14_->page_number = _tmp0_;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = name;
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListExpandableItem*) granite_widgets_source_list_expandable_item_construct (object_type, _tmp1_);
#line 148 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data14_->self = g_object_ref (self);
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp2_ = _data14_->page_number;
#line 149 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_set_page_number (self, _tmp2_);
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp3_ = icon;
#line 150 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) self, _tmp3_);
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp4_ = hint;
#line 151 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->hint = _tmp4_;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp5_ = activatable_icon;
#line 152 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp5_ != NULL) {
#line 1550 "SourceListView.c"
		GIcon* _tmp6_;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp6_ = activatable_icon;
#line 153 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) self, _tmp6_);
#line 1556 "SourceListView.c"
	}
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp7_ = hint;
#line 155 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp7_ == NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO) {
#line 1562 "SourceListView.c"
		GtkMenu* _tmp8_;
		GtkMenuItem* _tmp9_;
		GtkMenuItem* _tmp10_;
		GtkMenu* _tmp11_;
		GtkMenuItem* _tmp12_;
		GtkMenu* _tmp13_;
#line 156 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp8_ = (GtkMenu*) gtk_menu_new ();
#line 156 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp8_);
#line 156 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->deviceMenu);
#line 156 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->deviceMenu = _tmp8_;
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import to Library"));
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp9_);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->deviceImportToLibrary);
#line 157 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->deviceImportToLibrary = _tmp9_;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp10_ = self->priv->deviceImportToLibrary;
#line 158 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp10_, "activate", (GCallback) ____lambda81__gtk_menu_item_activate, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 159 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp11_ = self->priv->deviceMenu;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp12_ = self->priv->deviceImportToLibrary;
#line 159 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp11_, (GtkWidget*) _tmp12_);
#line 160 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp13_ = self->priv->deviceMenu;
#line 160 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp13_);
#line 1599 "SourceListView.c"
	}
#line 163 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp14_ = hint;
#line 163 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp14_ == NOISE_VIEW_WRAPPER_HINT_DEVICE) {
#line 1605 "SourceListView.c"
		GtkMenu* _tmp15_;
		GtkMenuItem* _tmp16_;
		GtkMenuItem* _tmp17_;
		GObject* _tmp18_;
		GtkMenu* _tmp45_;
		GtkMenuItem* _tmp46_;
		GtkMenu* _tmp47_;
#line 164 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp15_ = (GtkMenu*) gtk_menu_new ();
#line 164 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp15_);
#line 164 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->deviceMenu);
#line 164 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->deviceMenu = _tmp15_;
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp16_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Eject"));
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp16_);
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->deviceEject);
#line 165 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->deviceEject = _tmp16_;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp17_ = self->priv->deviceEject;
#line 166 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp17_, "activate", (GCallback) ____lambda82__gtk_menu_item_activate, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp18_ = give_more_information;
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, NOISE_TYPE_DEVICE)) {
#line 1637 "SourceListView.c"
			NoiseDevice* device = NULL;
			GObject* _tmp19_;
			NoiseDevice* _tmp20_;
			NoiseDevice* _tmp21_;
			NoiseLibrary* _tmp22_;
			NoiseLibrary* _tmp23_;
			gboolean _tmp24_;
			gboolean _tmp25_;
			NoiseDevice* _tmp30_;
			NoiseLibrary* _tmp31_;
			NoiseLibrary* _tmp32_;
			gboolean _tmp33_;
			gboolean _tmp34_;
			NoiseDevice* _tmp39_;
			gboolean _tmp40_;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp19_ = give_more_information;
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, NOISE_TYPE_DEVICE, NoiseDevice));
#line 168 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			device = _tmp20_;
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp21_ = device;
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp22_ = noise_device_get_library (_tmp21_);
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp23_ = _tmp22_;
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp24_ = noise_library_support_playlists (_tmp23_);
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp25_ = _tmp24_;
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (_tmp23_);
#line 169 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp25_) {
#line 1673 "SourceListView.c"
				GtkMenuItem* _tmp26_;
				GtkMenuItem* _tmp27_;
				GtkMenu* _tmp28_;
				GtkMenuItem* _tmp29_;
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp26_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist"));
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				g_object_ref_sink (_tmp26_);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_g_object_unref0 (self->priv->deviceAddPlaylist);
#line 170 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				self->priv->deviceAddPlaylist = _tmp26_;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp27_ = self->priv->deviceAddPlaylist;
#line 171 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				g_signal_connect_data (_tmp27_, "activate", (GCallback) ______lambda83__gtk_menu_item_activate, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 172 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp28_ = self->priv->deviceMenu;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp29_ = self->priv->deviceAddPlaylist;
#line 172 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp28_, (GtkWidget*) _tmp29_);
#line 1696 "SourceListView.c"
			}
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp30_ = device;
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp31_ = noise_device_get_library (_tmp30_);
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp32_ = _tmp31_;
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp33_ = noise_library_support_smart_playlists (_tmp32_);
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp34_ = _tmp33_;
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (_tmp32_);
#line 174 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp34_) {
#line 1712 "SourceListView.c"
				GtkMenuItem* _tmp35_;
				GtkMenuItem* _tmp36_;
				GtkMenu* _tmp37_;
				GtkMenuItem* _tmp38_;
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp35_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Smart Playlist"));
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				g_object_ref_sink (_tmp35_);
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_g_object_unref0 (self->priv->deviceAddSmartPlaylist);
#line 175 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				self->priv->deviceAddSmartPlaylist = _tmp35_;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp36_ = self->priv->deviceAddSmartPlaylist;
#line 176 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				g_signal_connect_data (_tmp36_, "activate", (GCallback) ______lambda84__gtk_menu_item_activate, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp37_ = self->priv->deviceMenu;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp38_ = self->priv->deviceAddSmartPlaylist;
#line 177 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp37_, (GtkWidget*) _tmp38_);
#line 1735 "SourceListView.c"
			}
#line 179 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp39_ = device;
#line 179 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp40_ = noise_device_read_only (_tmp39_);
#line 179 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp40_ == FALSE) {
#line 1743 "SourceListView.c"
				GtkMenuItem* _tmp41_;
				GtkMenuItem* _tmp42_;
				GtkMenu* _tmp43_;
				GtkMenuItem* _tmp44_;
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp41_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Sync"));
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				g_object_ref_sink (_tmp41_);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_g_object_unref0 (self->priv->deviceSync);
#line 180 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				self->priv->deviceSync = _tmp41_;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp42_ = self->priv->deviceSync;
#line 181 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				g_signal_connect_data (_tmp42_, "activate", (GCallback) ______lambda85__gtk_menu_item_activate, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp43_ = self->priv->deviceMenu;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp44_ = self->priv->deviceSync;
#line 182 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp43_, (GtkWidget*) _tmp44_);
#line 1766 "SourceListView.c"
			}
#line 167 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 1770 "SourceListView.c"
		}
#line 185 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp45_ = self->priv->deviceMenu;
#line 185 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp46_ = self->priv->deviceEject;
#line 185 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp45_, (GtkWidget*) _tmp46_);
#line 186 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp47_ = self->priv->deviceMenu;
#line 186 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp47_);
#line 1782 "SourceListView.c"
	}
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	block14_data_unref (_data14_);
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data14_ = NULL;
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return self;
#line 1790 "SourceListView.c"
}


NoiseSourceListExpandableItem* noise_source_list_expandable_item_new (gint page_number, const gchar* name, NoiseViewWrapperHint hint, GIcon* icon, GIcon* activatable_icon, GObject* give_more_information) {
#line 147 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return noise_source_list_expandable_item_construct (NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, page_number, name, hint, icon, activatable_icon, give_more_information);
#line 1797 "SourceListView.c"
}


static GtkMenu* noise_source_list_expandable_item_real_get_context_menu (GraniteWidgetsSourceListItem* base) {
	NoiseSourceListExpandableItem * self;
	GtkMenu* result = NULL;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
#line 190 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListExpandableItem*) base;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->deviceMenu;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = _tmp1_;
#line 191 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 1816 "SourceListView.c"
}


gint noise_source_list_expandable_item_get_page_number (NoiseSourceListExpandableItem* self) {
	gint result;
	gint _tmp0_;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_page_number;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 1831 "SourceListView.c"
}


void noise_source_list_expandable_item_set_page_number (NoiseSourceListExpandableItem* self, gint value) {
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (noise_source_list_expandable_item_get_page_number (self) != value) {
#line 1840 "SourceListView.c"
		gint _tmp0_;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp0_ = value;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self->priv->_page_number = _tmp0_;
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_source_list_expandable_item_properties[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_PAGE_NUMBER_PROPERTY]);
#line 1848 "SourceListView.c"
	}
}


static void noise_source_list_expandable_item_class_init (NoiseSourceListExpandableItemClass * klass) {
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_parent_class = g_type_class_peek_parent (klass);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_type_class_add_private (klass, sizeof (NoiseSourceListExpandableItemPrivate));
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem *)) noise_source_list_expandable_item_real_get_context_menu;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_source_list_expandable_item_get_property;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_source_list_expandable_item_set_property;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_source_list_expandable_item_finalize;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SOURCE_LIST_EXPANDABLE_ITEM_PAGE_NUMBER_PROPERTY, noise_source_list_expandable_item_properties[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_PAGE_NUMBER_PROPERTY] = g_param_spec_int ("page-number", "page-number", "page-number", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL] = g_signal_new ("device-import-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL] = g_signal_new ("device-eject-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL] = g_signal_new ("device-sync-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-playlist-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-smartplaylist-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 1878 "SourceListView.c"
}


static void noise_source_list_expandable_item_noise_source_list_entry_interface_init (NoiseSourceListEntryIface * iface) {
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_noise_source_list_entry_parent_iface = g_type_interface_peek_parent (iface);
#line 1885 "SourceListView.c"
}


static void noise_source_list_expandable_item_instance_init (NoiseSourceListExpandableItem * self) {
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv = NOISE_SOURCE_LIST_EXPANDABLE_ITEM_GET_PRIVATE (self);
#line 130 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv->_page_number = -1;
#line 1894 "SourceListView.c"
}


static void noise_source_list_expandable_item_finalize (GObject * obj) {
	NoiseSourceListExpandableItem * self;
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem);
#line 134 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->deviceMenu);
#line 135 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->deviceImportToLibrary);
#line 136 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->deviceEject);
#line 137 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->deviceAddPlaylist);
#line 138 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->deviceAddSmartPlaylist);
#line 139 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->deviceSync);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (noise_source_list_expandable_item_parent_class)->finalize (obj);
#line 1916 "SourceListView.c"
}


GType noise_source_list_expandable_item_get_type (void) {
	static volatile gsize noise_source_list_expandable_item_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_expandable_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListExpandableItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_expandable_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListExpandableItem), 0, (GInstanceInitFunc) noise_source_list_expandable_item_instance_init, NULL };
		static const GInterfaceInfo noise_source_list_entry_info = { (GInterfaceInitFunc) noise_source_list_expandable_item_noise_source_list_entry_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_source_list_expandable_item_type_id;
		noise_source_list_expandable_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "NoiseSourceListExpandableItem", &g_define_type_info, 0);
		g_type_add_interface_static (noise_source_list_expandable_item_type_id, NOISE_TYPE_SOURCE_LIST_ENTRY, &noise_source_list_entry_info);
		g_once_init_leave (&noise_source_list_expandable_item_type_id__volatile, noise_source_list_expandable_item_type_id);
	}
	return noise_source_list_expandable_item_type_id__volatile;
}


static void _vala_noise_source_list_expandable_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NoiseSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_EXPANDABLE_ITEM_PAGE_NUMBER_PROPERTY:
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_value_set_int (value, noise_source_list_expandable_item_get_page_number (self));
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		break;
#line 1945 "SourceListView.c"
		default:
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		break;
#line 1951 "SourceListView.c"
	}
}


static void _vala_noise_source_list_expandable_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NoiseSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_EXPANDABLE_ITEM_PAGE_NUMBER_PROPERTY:
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		noise_source_list_expandable_item_set_page_number (self, g_value_get_int (value));
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		break;
#line 1967 "SourceListView.c"
		default:
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 129 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		break;
#line 1973 "SourceListView.c"
	}
}


static void __lambda6_ (NoisePlayListCategory* self) {
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLocalLibrary* _tmp2_;
	NoiseLocalLibrary* _tmp3_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = noise_app_get_main_window ();
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = _tmp0_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp2_ = noise_library_window_get_library_manager (self);
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp3_ = _tmp2_;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_library_window_create_new_playlist (_tmp1_, (NoiseLibrary*) _tmp3_);
#line 1993 "SourceListView.c"
}


static void ___lambda6__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda6_ ((NoisePlayListCategory*) self);
#line 2000 "SourceListView.c"
}


static void __lambda29_ (NoisePlayListCategory* self) {
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = noise_app_get_main_window ();
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = _tmp0_;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_library_window_show_smart_playlist_dialog (_tmp1_, NULL);
#line 2013 "SourceListView.c"
}


static void ___lambda29__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda29_ ((NoisePlayListCategory*) self);
#line 2020 "SourceListView.c"
}


static void __lambda30_ (NoisePlayListCategory* self) {
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_play_list_category_signals[NOISE_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL], 0);
#line 2027 "SourceListView.c"
}


static void ___lambda30__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda30_ ((NoisePlayListCategory*) self);
#line 2034 "SourceListView.c"
}


NoisePlayListCategory* noise_play_list_category_construct (GType object_type, const gchar* name) {
	NoisePlayListCategory * self = NULL;
	const gchar* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenuItem* _tmp2_;
	GtkMenuItem* _tmp3_;
	GtkMenuItem* _tmp4_;
	GtkMenu* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenu* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenu* _tmp9_;
	GtkMenuItem* _tmp10_;
	GtkMenu* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
#line 205 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 206 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = name;
#line 206 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoisePlayListCategory*) granite_widgets_source_list_expandable_item_construct (object_type, _tmp0_);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = (GtkMenu*) gtk_menu_new ();
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp1_);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistMenu);
#line 209 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv->playlistMenu = _tmp1_;
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist"));
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp2_);
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistNew);
#line 210 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv->playlistNew = _tmp2_;
#line 211 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Smart Playlist"));
#line 211 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp3_);
#line 211 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->smartPlaylistNew);
#line 211 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv->smartPlaylistNew = _tmp3_;
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import Playlists"));
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp4_);
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistImport);
#line 212 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv->playlistImport = _tmp4_;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp5_ = self->priv->playlistMenu;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp6_ = self->priv->playlistNew;
#line 214 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp5_, (GtkWidget*) _tmp6_);
#line 215 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp7_ = self->priv->playlistMenu;
#line 215 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp8_ = self->priv->smartPlaylistNew;
#line 215 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp7_, (GtkWidget*) _tmp8_);
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp9_ = self->priv->playlistMenu;
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp10_ = self->priv->playlistImport;
#line 216 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp9_, (GtkWidget*) _tmp10_);
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp11_ = self->priv->playlistMenu;
#line 217 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp11_);
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp12_ = self->priv->playlistNew;
#line 219 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp12_, "activate", (GCallback) ___lambda6__gtk_menu_item_activate, self, 0);
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp13_ = self->priv->smartPlaylistNew;
#line 220 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp13_, "activate", (GCallback) ___lambda29__gtk_menu_item_activate, self, 0);
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp14_ = self->priv->playlistImport;
#line 221 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp14_, "activate", (GCallback) ___lambda30__gtk_menu_item_activate, self, 0);
#line 205 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return self;
#line 2129 "SourceListView.c"
}


NoisePlayListCategory* noise_play_list_category_new (const gchar* name) {
#line 205 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return noise_play_list_category_construct (NOISE_TYPE_PLAY_LIST_CATEGORY, name);
#line 2136 "SourceListView.c"
}


static GtkMenu* noise_play_list_category_real_get_context_menu (GraniteWidgetsSourceListItem* base) {
	NoisePlayListCategory * self;
	GtkMenu* result = NULL;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
#line 224 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoisePlayListCategory*) base;
#line 225 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->playlistMenu;
#line 225 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 225 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = _tmp1_;
#line 225 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 2155 "SourceListView.c"
}


static gboolean noise_play_list_category_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base) {
	NoisePlayListCategory * self;
	gboolean result = FALSE;
#line 229 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoisePlayListCategory*) base;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = TRUE;
#line 230 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 2168 "SourceListView.c"
}


static gint noise_play_list_category_real_compare (GraniteWidgetsSourceListSortable* base, GraniteWidgetsSourceListItem* a, GraniteWidgetsSourceListItem* b) {
	NoisePlayListCategory * self;
	gint result = 0;
	NoiseSourceListItem* item_a = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	NoiseSourceListItem* _tmp1_;
	NoiseSourceListItem* item_b = NULL;
	GraniteWidgetsSourceListItem* _tmp2_;
	NoiseSourceListItem* _tmp3_;
	gboolean _tmp4_ = FALSE;
	NoiseSourceListItem* _tmp5_;
	NoiseSourceListItem* _tmp7_;
	NoiseViewWrapperHint _tmp8_;
	NoiseSourceListItem* _tmp24_;
	NoiseViewWrapperHint _tmp25_;
	NoiseSourceListItem* _tmp32_;
	NoiseViewWrapperHint _tmp33_;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoisePlayListCategory*) base;
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 233 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 234 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = a;
#line 234 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, NOISE_TYPE_SOURCE_LIST_ITEM) ? ((NoiseSourceListItem*) _tmp0_) : NULL);
#line 234 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	item_a = _tmp1_;
#line 235 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp2_ = b;
#line 235 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, NOISE_TYPE_SOURCE_LIST_ITEM) ? ((NoiseSourceListItem*) _tmp2_) : NULL);
#line 235 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	item_b = _tmp3_;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp5_ = item_a;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp5_ == NULL) {
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = TRUE;
#line 2213 "SourceListView.c"
	} else {
		NoiseSourceListItem* _tmp6_;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp6_ = item_b;
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = _tmp6_ == NULL;
#line 2220 "SourceListView.c"
	}
#line 237 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp4_) {
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		result = 0;
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_b);
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_a);
#line 238 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		return result;
#line 2232 "SourceListView.c"
	}
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp7_ = item_a;
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp8_ = _tmp7_->hint;
#line 240 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp8_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 2240 "SourceListView.c"
		NoiseSourceListItem* _tmp9_;
		NoiseViewWrapperHint _tmp10_;
#line 242 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp9_ = item_b;
#line 242 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp10_ = _tmp9_->hint;
#line 242 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		if (_tmp10_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 2249 "SourceListView.c"
			GCompareFunc _tmp11_;
			NoiseSourceListItem* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			NoiseSourceListItem* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp11_ = g_strcmp0;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp12_ = item_a;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp13_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp12_);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp14_ = _tmp13_;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp15_ = g_utf8_collate_key (_tmp14_, (gssize) -1);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp16_ = _tmp15_;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp17_ = item_b;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp18_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp17_);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp19_ = _tmp18_;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp20_ = g_utf8_collate_key (_tmp19_, (gssize) -1);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp21_ = _tmp20_;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp22_ = _tmp11_ (_tmp16_, _tmp21_);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp23_ = _tmp22_;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_free0 (_tmp21_);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_free0 (_tmp16_);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			result = _tmp23_;
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 243 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			return result;
#line 2301 "SourceListView.c"
		}
#line 246 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		result = -1;
#line 246 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_b);
#line 246 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_a);
#line 246 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		return result;
#line 2311 "SourceListView.c"
	}
#line 249 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp24_ = item_a;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp25_ = _tmp24_->hint;
#line 249 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp25_ == NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
#line 2319 "SourceListView.c"
		NoiseSourceListItem* _tmp26_;
		NoiseViewWrapperHint _tmp27_;
		NoiseSourceListItem* _tmp28_;
		NoiseViewWrapperHint _tmp29_;
		NoiseSourceListItem* _tmp30_;
		NoiseViewWrapperHint _tmp31_;
#line 251 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp26_ = item_b;
#line 251 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp27_ = _tmp26_->hint;
#line 251 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		if (_tmp27_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			result = 1;
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 252 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			return result;
#line 2340 "SourceListView.c"
		}
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp28_ = item_b;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp29_ = _tmp28_->hint;
#line 255 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		if (_tmp29_ == NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
#line 256 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			result = 0;
#line 256 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 256 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 256 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			return result;
#line 2356 "SourceListView.c"
		}
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp30_ = item_b;
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp31_ = _tmp30_->hint;
#line 259 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		if (_tmp31_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 260 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			result = -1;
#line 260 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 260 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 260 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			return result;
#line 2372 "SourceListView.c"
		}
	}
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp32_ = item_a;
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp33_ = _tmp32_->hint;
#line 263 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp33_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 2381 "SourceListView.c"
		NoiseSourceListItem* _tmp34_;
		NoiseViewWrapperHint _tmp35_;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp34_ = item_b;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp35_ = _tmp34_->hint;
#line 265 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		if (_tmp35_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			result = 0;
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 266 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			return result;
#line 2398 "SourceListView.c"
		}
#line 269 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		result = 1;
#line 269 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_b);
#line 269 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_a);
#line 269 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		return result;
#line 2408 "SourceListView.c"
	}
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = 0;
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (item_b);
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (item_a);
#line 272 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 2418 "SourceListView.c"
}


static void noise_play_list_category_class_init (NoisePlayListCategoryClass * klass) {
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_play_list_category_parent_class = g_type_class_peek_parent (klass);
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_type_class_add_private (klass, sizeof (NoisePlayListCategoryPrivate));
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem *)) noise_play_list_category_real_get_context_menu;
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_play_list_category_finalize;
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_play_list_category_signals[NOISE_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-import-clicked", NOISE_TYPE_PLAY_LIST_CATEGORY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2433 "SourceListView.c"
}


static void noise_play_list_category_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface) {
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_play_list_category_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable *)) noise_play_list_category_real_allow_dnd_sorting;
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable *, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) noise_play_list_category_real_compare;
#line 2444 "SourceListView.c"
}


static void noise_play_list_category_instance_init (NoisePlayListCategory * self) {
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv = NOISE_PLAY_LIST_CATEGORY_GET_PRIVATE (self);
#line 2451 "SourceListView.c"
}


static void noise_play_list_category_finalize (GObject * obj) {
	NoisePlayListCategory * self;
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategory);
#line 199 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistMenu);
#line 200 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistNew);
#line 201 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->smartPlaylistNew);
#line 202 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlistImport);
#line 195 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (noise_play_list_category_parent_class)->finalize (obj);
#line 2469 "SourceListView.c"
}


GType noise_play_list_category_get_type (void) {
	static volatile gsize noise_play_list_category_type_id__volatile = 0;
	if (g_once_init_enter (&noise_play_list_category_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlayListCategoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_play_list_category_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePlayListCategory), 0, (GInstanceInitFunc) noise_play_list_category_instance_init, NULL };
		static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) noise_play_list_category_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_play_list_category_type_id;
		noise_play_list_category_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "NoisePlayListCategory", &g_define_type_info, 0);
		g_type_add_interface_static (noise_play_list_category_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
		g_once_init_leave (&noise_play_list_category_type_id__volatile, noise_play_list_category_type_id);
	}
	return noise_play_list_category_type_id__volatile;
}


NoiseSourceListRoot* noise_source_list_root_construct (GType object_type) {
	NoiseSourceListRoot * self = NULL;
#line 280 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListRoot*) granite_widgets_source_list_expandable_item_construct (object_type, "SourceListRoot");
#line 279 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return self;
#line 2493 "SourceListView.c"
}


NoiseSourceListRoot* noise_source_list_root_new (void) {
#line 279 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return noise_source_list_root_construct (NOISE_TYPE_SOURCE_LIST_ROOT);
#line 2500 "SourceListView.c"
}


static gboolean noise_source_list_root_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base) {
	NoiseSourceListRoot * self;
	gboolean result = FALSE;
#line 283 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListRoot*) base;
#line 284 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = TRUE;
#line 284 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 2513 "SourceListView.c"
}


static gint noise_source_list_root_real_compare (GraniteWidgetsSourceListSortable* base, GraniteWidgetsSourceListItem* a, GraniteWidgetsSourceListItem* b) {
	NoiseSourceListRoot * self;
	gint result = 0;
#line 287 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListRoot*) base;
#line 287 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 287 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 288 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = 0;
#line 288 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 2530 "SourceListView.c"
}


static void noise_source_list_root_class_init (NoiseSourceListRootClass * klass) {
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_root_parent_class = g_type_class_peek_parent (klass);
#line 2537 "SourceListView.c"
}


static void noise_source_list_root_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface) {
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_root_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable *)) noise_source_list_root_real_allow_dnd_sorting;
#line 276 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable *, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) noise_source_list_root_real_compare;
#line 2548 "SourceListView.c"
}


static void noise_source_list_root_instance_init (NoiseSourceListRoot * self) {
}


GType noise_source_list_root_get_type (void) {
	static volatile gsize noise_source_list_root_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_root_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListRootClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_root_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListRoot), 0, (GInstanceInitFunc) noise_source_list_root_instance_init, NULL };
		static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) noise_source_list_root_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_source_list_root_type_id;
		noise_source_list_root_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "NoiseSourceListRoot", &g_define_type_info, 0);
		g_type_add_interface_static (noise_source_list_root_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
		g_once_init_leave (&noise_source_list_root_type_id__volatile, noise_source_list_root_type_id);
	}
	return noise_source_list_root_type_id__volatile;
}


static void __lambda80_ (NoiseSourceListView* self) {
#line 326 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL], 0);
#line 2573 "SourceListView.c"
}


static void ___lambda80__noise_play_list_category_playlist_import_clicked (NoisePlayListCategory* _sender, gpointer self) {
#line 326 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda80_ ((NoiseSourceListView*) self);
#line 2580 "SourceListView.c"
}


NoiseSourceListView* noise_source_list_view_construct (GType object_type) {
	NoiseSourceListView * self = NULL;
	NoiseSourceListRoot* _tmp0_;
	NoiseSourceListRoot* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GraniteWidgetsSourceListExpandableItem* _tmp4_;
	NoisePlayListCategory* _tmp5_;
	NoisePlayListCategory* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	GraniteWidgetsSourceListExpandableItem* _tmp8_;
	GraniteWidgetsSourceListExpandableItem* _tmp9_;
	GraniteWidgetsSourceListExpandableItem* _tmp10_;
	GraniteWidgetsSourceListExpandableItem* _tmp11_;
	GraniteWidgetsSourceListExpandableItem* _tmp12_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	GraniteWidgetsSourceListExpandableItem* _tmp14_;
	GraniteWidgetsSourceListExpandableItem* _tmp15_;
	GraniteWidgetsSourceListExpandableItem* _tmp16_;
	GraniteWidgetsSourceListExpandableItem* _tmp17_;
	NoisePlayListCategory* _tmp18_;
	GraniteWidgetsSourceListExpandableItem* _tmp19_;
	GraniteWidgetsSourceListExpandableItem* _tmp20_;
	GtkTargetEntry uri_list_entry = {0};
	GtkTargetEntry _tmp21_ = {0};
	GtkTargetEntry _tmp22_;
	GtkTargetEntry* _tmp23_;
	GtkTargetEntry* _tmp24_;
	gint _tmp24__length1;
#line 319 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = noise_source_list_root_new ();
#line 319 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = _tmp0_;
#line 319 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListView*) granite_widgets_source_list_construct (object_type, (GraniteWidgetsSourceListExpandableItem*) _tmp1_);
#line 319 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (_tmp1_);
#line 322 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp2_ = granite_widgets_source_list_expandable_item_new (_ ("Library"));
#line 322 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->library_category);
#line 322 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv->library_category = _tmp2_;
#line 323 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp3_ = granite_widgets_source_list_expandable_item_new (_ ("Devices"));
#line 323 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->devices_category);
#line 323 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv->devices_category = _tmp3_;
#line 324 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp4_ = granite_widgets_source_list_expandable_item_new (_ ("Network"));
#line 324 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->network_category);
#line 324 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv->network_category = _tmp4_;
#line 325 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp5_ = noise_play_list_category_new (_ ("Playlists"));
#line 325 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlists_category);
#line 325 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv->playlists_category = _tmp5_;
#line 326 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp6_ = self->priv->playlists_category;
#line 326 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp6_, "playlist-import-clicked", (GCallback) ___lambda80__noise_play_list_category_playlist_import_clicked, self, 0);
#line 327 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp7_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 327 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp8_ = _tmp7_;
#line 327 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp9_ = self->priv->library_category;
#line 327 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp8_, (GraniteWidgetsSourceListItem*) _tmp9_);
#line 328 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp10_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 328 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp11_ = _tmp10_;
#line 328 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp12_ = self->priv->devices_category;
#line 328 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp11_, (GraniteWidgetsSourceListItem*) _tmp12_);
#line 329 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp13_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 329 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp14_ = _tmp13_;
#line 329 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp15_ = self->priv->network_category;
#line 329 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp14_, (GraniteWidgetsSourceListItem*) _tmp15_);
#line 330 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp16_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 330 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp17_ = _tmp16_;
#line 330 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp18_ = self->priv->playlists_category;
#line 330 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp17_, (GraniteWidgetsSourceListItem*) _tmp18_);
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp19_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp20_ = _tmp19_;
#line 331 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_expand_all (_tmp20_, FALSE, FALSE);
#line 333 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp21_.target = "text/uri-list";
#line 333 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp21_.flags = (guint) GTK_TARGET_SAME_APP;
#line 333 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp21_.info = (guint) 0;
#line 333 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	uri_list_entry = _tmp21_;
#line 334 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp22_ = uri_list_entry;
#line 334 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp23_ = g_new0 (GtkTargetEntry, 1);
#line 334 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp23_[0] = _tmp22_;
#line 334 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp24_ = _tmp23_;
#line 334 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp24__length1 = 1;
#line 334 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	granite_widgets_source_list_enable_drag_dest ((GraniteWidgetsSourceList*) self, _tmp24_, 1, GDK_ACTION_COPY);
#line 334 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp24_ = (g_free (_tmp24_), NULL);
#line 318 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return self;
#line 2711 "SourceListView.c"
}


NoiseSourceListView* noise_source_list_view_new (void) {
#line 318 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return noise_source_list_view_construct (NOISE_TYPE_SOURCE_LIST_VIEW);
#line 2718 "SourceListView.c"
}


/**
     * Change the visibility of each category
     */
void noise_source_list_view_change_playlist_category_visibility (NoiseSourceListView* self, gboolean visible) {
	NoisePlayListCategory* _tmp0_;
	gboolean _tmp1_;
#line 341 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 342 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->playlists_category;
#line 342 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = visible;
#line 342 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	granite_widgets_source_list_item_set_visible ((GraniteWidgetsSourceListItem*) _tmp0_, _tmp1_);
#line 2736 "SourceListView.c"
}


/**
     * Adds an item to the sidebar for the ViewWrapper object.
     * It chooses the appropiate category based on the object's hint property.
     *
     * TODO: Change ViewWrapper.Hint to core values.
     */
static Block15Data* block15_data_ref (Block15Data* _data15_) {
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return _data15_;
#line 2751 "SourceListView.c"
}


static void block15_data_unref (void * _userdata_) {
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 2760 "SourceListView.c"
		NoiseSourceListView* self;
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		self = _data15_->self;
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_data15_->expandable_item);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_data15_->sourcelist_item);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (self);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_slice_free (Block15Data, _data15_);
#line 2772 "SourceListView.c"
	}
}


static void __lambda86_ (NoiseSourceListView* self) {
#line 370 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL], 0);
#line 2780 "SourceListView.c"
}


static void ___lambda86__granite_widgets_source_list_item_activated (GraniteWidgetsSourceListItem* _sender, gpointer self) {
#line 370 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda86_ ((NoiseSourceListView*) self);
#line 2787 "SourceListView.c"
}


static void __lambda87_ (Block15Data* _data15_, const gchar* new_name) {
	NoiseSourceListView* self;
	NoiseSourceListItem* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_;
#line 371 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data15_->self;
#line 371 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (new_name != NULL);
#line 371 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data15_->sourcelist_item;
#line 371 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = noise_source_list_item_get_page_number (_tmp0_);
#line 371 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp2_ = _tmp1_;
#line 371 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp3_ = new_name;
#line 371 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_EDITED_SIGNAL], 0, _tmp2_, _tmp3_);
#line 2811 "SourceListView.c"
}


static void ___lambda87__granite_widgets_source_list_item_edited (GraniteWidgetsSourceListItem* _sender, const gchar* new_name, gpointer self) {
#line 371 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda87_ (self, new_name);
#line 2818 "SourceListView.c"
}


static void __lambda88_ (Block15Data* _data15_, GraniteWidgetsSourceListItem* sl) {
	NoiseSourceListView* self;
	NoiseSourceListItem* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 372 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data15_->self;
#line 372 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (sl != NULL);
#line 372 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data15_->sourcelist_item;
#line 372 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = noise_source_list_item_get_page_number (_tmp0_);
#line 372 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp2_ = _tmp1_;
#line 372 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL], 0, _tmp2_);
#line 2839 "SourceListView.c"
}


static void ___lambda88__granite_widgets_source_list_item_action_activated (GraniteWidgetsSourceListItem* _sender, gpointer self) {
#line 372 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda88_ (self, _sender);
#line 2846 "SourceListView.c"
}


static void __lambda89_ (NoiseSourceListView* self, gint pn) {
	gint _tmp0_;
#line 373 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = pn;
#line 373 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_);
#line 2856 "SourceListView.c"
}


static void ___lambda89__noise_source_list_item_playlist_rename_clicked (NoiseSourceListItem* _sender, gint page_number, gpointer self) {
#line 373 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda89_ ((NoiseSourceListView*) self, page_number);
#line 2863 "SourceListView.c"
}


static void __lambda90_ (NoiseSourceListView* self, gint pn) {
	gint _tmp0_;
#line 374 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = pn;
#line 374 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL], 0, _tmp0_);
#line 2873 "SourceListView.c"
}


static void ___lambda90__noise_source_list_item_playlist_edit_clicked (NoiseSourceListItem* _sender, gint page_number, gpointer self) {
#line 374 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda90_ ((NoiseSourceListView*) self, page_number);
#line 2880 "SourceListView.c"
}


static void __lambda91_ (NoiseSourceListView* self, gint pn) {
	gint _tmp0_;
#line 375 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = pn;
#line 375 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 2890 "SourceListView.c"
}


static void ___lambda91__noise_source_list_item_playlist_remove_clicked (NoiseSourceListItem* _sender, gint page_number, gpointer self) {
#line 375 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda91_ ((NoiseSourceListView*) self, page_number);
#line 2897 "SourceListView.c"
}


static void __lambda92_ (NoiseSourceListView* self, gint pn) {
	gint _tmp0_;
#line 376 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = pn;
#line 376 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 2907 "SourceListView.c"
}


static void ___lambda92__noise_source_list_item_playlist_save_clicked (NoiseSourceListItem* _sender, gint page_number, gpointer self) {
#line 376 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda92_ ((NoiseSourceListView*) self, page_number);
#line 2914 "SourceListView.c"
}


static void __lambda93_ (NoiseSourceListView* self, gint pn) {
	gint _tmp0_;
#line 377 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = pn;
#line 377 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, _tmp0_);
#line 2924 "SourceListView.c"
}


static void ___lambda93__noise_source_list_item_playlist_export_clicked (NoiseSourceListItem* _sender, gint page_number, gpointer self) {
#line 377 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda93_ ((NoiseSourceListView*) self, page_number);
#line 2931 "SourceListView.c"
}


static void __lambda94_ (NoiseSourceListView* self, gint pn, gchar** uris, int uris_length1) {
	gint _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 378 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = pn;
#line 378 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = uris;
#line 378 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1__length1 = uris_length1;
#line 378 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL], 0, _tmp0_, _tmp1_, _tmp1__length1);
#line 2947 "SourceListView.c"
}


static void ___lambda94__noise_source_list_item_playlist_media_added (NoiseSourceListItem* _sender, gint page_number, gchar** media, int media_length1, gpointer self) {
#line 378 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda94_ ((NoiseSourceListView*) self, page_number, media, media_length1);
#line 2954 "SourceListView.c"
}


static void __lambda95_ (Block15Data* _data15_, gint pn) {
	NoiseSourceListView* self;
	NoiseSourceListExpandableItem* _tmp0_;
	gint _tmp1_;
#line 380 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = _data15_->self;
#line 380 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = _data15_->expandable_item;
#line 380 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = noise_source_list_view_get_device_from_item (self, _tmp0_);
#line 380 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL], 0, _tmp1_);
#line 2970 "SourceListView.c"
}


static void ___lambda95__noise_source_list_expandable_item_device_import_clicked (NoiseSourceListExpandableItem* _sender, gint page_number, gpointer self) {
#line 380 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda95_ (self, page_number);
#line 2977 "SourceListView.c"
}


static void __lambda96_ (NoiseSourceListView* self, gint pn) {
	gint _tmp0_;
#line 381 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = pn;
#line 381 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL], 0, _tmp0_);
#line 2987 "SourceListView.c"
}


static void ___lambda96__noise_source_list_expandable_item_device_eject_clicked (NoiseSourceListExpandableItem* _sender, gint page_number, gpointer self) {
#line 381 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda96_ ((NoiseSourceListView*) self, page_number);
#line 2994 "SourceListView.c"
}


static void __lambda97_ (NoiseSourceListView* self, gint pn) {
	gint _tmp0_;
#line 382 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = pn;
#line 382 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL], 0, _tmp0_);
#line 3004 "SourceListView.c"
}


static void ___lambda97__noise_source_list_expandable_item_device_sync_clicked (NoiseSourceListExpandableItem* _sender, gint page_number, gpointer self) {
#line 382 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda97_ ((NoiseSourceListView*) self, page_number);
#line 3011 "SourceListView.c"
}


static void __lambda98_ (NoiseSourceListView* self, gint pn) {
	gint _tmp0_;
#line 383 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = pn;
#line 383 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL], 0, _tmp0_);
#line 3021 "SourceListView.c"
}


static void ___lambda98__noise_source_list_expandable_item_device_new_playlist_clicked (NoiseSourceListExpandableItem* _sender, gint page_number, gpointer self) {
#line 383 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda98_ ((NoiseSourceListView*) self, page_number);
#line 3028 "SourceListView.c"
}


static void __lambda99_ (NoiseSourceListView* self, gint pn) {
	gint _tmp0_;
#line 384 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = pn;
#line 384 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL], 0, _tmp0_);
#line 3038 "SourceListView.c"
}


static void ___lambda99__noise_source_list_expandable_item_device_new_smartplaylist_clicked (NoiseSourceListExpandableItem* _sender, gint page_number, gpointer self) {
#line 384 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	__lambda99_ ((NoiseSourceListView*) self, page_number);
#line 3045 "SourceListView.c"
}


NoiseSourceListEntry* noise_source_list_view_add_item (NoiseSourceListView* self, gint page_number, const gchar* name, NoiseViewWrapperHint hint, GIcon* icon, GIcon* activatable_icon, NoiseSourceListExpandableItem* into_expandable, GObject* give_more_information) {
	NoiseSourceListEntry* result = NULL;
	Block15Data* _data15_;
	gint _tmp0_;
	const gchar* _tmp1_;
	NoiseViewWrapperHint _tmp2_;
	GIcon* _tmp3_;
	GIcon* _tmp4_;
	NoiseSourceListItem* _tmp5_;
	gint _tmp6_;
	const gchar* _tmp7_;
	NoiseViewWrapperHint _tmp8_;
	GIcon* _tmp9_;
	GIcon* _tmp10_;
	GObject* _tmp11_;
	NoiseSourceListExpandableItem* _tmp12_;
	NoiseViewWrapperHint _tmp13_;
	NoiseSourceListItem* _tmp20_;
	NoiseSourceListItem* _tmp21_;
	NoiseSourceListExpandableItem* _tmp22_;
	NoiseSourceListItem* _tmp23_;
	NoiseSourceListItem* _tmp24_;
	NoiseSourceListItem* _tmp25_;
	NoiseSourceListItem* _tmp26_;
	NoiseSourceListItem* _tmp27_;
	NoiseSourceListItem* _tmp28_;
	NoiseSourceListExpandableItem* _tmp29_;
	NoiseSourceListExpandableItem* _tmp30_;
	NoiseSourceListExpandableItem* _tmp31_;
	NoiseSourceListExpandableItem* _tmp32_;
	NoiseSourceListExpandableItem* _tmp33_;
	NoiseViewWrapperHint _tmp34_;
	NoiseViewWrapperHint _tmp75_;
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data15_ = g_slice_new0 (Block15Data);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data15_->_ref_count_ = 1;
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data15_->self = g_object_ref (self);
#line 359 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = page_number;
#line 359 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp1_ = name;
#line 359 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp2_ = hint;
#line 359 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp3_ = icon;
#line 359 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp4_ = activatable_icon;
#line 359 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp5_ = noise_source_list_item_new (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_);
#line 359 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data15_->sourcelist_item = _tmp5_;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp6_ = page_number;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp7_ = name;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp8_ = hint;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp9_ = icon;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp10_ = activatable_icon;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp11_ = give_more_information;
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp12_ = noise_source_list_expandable_item_new (_tmp6_, _tmp7_, _tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 360 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data15_->expandable_item = _tmp12_;
#line 362 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp13_ = hint;
#line 362 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp13_ == NOISE_VIEW_WRAPPER_HINT_DEVICE) {
#line 3128 "SourceListView.c"
		NoiseSourceListExpandableItem* _tmp14_;
		NoiseSourceListExpandableItem* _tmp15_;
		GIcon* _tmp16_;
		GIcon* _tmp17_;
#line 363 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp14_ = _data15_->expandable_item;
#line 363 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		granite_widgets_source_list_expandable_item_set_collapsible ((GraniteWidgetsSourceListExpandableItem*) _tmp14_, FALSE);
#line 364 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp15_ = _data15_->expandable_item;
#line 364 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp16_ = icon;
#line 364 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) _tmp15_, _tmp16_);
#line 365 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp17_ = activatable_icon;
#line 365 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		if (_tmp17_ != NULL) {
#line 3147 "SourceListView.c"
			NoiseSourceListExpandableItem* _tmp18_;
			GIcon* _tmp19_;
#line 366 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp18_ = _data15_->expandable_item;
#line 366 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp19_ = activatable_icon;
#line 366 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) _tmp18_, _tmp19_);
#line 3156 "SourceListView.c"
		}
	}
#line 370 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp20_ = _data15_->sourcelist_item;
#line 370 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object ((GraniteWidgetsSourceListItem*) _tmp20_, "activated", (GCallback) ___lambda86__granite_widgets_source_list_item_activated, self, 0);
#line 371 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp21_ = _data15_->sourcelist_item;
#line 371 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_data ((GraniteWidgetsSourceListItem*) _tmp21_, "edited", (GCallback) ___lambda87__granite_widgets_source_list_item_edited, block15_data_ref (_data15_), (GClosureNotify) block15_data_unref, 0);
#line 372 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp22_ = _data15_->expandable_item;
#line 372 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_data ((GraniteWidgetsSourceListItem*) _tmp22_, "action-activated", (GCallback) ___lambda88__granite_widgets_source_list_item_action_activated, block15_data_ref (_data15_), (GClosureNotify) block15_data_unref, 0);
#line 373 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp23_ = _data15_->sourcelist_item;
#line 373 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp23_, "playlist-rename-clicked", (GCallback) ___lambda89__noise_source_list_item_playlist_rename_clicked, self, 0);
#line 374 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp24_ = _data15_->sourcelist_item;
#line 374 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp24_, "playlist-edit-clicked", (GCallback) ___lambda90__noise_source_list_item_playlist_edit_clicked, self, 0);
#line 375 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp25_ = _data15_->sourcelist_item;
#line 375 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp25_, "playlist-remove-clicked", (GCallback) ___lambda91__noise_source_list_item_playlist_remove_clicked, self, 0);
#line 376 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp26_ = _data15_->sourcelist_item;
#line 376 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp26_, "playlist-save-clicked", (GCallback) ___lambda92__noise_source_list_item_playlist_save_clicked, self, 0);
#line 377 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp27_ = _data15_->sourcelist_item;
#line 377 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp27_, "playlist-export-clicked", (GCallback) ___lambda93__noise_source_list_item_playlist_export_clicked, self, 0);
#line 378 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp28_ = _data15_->sourcelist_item;
#line 378 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp28_, "playlist-media-added", (GCallback) ___lambda94__noise_source_list_item_playlist_media_added, self, 0);
#line 380 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp29_ = _data15_->expandable_item;
#line 380 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_data (_tmp29_, "device-import-clicked", (GCallback) ___lambda95__noise_source_list_expandable_item_device_import_clicked, block15_data_ref (_data15_), (GClosureNotify) block15_data_unref, 0);
#line 381 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp30_ = _data15_->expandable_item;
#line 381 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp30_, "device-eject-clicked", (GCallback) ___lambda96__noise_source_list_expandable_item_device_eject_clicked, self, 0);
#line 382 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp31_ = _data15_->expandable_item;
#line 382 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp31_, "device-sync-clicked", (GCallback) ___lambda97__noise_source_list_expandable_item_device_sync_clicked, self, 0);
#line 383 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp32_ = _data15_->expandable_item;
#line 383 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp32_, "device-new-playlist-clicked", (GCallback) ___lambda98__noise_source_list_expandable_item_device_new_playlist_clicked, self, 0);
#line 384 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp33_ = _data15_->expandable_item;
#line 384 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp33_, "device-new-smartplaylist-clicked", (GCallback) ___lambda99__noise_source_list_expandable_item_device_new_smartplaylist_clicked, self, 0);
#line 386 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp34_ = hint;
#line 386 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	switch (_tmp34_) {
#line 386 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_MUSIC:
#line 3221 "SourceListView.c"
		{
			NoiseSourceListExpandableItem* _tmp35_;
#line 388 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp35_ = into_expandable;
#line 388 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp35_ == NULL) {
#line 3228 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp36_;
				NoiseSourceListItem* _tmp37_;
#line 389 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp36_ = self->priv->library_category;
#line 389 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp37_ = _data15_->sourcelist_item;
#line 389 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp36_, (GraniteWidgetsSourceListItem*) _tmp37_);
#line 3237 "SourceListView.c"
			} else {
				NoiseSourceListExpandableItem* _tmp38_;
				NoiseSourceListItem* _tmp39_;
#line 391 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp38_ = into_expandable;
#line 391 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp39_ = _data15_->sourcelist_item;
#line 391 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp38_, (GraniteWidgetsSourceListItem*) _tmp39_);
#line 3247 "SourceListView.c"
			}
#line 393 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			break;
#line 3251 "SourceListView.c"
		}
#line 386 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_PLAYLIST:
#line 3255 "SourceListView.c"
		{
			NoiseSourceListExpandableItem* _tmp40_;
#line 395 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp40_ = into_expandable;
#line 395 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp40_ == NULL) {
#line 3262 "SourceListView.c"
				NoiseSourceListItem* _tmp41_;
				NoisePlayListCategory* _tmp42_;
				NoiseSourceListItem* _tmp43_;
#line 396 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp41_ = _data15_->sourcelist_item;
#line 396 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp41_, TRUE);
#line 397 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp42_ = self->priv->playlists_category;
#line 397 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp43_ = _data15_->sourcelist_item;
#line 397 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp42_, (GraniteWidgetsSourceListItem*) _tmp43_);
#line 3276 "SourceListView.c"
			} else {
				NoiseSourceListItem* _tmp44_;
				NoiseSourceListExpandableItem* _tmp45_;
				NoiseSourceListItem* _tmp46_;
#line 399 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp44_ = _data15_->sourcelist_item;
#line 399 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp44_, TRUE);
#line 400 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp45_ = into_expandable;
#line 400 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp46_ = _data15_->sourcelist_item;
#line 400 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp45_, (GraniteWidgetsSourceListItem*) _tmp46_);
#line 3291 "SourceListView.c"
			}
#line 402 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			break;
#line 3295 "SourceListView.c"
		}
#line 386 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
#line 3299 "SourceListView.c"
		{
			NoiseSourceListExpandableItem* _tmp47_;
#line 404 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp47_ = into_expandable;
#line 404 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp47_ == NULL) {
#line 3306 "SourceListView.c"
				NoiseSourceListItem* _tmp48_;
				NoisePlayListCategory* _tmp49_;
				NoiseSourceListItem* _tmp50_;
#line 405 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp48_ = _data15_->sourcelist_item;
#line 405 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp48_, FALSE);
#line 406 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp49_ = self->priv->playlists_category;
#line 406 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp50_ = _data15_->sourcelist_item;
#line 406 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp49_, (GraniteWidgetsSourceListItem*) _tmp50_);
#line 3320 "SourceListView.c"
			} else {
				NoiseSourceListItem* _tmp51_;
				NoiseSourceListExpandableItem* _tmp52_;
				NoiseSourceListItem* _tmp53_;
#line 408 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp51_ = _data15_->sourcelist_item;
#line 408 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp51_, FALSE);
#line 409 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp52_ = into_expandable;
#line 409 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp53_ = _data15_->sourcelist_item;
#line 409 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp52_, (GraniteWidgetsSourceListItem*) _tmp53_);
#line 3335 "SourceListView.c"
			}
#line 411 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			break;
#line 3339 "SourceListView.c"
		}
#line 386 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
#line 3343 "SourceListView.c"
		{
			NoiseSourceListExpandableItem* _tmp54_;
#line 413 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp54_ = into_expandable;
#line 413 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp54_ == NULL) {
#line 3350 "SourceListView.c"
				NoiseSourceListItem* _tmp55_;
				NoisePlayListCategory* _tmp56_;
				NoiseSourceListItem* _tmp57_;
#line 414 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp55_ = _data15_->sourcelist_item;
#line 414 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp55_, TRUE);
#line 415 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp56_ = self->priv->playlists_category;
#line 415 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp57_ = _data15_->sourcelist_item;
#line 415 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp56_, (GraniteWidgetsSourceListItem*) _tmp57_);
#line 3364 "SourceListView.c"
			} else {
				NoiseSourceListExpandableItem* _tmp58_;
				NoiseSourceListItem* _tmp59_;
#line 417 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp58_ = into_expandable;
#line 417 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp59_ = _data15_->sourcelist_item;
#line 417 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp58_, (GraniteWidgetsSourceListItem*) _tmp59_);
#line 3374 "SourceListView.c"
			}
#line 419 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			break;
#line 3378 "SourceListView.c"
		}
#line 386 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_DEVICE:
#line 3382 "SourceListView.c"
		{
			NoiseSourceListExpandableItem* _tmp60_;
#line 421 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp60_ = into_expandable;
#line 421 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp60_ == NULL) {
#line 3389 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp61_;
				NoiseSourceListExpandableItem* _tmp62_;
#line 422 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp61_ = self->priv->devices_category;
#line 422 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp62_ = _data15_->expandable_item;
#line 422 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp61_, (GraniteWidgetsSourceListItem*) _tmp62_);
#line 3398 "SourceListView.c"
			} else {
				NoiseSourceListExpandableItem* _tmp63_;
				NoiseSourceListExpandableItem* _tmp64_;
#line 424 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp63_ = into_expandable;
#line 424 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp64_ = _data15_->expandable_item;
#line 424 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp63_, (GraniteWidgetsSourceListItem*) _tmp64_);
#line 3408 "SourceListView.c"
			}
#line 426 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			break;
#line 3412 "SourceListView.c"
		}
#line 386 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
#line 3416 "SourceListView.c"
		{
			NoiseSourceListExpandableItem* _tmp65_;
#line 428 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp65_ = into_expandable;
#line 428 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp65_ == NULL) {
#line 3423 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp66_;
				NoiseSourceListExpandableItem* _tmp67_;
#line 429 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp66_ = self->priv->devices_category;
#line 429 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp67_ = _data15_->expandable_item;
#line 429 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp66_, (GraniteWidgetsSourceListItem*) _tmp67_);
#line 3432 "SourceListView.c"
			} else {
				NoiseSourceListExpandableItem* _tmp68_;
				NoiseSourceListExpandableItem* _tmp69_;
#line 431 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp68_ = into_expandable;
#line 431 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp69_ = _data15_->expandable_item;
#line 431 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp68_, (GraniteWidgetsSourceListItem*) _tmp69_);
#line 3442 "SourceListView.c"
			}
#line 433 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			break;
#line 3446 "SourceListView.c"
		}
#line 386 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE:
#line 3450 "SourceListView.c"
		{
			NoiseSourceListExpandableItem* _tmp70_;
#line 435 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp70_ = into_expandable;
#line 435 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp70_ == NULL) {
#line 3457 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp71_;
				NoiseSourceListItem* _tmp72_;
#line 436 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp71_ = self->priv->network_category;
#line 436 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp72_ = _data15_->sourcelist_item;
#line 436 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp71_, (GraniteWidgetsSourceListItem*) _tmp72_);
#line 3466 "SourceListView.c"
			} else {
				NoiseSourceListExpandableItem* _tmp73_;
				NoiseSourceListItem* _tmp74_;
#line 438 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp73_ = into_expandable;
#line 438 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp74_ = _data15_->sourcelist_item;
#line 438 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp73_, (GraniteWidgetsSourceListItem*) _tmp74_);
#line 3476 "SourceListView.c"
			}
#line 440 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			break;
#line 3480 "SourceListView.c"
		}
		default:
		{
#line 442 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			break;
#line 3486 "SourceListView.c"
		}
	}
#line 445 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp75_ = hint;
#line 445 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (_tmp75_ == NOISE_VIEW_WRAPPER_HINT_DEVICE) {
#line 3493 "SourceListView.c"
		NoiseSourceListExpandableItem* _tmp76_;
		NoiseSourceListEntry* _tmp77_;
#line 446 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp76_ = _data15_->expandable_item;
#line 446 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp77_ = _g_object_ref0 ((NoiseSourceListEntry*) _tmp76_);
#line 446 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		result = _tmp77_;
#line 446 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		block15_data_unref (_data15_);
#line 446 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_data15_ = NULL;
#line 446 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		return result;
#line 3508 "SourceListView.c"
	} else {
		NoiseSourceListItem* _tmp78_;
		NoiseSourceListEntry* _tmp79_;
#line 448 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp78_ = _data15_->sourcelist_item;
#line 448 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp79_ = _g_object_ref0 ((NoiseSourceListEntry*) _tmp78_);
#line 448 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		result = _tmp79_;
#line 448 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		block15_data_unref (_data15_);
#line 448 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_data15_ = NULL;
#line 448 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		return result;
#line 3524 "SourceListView.c"
	}
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	block15_data_unref (_data15_);
#line 351 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_data15_ = NULL;
#line 3530 "SourceListView.c"
}


static void noise_source_list_view_real_item_selected (GraniteWidgetsSourceList* base, GraniteWidgetsSourceListItem* item) {
	NoiseSourceListView * self;
	GraniteWidgetsSourceListItem* _tmp0_;
#line 452 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = (NoiseSourceListView*) base;
#line 453 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = item;
#line 453 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 3543 "SourceListView.c"
		NoiseSourceListItem* sidebar_item = NULL;
		GraniteWidgetsSourceListItem* _tmp1_;
		NoiseSourceListItem* _tmp2_;
		NoiseSourceListItem* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 454 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp1_ = item;
#line 454 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, NOISE_TYPE_SOURCE_LIST_ITEM) ? ((NoiseSourceListItem*) _tmp1_) : NULL);
#line 454 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		sidebar_item = _tmp2_;
#line 455 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp3_ = sidebar_item;
#line 455 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = noise_source_list_item_get_page_number (_tmp3_);
#line 455 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 455 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp5_);
#line 453 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (sidebar_item);
#line 3566 "SourceListView.c"
	} else {
		GraniteWidgetsSourceListItem* _tmp6_;
#line 456 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp6_ = item;
#line 456 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 3573 "SourceListView.c"
			NoiseSourceListExpandableItem* sidebar_item = NULL;
			GraniteWidgetsSourceListItem* _tmp7_;
			NoiseSourceListExpandableItem* _tmp8_;
			NoiseSourceListExpandableItem* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 457 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp7_ = item;
#line 457 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM) ? ((NoiseSourceListExpandableItem*) _tmp7_) : NULL);
#line 457 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			sidebar_item = _tmp8_;
#line 458 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp9_ = sidebar_item;
#line 458 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp10_ = noise_source_list_expandable_item_get_page_number (_tmp9_);
#line 458 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp11_ = _tmp10_;
#line 458 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp11_);
#line 456 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (sidebar_item);
#line 3596 "SourceListView.c"
		}
	}
}


void noise_source_list_view_remove_playlist (NoiseSourceListView* self, gint page_number) {
	GeeTreeSet* items = NULL;
	GeeTreeSet* _tmp17_;
#line 463 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 3607 "SourceListView.c"
	{
		GeeIterator* _playlist_it = NULL;
		NoisePlayListCategory* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->playlists_category;
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) _tmp0_);
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_playlist_it = _tmp5_;
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 3634 "SourceListView.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_;
			GraniteWidgetsSourceListItem* playlist = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp6_ = _playlist_it;
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (!_tmp7_) {
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				break;
#line 3649 "SourceListView.c"
			}
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp8_ = _playlist_it;
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			playlist = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 465 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp10_ = playlist;
#line 465 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 3661 "SourceListView.c"
				gint _tmp11_;
				GraniteWidgetsSourceListItem* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 466 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp11_ = page_number;
#line 466 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp12_ = playlist;
#line 466 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp13_ = noise_source_list_item_get_page_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
#line 466 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp14_ = _tmp13_;
#line 466 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				if (_tmp11_ == _tmp14_) {
#line 3676 "SourceListView.c"
					NoisePlayListCategory* _tmp15_;
					GraniteWidgetsSourceListItem* _tmp16_;
#line 467 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp15_ = self->priv->playlists_category;
#line 467 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp16_ = playlist;
#line 467 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					granite_widgets_source_list_expandable_item_remove ((GraniteWidgetsSourceListExpandableItem*) _tmp15_, _tmp16_);
#line 468 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (playlist);
#line 468 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (_playlist_it);
#line 468 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					return;
#line 3691 "SourceListView.c"
				}
			}
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist);
#line 3696 "SourceListView.c"
		}
#line 464 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_playlist_it);
#line 3700 "SourceListView.c"
	}
#line 472 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp17_ = gee_tree_set_new (NOISE_TYPE_SOURCE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 472 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	items = _tmp17_;
#line 3706 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp18_;
		GeeCollection* _tmp19_;
		GeeCollection* _tmp20_;
		GeeCollection* _tmp21_;
		GeeIterator* _tmp22_;
		GeeIterator* _tmp23_;
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp18_ = self->priv->devices_category;
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp19_ = granite_widgets_source_list_expandable_item_get_children (_tmp18_);
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp20_ = _tmp19_;
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp21_ = _tmp20_;
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp23_ = _tmp22_;
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp21_);
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_device_it = _tmp23_;
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 3733 "SourceListView.c"
			GeeIterator* _tmp24_;
			gboolean _tmp25_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp26_;
			gpointer _tmp27_;
			GraniteWidgetsSourceListItem* _tmp28_;
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp24_ = _device_it;
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp25_ = gee_iterator_next (_tmp24_);
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (!_tmp25_) {
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				break;
#line 3748 "SourceListView.c"
			}
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp26_ = _device_it;
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp27_ = gee_iterator_get (_tmp26_);
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp27_;
#line 474 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp28_ = device;
#line 474 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 3760 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp29_;
#line 475 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp29_ = device;
#line 475 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				noise_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), &items);
#line 3766 "SourceListView.c"
				{
					GeeIterator* _item_it = NULL;
					GeeTreeSet* _tmp30_;
					GeeIterator* _tmp31_;
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp30_ = items;
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp31_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp30_);
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_item_it = _tmp31_;
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					while (TRUE) {
#line 3779 "SourceListView.c"
						GeeIterator* _tmp32_;
						gboolean _tmp33_;
						NoiseSourceListItem* item = NULL;
						GeeIterator* _tmp34_;
						gpointer _tmp35_;
						NoiseSourceListItem* _tmp36_;
						gint _tmp37_;
						gint _tmp38_;
						gint _tmp39_;
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp32_ = _item_it;
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp33_ = gee_iterator_next (_tmp32_);
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						if (!_tmp33_) {
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							break;
#line 3797 "SourceListView.c"
						}
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp34_ = _item_it;
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp35_ = gee_iterator_get (_tmp34_);
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						item = (NoiseSourceListItem*) _tmp35_;
#line 477 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp36_ = item;
#line 477 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp37_ = noise_source_list_item_get_page_number (_tmp36_);
#line 477 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp38_ = _tmp37_;
#line 477 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp39_ = page_number;
#line 477 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						if (_tmp38_ == _tmp39_) {
#line 3815 "SourceListView.c"
							NoiseSourceListItem* _tmp40_;
							GraniteWidgetsSourceListExpandableItem* _tmp41_;
							GraniteWidgetsSourceListExpandableItem* _tmp42_;
							NoiseSourceListItem* _tmp43_;
#line 478 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_tmp40_ = item;
#line 478 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_tmp41_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) _tmp40_);
#line 478 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_tmp42_ = _tmp41_;
#line 478 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_tmp43_ = item;
#line 478 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							granite_widgets_source_list_expandable_item_remove (_tmp42_, (GraniteWidgetsSourceListItem*) _tmp43_);
#line 479 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_g_object_unref0 (item);
#line 479 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_g_object_unref0 (_item_it);
#line 479 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_g_object_unref0 (device);
#line 479 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_g_object_unref0 (_device_it);
#line 479 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_g_object_unref0 (items);
#line 479 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							return;
#line 3842 "SourceListView.c"
						}
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_g_object_unref0 (item);
#line 3846 "SourceListView.c"
					}
#line 476 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (_item_it);
#line 3850 "SourceListView.c"
				}
			}
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 3855 "SourceListView.c"
		}
#line 473 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 3859 "SourceListView.c"
	}
#line 463 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (items);
#line 3863 "SourceListView.c"
}


GeeCollection* noise_source_list_view_remove_device (NoiseSourceListView* self, gint page_number) {
	GeeCollection* result = NULL;
	GeeTreeSet* pages = NULL;
	GeeTreeSet* _tmp0_;
#line 487 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 488 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp0_ = gee_tree_set_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 488 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	pages = _tmp0_;
#line 3877 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp1_ = self->priv->devices_category;
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp2_ = granite_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = _tmp3_;
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp6_ = _tmp5_;
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp4_);
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_device_it = _tmp6_;
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 3904 "SourceListView.c"
			GeeIterator* _tmp7_;
			gboolean _tmp8_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			GraniteWidgetsSourceListItem* _tmp11_;
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp7_ = _device_it;
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (!_tmp8_) {
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				break;
#line 3919 "SourceListView.c"
			}
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp9_ = _device_it;
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp10_;
#line 490 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp11_ = device;
#line 490 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 3931 "SourceListView.c"
				gint _tmp12_;
				GraniteWidgetsSourceListItem* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 491 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp12_ = page_number;
#line 491 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp13_ = device;
#line 491 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp14_ = noise_source_list_expandable_item_get_page_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
#line 491 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp15_ = _tmp14_;
#line 491 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				if (_tmp12_ == _tmp15_) {
#line 3946 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp16_;
					GraniteWidgetsSourceListExpandableItem* _tmp17_;
					GraniteWidgetsSourceListItem* _tmp18_;
#line 492 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp16_ = device;
#line 492 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					noise_source_list_view_enumerate_children_pages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), &pages);
#line 493 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp17_ = self->priv->devices_category;
#line 493 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp18_ = device;
#line 493 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					granite_widgets_source_list_expandable_item_remove (_tmp17_, _tmp18_);
#line 494 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					result = (GeeCollection*) pages;
#line 494 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (device);
#line 494 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (_device_it);
#line 494 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					return result;
#line 3968 "SourceListView.c"
				}
			}
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 3973 "SourceListView.c"
		}
#line 489 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 3977 "SourceListView.c"
	}
#line 498 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = (GeeCollection*) pages;
#line 498 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 3983 "SourceListView.c"
}


gint noise_source_list_view_get_device_from_item (NoiseSourceListView* self, NoiseSourceListExpandableItem* item) {
	gint result = 0;
#line 502 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 502 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_val_if_fail (item != NULL, 0);
#line 3993 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->devices_category;
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children (_tmp0_);
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_device_it = _tmp5_;
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4020 "SourceListView.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			NoiseSourceListExpandableItem* _tmp10_;
			GraniteWidgetsSourceListExpandableItem* _tmp11_;
			GraniteWidgetsSourceListExpandableItem* _tmp12_;
			GraniteWidgetsSourceListItem* _tmp13_;
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp6_ = _device_it;
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (!_tmp7_) {
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				break;
#line 4038 "SourceListView.c"
			}
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp8_ = _device_it;
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 504 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp10_ = item;
#line 504 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp11_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) _tmp10_);
#line 504 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp12_ = _tmp11_;
#line 504 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp13_ = device;
#line 504 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (_tmp12_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem)) {
#line 4056 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp14_;
#line 505 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp14_ = device;
#line 505 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 4062 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp15_;
					gint _tmp16_;
					gint _tmp17_;
#line 506 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp15_ = device;
#line 506 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp16_ = noise_source_list_expandable_item_get_page_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
#line 506 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp17_ = _tmp16_;
#line 506 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					result = _tmp17_;
#line 506 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (device);
#line 506 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (_device_it);
#line 506 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					return result;
#line 4080 "SourceListView.c"
				}
			}
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4085 "SourceListView.c"
		}
#line 503 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4089 "SourceListView.c"
	}
#line 510 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	result = -1;
#line 510 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	return result;
#line 4095 "SourceListView.c"
}


void noise_source_list_view_enumerate_children_pages (NoiseSourceListView* self, NoiseSourceListExpandableItem* exp_item, GeeTreeSet* * pages) {
#line 513 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 513 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (exp_item != NULL);
#line 513 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (*pages != NULL);
#line 4106 "SourceListView.c"
	{
		GeeIterator* _views_it = NULL;
		NoiseSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp0_ = exp_item;
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_views_it = _tmp5_;
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4133 "SourceListView.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_;
			GraniteWidgetsSourceListItem* views = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp6_ = _views_it;
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (!_tmp7_) {
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				break;
#line 4148 "SourceListView.c"
			}
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp8_ = _views_it;
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			views = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 515 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp10_ = views;
#line 515 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 4160 "SourceListView.c"
				GeeTreeSet* _tmp11_;
				GraniteWidgetsSourceListItem* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				GraniteWidgetsSourceListItem* _tmp15_;
#line 516 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp11_ = *pages;
#line 516 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp12_ = views;
#line 516 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp13_ = noise_source_list_expandable_item_get_page_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
#line 516 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp14_ = _tmp13_;
#line 516 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, (gpointer) ((gintptr) _tmp14_));
#line 517 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp15_ = views;
#line 517 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				noise_source_list_view_enumerate_children_pages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), pages);
#line 4180 "SourceListView.c"
			} else {
				GraniteWidgetsSourceListItem* _tmp16_;
#line 518 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp16_ = views;
#line 518 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 4187 "SourceListView.c"
					GeeTreeSet* _tmp17_;
					GraniteWidgetsSourceListItem* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
#line 519 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp17_ = *pages;
#line 519 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp18_ = views;
#line 519 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp19_ = noise_source_list_item_get_page_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
#line 519 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp20_ = _tmp19_;
#line 519 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, (gpointer) ((gintptr) _tmp20_));
#line 4202 "SourceListView.c"
				}
			}
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (views);
#line 4207 "SourceListView.c"
		}
#line 514 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_views_it);
#line 4211 "SourceListView.c"
	}
}


void noise_source_list_view_enumerate_children_items (NoiseSourceListView* self, NoiseSourceListExpandableItem* exp_item, GeeTreeSet* * pages) {
#line 524 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 524 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (exp_item != NULL);
#line 524 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (*pages != NULL);
#line 4223 "SourceListView.c"
	{
		GeeIterator* _views_it = NULL;
		NoiseSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp0_ = exp_item;
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_views_it = _tmp5_;
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4250 "SourceListView.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_;
			GraniteWidgetsSourceListItem* views = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp6_ = _views_it;
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (!_tmp7_) {
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				break;
#line 4265 "SourceListView.c"
			}
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp8_ = _views_it;
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			views = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 526 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp10_ = views;
#line 526 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 4277 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp11_;
#line 527 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp11_ = views;
#line 527 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				noise_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), pages);
#line 4283 "SourceListView.c"
			} else {
				GraniteWidgetsSourceListItem* _tmp12_;
#line 528 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp12_ = views;
#line 528 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 4290 "SourceListView.c"
					GeeTreeSet* _tmp13_;
					GraniteWidgetsSourceListItem* _tmp14_;
#line 529 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp13_ = *pages;
#line 529 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp14_ = views;
#line 529 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
#line 4299 "SourceListView.c"
				}
			}
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (views);
#line 4304 "SourceListView.c"
		}
#line 525 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_views_it);
#line 4308 "SourceListView.c"
	}
}


void noise_source_list_view_change_playlist_name (NoiseSourceListView* self, gint page_number, const gchar* new_name) {
	GeeTreeSet* items = NULL;
	GeeTreeSet* _tmp17_;
#line 535 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 535 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (new_name != NULL);
#line 4320 "SourceListView.c"
	{
		GeeIterator* _playlist_it = NULL;
		NoisePlayListCategory* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->playlists_category;
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) _tmp0_);
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_playlist_it = _tmp5_;
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4347 "SourceListView.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_;
			GraniteWidgetsSourceListItem* playlist = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp6_ = _playlist_it;
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (!_tmp7_) {
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				break;
#line 4362 "SourceListView.c"
			}
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp8_ = _playlist_it;
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			playlist = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 537 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp10_ = playlist;
#line 537 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 4374 "SourceListView.c"
				gint _tmp11_;
				GraniteWidgetsSourceListItem* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 538 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp11_ = page_number;
#line 538 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp12_ = playlist;
#line 538 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp13_ = noise_source_list_item_get_page_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
#line 538 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp14_ = _tmp13_;
#line 538 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				if (_tmp11_ == _tmp14_) {
#line 4389 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp15_;
					const gchar* _tmp16_;
#line 539 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp15_ = playlist;
#line 539 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp16_ = new_name;
#line 539 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem), _tmp16_);
#line 540 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (playlist);
#line 540 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (_playlist_it);
#line 540 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					return;
#line 4404 "SourceListView.c"
				}
			}
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist);
#line 4409 "SourceListView.c"
		}
#line 536 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_playlist_it);
#line 4413 "SourceListView.c"
	}
#line 544 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_tmp17_ = gee_tree_set_new (NOISE_TYPE_SOURCE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 544 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	items = _tmp17_;
#line 4419 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp18_;
		GeeCollection* _tmp19_;
		GeeCollection* _tmp20_;
		GeeCollection* _tmp21_;
		GeeIterator* _tmp22_;
		GeeIterator* _tmp23_;
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp18_ = self->priv->devices_category;
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp19_ = granite_widgets_source_list_expandable_item_get_children (_tmp18_);
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp20_ = _tmp19_;
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp21_ = _tmp20_;
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp23_ = _tmp22_;
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp21_);
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_device_it = _tmp23_;
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4446 "SourceListView.c"
			GeeIterator* _tmp24_;
			gboolean _tmp25_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp26_;
			gpointer _tmp27_;
			GraniteWidgetsSourceListItem* _tmp28_;
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp24_ = _device_it;
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp25_ = gee_iterator_next (_tmp24_);
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (!_tmp25_) {
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				break;
#line 4461 "SourceListView.c"
			}
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp26_ = _device_it;
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp27_ = gee_iterator_get (_tmp26_);
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp27_;
#line 546 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp28_ = device;
#line 546 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 4473 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp29_;
#line 547 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp29_ = device;
#line 547 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				noise_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), &items);
#line 4479 "SourceListView.c"
				{
					GeeIterator* _item_it = NULL;
					GeeTreeSet* _tmp30_;
					GeeIterator* _tmp31_;
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp30_ = items;
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp31_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp30_);
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_item_it = _tmp31_;
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					while (TRUE) {
#line 4492 "SourceListView.c"
						GeeIterator* _tmp32_;
						gboolean _tmp33_;
						NoiseSourceListItem* item = NULL;
						GeeIterator* _tmp34_;
						gpointer _tmp35_;
						NoiseSourceListItem* _tmp36_;
						gint _tmp37_;
						gint _tmp38_;
						gint _tmp39_;
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp32_ = _item_it;
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp33_ = gee_iterator_next (_tmp32_);
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						if (!_tmp33_) {
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							break;
#line 4510 "SourceListView.c"
						}
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp34_ = _item_it;
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp35_ = gee_iterator_get (_tmp34_);
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						item = (NoiseSourceListItem*) _tmp35_;
#line 549 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp36_ = item;
#line 549 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp37_ = noise_source_list_item_get_page_number (_tmp36_);
#line 549 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp38_ = _tmp37_;
#line 549 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_tmp39_ = page_number;
#line 549 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						if (_tmp38_ == _tmp39_) {
#line 4528 "SourceListView.c"
							NoiseSourceListItem* _tmp40_;
							const gchar* _tmp41_;
#line 550 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_tmp40_ = item;
#line 550 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_tmp41_ = new_name;
#line 550 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem), _tmp41_);
#line 551 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_g_object_unref0 (item);
#line 551 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_g_object_unref0 (_item_it);
#line 551 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_g_object_unref0 (device);
#line 551 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_g_object_unref0 (_device_it);
#line 551 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							_g_object_unref0 (items);
#line 551 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
							return;
#line 4549 "SourceListView.c"
						}
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
						_g_object_unref0 (item);
#line 4553 "SourceListView.c"
					}
#line 548 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (_item_it);
#line 4557 "SourceListView.c"
				}
			}
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4562 "SourceListView.c"
		}
#line 545 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4566 "SourceListView.c"
	}
#line 535 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (items);
#line 4570 "SourceListView.c"
}


void noise_source_list_view_change_device_name (NoiseSourceListView* self, gint page_number, const gchar* new_name) {
#line 559 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 559 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (new_name != NULL);
#line 4579 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->devices_category;
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children (_tmp0_);
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_device_it = _tmp5_;
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4606 "SourceListView.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp6_ = _device_it;
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (!_tmp7_) {
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				break;
#line 4621 "SourceListView.c"
			}
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp8_ = _device_it;
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 561 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_tmp10_ = device;
#line 561 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 4633 "SourceListView.c"
				gint _tmp11_;
				GraniteWidgetsSourceListItem* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 562 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp11_ = page_number;
#line 562 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp12_ = device;
#line 562 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp13_ = noise_source_list_item_get_page_number (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
#line 562 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				_tmp14_ = _tmp13_;
#line 562 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
				if (_tmp11_ == _tmp14_) {
#line 4648 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp15_;
					const gchar* _tmp16_;
#line 563 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp15_ = device;
#line 563 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_tmp16_ = new_name;
#line 563 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem), _tmp16_);
#line 564 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (device);
#line 564 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					_g_object_unref0 (_device_it);
#line 564 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
					return;
#line 4663 "SourceListView.c"
				}
			}
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4668 "SourceListView.c"
		}
#line 560 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4672 "SourceListView.c"
	}
}


static void g_cclosure_user_marshal_VOID__INT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_STRING) (gpointer data1, gint arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_return_if_fail (n_param_values == 3);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		data1 = closure->data;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		data2 = param_values->data[0].v_pointer;
#line 4692 "SourceListView.c"
	} else {
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		data1 = param_values->data[0].v_pointer;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
		data2 = closure->data;
#line 4698 "SourceListView.c"
	}
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	callback = (GMarshalFunc_VOID__INT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 4704 "SourceListView.c"
}


static void noise_source_list_view_class_init (NoiseSourceListViewClass * klass) {
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_parent_class = g_type_class_peek_parent (klass);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	g_type_class_add_private (klass, sizeof (NoiseSourceListViewPrivate));
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListClass *) klass)->item_selected = (void (*) (GraniteWidgetsSourceList *, GraniteWidgetsSourceListItem*)) noise_source_list_view_real_item_selected;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_source_list_view_finalize;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_EDITED_SIGNAL] = g_signal_new ("edited", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_STRING, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_STRING);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL] = g_signal_new ("item-action-activated", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL] = g_signal_new ("activated", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL] = g_signal_new ("playlist-rename-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL] = g_signal_new ("playlist-edit-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL] = g_signal_new ("playlist-remove-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL] = g_signal_new ("playlist-save-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-export-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-import-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("playlist-media-added", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_BOXED_INT, G_TYPE_NONE, 3, G_TYPE_INT, G_TYPE_STRV, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL] = g_signal_new ("device-import-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL] = g_signal_new ("device-eject-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL] = g_signal_new ("device-sync-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-playlist-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-smartplaylist-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 4749 "SourceListView.c"
}


static void noise_source_list_view_instance_init (NoiseSourceListView * self) {
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self->priv = NOISE_SOURCE_LIST_VIEW_GET_PRIVATE (self);
#line 4756 "SourceListView.c"
}


static void noise_source_list_view_finalize (GObject * obj) {
	NoiseSourceListView * self;
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListView);
#line 294 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->library_category);
#line 295 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->devices_category);
#line 296 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->network_category);
#line 297 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlists_category);
#line 292 "/builddir/build/BUILD/music-0.4.2/src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (noise_source_list_view_parent_class)->finalize (obj);
#line 4774 "SourceListView.c"
}


GType noise_source_list_view_get_type (void) {
	static volatile gsize noise_source_list_view_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListView), 0, (GInstanceInitFunc) noise_source_list_view_instance_init, NULL };
		GType noise_source_list_view_type_id;
		noise_source_list_view_type_id = g_type_register_static (GRANITE_WIDGETS_TYPE_SOURCE_LIST, "NoiseSourceListView", &g_define_type_info, 0);
		g_once_init_leave (&noise_source_list_view_type_id__volatile, noise_source_list_view_type_id);
	}
	return noise_source_list_view_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



